////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge RTCD@\ \[Xt@C
: 1) {t@C͑SvWFNg(INtime/NTX/Win)Ŏgp鋤ʃt@CłB
      2) edgeWriteRTCD() ̒ӎ
        [ۇ@]
	     edgeWriteRTCDsedgeReadRTCDsꂽꍇɁA
		 ReadʒuWriteʒuCR[ɂȂ炸AZ}tH𑗂ȂȂĂ܂
		 Ƃ(Windows)
        []
     	 Ǎ݃R[h0̂Ƃ̂݃Z}tH𑗂悤ɂĂ
        [΍]
		 ʒmZ}tH𖈉񑗂悤ɂĂ܂B

        [ۇA]

   	    []
         rZ}tHʒmZ}tH̏ԂɂȂĂ邽߁AʒmZ}tH̑O
		 Xbh̏荞܂₷B
        [΍]
     	 ʒmZ}tHrZ}tH̏Ԃɂ܂B

      3) edgeReadRTCD() ̒ӎ
        [ۇ@]
         500f[^ݏIA499ڂ̓Ǎ݂Łuf[^XV܂vG[
		 Ȃ邱ƂB
		 (51񂮂炢̕pxŐΐ삳PCɂĔBPCł220񂾂B)
		[]
		 edgeReadRTCD1̊ԂedgeWriteRTCD2Ă΂邱ƂŁA2ڂ̒ʒmZ}tH
		 edgeReadRTCD̒ʒmZ}tHNAŃNAA̒ʒmZ}tH҂ŃZ}tHȂ
		 ^CAEgƂȂB
        [΍]
		 ʒmZ}tHMAǍ݈ʒuƏ݈ʒuꍇ̓Z}tH҂̃gCs悤
		 ΉB

: 2019.08.08 VK쐬
      2019.11.05 obt@tɏݗvꍇ̓obt@tG[ɂ悤Ή
--------------------------------------------------------------------------------*/

#include "apiRTCD.h"

//------------------------------------------------------------------------------
// 萔
//------------------------------------------------------------------------------
#define RTCD_NAME_FORMAT "eg%s"									// RTCDJ^OtH[}bg
#define SEM1_NAME_FORMAT "eg%s01"								// rpZ}tHJ^OtH[}bg
#define SEM2_NAME_FORMAT "eg%s02"								// ʒmpZ}tHJ^OtH[}bg
#define RTCD_NAME_LEN_MAX 8										// RTCDJ^Oő啶
#define RTCD_HANDLE_CODE 0x52544344								// RTCDnhʃR[h(nhÓ`FbNp)
#define NEXT_POS(pos,max) ( ((pos+1) >= max) ? 0 : (pos+1) )	// ̃R[hʒu擾

//------------------------------------------------------------------------------
// API֐
//------------------------------------------------------------------------------

/*------------------------------------------------------------------------------
Tv  : RTCD𐶐
  : pName    [in] RTCD
        dwMode   [in] ݃[h 1:VO[h 2:}`[h
        dwLength [in] R[h(bytes)
        dwNum    [in] R[h
        pRtcdInfo [out] 
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeCreateRTCD(const char *pName, DWORD dwMode, DWORD dwLength, DWORD dwNum, RTCDMEMINFO *pRtcdInfo)
{
	int					result = 0;
	int					ret;
	size_t				len;
	DWORD				rtcdSize;
	char				szName[16];			// RTCDJ^O
	char				szSem1Name[16];		// rpZ}tHJ^O
	char				szSem2Name[16];		// ʒmpZ}tHJ^O
	EDGE_RTCD_HEADER	*pHeader = NULL;	// RTCDwb_[
	RTCD_MEM_RESULT		memResult;			// RTCDʏ

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pName == NULL) {													// RTCD̃`FbN
		return EDGE_RTCD_NAME_INVALID;										// RTCD̂sł
	}
	
	len = strlen(pName);
	if ( (len <= 0) || (len > RTCD_NAME_LEN_MAX) ) {						// RTCD̕`FbN
		return EDGE_RTCD_NAME_LENGTH_ERROR;									// RTCD̂̕G[
	}
	
	if ( (dwMode < RTCD_WRITE_SINGLE) || (dwMode > RTCD_WRITE_MULTI) ) {	// ݃[h`FbN
		return EDGE_RTCD_WRITE_MODE_ERROR;									// RTCD݃[hG[
	}
	
	if ( dwLength == 0 ) {													// R[h`FbN
		return EDGE_RTCD_RECORD_LENGTH_ERROR;								// RTCDR[hG[
	}
	
	if ( dwNum <= 1 ) {														// R[h`FbN
		return EDGE_RTCD_RECORD_NUM_ERROR;									// RTCDR[hG[
	}
	
	if (pRtcdInfo == NULL) {												// RTCD`FbN
		return EDGE_RTCD_MEMINFO_INVALID;									// RTCD񂪕sł
	}

	//--------------------------------------------------------------------
	// RTCD̑O
	//--------------------------------------------------------------------

	memset(szName, 0, sizeof(szName));										// RTCDJ^O
	sprintf_s(szName, sizeof(szName), RTCD_NAME_FORMAT, pName);

	memset(szSem1Name, 0, sizeof(szSem1Name));								// rpZ}tHJ^O
	sprintf_s(szSem1Name, sizeof(szSem1Name), SEM1_NAME_FORMAT, pName);

	memset(szSem2Name, 0, sizeof(szSem2Name));								// ʒmpZ}tHJ^O
	sprintf_s(szSem2Name, sizeof(szSem2Name), SEM2_NAME_FORMAT, pName);

	rtcdSize = sizeof(EDGE_RTCD_HEADER) + ((sizeof(EDGE_RECORD_HEADER) + dwLength) * dwNum);	// RTCD̃TCYZo (wb_[ + f[^)

	//--------------------------------------------------------------------
	// RTCD
	//--------------------------------------------------------------------
	ret = CreateRTCD(szName, (DWORD)rtcdSize, dwMode, dwLength, dwNum, szSem1Name, szSem2Name, &memResult);	// RTCD𐶐
	if (ret != EDGE_SUCCESS) {
		return ret;												// G[R[hԂ
	}

	memset(memResult.pMem, 0, rtcdSize);						// RTCD

	//--------------------------------------------------------------------
	// RTCDwb_[񏑍
	//--------------------------------------------------------------------
	pHeader = (EDGE_RTCD_HEADER*)memResult.pMem;
	pHeader->record_num			= dwNum;						// R[h
	pHeader->record_size		= dwLength;						// R[hTCY(oCg)
	pHeader->read_pos			= 0;							// Ǎ݈ʒu
	pHeader->write_pos			= 0;							// ݈ʒu
	pHeader->write_mode			= dwMode;						// ݃[h 1:VO 2:}`
	pHeader->read_open_count	= 0;							// Ǎ݃[hI[vJE^
	pHeader->write_open_count	= 0;							// ݃[hI[vJE^
	pHeader->lost_count			= 0;							// JE^
	strcpy_s(pHeader->name, sizeof(pHeader->name), pName);		// RTCD
	pHeader->mem_handle			= memResult.hMem;				// RTCDnhl (edgeDeleteRTCDɂRTCD폜邽߂Ƀnhli[)
	pHeader->lock_sem_handle	= memResult.hLockSem;			// rpZ}tHnhl (edgeDeleteRTCDɂĔrpZ}tH폜邽߂Ƀnhli[)
	pHeader->notify_sem_handle	= memResult.hNotifySem;			// ʒmpZ}tHnhl (edgeDeleteRTCDɂďʒmpZ}tH폜邽߂Ƀnhli[)

	//--------------------------------------------------------------------
	// Zbg
	//--------------------------------------------------------------------
	pRtcdInfo->pRtcd		= memResult.pMem;					// RTCD|C^({)
	pRtcdInfo->mem_handle	= memResult.hMem;					// RTCDnh
	pRtcdInfo->sem1_handle	= memResult.hLockSem;				// rpZ}tHnh(NTXłedgeDeleteRTCDɂĔrpZ}tH폜邽߂Ƀnhli[)
	pRtcdInfo->sem2_handle	= memResult.hNotifySem;				// ʒmpZ}tHnh(NTXłedgeDeleteRTCDɂďʒmpZ}tH폜邽߂Ƀnhli[)
	strcpy_s(pRtcdInfo->name, sizeof(pRtcdInfo->name), pName);	// RTCD

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCD폜
  : pRtcdInfo [in] RTCD
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeDeleteRTCD(RTCDMEMINFO *pRtcdInfo)
{
	int					ret;
	char				szName[16];			// RTCDJ^O
	char				szSem1Name[16];		// rpZ}tHJ^O
	char				szSem2Name[16];		// ʒmpZ}tHJ^O

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pRtcdInfo == NULL) {				// RTCD`FbN
		return EDGE_RTCD_MEMINFO_INVALID;	// RTCD񂪕sł
	}
	
	if (pRtcdInfo->pRtcd == NULL) {			// RTCDwb_[|C^`FbN
		return EDGE_RTCD_MEMINFO_INVALID;	// RTCD񂪕sł
	}
	
	memset(szName, 0, sizeof(szName));												// RTCDJ^O
	sprintf_s(szName, sizeof(szName), RTCD_NAME_FORMAT, pRtcdInfo->name);

	memset(szSem1Name, 0, sizeof(szSem1Name));										// rpZ}tHJ^O
	sprintf_s(szSem1Name, sizeof(szSem1Name), SEM1_NAME_FORMAT, pRtcdInfo->name);

	memset(szSem2Name, 0, sizeof(szSem2Name));										// ʒmpZ}tHJ^O
	sprintf_s(szSem2Name, sizeof(szSem2Name), SEM2_NAME_FORMAT, pRtcdInfo->name);


	//--------------------------------------------------------------------
	// RTCD폜
	//--------------------------------------------------------------------
	ret = DeleteRTCD(szName, pRtcdInfo, szSem1Name, szSem2Name);	// RTCD폜
	if (ret != EDGE_SUCCESS) {
		return ret;													// G[R[hԂ
	}

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCDI[v
  : pName   [in] RTCD
        dwAccess[in] ANZX[h
        pHandle [out] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeOpenRTCD(const char *pName, DWORD dwAccess, RTCDHANDLE *pHandle)
{
	int					ret;
	size_t				len;
	char				szName[16];			// RTCDJ^O
	char				szSem1Name[16];		// rpZ}tHJ^O
	char				szSem2Name[16];		// ʒmpZ}tHJ^O
	BYTE				*pMem = NULL;		// RTCD}bsO|C^
	EDGE_RTCD_HEADER	*pHeader = NULL;	// RTCDwb_[
	void				*hMap = NULL;		// RTCDnh
	void				*hSem1 = NULL;		// rpZ}tHnh
	void				*hSem2 = NULL;		// ʒmpZ}tHnh

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pName == NULL) {												// RTCD̃`FbN
		return EDGE_RTCD_NAME_INVALID;									// RTCD̂sł
	}
	
	len = strlen(pName);
	if ( (len <= 0) || (len > RTCD_NAME_LEN_MAX) ) {					// RTCD̕`FbN
		return EDGE_RTCD_NAME_LENGTH_ERROR;								// RTCD̂̕G[
	}
	
	if ( (dwAccess < RTCD_READ) || (dwAccess > RTCD_READWRITE) ) {		// ANZX[h`FbN
		return EDGE_RTCD_ACCESS_MODE_ERROR;								// RTCDANZX[hG[
	}
	
	if (pHandle == NULL) {												// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;								// RTCDnhsł
	}

	memset(szName, 0, sizeof(szName));									// RTCDJ^O
	sprintf_s(szName, sizeof(szName), RTCD_NAME_FORMAT, pName);

	memset(szSem1Name, 0, sizeof(szSem1Name));							// rpZ}tHJ^O
	sprintf_s(szSem1Name, sizeof(szSem1Name), SEM1_NAME_FORMAT, pName);

	memset(szSem2Name, 0, sizeof(szSem2Name));							// ʒmpZ}tHJ^O
	sprintf_s(szSem2Name, sizeof(szSem2Name), SEM2_NAME_FORMAT, pName);

	//--------------------------------------------------------------------
	// RTCDI[v(}bsO)
	//--------------------------------------------------------------------
	ret = OpenRTCD(szName, szSem1Name, szSem2Name, &pMem, &hMap, &hSem1, &hSem2);	// RTCDI[v
	if (ret != EDGE_SUCCESS) {
		return ret;						// G[R[hԂ
	}

	pHeader = (EDGE_RTCD_HEADER*)pMem;	// RTCDwb_[|C^擾

	//--------------------------------------------------
	// ANZX[h̑Ó`FbN
	//--------------------------------------------------
	if ( (dwAccess == RTCD_READ) || (dwAccess == RTCD_READWRITE) )	// Ǎ݃ANZX ܂ ǏANZX̂Ƃ
	{
		if ( pHeader->read_open_count > 0 ) {						// Ǎ݃I[vĂXbhƂ
			return EDGE_RTCD_ALREADY_OPEN_READ_ERROR;				// ɓǍ݃ANZXŃI[vĂ܂
		}
		pHeader->read_open_count++;									// Ǎ݃I[vJE^CNg
	}
	
	if ( (dwAccess == RTCD_WRITE) || (dwAccess == RTCD_READWRITE) ) // ݃ANZX ܂ ǏANZX̂Ƃ
	{
		if ( pHeader->write_mode == RTCD_WRITE_SINGLE )				// ݃[hVO[ĥƂ
		{
			if ( pHeader->write_open_count > 0 ) {					// ݃I[vĂXbhƂ
				return EDGE_RTCD_ALREADY_OPEN_WRITE_ERROR;			// ɏ݃ANZXŃI[vĂ܂(VO[h)
			}
		}
		else if ( pHeader->write_mode == RTCD_WRITE_MULTI )			// ݃[h}`[ĥƂ
		{
																	// }`[h̏ꍇ͕Xbh珑݉\̂߃`FbNȂ
		}

		pHeader->write_open_count++;								// ݃I[vJE^CNg
	}

	//--------------------------------------------------------------------
	// RTCDwb_[񏑍
	//--------------------------------------------------------------------
	pHandle->code			= RTCD_HANDLE_CODE;						// RTCDnhʃR[h
	pHandle->pRtcdHeader	= pHeader;								// RTCDwb_[̃|C^
	pHandle->pRtcdData		= pMem + sizeof(EDGE_RTCD_HEADER);		// RTCDf[^̃|C^
	pHandle->pMem_handle	= hMap;									// RTCDnh
	pHandle->pSem1_handle	= hSem1;								// rpZ}tHnh
	pHandle->pSem2_handle	= hSem2;								// ʒmpZ}tHnh
	pHandle->access			= dwAccess;								// ANZX[h

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCDN[Y
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeCloseRTCD(RTCDHANDLE *pHandle)
{
	int ret;

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {					// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}
	
	if (pHandle->pRtcdHeader == NULL) {		// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}
	
	if (pHandle->pRtcdData == NULL) {		// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}

	if ( (pHandle->access == RTCD_READ) || (pHandle->access == RTCD_READWRITE) ) {	// Ǎ݃ANZX ܂ ǏANZX̂Ƃ
		pHandle->pRtcdHeader->read_open_count--;									// Ǎ݃I[vJE^fNg
	}
	
	if ( (pHandle->access == RTCD_WRITE) || (pHandle->access == RTCD_READWRITE) ) { // ݃ANZX ܂ ǏANZX̂Ƃ
		pHandle->pRtcdHeader->write_open_count--;									// ݃I[vJE^fNg
	}

	//--------------------------------------------------------------------
	// RTCDN[Y
	//--------------------------------------------------------------------
	ret = CloseRTCD(pHandle);				// RTCDN[Y(A}bv)
	if (ret != EDGE_SUCCESS) {
		return ret;							// G[R[hԂ
	}

	memset(pHandle, 0, sizeof(RTCDHANDLE));	// RTCDnhNA

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCDɃR[h
  : pHandle [in] RTCDnh
        pBuffer [in] ݃f[^obt@
        dwSize  [in] ݃f[^TCY(bytes)
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
        2019.11.05 obt@tɏݗvꍇ̓obt@tG[ɂ悤Ή
--------------------------------------------------------------------------------*/
egRTCD_API int edgeWriteRTCD(RTCDHANDLE *pHandle, void *pBuffer, DWORD dwSize)
{
	int					ret;
	DWORD				dwWritePos;
	DWORD				dwNextWritePos;
	EDGE_RECORD_HEADER	*pRecHeader = NULL;
	BYTE				*pRec = NULL;

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {								// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}
	
	if (pHandle->pRtcdHeader == NULL) {					// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}
	
	if (pHandle->pRtcdData == NULL) {					// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}
	
	if (pBuffer == NULL) {								// ݃f[^obt@`FbN
		return EDGE_RTCD_BUFFER_INVALID;				// obt@sł
	}
	
	if (dwSize == 0) {									// ݃f[^TCY`FbN
		return EDGE_RTCD_WRITE_SIZE_INVALID;			// ݃TCYsł
	}
	
	if (dwSize > pHandle->pRtcdHeader->record_size) {	// ݃f[^TCYR[hTCY傫ꍇ̓G[Ƃ
		return EDGE_RTCD_BUFFER_SIZE_INVALID;			// obt@TCYsł
	}

	//--------------------------------------------------------------------
	// rpZ}tH擾
	//--------------------------------------------------------------------
	if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)				// ݃}`[ĥƂ
	{
		ret = WaitRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle, 100000);		// rpZ}tH擾(Timeout:10sec)
		if (ret != EDGE_SUCCESS) {
			return ret;														// G[R[hԂ
		}
	}

	//--------------------------------------------------------------------
	// ݏ݈ʒũR[hwb_[|C^擾
	//--------------------------------------------------------------------
	dwWritePos = pHandle->pRtcdHeader->write_pos;																	// ݂̏݃R[hʒu(CfbNX)擾
	pRec = pHandle->pRtcdData + ((sizeof(EDGE_RECORD_HEADER) + pHandle->pRtcdHeader->record_size) * dwWritePos);	// ݃R[hʒũ|C^擾
	pRecHeader = (EDGE_RECORD_HEADER*)pRec;																			// R[hwb_[Ƀ|C^ϊ

	//--------------------------------------------------------------------
	// obt@t`FbN
	//--------------------------------------------------------------------
	dwNextWritePos = NEXT_POS(dwWritePos, pHandle->pRtcdHeader->record_num);	// ݈ʒu擾

	if (dwNextWritePos == pHandle->pRtcdHeader->read_pos)						// ݈ʒuƓǍ݈ʒuƂ
	{
		pHandle->pRtcdHeader->lost_count++;										// JE^CNg(RTCDwb_)
		pRecHeader->lost_count++;												// JE^CNg(RTCDR[hwb_)

		if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)				// ݃}`[ĥƂ
		{
			ret = ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle);			// rpZ}tH
			if (ret != EDGE_SUCCESS) {
				return ret;														// G[R[hԂ
			}
		}

		return EDGE_RTCD_BUFFER_FULL_ERROR;										// obt@tG[
	}

	//--------------------------------------------------------------------
	// ݓ擾
	//--------------------------------------------------------------------
	GetNowTime(&pRecHeader->time, &pRecHeader->millisecond, &pRecHeader->microsecond);

	//--------------------------------------------------------------------
	// RTCDɃR[hf[^
	//--------------------------------------------------------------------
	pRecHeader->time		= pRecHeader->time;						// W (1970N11̌oߕb)
    pRecHeader->millisecond = pRecHeader->millisecond;				// W ~b
    pRecHeader->microsecond	= pRecHeader->microsecond;				// W }CNb
	pRecHeader->size		= dwSize;								// f[^TCY(bytes)
	pRecHeader->reserve[0]	= 0;									// \
	pRecHeader->reserve[1]	= 0;									// \
	pRecHeader->reserve[2]	= 0;									// \
	pRecHeader->reserve[3]	= 0;									// \
	pRecHeader->reserve[4]	= 0;									// \
	pRecHeader->reserve[5]	= 0;									// \
	pRecHeader->reserve[6]	= 0;									// \
	pRecHeader->reserve[7]	= 0;									// \
	pRecHeader->reserve[8]	= 0;									// \
	pRecHeader->reserve[9]	= 0;									// \
	pRecHeader->reserve[10]	= 0;									// \
	pRecHeader->reserve[11]	= 0;									// \
	pRecHeader->reserve[12]	= 0;									// \
	pRecHeader->reserve[13]	= 0;									// \
	pRecHeader->reserve[14]	= 0;									// \
	pRecHeader->reserve[15]	= 0;									// \
	pRecHeader->reserve[16]	= 0;									// \
	pRecHeader->reserve[17]	= 0;									// \

	memcpy(pRec + sizeof(EDGE_RECORD_HEADER), pBuffer, dwSize);		// ݃R[hʒũf[^Ɏw肳ꂽf[^
	pHandle->pRtcdHeader->write_pos = dwNextWritePos;				// ݈̏ʒuRTCDwb_[ɏ

	//------------------------------------------------------------------------------
	// ݒʒmZ}tHɒʒm
	// ӓ_ɂĂ͖{t@C̃wb_[RgQ
	//------------------------------------------------------------------------------
	ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem2_handle);				// ݒʒmZ}tH𑗐M

	//--------------------------------------------------------------------
	// rpZ}tH
	//--------------------------------------------------------------------
	if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)		// ݃}`[ĥƂ
	{
		ret = ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle);	// rpZ}tH
		if (ret != EDGE_SUCCESS) {
			return ret;												// G[R[hԂ
		}
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDɃR[h
  : pHandle [in] RTCDnh
		pBuffer1 [in] ݃wb_obt@
		dwSize1  [in] ݃wb_TCY(bytes)
		pBuffer2 [in] ݃f[^obt@
		dwSize2  [in] ݃f[^TCY(bytes)
߂l: Xe[^XR[h
  : 2023.03.28 {{  VK쐬 GbW[{bNXp ʂ̃f[^̊֐ŏ
--------------------------------------------------------------------------------*/
egRTCD_API int edgeWriteRTCD4Mbox(RTCDHANDLE *pHandle, void *pBuffer1, DWORD dwSize1, void *pBuffer2, DWORD dwSize2)
{
	int					ret;
	DWORD				dwWritePos;
	DWORD				dwNextWritePos;
	EDGE_RECORD_HEADER	*pRecHeader = NULL;
	BYTE				*pRec = NULL;
	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {								// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}

	if (pHandle->pRtcdHeader == NULL) {					// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}

	if (pHandle->pRtcdData == NULL) {					// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;				// nhsł
	}

	if (pBuffer1 == NULL) {								// ݃f[^obt@`FbN
		return EDGE_RTCD_BUFFER_INVALID;				// obt@sł
	}

	// pBuffer2ĂG[ɂȂ
	
	if (dwSize1 + dwSize2 == 0) {						// ݃f[^TCY`FbN
		return EDGE_RTCD_WRITE_SIZE_INVALID;			// ݃TCYsł
	}

	if (dwSize1 + dwSize2 > pHandle->pRtcdHeader->record_size) {	// ݃f[^TCYR[hTCY傫ꍇ̓G[Ƃ
		return EDGE_RTCD_BUFFER_SIZE_INVALID;			// obt@TCYsł
	}

	//--------------------------------------------------------------------
	// rpZ}tH擾
	//--------------------------------------------------------------------
	if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)				// ݃}`[ĥƂ
	{
		ret = WaitRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle, 100000);		// rpZ}tH擾(Timeout:10sec)
		if (ret != EDGE_SUCCESS) {
			return ret;														// G[R[hԂ
		}
	}

	//--------------------------------------------------------------------
	// ݏ݈ʒũR[hwb_[|C^擾
	//--------------------------------------------------------------------
	dwWritePos = pHandle->pRtcdHeader->write_pos;																	// ݂̏݃R[hʒu(CfbNX)擾
	pRec = pHandle->pRtcdData + ((sizeof(EDGE_RECORD_HEADER) + pHandle->pRtcdHeader->record_size) * dwWritePos);	// ݃R[hʒũ|C^擾
	pRecHeader = (EDGE_RECORD_HEADER*)pRec;																			// R[hwb_[Ƀ|C^ϊ

	//--------------------------------------------------------------------
	// obt@t`FbN
	//--------------------------------------------------------------------
	dwNextWritePos = NEXT_POS(dwWritePos, pHandle->pRtcdHeader->record_num);	// ݈ʒu擾

	if (dwNextWritePos == pHandle->pRtcdHeader->read_pos)						// ݈ʒuƓǍ݈ʒuƂ
	{
		pHandle->pRtcdHeader->lost_count++;										// JE^CNg(RTCDwb_)
		pRecHeader->lost_count++;												// JE^CNg(RTCDR[hwb_)

		if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)				// ݃}`[ĥƂ
		{
			ret = ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle);			// rpZ}tH
			if (ret != EDGE_SUCCESS) {
				return ret;														// G[R[hԂ
			}
		}

		return EDGE_RTCD_BUFFER_FULL_ERROR;										// obt@tG[
	}

	//--------------------------------------------------------------------
	// ݓ擾
	//--------------------------------------------------------------------
	//GetNowTime(&pRecHeader->time, &pRecHeader->millisecond, &pRecHeader->microsecond);

	//--------------------------------------------------------------------
	// RTCDɃR[hf[^
	//--------------------------------------------------------------------
	pRecHeader->time = pRecHeader->time;						// W (1970N11̌oߕb)
	pRecHeader->millisecond = pRecHeader->millisecond;				// W ~b
	pRecHeader->microsecond = pRecHeader->microsecond;				// W }CNb
	pRecHeader->size = dwSize1 + dwSize2;								// f[^TCY(bytes)
	pRecHeader->reserve[0] = 0;									// \
	pRecHeader->reserve[1] = 0;									// \
	pRecHeader->reserve[2] = 0;									// \
	pRecHeader->reserve[3] = 0;									// \
	pRecHeader->reserve[4] = 0;									// \
	pRecHeader->reserve[5] = 0;									// \
	pRecHeader->reserve[6] = 0;									// \
	pRecHeader->reserve[7] = 0;									// \
	pRecHeader->reserve[8] = 0;									// \
	pRecHeader->reserve[9] = 0;									// \
	pRecHeader->reserve[10] = 0;									// \
	pRecHeader->reserve[11] = 0;									// \
	pRecHeader->reserve[12] = 0;									// \
	pRecHeader->reserve[13] = 0;									// \
	pRecHeader->reserve[14] = 0;									// \
	pRecHeader->reserve[15] = 0;									// \
	pRecHeader->reserve[16] = 0;									// \
	pRecHeader->reserve[17] = 0;									// \

	memcpy(pRec + sizeof(EDGE_RECORD_HEADER), pBuffer1, dwSize1);		// ݃R[hʒũf[^Ɏw肳ꂽf[^
	if(pBuffer2 != NULL && dwSize2 > 0)								// w肪ꍇ̂ݏ
		memcpy(pRec + sizeof(EDGE_RECORD_HEADER) + dwSize1, pBuffer2, dwSize2);		// ݃R[hʒũf[^Ɏw肳ꂽf[^

	pHandle->pRtcdHeader->write_pos = dwNextWritePos;				// ݈̏ʒuRTCDwb_[ɏ
	
	//------------------------------------------------------------------------------
	// ݒʒmZ}tHɒʒm
	// ӓ_ɂĂ͖{t@C̃wb_[RgQ
	//------------------------------------------------------------------------------
	ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem2_handle);				// ݒʒmZ}tH𑗐M

	//--------------------------------------------------------------------
	// rpZ}tH
	//--------------------------------------------------------------------
	if (pHandle->pRtcdHeader->write_mode == RTCD_WRITE_MULTI)		// ݃}`[ĥƂ
	{
		ret = ReleaseRTCDSemaphore((OBJHANDLE)pHandle->pSem1_handle);	// rpZ}tH
		if (ret != EDGE_SUCCESS) {
			return ret;												// G[R[hԂ
		}
	}

	return EDGE_SUCCESS;
}
/*------------------------------------------------------------------------------
Tv  : RTCD烌R[hǂݍ
  : pHandle      [in]  RTCDnh
        pBuffer      [in]  Ǎ݃f[^obt@
        dwBufferSize [in]  Ǎ݃f[^obt@TCY(bytes)
        pDataTime    [out] R[hwb_[
        dwTimeout    [in]  ^CAEg(msec)
߂l: Xe[^XR[h
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeReadRTCD(RTCDHANDLE *pHandle, void *pBuffer, DWORD dwBufferSize, EDGE_RECORD_HEADER *pDataTime, DWORD dwTimeout)
{
	int					ret;
	BYTE				*pRec = NULL;
	DWORD				dwCount;				// Ǎ݃R[h
	EDGE_RECORD_HEADER	*pRecHeader = NULL;

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {									// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}
	
	if (pHandle->pRtcdHeader == NULL) {						// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}
	
	if (pHandle->pRtcdData == NULL) {						// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}
	
	if (pBuffer == NULL) {									// Ǎ݃f[^obt@`FbN
		return EDGE_RTCD_BUFFER_INVALID;					// obt@sł
	}
	
	if (dwBufferSize == 0) {								// Ǎ݃f[^obt@TCY`FbN
		return EDGE_RTCD_BUFFER_SIZE_INVALID;				// obt@TCYsł
	}
	
	if (dwBufferSize < pHandle->pRtcdHeader->record_size) { // Ǎ݃f[^obt@TCYR[hTCY菬ꍇ̓G[Ƃ
		return EDGE_RTCD_BUFFER_SIZE_INVALID;				// obt@TCYsł
	}

	//--------------------------------------------------------------------
	// ݒʒmM
	//--------------------------------------------------------------------
	dwCount = pHandle->pRtcdHeader->record_num - pHandle->pRtcdHeader->read_pos + pHandle->pRtcdHeader->write_pos;	// Ǎ݃R[h擾
	if (dwCount >= pHandle->pRtcdHeader->record_num) {
		dwCount = dwCount - pHandle->pRtcdHeader->record_num;
	}
	
	if (dwCount == 0)																// Ǎ݃R[h0̂Ƃ(݃R[hƂ)
	{
		while(1){																	// ݒʒmZ}tHM܂őҋ@
																					// ӓ_ɂĂ͖{t@C̃wb_[RgQ
			ret = WaitRTCDSemaphore((OBJHANDLE)pHandle->pSem2_handle, dwTimeout);		// ݒʒmZ}tHMҋ@(^CAEgL)
			if (ret != EDGE_SUCCESS) {
				if (ret == EDGE_RTCD_SEMAPHORE_TIMEOUT) {							// Z}tH^CAEĝƂ
					return EDGE_RTCD_NO_UPDATE;										// f[^XV܂
				} else {
					return ret;														// ԂĂG[R[ĥ܂ܕԂ
				}
			}

			if (pHandle->pRtcdHeader->read_pos != pHandle->pRtcdHeader->write_pos){ // Ǎ݈ʒuƏ݈ʒuقȂƂ̓R[hǍ݂s߃[v𔲂
				break;
			}
		}
	}

	//--------------------------------------------------------------------
	// RTCD烌R[hf[^Ǎ
	//--------------------------------------------------------------------
	pRec = pHandle->pRtcdData + ((sizeof(EDGE_RECORD_HEADER) + pHandle->pRtcdHeader->record_size) * pHandle->pRtcdHeader->read_pos);	// Ǎ݃R[hʒũ|C^擾
	if (pDataTime != NULL) {																											// R[hwb_[̎w肪LȂƂ
		memcpy(pDataTime, pRec, sizeof(EDGE_RECORD_HEADER));																			// RTCD烌R[hwb_[ǂݍ
	}
	memcpy(pBuffer, pRec + sizeof(EDGE_RECORD_HEADER), pHandle->pRtcdHeader->record_size);												// RTCD烌R[hf[^ǂݍ

	//--------------------------------------------------------------------
	// JE^NA
	//--------------------------------------------------------------------
	pRecHeader = (EDGE_RECORD_HEADER*)pRec;		// R[hwb_[Ƀ|C^ϊ
	pRecHeader->lost_count = 0;					// JE^NA

	//--------------------------------------------------------------------
	// Ǎ݈ʒuCNg
	//--------------------------------------------------------------------
	pHandle->pRtcdHeader->read_pos = NEXT_POS(pHandle->pRtcdHeader->read_pos, pHandle->pRtcdHeader->record_num);	// Ǎ݈ʒuLɏ

	return EDGE_SUCCESS;
}
/*------------------------------------------------------------------------------
Tv  : RTCD烌R[hǂݍ
  : pHandle      [in]  RTCDnh
		pBuffer1      [in]  Ǎ݃wb_obt@
		dwBufferSize1 [in]  Ǎ݃wb_obt@TCY(bytes)
		pBuffer2      [in]  Ǎ݃f[^obt@
		dwBufferSize2 [in]  Ǎ݃f[^obt@TCY(bytes)
		pDataTime    [out] R[hwb_[
		dwTimeout    [in]  ^CAEg(msec)
߂l: Xe[^XR[h
  : 2023.03.29 {{  VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeReadRTCD4Mbox(RTCDHANDLE *pHandle, void *pBuffer1, DWORD dwBufferSize1, void *pBuffer2, DWORD dwBufferSize2, EDGE_RECORD_HEADER *pDataTime, DWORD dwTimeout)
{
	int					ret;
	BYTE				*pRec = NULL;
	DWORD				dwCount;				// Ǎ݃R[h
	EDGE_RECORD_HEADER	*pRecHeader = NULL;

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {									// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}

	if (pHandle->pRtcdHeader == NULL) {						// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}

	if (pHandle->pRtcdData == NULL) {						// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}

	if (pBuffer1 == NULL) {									// Ǎ݃f[^obt@`FbN
		return EDGE_RTCD_BUFFER_INVALID;					// obt@sł
	}

	if (dwBufferSize1 == 0) {								// Ǎ݃f[^obt@TCY`FbN
		return EDGE_RTCD_BUFFER_SIZE_INVALID;				// obt@TCYsł
	}

	if (pBuffer2 == NULL && dwBufferSize2 > 0) {			// Ǎ݃f[^obt@`FbN
		return EDGE_RTCD_BUFFER_INVALID;					// obt@sł
	}

	if ((dwBufferSize1 + dwBufferSize2) < pHandle->pRtcdHeader->record_size) { // Ǎ݃f[^obt@TCYR[hTCY菬ꍇ̓G[Ƃ
		return EDGE_RTCD_BUFFER_SIZE_INVALID;				// obt@TCYsł
	}

	//--------------------------------------------------------------------
	// ݒʒmM
	//--------------------------------------------------------------------
	dwCount = pHandle->pRtcdHeader->record_num - pHandle->pRtcdHeader->read_pos + pHandle->pRtcdHeader->write_pos;	// Ǎ݃R[h擾
	if (dwCount >= pHandle->pRtcdHeader->record_num) {
		dwCount = dwCount - pHandle->pRtcdHeader->record_num;
	}

	if (dwCount == 0)																// Ǎ݃R[h0̂Ƃ(݃R[hƂ)
	{
		while (1) {																	// ݒʒmZ}tHM܂őҋ@
																					// ӓ_ɂĂ͖{t@C̃wb_[RgQ
			ret = WaitRTCDSemaphore((OBJHANDLE)pHandle->pSem2_handle, dwTimeout);		// ݒʒmZ}tHMҋ@(^CAEgL)
			if (ret != EDGE_SUCCESS) {
				if (ret == EDGE_RTCD_SEMAPHORE_TIMEOUT) {							// Z}tH^CAEĝƂ
					return EDGE_RTCD_NO_UPDATE;										// f[^XV܂
				}
				else {
					return ret;														// ԂĂG[R[ĥ܂ܕԂ
				}
			}

			if (pHandle->pRtcdHeader->read_pos != pHandle->pRtcdHeader->write_pos) { // Ǎ݈ʒuƏ݈ʒuقȂƂ̓R[hǍ݂s߃[v𔲂
				break;
			}
		}
	}

	//--------------------------------------------------------------------
	// RTCD烌R[hf[^Ǎ
	//--------------------------------------------------------------------
	pRec = pHandle->pRtcdData + ((sizeof(EDGE_RECORD_HEADER) + pHandle->pRtcdHeader->record_size) * pHandle->pRtcdHeader->read_pos);	// Ǎ݃R[hʒũ|C^擾
	if (pDataTime != NULL) {																											// R[hwb_[̎w肪LȂƂ
		memcpy(pDataTime, pRec, sizeof(EDGE_RECORD_HEADER));																			// RTCD烌R[hwb_[ǂݍ
	}
	memcpy(pBuffer1, pRec + sizeof(EDGE_RECORD_HEADER), dwBufferSize1);												// RTCD烌R[hf[^ǂݍ
	memcpy(pBuffer2, pRec + sizeof(EDGE_RECORD_HEADER) + dwBufferSize1, pHandle->pRtcdHeader->record_size - dwBufferSize1);												// RTCD烌R[hf[^ǂݍ

	//--------------------------------------------------------------------
	// JE^NA
	//--------------------------------------------------------------------
	pRecHeader = (EDGE_RECORD_HEADER*)pRec;		// R[hwb_[Ƀ|C^ϊ
	pRecHeader->lost_count = 0;					// JE^NA

	//--------------------------------------------------------------------
	// Ǎ݈ʒuCNg
	//--------------------------------------------------------------------
	pHandle->pRtcdHeader->read_pos = NEXT_POS(pHandle->pRtcdHeader->read_pos, pHandle->pRtcdHeader->record_num);	// Ǎ݈ʒuLɏ

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCD擾
  : pHandle [in]  RTCDnh
        pInfo   [out] RTCD
߂l: Xe[^XR[h
  : 2019.08.05 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeGetRTCDInfo(RTCDHANDLE *pHandle, EDGE_RTCD_HEADER *pInfo)
{
	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {					// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}
	
	if (pHandle->pRtcdHeader == NULL) {		// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}
	
	if (pHandle->pRtcdData == NULL) {		// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;	// nhsł
	}
	
	if (pInfo == NULL) {					// RTCD`FbN
		return EDGE_RTCD_INFO_INVALID;		// RTCD񂪕sł
	}

	//--------------------------------------------------------------------
	// RTCDԂ
	//--------------------------------------------------------------------
	memcpy(pInfo, pHandle->pRtcdHeader, sizeof(EDGE_RTCD_HEADER));

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCD̓Ǎ/݃I[vJE^NA
  : pName   [in] RTCD
        dwAccess[in] ANZX[h
߂l: Xe[^XR[h
  : 2019.12.18 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeClearRTCDCounter(const char *pName, DWORD dwAccess)
{
	int					ret;
	size_t				len;
	char				szName[16];			// RTCDJ^O
	char				szSem1Name[16];		// rpZ}tHJ^O
	char				szSem2Name[16];		// ʒmpZ}tHJ^O
	BYTE				*pMem = NULL;		// RTCD}bsO|C^
	EDGE_RTCD_HEADER	*pHeader = NULL;	// RTCDwb_[
	void				*hMap = NULL;		// RTCDnh
	void				*hSem1 = NULL;		// rpZ}tHnh
	void				*hSem2 = NULL;		// ʒmpZ}tHnh
	RTCDHANDLE			handle;				// RTCDnh

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pName == NULL) {												// RTCD̃`FbN
		return EDGE_RTCD_NAME_INVALID;									// RTCD̂sł
	}
	
	len = strlen(pName);
	if ( (len <= 0) || (len > RTCD_NAME_LEN_MAX) ) {					// RTCD̕`FbN
		return EDGE_RTCD_NAME_LENGTH_ERROR;								// RTCD̂̕G[
	}
	
	if ( (dwAccess < RTCD_READ) || (dwAccess > RTCD_READWRITE) ) {		// ANZX[h`FbN
		return EDGE_RTCD_ACCESS_MODE_ERROR;								// RTCDANZX[hG[
	}
	
	memset(szName, 0, sizeof(szName));									// RTCDJ^O
	sprintf_s(szName, sizeof(szName), RTCD_NAME_FORMAT, pName);

	memset(szSem1Name, 0, sizeof(szSem1Name));							// rpZ}tHJ^O
	sprintf_s(szSem1Name, sizeof(szSem1Name), SEM1_NAME_FORMAT, pName);

	memset(szSem2Name, 0, sizeof(szSem2Name));							// ʒmpZ}tHJ^O
	sprintf_s(szSem2Name, sizeof(szSem2Name), SEM2_NAME_FORMAT, pName);

	//--------------------------------------------------------------------
	// RTCDI[v(}bsO)
	//--------------------------------------------------------------------
	ret = OpenRTCD(szName, szSem1Name, szSem2Name, &pMem, &hMap, &hSem1, &hSem2);	// RTCDI[v
	if (ret != EDGE_SUCCESS) {
		return ret;						// G[R[hԂ
	}

	pHeader = (EDGE_RTCD_HEADER*)pMem;	// RTCDwb_[|C^擾

	//--------------------------------------------------------------------
	// RTCDwb_[擾
	//--------------------------------------------------------------------
	handle.pRtcdHeader	= pHeader;								// RTCDwb_[̃|C^
	handle.pRtcdData	= pMem + sizeof(EDGE_RTCD_HEADER);		// RTCDf[^̃|C^
	handle.pMem_handle	= hMap;									// RTCDnh
	handle.pSem1_handle	= hSem1;								// rpZ}tHnh
	handle.pSem2_handle	= hSem2;								// ʒmpZ}tHnh
	handle.access		= dwAccess;								// ANZX[h

	//--------------------------------------------------------------------
	// Ǎ/݃I[vJE^̃NA
	//--------------------------------------------------------------------
	if ( (dwAccess == RTCD_READ) || (dwAccess == RTCD_READWRITE) )	// Ǎ݃ANZX ܂ ǏANZX̂Ƃ
	{
		pHeader->read_open_count = 0;								// Ǎ݃I[vJE^NA
	}

	if ( (dwAccess == RTCD_WRITE) || (dwAccess == RTCD_READWRITE) ) // ݃ANZX ܂ ǏANZX̂Ƃ
	{
		pHeader->write_open_count = 0;								// ݃I[vJE^NA
	}

	//--------------------------------------------------------------------
	// RTCDN[Y
	//--------------------------------------------------------------------
	ret = CloseRTCD(&handle);				// RTCDN[Y(A}bv)
	if (ret != EDGE_SUCCESS) {
		return ret;							// G[R[hԂ
	}

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCDnhÓ𔻒肷
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.12.19 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeIsRTCDHandle(RTCDHANDLE *pHandle)
{
	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (pHandle == NULL) {									// RTCDnh`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}
	
	if (pHandle->pRtcdHeader == NULL) {						// RTCDwb_[|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}
	
	if (pHandle->pRtcdData == NULL) {						// RTCDf[^|C^`FbN
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}

	//--------------------------------------------------------------------
	// nhÓ`FbN
	//--------------------------------------------------------------------
	if (pHandle->code != RTCD_HANDLE_CODE) {
		return EDGE_RTCD_HANDLE_INVALID;					// nhsł
	}

	return EDGE_SUCCESS;
}
