////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge RTCD֘A@\API NTXp\[Xt@C
: {t@CɂNTXɈˑLqĂ܂B
: 2019.08.08 VK쐬
      2019.12.09 RTCDR[hwb_[ oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/

#include "stdafx.h"
#include <ntx.h>
#include "egRTCDntx.h"


#if defined(_MSC_VER) || defined(_MSC_EXTENSIONS)
	#define DELTA_EPOCH_IN_MICROSECS  11644473600000000Ui64
#else
	#define DELTA_EPOCH_IN_MICROSECS  11644473600000000ULL
#endif

static NTXLOCATION		hRtcdLoc = NTX_UNDEFINED_LOCATION;	// RTCDnodẽP[Vnh


BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}


//------------------------------------------------------------------------------
// [J֐
//------------------------------------------------------------------------------
/*****************************************************************************
* FUNCTION:		edge_setNode
* DESCRIPTION:
*   ()RTCD쐬m[hZbg
\*****************************************************************************/
int _edge_setNode(NTXLOCATION hLoc)
{
	NTXHANDLE	hRoot;
	NTXHANDLE	hMem = NTX_BAD_NTXHANDLE;

	if (hRtcdLoc != NTX_UNDEFINED_LOCATION)
	{
		return EDGE_RTCD_EXIST_ERROR;	// Ɏ擾ς̏ꍇ͖
	}

	if (hLoc != NTX_UNDEFINED_LOCATION) {
		hRoot = ntxGetRootRtProcess(hLoc);
		if (hRoot != NTX_BAD_NTXHANDLE) {
			hMem = ntxAllocateRtMemory(hLoc, 1);	// m
			if (hMem == NTX_BAD_NTXHANDLE)
				goto failed;

			ntxCatalogNtxHandle(hRoot, hMem, (LPSTR)EGRTCDNODE);	// J^O
			hRtcdLoc = hLoc;
			return EDGE_SUCCESS;
		}
	}
	return EDGE_LOCATION_ERROR;
failed:
	if (hMem != NTX_NULL_NTXHANDLE)
		ntxFreeRtMemory(hMem);
	return EDGE_LOCATION_ERROR;
}

/*****************************************************************************
* FUNCTION:		edge_setNode
* DESCRIPTION:
*   ()RTCD쐬m[hZbg
\*****************************************************************************/
int edge_setNode(const char *Name)
{
	NTXLOCATION hLoc;

	if (hRtcdLoc != NTX_UNDEFINED_LOCATION)
	{
		return EDGE_RTCD_EXIST_ERROR;			// Ɏ擾ς̏ꍇ͖
	}

	hLoc = ntxGetLocationByName(Name);	// P[Vnh擾
	if (hLoc != NTX_UNDEFINED_LOCATION) {
		return _edge_setNode(hLoc);
	}
	return EDGE_LOCATION_ERROR;
}
/*****************************************************************************
* FUNCTION:		searchRTCD
* DESCRIPTION:
*   ()RTCD̃J^O
\*****************************************************************************/
NTXHANDLE searchRTCD(NTXLOCATION hLoc)
{
	NTXHANDLE	hRoot = NTX_BAD_NTXHANDLE;
	NTXHANDLE	hMem = NTX_BAD_NTXHANDLE;		// Lnh
	WORD		wRet;

	hRoot = ntxGetRootRtProcess(hLoc);	// w肳ꂽP[Ṽ[gvZX擾
	if (hRoot == NTX_BAD_NTXHANDLE) {
		return NTX_BAD_NTXHANDLE;
	}

	hMem = ntxLookupNtxHandle(hRoot, (LPSTR)EGRTCDNODE, NO_WAIT);	// RTCDbNAbv
	if (hMem == NTX_BAD_NTXHANDLE) {
		return NTX_BAD_NTXHANDLE;
	}

	wRet = ntxGetType(hMem);
	if (wRet == NTX_TYPE_RT_SHARED_MEMORY) {
		return hRoot;
	}

	return NTX_BAD_NTXHANDLE;
}

/*****************************************************************************
* FUNCTION:		GetLocationRTCD
* DESCRIPTION:
*   ()RTCD݂m[h̃P[Vnh擾
\*****************************************************************************/
NTXLOCATION GetLocationRTCD()
{
	NTXLOCATION hLoc;
	NTXHANDLE hRoot;
	bool isExist = false;

	if (hRtcdLoc != NTX_UNDEFINED_LOCATION)
	{
		return hRtcdLoc;							// Ɏ擾ςȂI
	}

	// find all nodes
	hLoc = ntxGetFirstLocation();			// ŏ̃P[V擾
	while (hLoc != NTX_UNDEFINED_LOCATION) {
		// m[hNĂ邩`FbN
		NTXSTATUS sts = ntxGetRtStatus(hLoc);
		if (sts == E_OK)
		{
			hRoot = searchRTCD(hLoc);					// RTCDJ^O
			if (hRoot != NTX_BAD_NTXHANDLE) {			// ꍇAnhێ
				hRtcdLoc = hLoc;
				break;
			}
		}
		hLoc = ntxGetNextLocation(hLoc);		// ̃P[V擾
	};

	if (hRtcdLoc == NTX_UNDEFINED_LOCATION) {
		// Ȃꍇ́A[Jm[h擾
		hLoc = NTX_LOCAL;
		NTXSTATUS sts = ntxGetRtStatus(hLoc);
		if (sts == E_OK)
		{
			_edge_setNode(hLoc);
		}
	}
	return hRtcdLoc;
}


/*------------------------------------------------------------------------------
Tv  : t@CpXt@C(vZX)擾
  : pPath     [in]  t@CpX
        pFileName [out] t@Cobt@
        buffSize  [in]  obt@TCY(bytes)
߂l: t@C̕TCY(bytes)
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
static int GetFileName(char *pPath, char *pFileName, int buffSize)
{
	int result = 0;
    char *p;
	char *pPeriod;
    p = &pPath[0];

	while(p != NULL)
	{
		p = strrchr(p, '\\');
        if( p ) {
            p++;
			pPeriod = strrchr(p, '.');
			if( pPeriod ) {
				result = (int)(pPeriod - p);					// vZXoCg
				strncpy_s(pFileName, buffSize, p, pPeriod - p);	// vZXRs[
			}
			break;
        }
    }

	return result;	// vZXoCgԂ
}


/*------------------------------------------------------------------------------
Tv  : ̃vZX擾
  : pProcessName [out] vZXobt@
        buffSize     [in]  obt@TCY(bytes)
߂l: true: false:s
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
static BOOL GetMyProcessName(char *pProcessName, int buffSize)
{
	DWORD dwRet;
	TCHAR szPath[MAX_PATH];
	char szDrive[4];
	char szDir[MAX_PATH];
	char szExt[8];

	memset(szPath, 0, sizeof(szPath));

	dwRet = GetModuleFileName(NULL, szPath, sizeof(szPath));
	if (dwRet == 0) {
		return FALSE;
	}

	memset(pProcessName, 0, buffSize);

	_splitpath_s(szPath, szDrive, sizeof(szDrive), szDir, sizeof(szDir), pProcessName, buffSize, szExt, sizeof(szExt));

	return TRUE;
}


struct timezone
{
	int tz_minuteswest; // minutes W of Greenwich
	int tz_dsttime;     // type of dst correction
};

struct timeval64 {
    long long tv_sec;
    long tv_usec;
};

/*------------------------------------------------------------------------------
Tv  : ݎ擾(Windows)
  : tv [out] ݎ 1970.01.01̌oߕbA}CNbԂ
߂l: 0:I 0ȊO:ُI
  : 2019.08.02 VK쐬
        2019.12.09 oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/
static int gettimeofdayWin(struct timeval64 *tv)
{
	FILETIME ft;
	unsigned __int64 tmpres = 0;

	if (NULL != tv)
	{
		GetSystemTimePreciseAsFileTime(&ft);

		tmpres |= ft.dwHighDateTime;
		tmpres <<= 32;
		tmpres |= ft.dwLowDateTime;
		tmpres /= 10;								// convert into microseconds

		tmpres -= DELTA_EPOCH_IN_MICROSECS;			// converting file time to unix epoch
		tv->tv_sec = (long long)(tmpres / 1000000UL);
		tv->tv_usec = (long)(tmpres % 1000000UL);
	}

	return 0;
}


//------------------------------------------------------------------------------
// O[o֐
//------------------------------------------------------------------------------

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
        {Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
        pMillisecond [out] ݎ ~bԂ
        pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2019.08.02 VK쐬
        2019.12.09 oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/
void GetNowTime(unsigned long long *pTime, WORD *pMillisecond, WORD *pMicrosecond)
{
	struct timeval64 tv;
	int ret;

	ret = gettimeofdayWin(&tv);	// ݎ擾

	*pTime = tv.tv_sec;
	*pMillisecond = (WORD)(tv.tv_usec/1000);
	*pMicrosecond = (WORD)(tv.tv_usec%1000);
}

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
		{Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
		pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2020.08.04  u  VK쐬
--------------------------------------------------------------------------------*/
void GetNowTimeVal(unsigned long long *pTime, DWORD *pMicrosecond)
{
	struct timeval64 tv;
	int ret;

	ret = gettimeofdayWin(&tv);	// ݎ擾
	*pTime = tv.tv_sec;
	*pMicrosecond = tv.tv_usec;
}

/*------------------------------------------------------------------------------
Tv  : WindowsCxgOɕo͂
  : type     [in] Cxg̎
        category [in] Cxg̕
        eventId  [in] Cxgʎq
        szMsg    [in] CxgOɏo͂镶
߂l: 0:I 0ȊO:ُI
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
int WriteEventLog(WORD type, WORD category, DWORD eventId, const char *szMsg)
{
	char szMyProcName[64];
	char szLog[256];
	HANDLE hEvent;

	if (!GetMyProcessName(szMyProcName, sizeof(szMyProcName))) {	// vZX擾
		return -1;
	}

	memset(szLog, 0, sizeof(szLog));
	sprintf_s(szLog, sizeof(szLog), "RT-edge.%s", szMyProcName);	// CxgÕ\[X𐶐

	hEvent = RegisterEventSource(NULL, szLog);
	ReportEvent(hEvent, type, category, eventId, NULL, 1, 0, &szMsg, NULL);
	DeregisterEventSource(hEvent);									// CxgOɕo
	return 0;
}

/*------------------------------------------------------------------------------
Tv  : RTCD𐶐
  : pName      [in] RTCD
        dwRtcdSize [in] RTCDTCY(bytes)
        dwMode     [in] ݃[h 1:VO[h 2:}`[h
        dwLength   [in] R[h(bytes)
        dwNum      [in] R[h
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMemResult [out] RTCDʏ
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int CreateRTCD(char *pName, DWORD dwRtcdSize, DWORD dwMode, DWORD dwLength, DWORD dwNum, char *pSem1Name, char *pSem2Name, RTCD_MEM_RESULT *pMemResult)
{
	int			result = 0;
	WORD		wRet;
	BYTE		*pMem = NULL;
	NTXSTATUS	stat = 0;
	NTXLOCATION	hLoc = NTX_UNDEFINED_LOCATION;
	NTXHANDLE	hRoot = NTX_BAD_NTXHANDLE;			// [gvZXnh
	NTXHANDLE	hMem = NTX_BAD_NTXHANDLE;			// Lnh
	NTXHANDLE	hSem = NTX_BAD_NTXHANDLE;			// Z}tHnh(`FbNp)
	NTXHANDLE	hLockSem = NTX_BAD_NTXHANDLE;		// rpZ}tHnh
	NTXHANDLE	hNotifySem = NTX_BAD_NTXHANDLE;		// ʒmpZ}tHnh

	//--------------------------------------------------------------------
	// RTCDO`FbN
	//--------------------------------------------------------------------
	hLoc = GetLocationRTCD();										// P[Vnh擾
	if (hLoc == NTX_UNDEFINED_LOCATION) {
		return EDGE_LOCATION_ERROR;									// P[Vnh擾G[
	}

	stat = ntxGetRtStatus(hLoc);							// J[lNmF
	if (stat != E_OK) {
		return EDGE_KERNEL_NOT_RUNNING;								// J[lNĂ܂
	}

	hRoot = ntxGetRootRtProcess(hLoc);						// [gvZXnh擾
	if (hRoot == NTX_BAD_NTXHANDLE) {
		return EDGE_ROOTPROCESS_ERROR;								// [gvZX擾G[
	}

	hMem = ntxLookupNtxHandle(hRoot, pName, NO_WAIT);		// RTCDbNAbv
	if (hMem != NTX_BAD_NTXHANDLE) {
		wRet = ntxGetType(hMem);
		if (wRet == NTX_ERROR) {
			ntxUncatalogNtxHandle(hRoot, hMem, pName);		// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == NTX_TYPE_RT_SHARED_MEMORY) {
			return EDGE_RTCD_EXIST_ERROR;							// ɓRTCD݂܂
		} else {
			return EDGE_RTCD_NAME_EXIST_ERROR;						// ɓOgĂ܂
		}
	}

	hSem = ntxLookupNtxHandle(hRoot, pSem1Name, NO_WAIT);	// ̔rpZ}tHĂ邩`FbN
	if (hSem != NTX_BAD_NTXHANDLE) {
		wRet = ntxGetType(hSem);
		if (wRet == NTX_ERROR) {
			ntxUncatalogNtxHandle(hRoot, hSem, pSem1Name);	// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == NTX_TYPE_RT_SEMAPHORE) {
			return EDGE_RTCD_SEMAPHORE1_EXIST_ERROR;				// ɓZ}tH݂܂(rpZ}tH)
		} else {
			return EDGE_RTCD_SEMAPHORE1_NAME_EXIST_ERROR;			// ɓOgĂ܂(rpZ}tH)
		}
	}

	hSem = ntxLookupNtxHandle(hRoot, pSem2Name, NO_WAIT);	// ̏ʒmpZ}tHĂ邩`FbN
	if (hSem != NTX_BAD_NTXHANDLE) {
		wRet = ntxGetType(hSem);
		if (wRet == NTX_ERROR) {
			ntxUncatalogNtxHandle(hRoot, hSem, pSem2Name);	// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == NTX_TYPE_RT_SEMAPHORE) {
			return EDGE_RTCD_SEMAPHORE2_EXIST_ERROR;				// ɓZ}tH݂܂(ʒmpZ}tH)
		} else {
			return EDGE_RTCD_SEMAPHORE2_NAME_EXIST_ERROR;			// ɓOgĂ܂(ʒmpZ}tH)
		}
	}

	//--------------------------------------------------------------------
	// RTCD𐶐
	//--------------------------------------------------------------------
	hMem = ntxAllocateRtMemory(hLoc, dwRtcdSize);									// RTCDm
	if (hMem == NTX_BAD_NTXHANDLE) {
		result = EDGE_RTCD_ALLOCATE_ERROR;													// RTCDmێs
		goto ROLLBACK_1;
	}

	pMem = (BYTE*)ntxMapRtSharedMemoryEx(hMem, NTX_MAP_WRITE|NTX_MAP_UNALIGNED);	// RTCD}bsO
	if (pMem == NULL) {
		return EDGE_RTCD_MAPPING_ERROR;														// }bsOs
		goto ROLLBACK_2;
	}

	stat = ntxCatalogNtxHandle(hRoot, hMem, pName);								// J^O
	if (stat != E_OK) {
		result = EDGE_RTCD_CATALOG_ERROR;													// RTCDJ^Os
		goto ROLLBACK_3;
	}

	hLockSem = ntxCreateRtSemaphore(hLoc, 1, 1, NTX_FIFO_QUEUING);					// rpZ}tH
	if (hLockSem == NTX_BAD_NTXHANDLE ) {
		result = EDGE_RTCD_CREATE_SEMAPHORE1_ERROR;											// Z}tHG[(rpZ}tH)
		goto ROLLBACK_4;
	}

	stat = ntxCatalogNtxHandle(hRoot, hLockSem, pSem1Name);						// rpZ}tHJ^O
	if (stat != E_OK) {
		result = EDGE_RTCD_CATALOG_SEMAPHORE1_ERROR;										// Z}tHJ^OG[(rpZ}tH)
		goto ROLLBACK_5;
	}

	hNotifySem = ntxCreateRtSemaphore(hLoc, 0, dwNum, NTX_FIFO_QUEUING);				// ʒmpZ}tH
	if (hNotifySem == NTX_BAD_NTXHANDLE ) {
		result = EDGE_RTCD_CREATE_SEMAPHORE2_ERROR;											// Z}tHG[(ʒmpZ}tH)
		goto ROLLBACK_6;
	}

	stat = ntxCatalogNtxHandle(hRoot, hNotifySem, pSem2Name);						// ʒmpZ}tHJ^O
	if (stat != E_OK) {
		result = EDGE_RTCD_CATALOG_SEMAPHORE2_ERROR;										// Z}tHJ^OG[(ʒmpZ}tH)
		goto ROLLBACK_7;
	}

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
	if (result != 0) {												// rŃG[Ƃ
ROLLBACK_7:
		ntxDeleteRtSemaphore(hNotifySem);					// ʒmpZ}tH폜
ROLLBACK_6:
		ntxUncatalogNtxHandle(hRoot, hLockSem, pSem1Name);	// rpZ}tHAJ^O
ROLLBACK_5:
		ntxDeleteRtSemaphore(hLockSem);					// rpZ}tH폜
ROLLBACK_4:
		ntxUncatalogNtxHandle(hRoot, hMem, pName);			// RTCDAJ^O
ROLLBACK_3:
		ntxUnmapRtSharedMemory(hMem);						// LA}bv
ROLLBACK_2:
		ntxFreeRtMemory(hMem);								// RTCD
ROLLBACK_1:
		return result;												// G[R[hԂ
	}

	//--------------------------------------------------------------------
	// RTCDʏ
	//--------------------------------------------------------------------
	memset(pMemResult, 0, sizeof(RTCD_MEM_RESULT));
	pMemResult->pMem = pMem;										// RTCD|C^
	pMemResult->hMem = (OBJHANDLE)hMem;									// RTCDnh
	pMemResult->hLockSem = (OBJHANDLE)hLockSem;							// Z}tHnh(rp)
	pMemResult->hNotifySem = (OBJHANDLE)hNotifySem;						// Z}tHnh(ݒʒmp)

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCD폜
  : pName     [in] RTCD
        pRtcdInfo [in] 
        pSem1Name [in] rpZ}tH
        pSem2Name [in] ʒmpZ}tH
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int DeleteRTCD(char *pName, RTCDMEMINFO *pRtcdInfo, char *pSem1Name, char *pSem2Name)
{
	NTXSTATUS			stat = 0;
	NTXLOCATION			hLoc = NTX_UNDEFINED_LOCATION;
	NTXHANDLE			hRoot = NTX_BAD_NTXHANDLE;					// [gvZXnh

	//--------------------------------------------------------------------
	// RTCDO`FbN
	//--------------------------------------------------------------------
	hLoc = GetLocationRTCD();										// P[Vnh擾
	if (hLoc == NTX_UNDEFINED_LOCATION) {
		return EDGE_LOCATION_ERROR;									// P[Vnh擾G[
	}

	stat = ntxGetRtStatus(hLoc);							// J[lNmF
	if (stat != E_OK) {
		return EDGE_KERNEL_NOT_RUNNING;								// J[lNĂ܂
	}

	hRoot = ntxGetRootRtProcess(hLoc);						// [gvZXnh擾
	if (hRoot == NTX_BAD_NTXHANDLE) {
		return EDGE_ROOTPROCESS_ERROR;								// [gvZX擾G[
	}

	//--------------------------------------------------------------------
	// RTCD폜
	//--------------------------------------------------------------------
	stat = ntxUncatalogNtxHandle(hRoot, (NTXHANDLE)pRtcdInfo->mem_handle, pName);			// RTCDAJ^O
	stat = ntxUncatalogNtxHandle(hRoot, (NTXHANDLE)pRtcdInfo->sem1_handle, pSem1Name);		// rpZ}tHAJ^O
	stat = ntxUncatalogNtxHandle(hRoot, (NTXHANDLE)pRtcdInfo->sem2_handle, pSem2Name);		// ʒmpZ}tHAJ^O

	stat = ntxDeleteRtSemaphore((NTXHANDLE)pRtcdInfo->sem1_handle);						// rpZ}tH폜
	if (stat != E_OK) {
		return EDGE_RTCD_DELETE_SEMAPHORE1_ERROR;													// Z}tH폜G[(rpZ}tH)
	}

	stat = ntxDeleteRtSemaphore((NTXHANDLE)pRtcdInfo->sem2_handle);						// ʒmpZ}tH폜
	if (stat != E_OK){
		return EDGE_RTCD_DELETE_SEMAPHORE2_ERROR;													// Z}tH폜G[(ʒmpZ}tH)
	}

	stat = ntxFreeRtMemory((NTXHANDLE)pRtcdInfo->mem_handle);								// RTCDnh폜
	if (stat != E_OK){
		return	EDGE_RTCD_DELETE_MEM_HANDLE_ERROR;													// nh폜G[
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDI[v
  : pName      [in] RTCD
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMem       [out] RTCD}bsÕ|C^
        pMap       [out] RTCDnh̃|C^
        pSem1      [out] rpZ}tHnh̃|C^
        pSem2      [out] ʒmpZ}tHnh̃|C^
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int OpenRTCD(char *pName, char *pSem1Name, char *pSem2Name, BYTE **pMem, void **pMap, void **pSem1, void **pSem2)
{
	WORD		wRet;
	NTXSTATUS	stat = 0;
	NTXLOCATION	hLoc = NTX_UNDEFINED_LOCATION;
	NTXHANDLE	hRoot = NTX_BAD_NTXHANDLE;			// [gvZXnh
	NTXHANDLE	hMem = NTX_BAD_NTXHANDLE;			// Lnh
	NTXHANDLE	hSem1 = NTX_BAD_NTXHANDLE;			// rpZ}tHnh
	NTXHANDLE	hSem2 = NTX_BAD_NTXHANDLE;			// ʒmpZ}tHnh

	//--------------------------------------------------------------------
	// RTCDI[vO`FbN
	//--------------------------------------------------------------------
	hLoc = GetLocationRTCD();						// P[Vnh擾
	if (hLoc == NTX_UNDEFINED_LOCATION) {
		return EDGE_LOCATION_ERROR;					// P[Vnh擾G[
	}

	stat = ntxGetRtStatus(hLoc);			// J[lNmF
	if (stat != E_OK) {
		return EDGE_KERNEL_NOT_RUNNING;				// J[lNĂ܂
	}

	hRoot = ntxGetRootRtProcess(hLoc);		// [gvZXnh擾
	if (hRoot == NTX_BAD_NTXHANDLE) {
		return EDGE_ROOTPROCESS_ERROR;				// [gvZX擾G[
	}

	//--------------------------------------------------------------------
	// RTCDI[v
	//--------------------------------------------------------------------
	hMem = ntxLookupNtxHandle(hRoot, pName, NO_WAIT);		// RTCDbNAbv
	if (hMem == NTX_BAD_NTXHANDLE) {
		return EDGE_RTCD_LOOKUP_ERROR;								// bNAbvs
	} else {
		wRet = ntxGetType(hMem);
		if (wRet == NTX_ERROR) {
			ntxUncatalogNtxHandle(hRoot, hMem, pName);		// J^OcĂԂ̂߃AJ^OăG[Ԃ
			return EDGE_RTCD_NOT_EXIST_ERROR;						// RTCD݂܂
		} else if (wRet == NTX_TYPE_RT_SHARED_MEMORY) {
																	// ̂ߏp
		} else {
			return EDGE_RTCD_NAME_EXIST_ERROR;						// ɓOgĂ܂
		}
	}

	*pMem = (BYTE*)ntxMapRtSharedMemoryEx(hMem, NTX_MAP_WRITE|NTX_MAP_UNALIGNED);	// L}bsO
	if (*pMem == NULL) {
		return EDGE_RTCD_MAPPING_ERROR;														// }bsOs
	}

	//--------------------------------------------------------------------
	// Z}tHI[v
	//--------------------------------------------------------------------
	hSem1 = ntxLookupNtxHandle(hRoot, pSem1Name, NO_WAIT);			// edgeWriteRTCD̒ŔrpZ}tHgp邽߁ArpZ}tH̃nh擾
	if (hSem1 == NTX_BAD_NTXHANDLE) {										// edgeCreateRTCDedgeOpenRTCDĂяoꍇ
		return EDGE_RTCD_LOOKUP_SEMAPHORE_ERROR;
	} else {
		wRet = ntxGetType(hSem1);
		if (wRet != NTX_TYPE_RT_SEMAPHORE) {								// nhsȏꍇ⓯J^ÕIuWFNgɎgĂꍇ
			if (wRet == NTX_ERROR) {										// INtime Explorerɂ(invalid)ɂȂĂꍇBZ}tH폜vZXIꂽꍇ(invalid)ƂȂ
				ntxUncatalogNtxHandle(hRoot, hSem1, pSem1Name);
				return EDGE_RTCD_NOT_EXIST_SEMAPHORE_ERROR;
			} else {														// J^ÕIuWFNgɎgĂꍇ
				return EDGE_RTCD_NAME_EXIST_ERROR;
			}
		}
	}

	hSem2 = ntxLookupNtxHandle(hRoot, pSem2Name, NO_WAIT);			// edgeReadRTCD/edgeWriteRTCD̒ŏʒmpZ}tHgp邽߁AʒmpZ}tH̃nh擾
	if (hSem2 == NTX_BAD_NTXHANDLE) {
		return EDGE_RTCD_LOOKUP_SEMAPHORE_ERROR;
	} else {
		wRet = ntxGetType(hSem2);
		if (wRet != NTX_TYPE_RT_SEMAPHORE) {								// nhsȏꍇ⓯J^ÕIuWFNgɎgĂꍇ
			if (wRet == NTX_ERROR) {										// INtime Explorerɂ(invalid)ɂȂĂꍇBZ}tH폜vZXIꂽꍇ(invalid)ƂȂ
				ntxUncatalogNtxHandle(hRoot, hSem2, pSem2Name);
				return EDGE_RTCD_NOT_EXIST_SEMAPHORE_ERROR;
			} else {														// J^ÕIuWFNgɎgĂꍇ
				return EDGE_RTCD_NAME_EXIST_ERROR;
			}
		}
	}

	//--------------------------------------------------------------------
	// nhԂ
	//--------------------------------------------------------------------
	*pMap	= hMem;		// RTCDnhԂ
	*pSem1	= hSem1;	// rpZ}tHnhԂ
	*pSem2	= hSem2;	// ʒmpZ}tHnhԂ

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDN[Y
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
      : 2019.12.20 A}bvȂ悤C(gNo18)
--------------------------------------------------------------------------------*/
int CloseRTCD(RTCDHANDLE *pHandle)
{
	//---------------------------------------------------------------------------------
	// NTXł͂ŃA}bv(ntxUnmapRtSharedMemory)sȂdlƂB
	// [R]
	// NTX̏ꍇ͓L𕡐}bvĂSēAhXƂȂB(NTX̎dl)
	// Ⴆ΁A鋤L𕡐XbhɂOPENREAD/WRITEĂŒɁA
	// XbhACLOSEsƁALɃ}bsOꂽ邽߁A
	// XbhREAD/WRITEsƃANZXᔽOĂ܂B
	// ̂߁A}bsOꂽ̓vZXI܂ŕێĂƂɂB
	//---------------------------------------------------------------------------------

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDZ}tH擾
  : hSem    [in] Z}tHnhl
        timeout [in] ^CAEgl(msec)
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int WaitRTCDSemaphore(OBJHANDLE hSem, DWORD timeout)
{
	WORD wRet;
	NTXSTATUS err;

	wRet = ntxWaitForRtSemaphore((NTXHANDLE)hSem, 1, timeout);
	if (wRet == NTX_ERROR) {
		err = ntxGetLastRtError();
		if (err == E_TIME)	{
			return EDGE_RTCD_SEMAPHORE_TIMEOUT;		// Z}tH^CAEg
		} else {
			return EDGE_RTCD_WAIT_SEMAPHORE_ERROR;	// Z}tH擾G[	
		}
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDrpZ}tH
  : hSem    [in] Z}tHnhl
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int ReleaseRTCDSemaphore(OBJHANDLE hSem)
{
	NTXSTATUS	stat = 0;
	
	stat = ntxReleaseRtSemaphore((NTXHANDLE)hSem, 1);	// Z}tH
	if ( stat != E_OK) {
		return EDGE_RTCD_RELEASE_SEMAPHORE_ERROR;				// Z}tHG[
	}

	return EDGE_SUCCESS;
}
