﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
namespace RTedge
{
    public static partial class EGDEFINE
    {

        //------------------------------------------------------------------------------
        // Edgeシステムスペック定義
        //
        //	※20200514_EgApiスペック表.xlsxも併せて更新してください	
        //------------------------------------------------------------------------------
        public const int EG_MAX_TAGENTRY_SETTINGMAX = 100000;   // タグエントリ最大数（テーブルのインデックス数制限）(設定上限)
        public const int EG_MAX_TAGENTRY = 10000;       // タグエントリ最大数（テーブルのインデックス数制限）(デフォルト)
        public const int EG_MAX_TAGNAME = 48;           // タグ名最大長
        public const int EG_MAX_TAGCOMMENT = 48;		// タグコメント最大長
        public const int EG_MAX_TAGADDRESS = 512;		// タグアドレス最大長
        public const int EG_MAX_TAGADDRCATEGORY = 10;   // タグアドレス(EdgeIOポート)のカテゴリ最大数

        public const int EG_MAX_DSETENTRY = 512;    	// データセットエントリ最大数（テーブルのインデックス数制限）
        public const int EG_MAX_DSETNAME = 32;  		// データセット名最大長
        public const int EG_MAX_DSETLINK = 2048;  		// データセットにリンクできるタグ最大数

        public const int EG_MAX_CLCTENTRY = 64; 		// コレクタエントリ最大数（テーブルのインデックス数制限）
        public const int EG_MAX_CLCTNAME = 8;     		// コレクタ名最大長 = Mailbox名最大長

        public const int EG_MAX_SERVICEENTRY = 32;		// サービスエントリ最大数（実質制限判定していない）
        public const int EG_MAX_SERVICENAME = 24;       // サービス名最大長
        public const int EG_MAX_SERVICEMAILBOXNAME = 4; // サービス名メールボックス名 NameSpace Index指定値4byte
        public const int EG_MAX_SERVICEPATH = 260;		// サービスパス最大長
        public const int EG_MAX_SERVICEARG = 260;		// サービス起動引数最大長
        public const int EG_MAX_NODENAME = 64;  		// ノード名最大長

        public const int EG_MAX_SPACEENTRY = 32;		// ネームスペースエントリ最大数
        public const int EG_MAX_SPACENAME = 16;		    // ネームスペース名最大長

        public const int EG_MAX_MAILBOXENTRY = 64;		// メールボックスエントリ最大数
        public const int EG_MAX_MAILBOXNAME = 8;		// メールボックス名(8byte)

        public const int EGFW_MAX_CLCTENTRY = 16;		// フレームワークの扱うコレクタ最大数
        public const int EGFW_MAX_MAILBOXENTRY = 16;	// フレームワークの扱うメールボックス最大数
        public const int EGFW_MAX_TAGREFENTRY = 1024;	// フレームワークの扱うTagRefエントリ最大数

        public const int EG_MAX_RTCD_NAME = 12;                             //RTCD名称(edgeAPI_RTCD.h EDGE_RTCD_HEADER)
        public const int EG_RTCD_HEADER_RESERVE = 188;                      //RTCD_HEADER reserve値(edgeAPI_RTCD.h EDGE_RTCD_HEADER)
        public const int EG_MAX_CATALOGNAME = 12;		// カタログ名(12byte)

        public const int EG_DIFF_VALUE_SIZE = 8;        // 値比較用データサイズ

        public const int EG_MAX_TAGTRIGGER_SIZE = 128;	// タグに設定可能な発報先サービス数(TagTrigger用)
        //
        // for C#
        //
        static public readonly string EG_MBOX_NAME_LOG = "EGSYSLOG";         //ログ格納用メールボックス名

        public static readonly uint EDGE_WRAP_PARAM_INVALID = 0x80010001;   // タグ名、またはその他設定値が範囲を超えています。
        public static readonly uint EDGE_RTCD_NO_UPDATE     = 0x8000011C;   // データ更新がありません
        public static readonly uint EDGE_TTABLE_NOEMPTY     = 0x8000040E;   // テーブルに空きがありません。
        public static readonly uint EDGE_RTCD_PROPERTY_NOT_SUPPORT = 0x8000011F;	// 指定したプロパティはサポートしていません
        public static readonly uint EDGE_FAILED_TO_START_PROCESS = 0x80000601;	// プロセスを開始できませんでした

        public static readonly uint EG_MSG_USER = 20000;                     //ユーザーメッセージ用 開始番号

        /// <summary>
        /// システム用 メッセージ番号一覧
        /// </summary>
        public enum EGMSG
        {
            EM_RETURN_RECEIVE_OK = 1,                   // 応答用メッセージ（返信依頼があるようなケース)
            EM_SERVICE_STOP = 101,                      // サービスストップメッセージ
            EM_SERVICE_RUN = 102,                       // サービス実行開始指令
            EM_SERVICE_PAUSE = 103,                     // サービス実行停止指令
            EM_SERVICE_UPDATE = 104,                    // データリフレッシュ指令
            EM_SERVICE_ADD_TAG = 111,                   // サービス内EgTagRef追加
            EM_SERVICE_REMOVE_TAG = 112,                // サービス内EgTagRef削除(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_CLEAR_TAG = 113,                 // サービス内EgTagRefオールクリア(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_ADD_OUT_TAG = 114,               // サービス内EgTagRef_OUT追加
            EM_SERVICE_REMOVE_OUT_TAG = 115,            // サービス内EgTagRef_OUT削除(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_CLEAR_OUT_TAG = 116,             // サービス内EgTagRef_OUTオールクリア(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_ADD_IN_TAG = 117,                // サービス内EgTagRef_IN追加
            EM_SERVICE_REMOVE_IN_TAG = 118,             // サービス内EgTagRef_IN削除(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_CLEAR_IN_TAG = 119,              // サービス内EgTagRef_INオールクリア
            EM_SERVICE_ADD_CLCTREF = 121,               // サービス内EgCollectorRef追加
            EM_SERVICE_REMOVE_CLCTREF = 122,            // サービス内EgCollectorRef削除(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_CLEAR_CLCTREF = 123,             // サービス内EgCollectorRefオールクリア(Ver.3.1では未実装 以降拡張用)
            EM_SERVICE_ADD_MBOX = 124,                  // サービス内EgMailbox追加
            EM_SERVICE_REMOVE_MBOX = 125,               // サービス内EgMailbox削除
            EM_SERVICE_ADD_TAGTRIGGER = 126,            // サービス内TagTrigger追加
            EM_SERVICE_READ_TAGTRIG_FINISH = 127,       // サービス内TagTrigger設定読み込み完了
            EM_COLLECTOR_CREATE = 201,                  // コレクタ作成メッセージ
            EM_COLLECTOR_START_ALL = 202,               // サービス内コレクタ全スタートメッセージ
            EM_COLLECTOR_STOP_ALL = 203,                // サービス内コレクタ全ストップメッセージ
            EM_COLLECTOR_START_ONE = 204,               // サービス内コレクタ一つスタートメッセージ(コレクタ名指定)
            EM_COLLECTOR_STOP_ONE = 205,                // サービス内コレクタ一つストップメッセージ(コレクタ名指定)
            EM_COLLECTOR_WRITED_DATA = 206,             // サービス内コレクタデータ書き込み時のメッセージID
            EM_TAGTRIGGER_NOTIFICATION = 250,           // トリガー対象タグ値変化通知
            EM_TAGTRIGGER_START = 251,					// タグトリガースレッドスタートメッセージ
            EM_READ_REQUEST_SERVICE_XML = 1000,         // フレームワーク処理 xml読み込み命令メッセージ
            EM_READ_REQUEST_SERVICE_XML_END = 1001,     // サービスごとフレームワークからのxml読み込み命令受信時、xmlを読み終わったときにサービスに送信するメッセージ
            EM_READ_XML_SERVICE_END = 1002,             // xml内のServiceタグを読み終わった際にCreate有無関係なく、対象のサービスに送るメッセージ
            EM_CORE_CREATE_SERVICE_END = 1003,          // xml内のServiceタグを読み終わった際にCreate時のみ対象のサービスに送るメッセージ
            EM_TAG_DEFAULT_VALUE_SET = 1004,			// タグのデフォルト値をロードする指令メッセージ
		    EM_TAG_DEFAULT_VALUE_SET_END = 1005,		// タグのデフォルト値をロードし終えた完了メッセージ
            EM_WRAPONLY_UPDATE_TAGTRIGREF = 2000,       // Wrap用 TagTrigger List更新処理
            EM_DEBUG_WRITE_SERVICEOBJ = 9000			// ログにdebug情報を出力するメッセージ
        };
        /// <summary>
        /// Tagの型一覧
        /// </summary>
        public enum egTagDataType
        {
            UNDEFINE = 0,
            Boolean = 1,
            SByte = 2,
            Byte = 3,
            Int16 = 4,
            UInt16 = 5,
            Int32 = 6,
            UInt32 = 7,
            Int64 = 8,
            UInt64 = 9,
            Float = 10,
            Double = 11,
            String = 12,
            Segment = 13, //(Byte配列)
            FIFO = 14,    //(中身はByte配列)
        };
        /// <summary>
        /// Windows用 スレッドプライオリティ
        /// </summary>
        public enum egPriority
        {
            EG_PRIORITY_240_255 = 240,	  // Base priority(Win) = 1
            EG_PRIORITY_232_239 = 232,    // Base priority(Win) = 2
            EG_PRIORITY_224_231 = 224,    // Base priority(Win) = 3
            EG_PRIORITY_216_223 = 216,    // Base priority(Win) = 4
            EG_PRIORITY_208_215 = 208,    // Base priority(Win) = 5
            EG_PRIORITY_200_207 = 200,    // Base priority(Win) = 6
            EG_PRIORITY_192_199 = 192,    // Base priority(Win) = 7
            EG_PRIORITY_184_191 = 184,    // Base priority(Win) = 8
            EG_PRIORITY_176_183 = 176,    // Base priority(Win) = 9
            EG_PRIORITY_168_175 = 168,    // Base priority(Win) = 10
            EG_PRIORITY_160_167 = 160,    // Base priority(Win) = 11
            EG_PRIORITY_152_159 = 152,    // Base priority(Win) = 12
            EG_PRIORITY_144_151 = 144,    // Base priority(Win) = 13
            EG_PRIORITY_136_143 = 136,    // Base priority(Win) = 14
            EG_PRIORITY_128_135 = 128,    // Base priority(Win) = 15
            EG_PRIORITY_80_127 = 80,      // Base priority(Win) = 16
            EG_PRIORITY_72_79 = 72,       // Base priority(Win) = 22
            EG_PRIORITY_64_71 = 64,       // Base priority(Win) = 23
            EG_PRIORITY_56_63 = 56,       // Base priority(Win) = 24
            EG_PRIORITY_48_55 = 48,       // Base priority(Win) = 25
            EG_PRIORITY_8_47 = 8,         // Base priority(Win) = 26
            EG_PRIORITY_0_7 = 0           // Base priority(Win) = 31
        };

        //SMART情報のステータス値
        public enum SMART_STATUS
        {
            GOOD = 0,
            GOOD_GREEN = 1,
            CAUTION = 2,
            BAD = 3,
            UNKNOWN = 4,
        };


    }
}
