﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Diagnostics;           // Debug.WriteLine出力用
namespace RTedge
{
    /// <summary>
    /// EgBaseService Logの箇所のみ記載
    /// </summary>
    public partial class edge_FW : egBaseClass
    {
        //LOG
        static public readonly string EG_LOG_MSG = "MSG"; // メッセージハンドラ
        static public readonly string EG_LOG_OPE = "OPE"; // オペレーション
        static public readonly string EG_LOG_WRN = "WRN"; // ワーニング
        static public readonly string EG_LOG_ERR = "ERR"; // エラー
        static public readonly string EG_LOG_DBG = "DBG"; // デバッグ情報
        static public readonly string EG_LOG_FER = "FER"; // FATAL ERROR

        //ロックオブジェクト
        static object logLock = new object();

        /// <summary>
        /// PrintLog 外部用
        /// </summary>
        /// <param name="stMode"></param>
        /// <param name="stFormatMess"></param>
        /// <param name="args"></param>
        public void PrintLog(string stMode, string stFormatMess, params string[] args)
        {
            try
            {
                lock (logLock)
                {
                    _C_EgFW_PrintLog(ServiceRealName, stMode, stFormatMess, args);
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine(System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
            }
        }
        /// <summary>
        /// Framework用
        /// </summary>
        /// <param name="stMode"></param>
        /// <param name="stFormatMess"></param>
        /// <param name="args"></param>
        private void PrintSysLog(string stMode, string stFormatMess, params string[] args)
        {
            try
            {
                lock (logLock)
                {
                    _C__EgFW_PrintSysLog(ServiceRealName, stMode, stFormatMess, args);
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine(System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
            }
        }
        /// <summary>
        /// Framework用
        /// </summary>
        /// <param name="ServiceName"></param>
        /// <param name="stMode"></param>
        /// <param name="stFormatMess"></param>
        /// <param name="args"></param>
        static public void _PrintSysLog(string stServiceName, string stMode, string stFormatMess, params string[] args)
        {
            try
            {
                lock (logLock)
                {
                    _C__EgFW_PrintSysLog(stServiceName, stMode, stFormatMess, args);
                }
            }
            catch (Exception ex)
            {
                Debug.WriteLine(System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
            }
        }
        
    }
}
