﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Text;
using System.Runtime.InteropServices;
namespace RTedge
{
    public partial class edge_FW : egBaseClass
    {



        /// <summary>
        /// サービス終了メッセージ受け取り時の関数追加  ライブラリ呼び出し部分
        /// </summary>
        /// <param name="callback"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "EgFW_AddInitEndFunc")]
        public static extern int _C_EgFW_AddInitEndFunc([MarshalAs(UnmanagedType.FunctionPtr)] CallbackInitEndFuncDelegate callback);
        
        /// <summary>
        /// EgFW_AddDebugFunc
        /// </summary>
        /// <param name="callback"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "EgFW_AddDebugFunc")]
        public static extern int _C_EgFW_AddDebugFunc([MarshalAs(UnmanagedType.FunctionPtr)] CallbackDebugFuncDelegate callback);
        
        /// <summary>
        /// ログ出力用  ライブラリ呼び出し部分
        /// </summary>
        /// <param name="ServiceName"></param>
        /// <param name="Mode"></param>
        /// <param name="format"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "EgFW_PrintLog")]
        private static extern int __C_EgFW_PrintLog(string ServiceName, string Mode, string format);
        public static int _C_EgFW_PrintLog(string ServiceName, string Mode, string format, params string[] param)
        {
            return __C_EgFW_PrintLog(ServiceName, Mode, egCommonFunc.ToShiftJis(string.Format(format, param)));
        }


        /// <summary>
        /// ログ出力用(システム用) ライブラリ呼び出し部分
        /// </summary>
        /// <param name="ServiceName"></param>
        /// <param name="Mode"></param>
        /// <param name="format"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_PrintSysLog")]
        private static extern int __C__EgFW_PrintSysLog(string ServiceName, string Mode, string format);
        private static int _C__EgFW_PrintSysLog(string ServiceName, string Mode, string format, params string[] param)
        {
            return __C__EgFW_PrintSysLog(ServiceName, Mode, egCommonFunc.ToShiftJis(string.Format(format, param)));
        }
        

        /// <summary>
        /// サービスメールボックス名取得関数 ライブラリ呼び出し部分
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetServiceName")]
        private static extern int _C__EgFW_GetServiceName(StringBuilder ServiceName);
        /// <summary>
        /// サービス名取得関数 ライブラリ呼び出し部分
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetServiceRealName")]
        private static extern int _C__EgFW_GetServiceRealName(StringBuilder ServiceName);

        /// <summary>
        /// サービスメールボックス名取得関数 ライブラリ呼び出し部分
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetServiceMboxName")]
        private static extern int _C__EgFW_GetServiceMboxName(StringBuilder ServiceMailboxName);
        
        /// <summary>
        /// サービスステータスTag名取得関数 ライブラリ呼び出し部分
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetServiceStateName")]
        private static extern int _C__EgFW_GetServiceStateName(StringBuilder StateName);
        
        /// <summary>
        /// TagRef OUT数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_OUT_Count")]
        private static extern int _C__EgFW_GetEgTagRef_OUT_Count();
        
        /// <summary>
        /// TagRef IN数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_IN_Count")]
        private static extern int _C__EgFW_GetEgTagRef_IN_Count();
        
        /// <summary>
        /// TagRef数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_Count")]
        private static extern int _C__EgFW_GetEgTagRef_Count();
        
        /// <summary>
        /// CollectorRef数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetCollectorRef_Count")]
        private static extern int _C__EgFW_GetCollectorRef_Count();
        
        /// <summary>
        /// Mailbox数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetMailbox_Count")]
        private static extern int _C__EgFW_GetMailbox_Count();
        
        //egMailBoxes_Count

        /// <summary>
        /// TagRef OUT 取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef_OUT")]
        private static extern int _C__EgFW_GetTagRef_OUT(IntPtr pPtr, int index);
        
        /// <summary>
        /// TagRef IN 取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef_IN")]
        private static extern int _C__EgFW_GetTagRef_IN(IntPtr pPtr, int index);
        
        /// <summary>
        /// TagRef 取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef")]
        private static extern int _C__EgFW_GetTagRef(IntPtr pPtr, int index);

        /// <summary>
        /// TagRef OUT EdgeIOポート情報数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_OUT_PortInfo_Count")]
        private static extern int _C__EgFW_GetEgTagRef_OUT_PortInfo_Count();

        /// <summary>
        /// TagRef IN EdgeIOポート情報数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_IN_PortInfo_Count")]
        private static extern int _C__EgFW_GetEgTagRef_IN_PortInfo_Count();

        /// <summary>
        /// TagRef EdgeIOポート情報数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetEgTagRef_PortInfo_Count")]
        private static extern int _C__EgFW_GetEgTagRef_PortInfo_Count();

        /// <summary>
        /// TagRef OUT EdgeIOポート情報取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef_OUT_PortInfo")]
        private static extern int _C__EgFW_GetTagRef_OUT_PortInfo(IntPtr pPtr, int index);

        /// <summary>
        /// TagRef IN EdgeIOポート情報取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef_IN_PortInfo")]
        private static extern int _C__EgFW_GetTagRef_IN_PortInfo(IntPtr pPtr, int index);

        /// <summary>
        /// TagRef EdgeIOポート情報取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagRef_PortInfo")]
        private static extern int _C__EgFW_GetTagRef_PortInfo(IntPtr pPtr, int index);

        /// <summary>
        /// コレクタ取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetCollector")]
        private static extern int _C__EgFW_GetCollector(IntPtr pPtr, int index);
        
        /// <summary>
        /// CollectorRef取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetCollectorRef")]
        private static extern int _C__EgFW_GetCollectorRef(IntPtr pPtr, int index);
        
        /// <summary>
        /// MailBox取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetMailBox")]
        private static extern int _C__EgFW_GetMailBox(IntPtr pPtr, int index);
        

        /// <summary>
        /// TagTrigger数 取得
        /// </summary>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagTrigger_Count")]
        private static extern int _C__EgFW_GetTagTrigger_Count();
        
        /// <summary>
        /// TagTrigger取得
        /// </summary>
        /// <param name="pPtr"></param>
        /// <param name="index"></param>
        /// <returns></returns>
        [DllImport("eghgapiWin.dll", CallingConvention = CallingConvention.Cdecl, EntryPoint = "_EgFW_GetTagTrigger")]
        private static extern int _C__EgFW_GetTagTrigger(IntPtr pPtr, int index);
    }
}
