/*****************************************************************************
* egAPI.c
*
*   RT-edge system system API
*
*       Copyright(C) 2020 Micronet Co. All Rights Reserved.
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

edge_API void* g_H_egSysCfg = 0;	// systemu configpW[nh
//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
/*****************************************************************************
* FUNCTION:	_EgSysDefSetting	
* DESCRIPTION:
*   VXeconfigpW[nhݒ
\*****************************************************************************/
int32_t _EgSysDefSetting(EDGESYSTEMCONFIG* SysCfg)
{
	// ݒt@C̃擾	
	if (g_H_egSysCfg == NULL)
	{
		g_H_egSysCfg = EgSysCfgLookup();
		if (g_H_egSysCfg == NULL)
		{
			//ݒlō쐬
			g_H_egSysCfg = EgSysCfgCreate(SysCfg);
		}
	}
	if (g_H_egSysCfg == NULL)//łȂꍇ́Aȉ̃G[Ԃ
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgInit
* DESCRIPTION:
*   Initilize t[[N 
\*****************************************************************************/
int32_t EgInit( EDGECONFIG *Config )
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;						// [hNG
	}

	return _EgFW_Initialize(Config);
}
/*****************************************************************************
* FUNCTION:		EgFinalize
* DESCRIPTION:
*   Finalize t[[N ㏈
\*****************************************************************************/
int32_t EgFinalize()
{
	int32_t ret = _EgFW_Finalize();		// t[[N ㏈

	edge_FreeLibrary(g_H_egosdep);		// egosdep̉
	edge_FreeLibrary(g_H_egSysCfg);		// systemu configpW[nh
	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgInitializeSpinLock
* DESCRIPTION:
*   ()XsbN̏
\*****************************************************************************/
void _EgInitializeSpinLock(HEGSPINLOCK spin)
{
	_EgReleaseSpinLock(spin);
}
/*****************************************************************************
* FUNCTION:		_EgAcquireSpinLock
* DESCRIPTION:
*   ()XsbN̑҂
\*****************************************************************************/
void _EgAcquireSpinLock(HEGSPINLOCK spin)
{
#if 0
	_asm
	{
		mov		eax, 1
		mov		ebx, [spin]
	_loop: 
		xchg	eax ,[ebx].current
		test	eax, eax
		jnz		_loop
	}
#endif
}
/*****************************************************************************
* FUNCTION:		_EgReleaseSpinLock
* DESCRIPTION:
*   ()XsbN̉
\*****************************************************************************/
void _EgReleaseSpinLock(HEGSPINLOCK spin)
{
#if 0
	_asm
	{
		mov		eax, 0
		mov		ebx, [spin]
		xchg	eax, [ebx].current
	}
#endif
}

/*****************************************************************************
* FUNCTION:		EgVariantInit
* DESCRIPTION:
*   EGVARIANT^̏
\*****************************************************************************/
int32_t EgVariantInit(EGVAR *pvarg)
{
	memset(pvarg, 0, sizeof(EGVAR));
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgVariantCopy
* DESCRIPTION:
*   EGVARIANT^̃Rs[
\*****************************************************************************/
int32_t EgVariantCopy(EGVAR *pvargDest, const EGVAR *pvargSrc)
{
	*pvargDest = *pvargSrc;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgAllocateString
* DESCRIPTION:
*   EGVARIANT^̃̕obt@
\*****************************************************************************/
EGVAR EgAllocateString(const char* string)
{
	EGVAR ret = { 0 };
	EGBSTR str = { 0 };

	HNAMESPACE hTag = EgTagGetHandle();						// f[^q[v𓾂邽߂NameSpaceviTODO:Tag namespaceȂp namespaceقj
	uint32_t strlength = (uint32_t)strlen(string) + sizeof(str->len);		// Kvȕ
	OFFSET heap = _AllocHeap((HNAMESPACE)hTag, strlength);	// obt@NameSpacẽq[vm
	if (heap == 0)
		return ret;					// TODO:q[vmۂ̎sAK؂ȃG[

	str = (EGBSTR)((intptr_t)heap + (intptr_t)hTag + (intptr_t)((LPNAMESPACE)hTag)->head.baseheap);				// BSTR̊i[obt@ƂĎg

	str->len = strlength;									// BSTRɂ͕Ă
	memcpy_s(str->string, strlength, string, strlength);	// BSTRɂ͕̎

	ret.vt = 0;						// TODO:K؂Ȍ^(EGBSTR)
	ret.val = (intptr_t)heap;
	
	return ret;			// EGVAR^
}
/*****************************************************************************
* FUNCTION:		EgGetTime
* DESCRIPTION:
*   Ԃ̎擾
\*****************************************************************************/
int32_t EgGetTime(EDGE_TIME_STAMP *pTime)
{
	return os_edge_getTime(pTime);
}
/*****************************************************************************
* FUNCTION:		EgGetTimeVal
* DESCRIPTION:
*   Ԃ̎擾
\*****************************************************************************/
int32_t EgGetTimeVal(EDGE_TIME_VAL *pTime)
{
	return os_edge_getTimeVal(pTime);
}
/*****************************************************************************
* FUNCTION:		EgLocaltime64
* DESCRIPTION:@t 23:59:59A3001 N 1  18 (萢E)܂ŕ\
*   Ԃ̕ϊ
\*****************************************************************************/
int32_t EgLocaltime64(void* pTime, void* pLongtime)
{
	return os_edge_Localtime64(pTime, pLongtime);
}
/*****************************************************************************
* FUNCTION:		EgDecode
* DESCRIPTION:
*   AhXformatɊÂăoCisrc̏ʒudstփf[^o
/// <param name="dst">ooCi̊i[</param>
/// <param name="dstsize">ooCi̊i[̃TCY</param>
/// <param name="src">ooCïʒu</param>
/// <param name="srcsize">ooCĩTCY</param>
/// <param name="addrformat">EdgeWAhX̎w</param>
/// <param name="actualsize">dstɊi[f[^̗LTCYԋp(nullw)</param>
/// <returns>펞EDGE_SUCCESS</returns>
///
\*****************************************************************************/
int32_t EgDecode(void* dst, size_t dstsize, const void* src, size_t srcsize, const char* addrformat, size_t *actualsize)
{
	int32_t result;
	int32_t	offset;
	size_t	size;
	int16_t	bit;
	uint8_t	typemode;
	size_t	actualsizedummy;

	// p[^̃AhXw肪Ó
	if (dst == NULL)			return EDGE_PARAM_INVALID;
	if (dstsize == 0)			return EDGE_PARAM_INVALID;
	if (src == NULL)			return EDGE_PARAM_INVALID;
	if (srcsize == 0)			return EDGE_PARAM_INVALID;
	if (addrformat == NULL)		return EDGE_PARAM_INVALID;
	if (actualsize==NULL)		actualsize = &actualsizedummy;		// actualsizeNULLweA_~[Ői߂

	// li[
	*actualsize = 0;

	// AhX
	result = EgParseAddress(addrformat, &offset, &size, &bit, &typemode);
	if (result != EDGE_SUCCESS)
		return result;				// G[

	// p[^Ó
	uint8_t *copyfrom;
	copyfrom = (uint8_t*)src + offset;	// Rs[̈ʒuZo

	if (typemode == 5)
	{
		if (bit == 0)						// %S̏ꍇ̓ʏ
			size = strlen(copyfrom) + 1;	// NULLZ(+1)Af[^
		else
			size = bit + 1;					// %S.x̏ꍇ̓f[^Œ
	}
	if(size > dstsize)
		return EGDE_COMMON_DECODE_FORMAT_DST_BUFFERR;	// DecodẽAhX(format)s(dstobt@)
	if (offset < 0)
		return EGDE_COMMON_DECODE_FORMAT_OFFSET1_ERR;	// DecodẽAhX(format)s(sK؂ȃItZbgʒu)
	if((size_t)offset > (srcsize-size))
		return EGDE_COMMON_DECODE_FORMAT_OFFSET2_ERR;	// DecodẽAhX(format)s(srcobt@offsetw肪)

	// oCiߏ
	if (typemode == 4)						// %Xa.b̏ꍇ̓ʏ
	{
		*(uint8_t*)dst = (*copyfrom & (1 << bit)) ? true : false;		// rbg̏ true or false
	}
	else
	{
		memcpy(dst, copyfrom, size);
		if (typemode == 5)
			((uint8_t*)dst)[size-1] = '0';				// I[null
	}

	// LTCYi[
	if (actualsize)
		*actualsize = size;

	return EDGE_SUCCESS;			// I
}
/*****************************************************************************
* FUNCTION:		EgMakeAddress
* DESCRIPTION:
*   ItZbglETCYAhXformat쐬(bit͍lȂ)
\*****************************************************************************/
const char* EgMakeAddress(int32_t offset, size_t size, char* buff ,size_t buffsize)
{
	// ̑Ó`FbN
	if (size < 1)	return NULL;		// w肪Ȃꍇ͉Ȃ
	if (buff == NULL)	return NULL;	// w肪Ȃꍇ͉Ȃ
	if (buffsize == 0)	return NULL;	// w肪Ȃꍇ͉Ȃ

	switch(size)		//TCYƂɎw̕ɕϊ
	{
		case 1:
			sprintf_s(buff, buffsize, "%%B%d", offset);	// 1oCg
			return buff;
		case 2:
			sprintf_s(buff, buffsize, "%%W%d", offset); // 2oCg
			return buff;
		case 4:
			sprintf_s(buff, buffsize, "%%D%d", offset); // 4oCg
			return buff;
		case 8:
			sprintf_s(buff, buffsize, "%%L%d", offset); // 8oCg
			return buff;
		default:
			return NULL;

	}

	return NULL; //w肵TCYł͂ȂꍇNULL
}

/// <summary>
/// AhXformatɊÂďݐoCȉʒuɃf[^o
/// </summary>
/// <param name="dst">ݐoCi̎w</param>
/// <param name="dstsize">ݐoCĩTCY</param>
/// <param name="src">ooCïʒu</param>
/// <param name="srcsize">ooCĩTCY</param>
/// <param name="addrformat">EdgeWAhX̎w</param>
/// <param name="actualsize">dstɊi[f[^̗LTCYԋp(nullw)</param>
/// <returns>펞EDGE_SUCCESS</returns>
///
int32_t EgEncode(void* dst, size_t dstsize, const void* src, size_t srcsize, const char* addrformat, size_t *actualsize)
{
	int32_t result;
	int32_t	offset;
	size_t	size;
	int16_t	bit;
	uint8_t	typemode;
	size_t	actualsizedummy;

	// p[^̃AhXw肪Ó
	if (dst == NULL)			return EDGE_PARAM_INVALID;
	if (src == NULL)			return EDGE_PARAM_INVALID;
	if (addrformat == NULL)		return EDGE_PARAM_INVALID;
	if (actualsize == NULL)		actualsize = &actualsizedummy;		// actualsizeNULLweA_~[Ői߂

	// li[
	*actualsize = 0;

	// AhX
	result = EgParseAddress(addrformat, &offset, &size, &bit, &typemode);
	if (result != EDGE_SUCCESS)
		return result;				// G[

	//--- pass4 ---
	uint8_t *copyto;
	copyto = (uint8_t*)dst + offset;	// Rs[̈ʒuZo

	if (typemode == 5)
	{
		if (bit == 0)					// %S̏ꍇ̓ʏ
			size = strlen(src) + 1;		// NULLZ(+1)Af[^
		else
			size = bit + 1;				// %S.x̏ꍇ̓f[^Œ
	}
	if (size > dstsize)
		return EGDE_COMMON_DECODE_FORMAT_DST_BUFFERR;	// DecodẽAhX(format)s(dstobt@)
	if (offset < 0)
		return EGDE_COMMON_DECODE_FORMAT_OFFSET1_ERR;	// DecodẽAhX(format)s(sK؂ȃItZbgʒu)
	if ((size_t)offset > (dstsize - size))
		return EGDE_COMMON_DECODE_FORMAT_OFFSET2_ERR;	// DecodẽAhX(format)s(srcobt@offsetw肪)

	//--- pass5 ---
	if (typemode == 4)						// %Xa.b̏ꍇ̓ʏ
	{
		if (*(uint8_t*)src == 0)
		{
			*copyto &= ~(1 << bit);		// rbgƂ
		}
		else if (*(uint8_t*)src == 1)
		{
			*copyto |= (1 << bit);		// rbgĂ
		}
		else
		{
			return EDGE_PARAM_INVALID;					// rbgwlK(0 or 1)ł͂ȂG[
		}
	}
	else
	{
		memcpy(copyto, src, size);
		if (typemode == 5)
			copyto[size - 1] = '0';				// I[null
	}

	// LTCYi[
	if (actualsize)
		*actualsize = size;

	return EDGE_SUCCESS;			// I
}

/// <summary>
/// address formatItZbgETCYɕ
/// </summary>
/// <param name="tagaddress">EdgeWAhX</param>
/// <param name="offset">oItZbgl̊i[</param>
/// <param name="size">of[^TCYl̊i[</param>
/// <param name="bit">orbgl̊i[i擾sv̂ƂNULLw\Arbg񂪊܂܂Ȃ-1i[j</param>
/// <returns>G[R[h</returns>
int32_t EgParseAddress(const char* addrformat, int32_t *offset, size_t *size, int16_t *bit ,uint8_t *typemode)
{
	int16_t		bitdummy;
	uint8_t		typemodedummy;				// AhXԍ
	char*		format = (char*)addrformat;
	struct _typeformat
	{
		char	*identify;		// ʎq
		size_t	itemsize;		// f[^̃TCY
		bool	prioduse;		// sIh؂
		uint8_t	priodmin;		// sIh؂̐l
		uint8_t	priodmax;		// sIh؂̐l
	} typeformat[] = {
		{	"%B",	1	,false },											// typemode=0
		{	"%W",	2	,false },											// typemode=1
		{	"%D",	4	,false },											// typemode=2
		{	"%L",	8	,false },											// typemode=3
		{	"%X",	1	,true ,EG_MIN_TAGBITNO		,EG_MAX_TAGBITNO},		// typemode=4
		{	"%S",	0	,true ,EG_MIN_TAGSTRINGLEN	,EG_MAX_TAGSTRINGLEN},	// typemode=5
		{0}
	};

	if (format == NULL)
		return EDGE_PARAM_INVALID;		// p[^si
	if (offset == NULL)
		return EDGE_PARAM_INVALID;		// p[^si
	if (size == NULL)
		return EDGE_PARAM_INVALID;		// p[^si
	if (bit == NULL)
		bit = &bitdummy;				// rbgsv(nullw)͋eA_~[̓ꕨőΏ
	if (typemode == NULL)
		typemode = &typemodedummy;		// ^Cvsv(nullw)͋eA_~[̓ꕨőΏ

	// li[
	*offset = 0;
	*size = 0;
	*bit = 0;

	struct _typeformat *target;		// rGg̃|C^
	size_t	datalen;				// rGg̃f[^TCY
	char*	cmpident;				// rGg̎ʎq
	size_t	cmplen;					// rGg̎ʎq
	bool	cmppriod;				// rGg̃sIhL

	//---- pass1 ---
	*typemode = 0;
	target = &typeformat[0];		// v鎯ʎq
	do {
		if (!target || !target->identify)
			return EGDE_COMMON_DECODE_FORMAT_CMPIDENT_ERR;				// DecodẽAhX(format)s(rGg̎ʎq)

		cmpident = target->identify;
		if (cmpident == 0)			// 炸I[
			return EGDE_COMMON_DECODE_FORMAT_CMPIDENT_ERR;				// DecodẽAhX(format)s(rGg̎ʎq)

		cmplen = strlen(target->identify);
		cmppriod = target->prioduse;

		if (strncmp(cmpident, format, cmplen) == 0)		// vo
		{
			datalen = target->itemsize;
			break;
		}
		++target;
		++(*typemode);
	} while (1);

	format += cmplen;				// ʎqNÂłǂݔ΂

	int	offsetval;					// oCgItZbgʒu
	int	priodval;				// sIh̒l
	cmppriod = strstr(format, ".");	// sIh܂܂Ă

	//--- pass3 ---
	if (cmppriod)					// sIhw܂ޏ̏ꍇ͈ȉ̏
	{
		char *context;
		char *token1, *token2;
		char *formattmp;						// strtokƗpꎞobt@
		size_t formatlen = strlen(format) + 1;	// [Jobt@ɃAhX]ʁistrtokɂĔj邽߁j
		formattmp = (char*)malloc(formatlen);
		os_edge_strncpy_s(formattmp, formatlen, format ,_TRUNCATE);
		token1 = strtok_s(formattmp, ".", &context);	// sIhOo
		token2 = strtok_s(NULL, ".", &context);			// sIho

		if (token1 == NULL)		// sIhw肪ׂƂɂȂƂ̓G[
		{
			free(formattmp);
			return EGDE_COMMON_DECODE_FORMAT_PRIOD1_ERR;	// DecodẽAhX(format)s(sIhw肪ׂƂɂȂ)
		}
		if (token2 == NULL)			// sIh̎w肪ȂƂ̓G[
		{
			free(formattmp);
			return EGDE_COMMON_DECODE_FORMAT_PRIOD2_ERR;	// DecodẽAhX(format)s(sIh̎w肪Ȃ)
		}

		offsetval = atoi(token1);
		priodval = atoi(token2);

		free(formattmp);			// strtokƗpꎞobt@sv

		if (priodval < target->priodmin)
			return EGDE_COMMON_DECODE_FORMAT_PRIOD3_ERR;				// DecodẽAhX(format)s(sIhlI[o[)
		if (priodval > target->priodmax)
			return EGDE_COMMON_DECODE_FORMAT_PRIOD4_ERR;				// DecodẽAhX(format)s(sIhlI[o[)

	}
	else
	{
		offsetval = atoi(format);	// sIhw܂܂Ȃ̏ꍇ͈ȉ̏
		priodval = 0;
	}

	// ʊi[
	*offset = offsetval;
	*size = typeformat[*typemode].itemsize;
	*bit = priodval;

	//if (typemode == 5)				// %S̏ꍇ̓ʏ
	//	datalen = priodval;			// f[^̓sIhlŏ
	//if (datalen > dstsize)
	//	return EGDE_COMMON_DECODE_FORMAT_DST_BUFFERR;	// DecodẽAhX(format)s(dstobt@)
	//if (offsetval < 0)
	//	return EGDE_COMMON_DECODE_FORMAT_OFFSET1_ERR;	// DecodẽAhX(format)s(sK؂ȃItZbgʒu)
	//if ((size_t)offsetval > (srcsize - datalen))
	//	return EGDE_COMMON_DECODE_FORMAT_OFFSET2_ERR;	// DecodẽAhX(format)s(srcobt@offsetw肪)

	//uint8_t *copyfrom;
	//copyfrom = (uint8_t*)src + offsetval;	// Rs[̈ʒuZoē]

	//if (typemode == 4)						// %Xa.b̏ꍇ̓ʏ
	//{
	//	*(uint8_t*)dst = (*copyfrom & (1 << priodval)) ? true : false;		// rbg̏ true or false
	//}
	//else
	//{
	//	memcpy(dst, copyfrom, datalen);
	//}

	return EDGE_SUCCESS;
}
//
// Tag
//
bool _LocalEgSysTagCreate(const char* tagName, uint16_t type, uint16_t size, const char* source, const char* comment)
{
	bool bRet = true;
	int32_t result;
	result = EgTagCreate(tagName, type, size, source, comment);	//EDGESYSTEM.SERVICEENTRY.MAX
	if (result != EDGE_SUCCESS)
	{
		_EgFW_PrintSysLog(NULL, EG_LOG_WRN, "Cannot Create TAG[%s] Status[%d]", tagName, result);
		result = false;
	}
	return result;
}
//
// VXeTag쐬
//
bool _EgSysTagCreate()
{
	bool bRet = true;
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_SERVICEENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Service entry.") == false) bRet = false; //EDGESYSTEM.SERVICEENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_DSETENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Dataset entry.") == false) bRet = false; //EDGESYSTEM.DSETENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_DSETLINK_MAX, EgVtUInt32, 4, "", "Maximum size of Dataset link tag entry.") == false) bRet = false; //EDGESYSTEM.DSETLINK.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_CLCTENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Collector entry.") == false) bRet = false; //EDGESYSTEM.CLCTENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_MAILBOXENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Mailbox entry.") == false) bRet = false; //EDGESYSTEM.MAILBOXENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_C2C_MAILBOXCOL_MAX, EgVtUInt32, 4, "", "Maximum col size of Mailbox for Container.") == false) bRet = false; //EDGESYSTEM.FW_C2C_MAILBOXCOL.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_C2C_MAILBOXROW_MAX, EgVtUInt32, 4, "", "Maximum row size of Mailbox for Container.") == false) bRet = false; //EDGESYSTEM.FW_C2C_MAILBOXROW.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_CLCTENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Framework Collector entry.") == false) bRet = false; //EDGESYSTEM.FW_CLCTENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_MAILBOXENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Framework Mailbox entry.") == false) bRet = false; //EDGESYSTEM.FW_MAILBOXENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_TAGREFENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Framework Tagref entry.") == false) bRet = false; //EDGESYSTEM.FW_TAGREFENTRY.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_DSETENTRYY_COUNT, EgVtUInt32, 4, "", "Dataset entry count.") == false) bRet = false; //EDGESYSTEM.DSETENTRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_CLCTENTRY_COUNT, EgVtUInt32, 4, "", "Collector entry count.") == false) bRet = false; //EDGESYSTEM.CLCTENTRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_SERVICEENTRY_COUNT, EgVtUInt32, 4, "", "Service entry count.") == false) bRet = false; //EDGESYSTEM.SERVICEENTRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_MAILBOXENTRY_COUNT, EgVtUInt32, 4, "", "Mailbox entry count.") == false) bRet = false; //EDGESYSTEM.MAILBOXENTRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_TAGENTRY_COUNT, EgVtUInt32, 4, "", "Tag entry count.") == false) bRet = false; //EDGESYSTEM.TAGENTRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_TAGPTRNUM_MAX, EgVtUInt32, 4, "", "Maximum number of Tag pointer.") == false) bRet = false; //EDGESYSTEM.TAGPTRNUM.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_TAGPTRSIZE_MAX, EgVtUInt32, 4, "", "Maximum size of Tag pointer.") == false) bRet = false; //EDGESYSTEM.TAGPTRSIZE.MAX
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_TAGPTRRETRY_COUNT, EgVtUInt32, 4, "", "Tag pointer lock retry count.") == false) bRet = false; //EDGESYSTEM.TAGPTRETRY.COUNT
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_FW_TAGTRIGGERENTRY_MAX, EgVtUInt32, 4, "", "Maximum number of Tag Trigger.") == false) bRet = false; //EDGESYSTEM.FW_TAGTRIGGERENTRY_MAX
	//if (_LocalEgSysTagCreate(EGSYSTAGNAME_SHM_ENTRY_MAX, EgVtUInt32, 4, "", "SHM local entries maximum.") == false) bRet = false;
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_SHM_RETRY_COUNT, EgVtUInt32, 4, "", "SHM lock retry count.") == false) bRet = false;
	if (_LocalEgSysTagCreate(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, EgVtUInt32, 4, "", "FIFO tag lock retry count.") == false) bRet = false;

	// IuWFNgő吔 l
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_SERVICEENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxServiceEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_DSETENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_DSETLINK_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetLink), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_CLCTENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_MAILBOXENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxMailboxEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_C2C_MAILBOXCOL_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxC2CMailboxCol), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_C2C_MAILBOXROW_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxC2CMailboxRow), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_CLCTENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwClctEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_MAILBOXENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwMailboxEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_TAGREFENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_TAGPTRNUM_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxTagPtrNum), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_TAGPTRSIZE_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxTagPtrSize), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_TAGPTRRETRY_COUNT, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxTagPtrRetry), sizeof(uint32_t));
	if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_FW_TAGTRIGGERENTRY_MAX, &(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagTrigEntry), sizeof(uint32_t));
	/* @memo {EDGESYSTEMCONFIGŊǗƂbȂ񂾂낤AʊǗȂ̂ŁAUŒlo͂̂ */
	{
		uint32_t buf;
		//buf = ***
		//if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_SHM_ENTRY_MAX, &buf, sizeof(uint32_t));
		buf = EG_SHM_MAX_RETRY_LOCK;
		if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_SHM_RETRY_COUNT, &buf, sizeof(uint32_t));
		buf = EG_FIFO_MAX_RETRY_LOCK;
		if (g_H_egSysCfg) EgTagWrite(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, &buf, sizeof(uint32_t));
	}


	return bRet;
}
