////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
*
*   RT-edge system Collector object
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
static HNAMESPACE		hObjKeep;				// COLLECTOR NameSpacẽnh
#define CLCT_ENTRY_SIZE	sizeof(ClctDesc)		// Gg̃oCgTCY
#define CLCT_NAME_SPACE	EGCLCTTABLE_NAME		// NamESpace̖

/*****************************************************************************
* FUNCTION:		EgCollectorGetHandle
* DESCRIPTION:
*   ()CollectorNameSpacenh𓾂
\*****************************************************************************/
HNAMESPACE EgCollectorGetHandle(void)
{
	if (hObjKeep != NULL)
		return hObjKeep;								// Ɏ擾ςȂI

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return NULL;

	hObjKeep = EgNamespaceLookup(CLCT_NAME_SPACE);
	if (hObjKeep != NULL)
		return hObjKeep;								// ČI

	hObjKeep = EgNamespaceCreate(CLCT_NAME_SPACE, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry*CLCT_ENTRY_SIZE);
	if (hObjKeep != NULL)
		return hObjKeep;								// NameSpaceVɍďI

	return NULL;										// NameSpace𐶐łɎs
}
/*****************************************************************************
* FUNCTION:		EgCollectorCreate
* DESCRIPTION:
*   Collectoro^
*   ɑ݂ꍇ͉Ȃ
\*****************************************************************************/
int32_t EgCollectorCreate(const char *Name,
						  const char *OwnerServiceName,
						  uint32_t Interval,
						  uint8_t Priority,
						  uint32_t ColSize,
						  uint32_t RowSize,
						  const char *DSetName)
{
	HNAMESPACE		hClct;

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	if (strlen(Name) > EG_MAX_CLCTNAME)
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;								// TCYُȏꍇ̓G[

	if (strlen(OwnerServiceName) > EG_MAX_SERVICENAME)
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;								// TCYُȏꍇ̓G[

	if (strlen(DSetName) > EG_MAX_DSETNAME)
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;								// TCYُȏꍇ̓G[

	hClct = EgCollectorGetHandle();											// Collector̖Oԃnh𓾂
	if (hClct == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (((LPNAMESPACE)hClct)->head.numitem >= ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry)	//ő吔𒴂ꍇ̓G[
		return EDGE_TTABLE_NOEMPTY;

	ClctDesc*		nsh = (ClctDesc*)EgNamespaceGetEntry(hClct, Name);		// CollectorT
	if (nsh != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (ClctDesc*)EgNamespaceAddEntry(hClct, Name, CLCT_ENTRY_SIZE);		// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs

	os_edge_strncpy_s(nsh->chClctName, sizeof(nsh->chClctName), Name, _TRUNCATE);		// ̕ۊ
	os_edge_strncpy_s(nsh->chOwnerName, sizeof(nsh->chOwnerName), OwnerServiceName, _TRUNCATE);
	os_edge_strncpy_s(nsh->chDSetName, sizeof(nsh->chDSetName), DSetName, _TRUNCATE);	// f[^Zbgۊ
	nsh->dwInterVal = Interval;												// Intervalۊ
	nsh->byPriority = Priority;												// Priorityۊ
	nsh->dwColSize = ColSize;												// ColSizeۊ
	nsh->dwRowSize = RowSize;												// RowSizeۊ

	((LPNAMESPACE)hClct)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_CLCTENTRY_COUNT, &(((LPNAMESPACE)hClct)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgCollectorGetProperty
* DESCRIPTION:
*   CollectorPropertyl擾
\*****************************************************************************/
int32_t EgCollectorGetProperty(const char *Name, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hClct;
	hClct = EgCollectorGetHandle();											// Collector̖Oԃnh𓾂
	if (hClct == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0 || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	ClctDesc*	nsh = (ClctDesc*)EgNamespaceGetEntry(hClct, Name);			// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Interval"))							// v邩
	{
		if (dwSize < sizeof(nsh->dwInterVal))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwInterVal;
	}
	else if (_HashCompare(hashed_propname, "Priority"))						// v邩
	{
		if (dwSize < sizeof(nsh->byPriority))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint8_t*)Value = nsh->byPriority;
	}
	else if (_HashCompare(hashed_propname, "ColSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwColSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwColSize;
	}
	else if (_HashCompare(hashed_propname, "RowSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwRowSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(uint32_t*)Value = nsh->dwRowSize;
	}
	else if (_HashCompare(hashed_propname, "DatasetName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chDSetName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chDSetName), nsh->chDSetName ,_TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(ClctDesc**)Value = (ClctDesc*)nsh;
	}
	else if (_HashCompare(hashed_propname, "Index"))						// v邩
	{
		if (dwSize < sizeof(NAMESPACE_INDEX*))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(NAMESPACE_INDEX**)Value = EgNamespaceGetIndex(hClct, Name);
	}
	else if (_HashCompare(hashed_propname, "Hash"))							// v邩
	{
		if (dwSize < sizeof(HASHCODE))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(HASHCODE*)Value = _HashCreate(hClct, Name);
	}
	else if (_HashCompare(hashed_propname, "Name"))							// v邩
	{
		if (dwSize < sizeof(nsh->chClctName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chClctName), nsh->chClctName ,_TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "OwnerName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chOwnerName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chOwnerName), nsh->chOwnerName, _TRUNCATE);
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgCollectorGetPropertyByIndex
* DESCRIPTION:
*   CollectorPropertyl擾
\*****************************************************************************/
int32_t EgCollectorGetPropertyByIndex(EDGE_INDEX *index, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hClct;
	hClct = EgCollectorGetHandle();											// Collector̖Oԃnh𓾂
	if (hClct == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	ClctDesc*	nsh = (ClctDesc*)EgNamespaceGetEntryByIndex(hClct, (LPNAMESPACE_INDEX)index);	// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Interval"))							// v邩
	{
		if (dwSize < sizeof(nsh->dwInterVal))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwInterVal;
	}
	else if (_HashCompare(hashed_propname, "Priority"))						// v邩
	{
		if (dwSize < sizeof(nsh->byPriority))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint8_t*)Value = nsh->byPriority;
	}
	else if (_HashCompare(hashed_propname, "ColSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwColSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwColSize;
	}
	else if (_HashCompare(hashed_propname, "RowSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwRowSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(uint32_t*)Value = nsh->dwRowSize;
	}
	else if (_HashCompare(hashed_propname, "DatasetName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chDSetName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chDSetName), nsh->chDSetName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(ClctDesc**)Value = (ClctDesc*)nsh;
	}
	else if (_HashCompare(hashed_propname, "Name"))							// v邩
	{
		if (dwSize < sizeof(nsh->chClctName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chClctName), nsh->chClctName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "OwnerName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chOwnerName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chOwnerName), nsh->chOwnerName, _TRUNCATE);
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgCollectorGetCount
* DESCRIPTION:
*   ݂̃RN^o^擾
\*****************************************************************************/
int32_t EgCollectorGetCount(uint32_t *pItemNum)
{
	HNAMESPACE		hClct;
	hClct = EgCollectorGetHandle();											// Collector̖Oԃnh𓾂
	if (hClct == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pItemNum == NULL)
		return EDGE_PARAM_INVALID;											// p[^s

	*pItemNum = EgNamespaceGetCount(hClct);									// Gg擾

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgCollectorGetEnum
* DESCRIPTION:
*   Collector̃CfbNXꗗ擾
\*****************************************************************************/
int32_t EgCollectorGetEnum(EDGE_INDEX *pBuffer, uint32_t dwSize, uint32_t *pItemNum)
{
	HNAMESPACE		hClct;
	hClct = EgCollectorGetHandle();											// Collector̖Oԃnh𓾂
	if (hClct == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dwSize < EgNamespaceGetCount(hClct) * sizeof(NAMESPACE_INDEX))		// i[obt@TCY`FbN
	{
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	return EgNamespaceEnumIndex(hClct, (void*)pBuffer, dwSize, pItemNum);	// NamespaceCfbNXꗗ擾
}
