////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egMailbox.h
*
*   RT-edge system Dataset object
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
static HNAMESPACE		hObjKeep;				// Dataset NameSpacẽnh
#define DSET_ENTRY_SIZE	sizeof(DsetDesc)		// Gg̃oCgTCY
#define DSET_OFFSETENTRY_SIZE	sizeof(OFFSET)		// Gg̃oCgTCY
#define DSET_NAME_SPACE	EGDSETTABLE_NAME		// NameSpace̖
/*****************************************************************************
* FUNCTION:		EgDatasetGetHandle
* DESCRIPTION:
*   ()DatasetNameSpacenh𓾂
\*****************************************************************************/
HNAMESPACE EgDatasetGetHandle(void)
{
	if (hObjKeep != NULL)
		return hObjKeep;								// Ɏ擾ςȂI

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return NULL;

	hObjKeep = EgNamespaceLookup(DSET_NAME_SPACE);
	if (hObjKeep != NULL)
		return hObjKeep;								// ČI

	hObjKeep = EgNamespaceCreate(DSET_NAME_SPACE, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetEntry, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetEntry * (DSET_ENTRY_SIZE + (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetLink - 1)*DSET_OFFSETENTRY_SIZE));
	if (hObjKeep != NULL)
		return hObjKeep;								// NameSpaceVɍďI

	return NULL;										// NameSpace𐶐łɎs
}

/*****************************************************************************
* FUNCTION:		EgDatasetCreate
* DESCRIPTION:
*   Dataseto^
*   ɑ݂ꍇ͉Ȃ
\*****************************************************************************/
int32_t EgDatasetCreate(const char *Name)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	if (strlen(Name) > EG_MAX_DSETNAME)										// DatasetName̒傫ꍇG[
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

	if(((LPNAMESPACE)hDset)->head.numitem >= ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetEntry)	//ő吔𒴂ꍇ̓G[
		return EDGE_TTABLE_NOEMPTY;

	DsetDesc*		nsh = (DsetDesc*)EgNamespaceGetEntry(hDset, Name);		// GgT
	if (nsh != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (DsetDesc*)EgNamespaceAddEntry(hDset, Name, DSET_ENTRY_SIZE + (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetLink - 1)*DSET_OFFSETENTRY_SIZE);		// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs

	nsh->woMaxCount = ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetEntry;
	os_edge_strncpy_s(nsh->chName, sizeof(nsh->chName), Name, _TRUNCATE);	// ̕ۊ

	((LPNAMESPACE)hDset)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_DSETENTRYY_COUNT, &(((LPNAMESPACE)hDset)->head.numitem), sizeof(uint32_t));
	
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgDatasetAddTag
* DESCRIPTION:
*   DatasetɃ^OTagǉ@Ow
\*****************************************************************************/
int32_t EgDatasetAddTag(const char *Name, const char *TagName)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	DsetDesc*		nsh = (DsetDesc*)EgNamespaceGetEntry(hDset, Name);		// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_DSETNAME;								// ݂s

	uint16_t	linkcount = nsh->woCount;
	if (linkcount >= ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxDsetLink)
		return EDGE_TTABLE_VALUE_OVERFLOW;									// o^𒴂鎸s

	HNAMESPACE TagHandle = EgTagGetHandle();
	TagsDesc *td;
	int32_t ret = EgTagGetProperty(TagName, "Entry", &td, sizeof(td));		// Tag̃Gg擾
	if (ret != EDGE_SUCCESS)
	{
		return ret;															// Tag݂s
	}
	nsh->tag[linkcount]= (OFFSET)((intptr_t)td - (intptr_t)TagHandle);		// Tag̃NGg
	nsh->woCount = ++linkcount;												// N++
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgDatasetGetFirst
* DESCRIPTION:
*   Dataset̍ŏ̃^O擾
\*****************************************************************************/
int32_t EgDatasetGetFirst(const char *Name ,dslink *dslink)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	DsetDesc*		nsh = (DsetDesc*)EgNamespaceGetEntry(hDset, Name);		// Dataset̃GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_DSETNAME;									// ݂s

	uint16_t	linkcount = nsh->woCount;									// Dataset̍\vf
	if( linkcount == 0 )
		return EDGE_TTABLE_NOEXISTT_DSETITEM;									// Ŏs

	HNAMESPACE TagHandle = EgTagGetHandle();								
	TagsDesc *td = (TagsDesc*)((intptr_t)nsh->tag[0] + (intptr_t)TagHandle);	// TAG̃Gg𓾂
	dslink->ds = nsh;														// Dataset̃GgoĂ
	dslink->inst = 0;
	dslink->offset = 0;														// ItZbglݒ
	dslink->tag = td;														// TAG̃GgԂ
	dslink->TagName = (char*)td->chName;									// Dataset̃Gg(dslink->TagName)Ԃ
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetNext
* DESCRIPTION:
*   Dataset̎̃^O擾
\*****************************************************************************/
int32_t EgDatasetGetNext(dslink *dslink)
{
	HNAMESPACE		hDset;
	TagsDesc*		dec;
	uint16_t		prevSize;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dslink == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	dec = (TagsDesc*)dslink->tag;
	if (dec)
		prevSize = dec->var.size;											//OTag̃f[^TCY擾

	DsetDesc* nsh = (DsetDesc*)dslink->ds;									// Dataset̃Ggo
	uint16_t inst = ++dslink->inst;
	if (nsh->tag[inst] == 0)												// ̃Gg
	{
		dslink->TagName = NULL;
		return EDGE_TTABLE_TAG_IS_NULL;										// nextȂ
	}

	HNAMESPACE TagHandle = EgTagGetHandle();
	TagsDesc *td = (TagsDesc*)((intptr_t)nsh->tag[inst] + (intptr_t)TagHandle);
	dslink->tag = td;														// TAG̃GgԂ
	dslink->offset = dslink->offset + prevSize;								// ItZbglݒ
	dslink->TagName = (char*)td->chName;									// ̃^O̖O

	return EDGE_SUCCESS;													// Dataset̃Gg(dslink->TagName)Ԃ
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetSize
* DESCRIPTION:
*   Dataset̑SĂTagSizeZA1R[h̃oCioCgTCYԂ
\*****************************************************************************/
size_t EgDatasetGetSize(const char *Name)
{
	dslink dsl;

	if (strlen(Name) == 0)
		return 0;															// 󕶎ENULL̓G[

	int	rtn = EgDatasetGetFirst(Name, &dsl);								//ŏTag擾
	if (rtn != EDGE_SUCCESS)
		return 0;

	TagsDesc *dec;
	int32_t binAllSize = 0;
	do {																	//TagȂ܂Ŏ擾
		dec = (TagsDesc*)dsl.tag;
		if (dec)
		{
			binAllSize += dec->var.size;									//l̃TCY擾vX
		}
	} while (EgDatasetGetNext(&dsl) == EDGE_SUCCESS);

	return binAllSize;
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetBinary
* DESCRIPTION:
*   Dataset̑SĂTagValue擾A1R[h̃oCilƂĘA쐬
\*****************************************************************************/
int32_t EgDatasetGetBinary(const char *Name, void* Dest, size_t DestSize)
{
	dslink dsl;

	if (Dest == NULL)
		return EDGE_PARAM_INVALID;											//p[^s

	if (EgDatasetGetSize(Name) > DestSize)
		return EDGE_PARAM_INVALID;											//p[^s

	int	rtn = EgDatasetGetFirst(Name, &dsl);								//ŏTag擾
	if (rtn != EDGE_SUCCESS)
		return rtn;

	TagsDesc *dec;
	int buffCount = 0;
	do {																	//TagȂ܂Ŏ擾
		dec = (TagsDesc*)dsl.tag;
		if (dec)
		{																	//DestvarȂ̓n
			memcpy_s((BYTE*)(Dest)+buffCount, dec->var.size, &dec->var.val, dec->var.size);
			buffCount += dec->var.size;
		}
	} while (EgDatasetGetNext(&dsl) == EDGE_SUCCESS);

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgDatasetSetBinary
* DESCRIPTION:
*   oCiƂDataset̑SĂTagValueXV
\*****************************************************************************/
int32_t EgDatasetSetBinary(const char *Name, void* Source, size_t SourceSize)
{
	dslink dsl;
	int	rtn = EgDatasetGetFirst(Name, &dsl);								//ŏTag擾
	if (rtn != EDGE_SUCCESS)
		return rtn;

	TagsDesc *dec;
	int buffCount = 0;
	do {																	//TagȂ܂Ŏ擾
		dec = (TagsDesc*)dsl.tag;
		if (dec)
		{																	//Source̓eTagɗƂ
			memcpy_s(&dec->var.val, sizeof(union EgVARIANTValues), (BYTE*)(Source)+buffCount, dec->var.size);
			buffCount += dec->var.size;
		}
	} while (EgDatasetGetNext(&dsl) == EDGE_SUCCESS);

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetPropertyByIndex
* DESCRIPTION:
*   ServicePropertyl擾
\*****************************************************************************/
int32_t EgDatasetGetPropertyByIndex(EDGE_INDEX *index, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	DsetDesc*	nsh = (DsetDesc*)EgNamespaceGetEntryByIndex(hDset, (LPNAMESPACE_INDEX)index);	// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Name"))								// v邩
	{
		if (dwSize < sizeof(nsh->chName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chName), nsh->chName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "ItemNum"))						// v邩
	{
		if (dwSize < sizeof(nsh->woCount))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->woCount;
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(DsetDesc**)Value = (DsetDesc*)nsh;
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetCount
* DESCRIPTION:
*   ݂Tago^擾
\*****************************************************************************/
int32_t EgDatasetGetCount(uint32_t *pItemNum)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pItemNum == NULL)
		return EDGE_PARAM_INVALID;											// p[^s

	*pItemNum = EgNamespaceGetCount(hDset);									// Gg擾

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgDatasetGetEnum
* DESCRIPTION:
*   Dataset̃CfbNXꗗ擾
\*****************************************************************************/
int32_t EgDatasetGetEnum(EDGE_INDEX *pBuffer, uint32_t dwSize, uint32_t *pItemNum)
{
	HNAMESPACE		hDset;
	hDset = EgDatasetGetHandle();											// Dataset̖Oԃnh𓾂
	if (hDset == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dwSize < EgNamespaceGetCount(hDset) * sizeof(NAMESPACE_INDEX))		// i[obt@TCY`FbN
	{
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	return EgNamespaceEnumIndex(hDset, (void*)pBuffer, dwSize, pItemNum);	// NamespaceCfbNXꗗ擾
}
