////
/// Copyright(C) 2021 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egDllLoad.c
*
*   RT-edge system / Dynamic-Link Library loding
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
edge_API void* g_H_egosdep = 0;		// egosdeppW[nh

// egosdepp֐|C^
DPedge_setNode				edge_setNode;
DPedge_getNodeName			edge_getNodeName;
DPedge_createMemory			edge_createMemory;
DPedge_freeMemory			edge_freeMemory;
DPedge_map					edge_map;
DPedge_unmap				edge_unmap;
DPedge_closeHandle			edge_closeHandle;
DPedge_mallocMemory			edge_mallocMemory;
DPedge_freemallocMemory		edge_freemallocMemory;
DPedge_catalog				edge_catalog;
DPedge_uncatalog			edge_uncatalog;
DPedge_lookup				edge_lookup;
DPedge_createService		edge_createService;
DPedge_createServiceEx		edge_createServiceEx;
DPedge_creMbox				edge_creMbox;
DPedge_delMbox				edge_delMbox;
DPedge_openMbox				edge_openMbox;
DPedge_closeMbox			edge_closeMbox;
DPedge_sendMbox				edge_sendMbox;
DPedge_recvMbox				edge_recvMbox;
DPedge_infoMbox				edge_infoMbox;
DPedge_createThread			edge_createThread;
DPedge_deleteThread			edge_deleteThread;
DPedge_sleep				edge_sleep;
DPedge_getProcPath			edge_getProcPath;
DPedge_getTime				edge_getTime;
DPedge_getTimeVal			edge_getTimeVal;
DPedge_Localtime64			edge_Localtime64;
DPedge_setPriority			edge_setPriority;
DPedge_getCommmandLine		edge_getCommmandLine;
DPedge_strncpy_s			edge_strncpy_s;
DPedge_checkHandle			edge_checkHandle;
DPedge_sendMboxEx			edge_sendMboxEx;
DPedge_recvMboxEx			edge_recvMboxEx;
DPedge_GetPCounter			edge_GetPCounter;
DPedge_CalcTime				edge_CalcTime;
DPedge_lookup_memory		edge_lookup_memory;


/*****************************************************************************
* FUNCTION:		EgIsINtime
* DESCRIPTION:
*   INtimeCXg[L`FbN
*   ߂l: 0      INtimeCXg[L
*           0 ȊO INtimeCXg[
\*****************************************************************************/
int EgIsINtime()
{
#ifdef __INTIME__
	// INtimeAvP[Vł̓`FbNsv
#else
	HKEY keyHandle;

	// INtimẽWXgL[I[vBINtimeCXg[́ATenAsysL[݂Ȃߎs
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Wow6432Node\\TenAsys\\INtime", 0, KEY_QUERY_VALUE, &keyHandle) != ERROR_SUCCESS) {
		return -1;
	}

	// WXgL[N[YB
	RegCloseKey(keyHandle);
#endif
	return 0;
}

/*****************************************************************************
* FUNCTION:		egosdep_LoadLibrary
* DESCRIPTION:
*   ()OSˑCu̓I[h
\*****************************************************************************/
void* load_egosdep()
{
#ifdef __INTIME__
	// -------------------------------------------------------------------------
	// NOTE: INtimeAvP[V̏ꍇ́A[h郉Cu͌Œ
	// -------------------------------------------------------------------------
	return (void*)LoadRtLibrary("egosdep.rsl");
#else
	// -------------------------------------------------------------------------
	// NOTE: WindowsAvP[V̏ꍇ́AINtimeLɂă[h
	//       Cu؂ւ
	// -------------------------------------------------------------------------
	if (0 == EgIsINtime())		// INtimeL𔻒
	{
		// INtime
		return (void*)LoadLibrary("egosdepntx.dll");
	}
	else
	{
		// WindowsiINtimeCXg[j
		return (void*)LoadLibrary("egosdepwin.dll");
	}
#endif
}

/*****************************************************************************
* FUNCTION:		eg_GetProcAddress
* DESCRIPTION:
*   ()OCů֐|C^擾
\*****************************************************************************/
void* eg_GetProcAddress(void* hMod, const char* func_name)
{
#ifdef __INTIME__
	return (void*)GetRtProcAddress((RTHANDLE)hMod, func_name);
#else
	return (void*)GetProcAddress((HMODULE)hMod, func_name);
#endif
}

/*****************************************************************************
* FUNCTION:		edge_FreeLibrary
* DESCRIPTION:
*   ()OCủ
\*****************************************************************************/
void edge_FreeLibrary(void* hMod)
{
#ifdef __INTIME__
	FreeRtLibrary((RTHANDLE)hMod);
#else
	FreeLibrary((HMODULE)hMod);
#endif
	g_H_egosdep = NULL;
	g_H_egSysCfg = NULL;
	return;
}


/*****************************************************************************
* FUNCTION:		egosdepLoad
* DESCRIPTION:
*   ()OSˑCu̓I[h
\*****************************************************************************/
int32_t egosdepLoadLibrary()
{
	if (g_H_egosdep == NULL)
	{
		g_H_egosdep = load_egosdep();		// egosdep̃[h
		
		if (g_H_egosdep == NULL)
		{
			return EDGE_MODULE_LOAD_ERROR;	// [hs͏𔲂
		}

		// Cu֐|C^̎擾
		edge_setNode			= (DPedge_setNode)eg_GetProcAddress(g_H_egosdep, "edge_setNode");
		edge_getNodeName		= (DPedge_getNodeName)eg_GetProcAddress(g_H_egosdep, "edge_getNodeName");
		edge_createMemory		= (DPedge_createMemory)eg_GetProcAddress(g_H_egosdep, "edge_createMemory");
		edge_freeMemory			= (DPedge_freeMemory)eg_GetProcAddress(g_H_egosdep, "edge_freeMemory");
		edge_map				= (DPedge_map)eg_GetProcAddress(g_H_egosdep, "edge_map");
		edge_unmap				= (DPedge_unmap)eg_GetProcAddress(g_H_egosdep, "edge_unmap");
		edge_closeHandle		= (DPedge_closeHandle)eg_GetProcAddress(g_H_egosdep, "edge_closeHandle");
		edge_mallocMemory		= (DPedge_mallocMemory)eg_GetProcAddress(g_H_egosdep, "edge_mallocMemory");
		edge_freemallocMemory	= (DPedge_freemallocMemory)eg_GetProcAddress(g_H_egosdep, "edge_freemallocMemory");
		edge_catalog			= (DPedge_catalog)eg_GetProcAddress(g_H_egosdep, "edge_catalog");
		edge_uncatalog			= (DPedge_uncatalog)eg_GetProcAddress(g_H_egosdep, "edge_uncatalog");
		edge_lookup				= (DPedge_lookup)eg_GetProcAddress(g_H_egosdep, "edge_lookup");
		edge_createService		= (DPedge_createService)eg_GetProcAddress(g_H_egosdep, "edge_createService");
		edge_createServiceEx	= (DPedge_createServiceEx)eg_GetProcAddress(g_H_egosdep, "edge_createServiceEx");
		edge_creMbox			= (DPedge_creMbox)eg_GetProcAddress(g_H_egosdep, "edge_creMbox");
		edge_delMbox			= (DPedge_delMbox)eg_GetProcAddress(g_H_egosdep, "edge_delMbox");
		edge_openMbox			= (DPedge_openMbox)eg_GetProcAddress(g_H_egosdep, "edge_openMbox");
		edge_closeMbox			= (DPedge_closeMbox)eg_GetProcAddress(g_H_egosdep, "edge_closeMbox");
		edge_sendMbox			= (DPedge_sendMbox)eg_GetProcAddress(g_H_egosdep, "edge_sendMbox");
		edge_recvMbox			= (DPedge_recvMbox)eg_GetProcAddress(g_H_egosdep, "edge_recvMbox");
		edge_infoMbox			= (DPedge_infoMbox)eg_GetProcAddress(g_H_egosdep, "edge_infoMbox");
		edge_createThread		= (DPedge_createThread)eg_GetProcAddress(g_H_egosdep, "edge_createThread");
		edge_deleteThread		= (DPedge_deleteThread)eg_GetProcAddress(g_H_egosdep, "edge_deleteThread");
		edge_sleep				= (DPedge_sleep)eg_GetProcAddress(g_H_egosdep, "edge_sleep");
		edge_getProcPath		= (DPedge_getProcPath)eg_GetProcAddress(g_H_egosdep, "edge_getProcPath");
		edge_getTime			= (DPedge_getTime)eg_GetProcAddress(g_H_egosdep, "edge_getTime");
		edge_getTimeVal			= (DPedge_getTimeVal)eg_GetProcAddress(g_H_egosdep, "edge_getTimeVal");
		edge_Localtime64		= (DPedge_Localtime64)eg_GetProcAddress(g_H_egosdep, "edge_Localtime64");
		edge_setPriority		= (DPedge_setPriority)eg_GetProcAddress(g_H_egosdep, "edge_setPriority");
		edge_getCommmandLine	= (DPedge_getCommmandLine)eg_GetProcAddress(g_H_egosdep, "edge_getCommmandLine");
		edge_strncpy_s			= (DPedge_strncpy_s)eg_GetProcAddress(g_H_egosdep, "edge_strncpy_s");
		edge_checkHandle		= (DPedge_checkHandle)eg_GetProcAddress(g_H_egosdep, "edge_checkHandle");
		edge_sendMboxEx			= (DPedge_sendMboxEx)eg_GetProcAddress(g_H_egosdep, "edge_sendMboxEx");
		edge_recvMboxEx			= (DPedge_recvMboxEx)eg_GetProcAddress(g_H_egosdep, "edge_recvMboxEx");
		edge_GetPCounter		= (DPedge_GetPCounter)eg_GetProcAddress(g_H_egosdep, "edge_GetPCounter");
		edge_CalcTime			= (DPedge_CalcTime)eg_GetProcAddress(g_H_egosdep, "edge_CalcTime");
		edge_lookup_memory		= (DPedge_lookup_memory)eg_GetProcAddress(g_H_egosdep, "edge_lookup_memory");

		// G[`FbN
		if (edge_createMemory == NULL ||
			edge_freeMemory == NULL ||
			edge_map == NULL ||
			edge_unmap == NULL ||
			edge_closeHandle == NULL ||
			edge_mallocMemory == NULL ||
			edge_freemallocMemory == NULL ||
			edge_catalog == NULL ||
			edge_uncatalog == NULL ||
			edge_setNode == NULL ||
			edge_getNodeName == NULL ||
			edge_lookup == NULL ||
			edge_createService == NULL ||
			edge_createServiceEx == NULL ||
			edge_creMbox == NULL ||
			edge_delMbox == NULL ||
			edge_openMbox == NULL ||
			edge_closeMbox == NULL ||
			edge_sendMbox == NULL ||
			edge_recvMbox == NULL ||
			edge_infoMbox == NULL ||
			edge_createThread == NULL ||
			edge_deleteThread == NULL ||
			edge_sleep == NULL ||
			edge_getProcPath == NULL ||
			edge_getTime == NULL ||
			edge_getTimeVal == NULL ||
			edge_Localtime64 == NULL ||
			edge_setPriority == NULL ||
			edge_getCommmandLine == NULL ||
			edge_strncpy_s == NULL ||
			edge_checkHandle == NULL || 
			edge_sendMboxEx == NULL ||
			edge_recvMboxEx == NULL ||
			edge_GetPCounter == NULL ||
			edge_CalcTime == NULL ||
			edge_lookup_memory == NULL)
		{
			// NOTE: {P[X̃G[́A֐`̕svȂǂɂB
			//       G[Ԃ𖾊mɂ邽߃W[nhNULLZbgB
			g_H_egosdep = NULL;	
			return EDGE_MODULE_LOAD_ERROR;
		}
	}

	return EDGE_SUCCESS;
}

