////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egFramework.cpp
*
*   RT-edge system Framework
*
\*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <sys/stat.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"
#define EG_MBOX_NAME_LOG			"EGSYSLOG"							//Õ[{bNX
#define EG_TAG_NAME_MBOXLOG_LOSTCNT "EDGESYSTEM.LogLostCnt"				//Logɏ߂ȂTag

#include <crtdbg.h>

//
//T[rXXe[^Xl
//
uint8_t EG_STATE_NOT_WORK = 0;			//NĂȂ or NI
uint8_t EG_STATE_NORMAL_WORK = 1;		//N
uint8_t EG_STATE_INITIAL_ERR = 2;		//initialɃG[
uint8_t EG_STATE_FINALIZE_ERR = 3;		//finalizeɃG[
uint8_t EG_STATE_SYSTEM_ERR = 4;		//ȃG[
uint8_t EG_STATE_INITIALIZING = 10;		//initial
uint8_t EG_STATE_CREATED_MBOX = 11;		//initial [{bNX쐬

//
//T[rXXe[^Xl
//
uint8_t EG_STATE2DEPEND_NOT_WORK = 0;			//NĂȂ or NI
uint8_t EG_STATE2DEPEND_INITIALEND = 0x0010;	//

//
//T[rXReiN\
//
#pragma pack(push,1)
//------------------------------------------------------------------------------
// SRVBOOTARG N̈i[\ //312byte
//------------------------------------------------------------------------------
typedef struct
{
	uint8_t		byPriority;						// vCIeB
	uint8_t		byTrigPriority;					// ^OgKMXbhvCIeB
	uint8_t		_Reserve1[2];					// \
	uint32_t	dwColSize;						// T[rXReiԒʐMp[{bNX 1R[hf[^TCY
	uint32_t	dwRowSize;						// T[rXReiԒʐMp[{bNX R[h
	char		chName[EG_MAX_SERVICENAME + 1];	// T[rX
	uint8_t		_Reserve2[2];					// \
	uint8_t		byPTestFlag;					// ptH[}XeXg邩ۂ̃tO
	uint32_t	_TrigCycle;						// ms
	uint32_t	_MyMboxCycle;					// ms
	char		chECIPath[EG_MAX_PATH + 1];		// ECIpX 256 + 1
	uint8_t		_Reserve4[3];					// \
} SRVBOOTARG;
#pragma pack(pop)
//
// Nʗpϐ
//
uint8_t EG_ARG_NON = 0;							// ftHg 
uint8_t EG_ARG_PRIORITY = 1;					// -priority
uint8_t EG_ARG_COLSIZE = 2;						// -colsize 
uint8_t EG_ARG_ROWSIZE = 3;						// -rowsize
uint8_t EG_ARG_NAME = 4;						// -name 
uint8_t EG_ARG_ECI = 5;							// -ECI 
uint8_t EG_ARG_TRIGPRIORITY = 6;				// -trigpriority
uint8_t EG_ARG_TRIGCYCLE = 7;					// -trigCycle
uint8_t EG_ARG_PTEST = 8;						// -ptest
uint8_t EG_ARG_MYMBOXCYCLE = 9;					// -mymboxCycle
#define EGFW_DEF_C2C_MAILBOXPRI	150		// ReiԒʐM[{bNXXbhvCIeB ftHg
#define EGFW_DEF_C2C_MAILBOXCOL	2048	// ReiԒʐM[{bNX1R[hf[^ ftHg
#define EGFW_DEF_C2C_MAILBOXROW	1024	// ReiԒʐM[{bNXR[h ftHg
#define EGFW_DEF_TRIGGER_PRI	150		// ^OgK[MpXbhvCIeB ftHg

//#######################################################################
//
// GNX|[gϐ (TODO v)
//
//########################################################################

edge_API char ServiceRealName[EG_MAX_SERVICENAME+1] = { 0 };			//T[rX
edge_API char ServiceMailboxName[EG_MAX_SERVICEMAILBOXNAME + 1] = { 0 };	//T[rX[{bNX
edge_API char ServiceName[EG_MAX_SERVICEMAILBOXNAME + 1] = { 0 };			//T[rX[{bNX//o[WpɎc
edge_API char ServiceStateName[EG_MAX_TAGNAME+1] = { 0 };				//T[rX̃ANeBuXe[^X(Tag)
edge_API char ServiceStateErrName[EG_MAX_TAGNAME+1] = { 0 };			//T[rẌُԃXe[^X(Tag)
edge_API char ServiceStateRunName[EG_MAX_TAGNAME+1] = { 0 };			//T[rX̎sԃXe[^X(Tag)
edge_API char ServiceStateLiveName[EG_MAX_TAGNAME+1] = { 0 };			//T[rXsCNg(Tag)
edge_API char ServiceState2DependName[EG_MAX_TAGNAME + 1] = { 0 };		//ˑ֌Wݒ莞̋NԌop^O(Tag)
edge_API char ServiceMboxTagName[EG_MAX_TAGNAME + 1] = { 0 };			//T[rX[{bNX Tag
edge_API char ServiceMboxColSizeName[EG_MAX_TAGNAME + 1] = { 0 };		//T[rXԒʐM[{bNX1R[hTCY(Tag)
edge_API char ServiceMboxRowSizeName[EG_MAX_TAGNAME + 1] = { 0 };		//T[rXԒʐM[{bNX̃R[h(Tag)
edge_API char ServiceTrigAutoRunName[EG_MAX_TAGNAME + 1] = { 0 };		//gK[Xbh̎Jnݒ^O ftHg
edge_API char ServiceTrigStateErrName[EG_MAX_TAGNAME + 1] = { 0 };		//gK[XbḧُԃXe[^X(Tag)
edge_API int32_t egTagRefs_OUT_Count = 0;								//TagRef OUT ̐
edge_API int32_t egTagRefs_IN_Count = 0;								//TagRef IN  ̐
edge_API int32_t egTagRefs_Count = 0;									//TagRef     ̐
edge_API int32_t egCollectors_Count = 0;								//Collector  ̐
edge_API int32_t egCollectorRefs_Count = 0;								//CollectorRef ̐
edge_API int32_t egMailBoxes_Count = 0;									//MailBox    ̐
edge_API int32_t egTagTriggers_Count = 0;								//TagTrigger   ̐
edge_API EGTAGREF* egTagRefs_OUT = NULL;								//TagRef OUT ꗗ |C^
edge_API EGTAGREF* egTagRefs_IN = NULL;									//TagRef IN  ꗗ |C^
edge_API EGTAGREF* egTagRefs = NULL;									//TagRef     ꗗ |C^
edge_API EGIOPORT* egTagRefs_OUT_PortInfo = NULL;						//TagRef OUTge[u(EdgeIO|[g) ꗗ |C^
edge_API EGIOPORT* egTagRefs_IN_PortInfo = NULL;						//TagRef IN ge[u(EdgeIO|[g) ꗗ |C^
edge_API EGIOPORT* egTagRefs_PortInfo = NULL;							//TagRef    ge[u(EdgeIO|[g) ꗗ |C^
edge_API EGLOCALCOLLECTOR* egCollectors = NULL;							//Collector  ꗗ |C^
edge_API EGCOLLECTORREF* egCollectorRefs = NULL;						//CollectorRef ꗗ |C^
edge_API EGMAILBOX* egMailBoxes = NULL;									//MailBox    ꗗ |C^
edge_API EGTAGTRIGGER* egTagTriggers = NULL;							//TagTrigger ꗗ|C^
//#######################################################################
//
// O[oϐ
//
//########################################################################
void*			gm_ThMBox = NULL;										//T[rXŗLMailbox̃Xbh߂l
uint8_t			gm_MyMailBoxCancelF;									//T[rXŗLMailbox̃^XNLZtO
void*			gm_ThTrig = NULL;										//^OgK[Mailbox̃Xbh߂l
uint8_t			gm_TagTriggerCanncelF;									//^OgK[MXbhLZtO
FUNC_POINTER	pUserFunc;												//T[rXŗLMailboxbZ[Wnh([U[pR[obN֐) TCYŒ
FUNC_POINTEREX	pUserFuncEx;											//T[rXŗLMailboxbZ[Wnh([U[pR[obN֐) TCY
INITENDFUNC_POINTER pInitEndFunc;										//EgBootT[rXxmlǂݏIۂɍs֐
RTCDMEMINFO		gm_MyMBoxMemInfo;										//T[rXŗLMailbox̍\
RTCDHANDLE		gm_MyMBoxHandle = { 0 } ;								//(TODO:Ȃ)T[rXŗLMailbox̃nh
RTCDHANDLE		gm_LogMBoxHandle = { 0 };								//(TODO:Ȃ)LOGMailbox̃nh
uint8_t			gm_OpendLogMBoxF = EG_FALSE;							//(TODO:Ȃ)LOGMailboxJĂ邩ۂ(ۂɎgp)
uint8_t			gm_ReadENDXmlFileF = EG_FALSE;							//g̃T[rXxmlt@CǂݏIۂ̃tO
uint8_t			gm_CoreCreateEndF = EG_FALSE;							//EgBootCreateI痧
uint8_t			gm_EdgeIOPortSetF = EG_FALSE;							//EdgeIO|[ggp邩ۂx{邽߂̃tO
uint8_t			gm_EdgeIOPortEnabled = EG_FALSE;						//EdgeIO|[ggpL
SRVBOOTARG		gm_CmdArg = { 0 };											//R}h initŎ擾
uint8_t			gm_TriggerThCreateF = EG_FALSE;							//gK[MXbhǂ̃tO
DEBUGFUNC_POINTER pDebugFunc;
uint8_t			gm_Ack_TAG_DEFAULT_VALUE_SET_END = EG_FALSE;			// ^OlǍvɑ΂鉞tO
int32_t			gm_Result_TAG_DEFAULT_VALUE_SET_END = EDGE_SUCCESS;		// ^OlǍvɑ΂鉞̃Xe[^X
//#######################################################################
//
// [J֐
//
//########################################################################
int32_t ExecTagTriggerTh();
int32_t AddTagTrigger(void* pData);
int32_t StartTagTrigThread();
/*****************************************************************************
* FUNCTION:		_PrintLog
* DESCRIPTION:
*   ()[{bNXփOo
\*****************************************************************************/
void _PrintLog(const char* pServiceName, const char* pLogWriter, const char* pMode, const char* pData)
{
	EDGE_TIME_STAMP ts = { 0 };	// ԏo͗p
	char date[128];				// Ԃ̏obt@
	int32_t ret = 0;			// ߂l
	char *messBuff = NULL;		// ObZ[Wei[郁̃|C^
	char pChkValue[64] = { 0 };	// ꎞ`FbNp
	uint32_t uiLogLostCnt = 0;	// Of[^pJE^

	struct tm	time;			// ԍ\
	__time64_t longTime;		// 64ō\

	//
	memset(date, 0, sizeof(date));

	ret = EgGetTime(&ts);		// Ԏ擾(ver2 edge-APIĂяo)
	if (ret != EDGE_SUCCESS) {
		sprintf_s(date, sizeof(date), "_TIME_ERROR_");
	}
	else {
		// ^CX^vl[JԂɕϊ
		longTime = (__time64_t)ts.time;
		if (os_edge_Localtime64(&time, &longTime) != 0) {
			printf("localtime_s Error errno=%d\n", errno);
			sprintf_s(date, sizeof(date), "_TIME_ERROR_");
		}

		sprintf_s(date, sizeof(date), "%d/%02d/%02d %d:%02d:%02d:%03d\n",
			time.tm_year + 1900, time.tm_mon + 1, time.tm_mday, time.tm_hour, time.tm_min, time.tm_sec, ts.millisecond);
	}

	//allocate
	size_t bufsize = 2048;
	messBuff = (char*)os_edge_mallocMemory(bufsize);
	if (messBuff == NULL)
		return;

	memset(messBuff, 0, bufsize);

	//J}؂Ńf[^쐬
	sprintf_s(messBuff,bufsize, "\"%s\",\"%s\",\"%s\",\"%s\",\"%s\"", date, pLogWriter, pServiceName, pMode, pData);
	if (gm_OpendLogMBoxF == EG_FALSE)//O[{bNXI[vĂȂꍇ̓I[v
	{
		//O[{bNX݃I[v
		if (EgMailboxOpen(EG_MBOX_NAME_LOG, RTCD_WRITE, &gm_LogMBoxHandle) == 0)
			gm_OpendLogMBoxF = EG_TRUE;
	}
	if (gm_OpendLogMBoxF == EG_TRUE)
	{
		//f[^
		ret = EgMailboxSend(&gm_LogMBoxHandle, pServiceName, 0, messBuff, 2048);
		if (ret != 0)
		{
			//LostJEgɒǉ
			EgTagGetProperty(EG_TAG_NAME_MBOXLOG_LOSTCNT, "Name", pChkValue, sizeof(pChkValue));
			if (strlen(pChkValue) == 0)
			{
				//Ȃꍇ͍쐬
				EgTagCreate(EG_TAG_NAME_MBOXLOG_LOSTCNT, EgVtUInt32, 4, "", "");
			}
			if (EgTagRead(EG_TAG_NAME_MBOXLOG_LOSTCNT, &uiLogLostCnt, sizeof(uiLogLostCnt)) == 0)
			{
				uiLogLostCnt++;//1ď
				EgTagWrite(EG_TAG_NAME_MBOXLOG_LOSTCNT, &uiLogLostCnt, sizeof(uint32_t));
			}
		}
	}

	//free
	os_edge_freemallocMemory(messBuff);
}
/*****************************************************************************
* FUNCTION:		PrintSysLog
* DESCRIPTION:
*   t[[NOo͊֐(VXep)
\*****************************************************************************/
void PrintSysLog(const char* pMode, const char* format, ...)
{
	va_list arg;
	char *messBuff = NULL;
	//allocate
	size_t bufsize = 1024;
	messBuff = (char*)os_edge_mallocMemory(bufsize);
	if (messBuff == NULL)
		return;

	memset(messBuff, 0, bufsize);

	//tH[}bgϊ
	va_start(arg, format);
	vsprintf_s(messBuff, bufsize, format, arg);
	va_end(arg);

	if (strlen(ServiceRealName) > 0)
		_PrintLog(ServiceRealName, "EGSYS", pMode, messBuff);		//T[rXw莞͎w̃T[rX
	else
		_PrintLog("N/A", "EGSYS", pMode, messBuff);				//T[rXꍇ N/A 

	//free
	os_edge_freemallocMemory(messBuff);
}
//
// IuWFNgőlݒԊmF + 쐬
//
bool EgSysCfgCheck()
{
	// ݒt@C̃擾	ɐݒ肳Ăꍇ͏Ȃ
	if (g_H_egSysCfg != NULL)
		return true;
	else
	{
		g_H_egSysCfg = EgSysCfgLookup();
		if (g_H_egSysCfg == NULL)
		{
			//ftHglō쐬
			g_H_egSysCfg = EgSysCfgCreate(NULL);
		}
	}

	if (g_H_egSysCfg == NULL)
		return false;
	return true;
}

/*****************************************************************************
* FUNCTION:		fnSendMessage ([J֐)
* DESCRIPTION:
* T[rXԒʐM̃bZ[WM֐
\*****************************************************************************/
int32_t fnSendMessage(const char* mboxName, int32_t messageNo, void* arg, uint32_t dwSize)
{
	RTCDHANDLE pHandle = { 0 };
	int32_t rtn;

	// 1 : Read , 2 : Write , 3 : ReadWrite
	rtn = EgMailboxOpen(mboxName, RTCD_WRITE, &pHandle);
	if (rtn != EDGE_SUCCESS)
		return rtn;

	//EgBootxmlǍ߂𑗐M
	rtn = EgMailboxSend(&pHandle, ServiceRealName, messageNo, arg, dwSize);
	if (rtn != EDGE_SUCCESS)
		PrintSysLog(EG_LOG_ERR, "EgMailboxSend Error = [%d] [FUNC = %s]", rtn, __func__);

	rtn = EgMailboxClose(&pHandle);//
	return rtn;
}
/*****************************************************************************
* FUNCTION:		fnSendMessageToMe ([J֐)
* DESCRIPTION:
* gɃbZ[WM֐
\*****************************************************************************/
int32_t fnSendMessageToMe(int32_t messageNo, void* arg, uint32_t dwSize)
{
	int32_t rtn;

	//g֖߂𑗐M
	rtn = EgMailboxSend(&gm_MyMBoxHandle, ServiceRealName, messageNo, arg, dwSize);
	if (rtn != EDGE_SUCCESS)
		PrintSysLog(EG_LOG_ERR, "EgMailboxSend Error = [%d] [FUNC = %s]", rtn, __func__);

	return rtn;
}
/*****************************************************************************
* FUNCTION:		fnSetFileExt (ГZp񂩂痬p)
* DESCRIPTION:
* ̧ٖ̊gqẘgqɐݒ肵̧ٖ܂B
*	chSrcName	̖(߽)
*	chSetName	V̧ٖݒ
*	chExt		gqi"."܂ފgqw肷j
*	߂l		ݒ肵񒷂Ԃ܂B
\*****************************************************************************/
static	size_t fnSetFileExt(char *chSrcName, char *chSetName, char *chExt) {
	size_t	nLen, i;

	nLen = strlen(chSrcName);							// ̧ٖ̕񒷂擾
	memcpy(chSetName, chSrcName, nLen + 1);				// ̧ٖ𖼏̐ݒޯ̧ɓ]
	for (i = nLen; i > 0; --i) {							// "."̧ٖ̌̌납s
		if (chSetName[i] == '\\')	break;				// ̫ނ̋؂
		if (chSetName[i] == ':')	break;				// ײޖ̋؂
		if (chSetName[i] == '.') {						// gqʒu
			nLen = i;									// gqO̧ٖނƂ
			break;
		}
	}
	memcpy(&chSetName[nLen], chExt, strlen(chExt) + 1);	// ۸т𖼏ޯ̧ɓ]

	return(strlen(chSetName));						// ݒ肵̒Ԃ
}
/*****************************************************************************
* FUNCTION:		fname_get (ГZp񂩂痬p)
* DESCRIPTION:
* tpXt@Ĉ݂擾
\*****************************************************************************/
static fname_get(char *path, char *fname)
{
	uint16_t i, j;						// forŎgpϐ
	char *buf = NULL;
	//allocate
	size_t bufsize = EG_MAX_SERVICEPATH + 1;
	buf = (char*)os_edge_mallocMemory(bufsize);

	j = 0;
	memset(buf, 0, bufsize);
	for (i = 0; i < EG_MAX_SERVICEPATH; i++) {								//pX̍ő啶260
		if (path[i] != 0) {
			if ((path[i] != '\\') && (path[i] != ':')) {	//hCul
				buf[j] = path[i];
				j++;
			}
			else {
				memset(buf, 0, bufsize);
				j = 0;
			}
		}
		else break;
	}
	memcpy(fname, buf, strlen(buf));

	//free
	os_edge_freemallocMemory(buf);

}	// end of fname_get()
/*****************************************************************************
* FUNCTION:		CreateTagRef
* DESCRIPTION:
*   TagRef̍쐬(VXep)
\*****************************************************************************/
int32_t CreateTagRef(const char* pName, EGTAGREF* pTagRef)
{
	int32_t rtn = 0;						// ߂l
	uint16_t Data = 0;						// GetPropertyŎ擾ް̔
	char     Address[EG_MAX_TAGADDRESS + 1];	// AhX\L
	uint32_t index = 0;
	void*    Entry;

	//
	// ̃`FbN
	//
	if (pName == NULL)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	os_edge_strncpy_s(pTagRef->Name, sizeof(pTagRef->Name), pName, _TRUNCATE);	//^ÕRs[
	if (strlen(pTagRef->Name) == 0)											//OG[
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	//
	//TAG̏擾ɍs
	//
	// pTagRef->Type
	rtn = EgTagGetProperty(pTagRef->Name, "Type", &Data, sizeof(Data));
	if (rtn == 0)
	{
		pTagRef->Type = Data;
	}
	else
	{
		// vpeB擾Ɏsꍇ́AY^Oo^ƔfAG[ԋpB
		PrintSysLog(EG_LOG_ERR, "EgTagGetProperty Type. [Name = %s] [FUNC = %s]", pTagRef->Name, __func__);
		return rtn;
	}

	// pTagRef->Size
	rtn = EgTagGetProperty(pTagRef->Name, "Size", &Data, sizeof(Data));
	if (rtn == 0)
		pTagRef->Size = Data;

	// pTagRef->Address
	memset(Address, 0, sizeof(Address));
	rtn = EgTagGetProperty(pTagRef->Name, "Address", &Address, sizeof(Address));
	if (rtn == 0)
	{
		os_edge_strncpy_s(pTagRef->Address, sizeof(pTagRef->Address), Address, _TRUNCATE);
		PrintSysLog(EG_LOG_DBG, "Add TagRef Address [Name = %s] [Address = %s] [FUNC = %s]", pTagRef->Name, pTagRef->Address, __func__);
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "Not Add TagRef Address [Name = %s] [FUNC = %s]", pTagRef->Name, __func__);
	}

	// pTagRef->Entry
	rtn = EgTagGetProperty(pTagRef->Name, "Entry", &Entry, sizeof(&Entry));
	if (rtn == 0)
		pTagRef->Entry = Entry;

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		CreateTagTrigger
* DESCRIPTION:
*   TagTrigger̍쐬(VXep)
\*****************************************************************************/
int32_t CreateTagTrigger(const char* pName, EGTAGTRIGGER* pTagTrigger)
{
	int32_t		rtn = 0;						// ߂l
	uint16_t	Data = 0;						// GetPropertyŎ擾ް̔
	char		Address[EG_MAX_TAGADDRESS + 1];	// AhX\L
	void*		Entry = NULL;					// Gg[ŃANZXł悤
	//
	// ̃`FbN
	//
	if (pName == NULL)//^OȂꍇ̓G[
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	os_edge_strncpy_s(pTagTrigger->Name, sizeof(pTagTrigger->Name), pName, _TRUNCATE);	//^ÕRs[
	if (strlen(pTagTrigger->Name) == 0)													//OG[
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	//
	//TAG̏擾ɍs
	//
	// pTagTrigger->Entry
	rtn = EgTagGetProperty(pTagTrigger->Name, "Entry", &Entry, sizeof(&Entry));
	if (rtn != 0)    // err̓Oo͂ďI ȂꍇNG
	{
		PrintSysLog(EG_LOG_DBG, "Not Add TagTrigger Entry [Name = %s] [FUNC = %s]", pTagTrigger->Name, __func__);
		return EDGE_TTABLE_NOT_EXIST_ERROR;
	}
	pTagTrigger->Entry = Entry;

	// pTagTrigger->Type
	rtn = EgTagGetProperty(pTagTrigger->Name, "Type", &Data, sizeof(Data));
	if (rtn != 0)    // err̓Oo͂ďI ȂꍇNG
	{
		// vpeB擾Ɏsꍇ́AY^Oo^ƔfAG[ԋpB
		PrintSysLog(EG_LOG_ERR, "EgTagGetProperty Type. [Name = %s] [FUNC = %s]", pTagTrigger->Name, __func__);
		return rtn;
	}
	pTagTrigger->Type = Data;

	// pTagRef->Size
	rtn = EgTagGetProperty(pTagTrigger->Name, "Size", &Data, sizeof(Data));
	if (rtn != 0)
	{
		// vpeB擾Ɏsꍇ́AY^Oo^ƔfAG[ԋpB
		PrintSysLog(EG_LOG_ERR, "EgTagGetProperty Size. [Name = %s] [FUNC = %s]", pTagTrigger->Name, __func__);
		return rtn;
	}
	pTagTrigger->Size = Data;

	// pTagTrigger->Address
	memset(Address, 0, sizeof(Address));
	rtn = EgTagGetProperty(pTagTrigger->Name, "Address", &Address, sizeof(Address));
	if (rtn == 0)	//擾̓Rs[āAOo
	{
		os_edge_strncpy_s(pTagTrigger->Address, sizeof(pTagTrigger->Address), Address, _TRUNCATE);
		PrintSysLog(EG_LOG_DBG, "Add TagTrigger Address [Name = %s] [Address = %s] [FUNC = %s]", pTagTrigger->Name, pTagTrigger->Address, __func__);
	}
	else            // err̓Oo
	{
		PrintSysLog(EG_LOG_DBG, "Not Add TagTrigger Address [Name = %s] [FUNC = %s]", pTagTrigger->Name, __func__);
	}
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		fnInitEdgeIOPortInfo
* DESCRIPTION:
*   Edge I/O|[g񏉊
\*****************************************************************************/
int32_t fnInitEdgeIOPortInfo()
{
	int32_t ret = EDGE_SUCCESS;
	char *tagName = NULL;		// Tag̖Opobt@
	uint8_t bEgIOport = EG_FALSE;

	if (gm_EdgeIOPortSetF == EG_FALSE)//ݒ̏ꍇxǂݍ
	{
		//allocate
		size_t bufsize = EG_MAX_TAGNAME + 1;
		tagName = (char*)os_edge_mallocMemory(bufsize);
		if (tagName == NULL)
			goto failed;

		memset(tagName, 0, bufsize);

		//EdgeIO|[ggpL^O̍쐬
		sprintf_s(tagName, EG_MAX_TAGNAME, "SERVICE.%s.EdgeIOPortEnabled", ServiceRealName);

		//EdgeIO|[ggpL̎擾
		ret = EgTagRead(tagName, &bEgIOport, sizeof(bEgIOport));
		if (ret == EDGE_SUCCESS)	// 擾OK
		{
			gm_EdgeIOPortEnabled = bEgIOport;	//擾lZbg
			PrintSysLog(EG_LOG_DBG, "EdgeIOPort Enabled:%d", bEgIOport);
		}
		else						// 擾NG
		{
			gm_EdgeIOPortEnabled = EG_FALSE;	//False(gp)Zbg
			PrintSysLog(EG_LOG_DBG, "EdgeIOPort Enabled:0(false)");
		}
		gm_EdgeIOPortSetF = EG_TRUE;
	}
	// ȉAEdgeIO|[ggp̏ꍇ̂ݏ
	if (gm_EdgeIOPortEnabled != 0)
	{
		// TagRefge[u(EdgeIO|[g)̗̈m
		// NOTE: TagRefƓƂȂ邽߁AMaxFwTagRefEntrygp
		if (egTagRefs_PortInfo == NULL)
			egTagRefs_PortInfo = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGIOPORT));
		if (egTagRefs_OUT_PortInfo == NULL)
			egTagRefs_OUT_PortInfo = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGIOPORT));
		if (egTagRefs_IN_PortInfo == NULL)
			egTagRefs_IN_PortInfo = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGIOPORT));
	}

	if (tagName)
		os_edge_freemallocMemory(tagName);

	return EDGE_SUCCESS;
failed:
	// free
	if (tagName)
		os_edge_freemallocMemory(tagName);
	return EDGE_RTCD_ALLOCATE_ERROR;
}

/*****************************************************************************
* FUNCTION:		fnDecodeEdgeIOPortAddr
* DESCRIPTION:
*   Edge I/O|[gAhX
\*****************************************************************************/
int32_t fnDecodeEdgeIOPortAddr(const char* pAddr, EGIOPORT* pTagRefEx)
{
	char *context;				// e|[p
	uint32_t workAddr = 0;		// AhXp[Nϐ
	int inBase;					// lϊ̊
	char *endptr = NULL;
	char* pIoAddr;				// AhX|C^
	char* pName;				// ʖ|C^
	char* wpPos;				// Ɨp[N|C^
	char tmpAddr[EG_MAX_TAGADDRESS + 1] = { 0 };	// Ɨpꎞobt@
	WORD bitPos = 0;

	//
	// ̃`FbN
	//
	if (pAddr == NULL || strlen(pAddr) == 0)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	// ̉ߒŕ񑀍삷邽߁ARs[
	strcpy_s(tmpAddr, EG_MAX_TAGADDRESS + 1, pAddr);
	pIoAddr = (char*)tmpAddr;
	pName = (char*)tmpAddr;
	// ---------------------------------------------------------------------
	// ReiNXʕ̍l
	// ---------------------------------------------------------------------
	wpPos = strstr(pIoAddr, "/");
	if (wpPos != NULL)//qbgꍇ̓AhX擾
	{
		wpPos = wpPos + 1;
		pIoAddr = wpPos;
		// XbV鎞̂ݎʖ擾
		wpPos = strtok_s(pName, "/", &context); //XbV؂Ŏʖ擾
		if (wpPos != NULL) //ꍇ̂݃Rs[
		{
			strcpy_s(pTagRefEx->AddrName, EG_MAX_CATALOGNAME + 1, wpPos);
		}
	}
	else//NULL̏ꍇedge I/O port Ƃ݂ȂȂ (2022/12/1 C)
	{
		return EDGE_SUCCESS;
	}
	// ---------------------------------------------------------------------
	// 10iE16i\L (AhX"16#"ꍇ16i\LƂĈ)
	// ---------------------------------------------------------------------
	inBase = 10;			// ftHg:10iɃZbg
	wpPos = strstr(pIoAddr, "16#");
	if (wpPos != NULL)		// ꍇ
	{
		wpPos = wpPos + 3;	// "16#"̌擾
		pIoAddr = wpPos;	// AhX擪ʒuXV
		inBase = 16;		// 16iɃZbg
	}
	// ---------------------------------------------------------------------
	// rbgANZX̍l(AhX.X 𔻒)
	// ---------------------------------------------------------------------
	wpPos = strstr(pIoAddr, ".");
	if (wpPos != NULL)		// .(hbg)ꍇ
	{
		*wpPos = '\0';		// AhXɃrbg͕sv̂߁AI[Zbg
		wpPos = wpPos + 1;	// .(hbg)̌擾
		bitPos = (WORD)strtoul(wpPos, &endptr, inBase);	// bitԍ擾
		if ((bitPos > 15) || (*endptr != '\0'))		    // bit0`15ȊOA܂́As܂܂ꍇ
		{
			PrintSysLog(EG_LOG_ERR, "Addrees bit format error. Address[%s]", pAddr);
			return EDGE_PARAM_INVALID;
		}
		pTagRefEx->woBitPos = bitPos;					// bitʒu擾
		pTagRefEx->woMaxBit = bitPos;					// Maxbit ł͎gݒ zɒǉɔrύX
		pTagRefEx->byBitUse = 1;						// bitgptOON
	}
	// ---------------------------------------------------------------------
	// 񂩂琔l֕ϊ
	// ---------------------------------------------------------------------
	workAddr = strtoul(pIoAddr, &endptr, inBase);
	if (*endptr != '\0')	// s܂܂ꍇ
	{
		PrintSysLog(EG_LOG_ERR, "Address format error. Address[%s]", pAddr);
		return EDGE_PARAM_INVALID;
	}
	//肪ȂΊi[
	pTagRefEx->Offset = workAddr;
	pTagRefEx->bIsValied = 1;	//LtO𗧂Ă
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		CreateEdgeIOPortInfo
* DESCRIPTION:
*   Edge I/O|[g̍쐬
\*****************************************************************************/
int32_t CreateEdgeIOPortInfo(void* pEntry, const char* pSrcAddr, EGIOPORT* pEgIoPort)
{
	int32_t rtn = EDGE_SUCCESS;					// ߂l

	//
	// ̃`FbN
	//
	if (pSrcAddr == NULL || pEgIoPort == NULL)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	// EdgeIO|[g񏉊
	fnInitEdgeIOPortInfo();

	// EdgeIO|[g̏ꍇ́A𔲂(G[ɂ͂Ȃ)
	if (gm_EdgeIOPortEnabled == 0) { return rtn; }

	pEgIoPort->Entry = pEntry;										// EgTagEntry
	strcpy_s(pEgIoPort->SrcAddr, EG_MAX_TAGADDRESS + 1, pSrcAddr);	// AhX
	pEgIoPort->Offset = 0;											// ItZbgl
	pEgIoPort->bIsValied = 0;										// I/O|[g
	// EdgeIO|[gAhX
	if (strlen(pSrcAddr) > 0)
	{
		rtn = fnDecodeEdgeIOPortAddr(pSrcAddr, pEgIoPort);
	}

	return rtn;
}
/*****************************************************************************
* FUNCTION:		SetEdgeIOPortMaxBit
* DESCRIPTION:
*   Edge I/O|[g őrbgl̐ݒ
\*****************************************************************************/
void SetEdgeIOPortMaxBit(int32_t TagRefCount, EGIOPORT* pPortInfoArray, EGIOPORT* pPort)
{
	int32_t i; //forŎgp
	// ǉEGIOPORTrbgt̏ꍇ̂ݍőrbgݒ
	if (pPort->byBitUse > 0)
	{
		//ʖႤ̂̃`FbN͍sȂ o[Wȍ~Kvł΍s
		for (i = 0; i < TagRefCount; i++)
		{
			//offsetꏏ̏ꍇ őbit蓖Ă
			if (pPortInfoArray[i].Offset == pPort->Offset)
			{
				if (pPortInfoArray[i].woMaxBit > pPort->woMaxBit) pPort->woMaxBit = pPortInfoArray[i].woMaxBit;
				else pPortInfoArray[i].woMaxBit = pPort->woMaxBit;
			}
		}
	}
}
/*****************************************************************************
* FUNCTION:		AddTagRef
* DESCRIPTION:
*   TagRef(BOTH)̒ǉ(VXep)
\*****************************************************************************/
int32_t AddTagRef(void* pData)
{
	int32_t rtn;	//߂l̕ϐ
	EGTAGREF tag;	//TagRef
	EGIOPORT edgeIO = { 0 };	//EdgeIO|[g

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//EgTagRefꍇ͏I
	if (!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_TAGNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egTagRefs_Count >= (int32_t)((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef to Service ERROR. Because the size is over. Name : %s", (const char*)pData);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}
	//
	// TagRef̍쐬
	//
	rtn = CreateTagRef(pData, &tag);
	if (rtn != 0)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef to Service ERROR. Name : %s, State : %d", tag.Name, rtn);
		return rtn;
	}

	//d`FbN
	for (int i = 0; i < egTagRefs_Count; i++)
	{
		if (strcmp(egTagRefs[i].Name, tag.Name) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgTagRef to Service ERROR. It's a registered Tag. Name : %s, State : %d", tag.Name, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}

	//
	// TagRefzɊi[
	//
	egTagRefs[egTagRefs_Count] = tag;

	//
	// TagRefg(EdgeIO|[g)̐
	//
	rtn = CreateEdgeIOPortInfo(tag.Entry, tag.Address, &edgeIO);
	if (rtn != EDGE_SUCCESS)
	{
		PrintSysLog(EG_LOG_WRN, "Create EgTagRef EdgeIOPortInfo WORNING. Name : %s, State : %d", tag.Name, rtn);
	}

	//
	// TagRefgzɊi[
	// NOTE: EdgeIO|[gLATagRefgz񂪏ς݂̏ꍇ̂
	//
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_PortInfo != NULL))
	{
		edgeIO.Index = egTagRefs_Count;			//\[gOIndexlێ TagRefindexƈvl
		SetEdgeIOPortMaxBit(egTagRefs_Count, egTagRefs_PortInfo, &edgeIO);	//őrbgl̐ݒ
		egTagRefs_PortInfo[egTagRefs_Count] = edgeIO;
	}

	// TagRefXV
	egTagRefs_Count++;

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		AddOUTTagRef
* DESCRIPTION:
*   TagRef(OUT)̒ǉ(VXep)
\*****************************************************************************/
int32_t AddOUTTagRef(void* pData)
{
	int32_t rtn;	//߂l̕ϐ
	EGTAGREF tag;	//TagRef
	EGIOPORT edgeIO = { 0 };;	//EdgeIO|[g

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//EgTagRefꍇ͏I
	if (!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_TAGNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egTagRefs_OUT_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef OUT to Service ERROR. Because the size is over. Name : %s", (const char*)pData);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}
	//
	// TagRef̍쐬
	//
	rtn = CreateTagRef(pData, &tag);
	if (rtn != 0)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef OUT to Service ERROR. Name : %s, State : %d", tag.Name, rtn);
		return rtn;
	}

	//d`FbN
	for (int i = 0; i < egTagRefs_OUT_Count; i++)
	{
		if (strcmp(egTagRefs_OUT[i].Name, tag.Name) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgTagRef OUT to Service ERROR. It's a registered Tag. Name : %s, State : %d", tag.Name, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}

	//
	// TagRefzɊi[
	//
	egTagRefs_OUT[egTagRefs_OUT_Count] = tag;

	//
	// TagRefg(EdgeIO|[g)̐
	//
	rtn = CreateEdgeIOPortInfo(tag.Entry, tag.Address, &edgeIO);
	if (rtn != EDGE_SUCCESS)
	{
		PrintSysLog(EG_LOG_WRN, "Create TagRefs_OUT EdgeIOPortInfo WORNING. Name : %s, State : %d", tag.Name, rtn);
	}

	//
	// TagRefgzɊi[
	// NOTE: EdgeIO|[gLATagRefgz񂪏ς݂̏ꍇ̂
	//
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_OUT_PortInfo != NULL))
	{
		edgeIO.Index = egTagRefs_OUT_Count;				//\[gOIndexlێ TagRefindexƈvl
		SetEdgeIOPortMaxBit(egTagRefs_OUT_Count, egTagRefs_OUT_PortInfo, &edgeIO);	//őrbgl̐ݒ
		egTagRefs_OUT_PortInfo[egTagRefs_OUT_Count] = edgeIO;
	}

	// TagRefXV
	egTagRefs_OUT_Count++;

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		AddINTagRef
* DESCRIPTION:
*   TagRef(IN)̒ǉ(VXep)
\*****************************************************************************/
int32_t AddINTagRef(void* pData)
{
	int32_t rtn;	//߂l̕ϐ
	EGTAGREF tag;	//TagRef
	EGIOPORT edgeIO = { 0 };;	//EdgeIO|[g

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//EgTagRefꍇ͏I
	if (!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_TAGNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egTagRefs_IN_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef IN to Service ERROR. Because the size is over. Name : %s", (const char*)pData);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}
	//
	// TagRef̍쐬
	//
	rtn = CreateTagRef(pData, &tag);
	if (rtn != 0)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagRef IN to Service ERROR. Name : %s, State : %d", tag.Name, rtn);
		return rtn;
	}

	// d`FbN
	for (int i = 0; i < egTagRefs_IN_Count; i++)
	{
		if (strcmp(egTagRefs_IN[i].Name, tag.Name) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgTagRef IN to Service ERROR. It's a registered Tag. Name : %s, State : %d", tag.Name, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}

	//
	// TagRefzɊi[
	//
	egTagRefs_IN[egTagRefs_IN_Count] = tag;

	//
	// TagRefg(EdgeIO|[g)̐
	//
	rtn = CreateEdgeIOPortInfo(tag.Entry, tag.Address, &edgeIO);
	if (rtn != EDGE_SUCCESS)
	{
		PrintSysLog(EG_LOG_WRN, "Create TagRefs_IN EdgeIOPortInfo WORNING. Name : %s, State : %d", tag.Name, rtn);
	}

	//
	// TagRefgzɊi[
	// NOTE: EdgeIO|[gLATagRefgz񂪏ς݂̏ꍇ̂
	//
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_IN_PortInfo != NULL))	
	{
		edgeIO.Index = egTagRefs_IN_Count;			//\[gOIndexlێ TagRefindexƈvl
		SetEdgeIOPortMaxBit(egTagRefs_IN_Count, egTagRefs_IN_PortInfo, &edgeIO);	//őrbgl̐ݒ
		egTagRefs_IN_PortInfo[egTagRefs_IN_Count] = edgeIO;		//Ԃɒǉ
	}

	// TagRefXV
	egTagRefs_IN_Count++;

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		AddCollector
* DESCRIPTION:
*   RN^̒ǉ(VXep)
\*****************************************************************************/
int32_t AddCollector(void* pData)
{
	EGLOCALCOLLECTOR    clctor = { 0 };	//RN^̍\
	int32_t rtn = 0;					//߂l

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//RN^ꍇ͏I
	if(!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_CLCTNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//RN^̃Rs[
	os_edge_strncpy_s(clctor.CollectorName, sizeof(clctor.CollectorName), (char*)pData, _TRUNCATE);
	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egCollectors_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgCollector to Service ERROR. Because the size is over. Name : %s", clctor.CollectorName);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}

	//d`FbN(Ȃɑ݂Ȃ낤ƂvŃoJ)
	for (int i = 0; i < egCollectors_Count; i++)
	{
		if (strcmp(egCollectors[i].CollectorName, clctor.CollectorName) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgCollector to Service ERROR. Name : %s, State : %d", clctor.CollectorName, rtn);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}

	char serviceName[EG_MAX_SERVICENAME+1];		 //T[rX̎擾
	memset(serviceName, 0, sizeof(serviceName));
	rtn = EgCollectorGetProperty(clctor.CollectorName, "OwnerName", serviceName, sizeof(serviceName));
	//T[rX̃Rs[
	if(rtn == 0)
		os_edge_strncpy_s(clctor.OwnerServiceName, sizeof(clctor.OwnerServiceName), serviceName, _TRUNCATE);

	//Rs[ w肪ꍇ100ms
	uint32_t dwInterval = 100;
	rtn = EgCollectorGetProperty(clctor.CollectorName, "Interval", &dwInterval, sizeof(dwInterval));
	if(rtn != 0 || dwInterval == 0)
		dwInterval = 100;
	
	clctor.dwInterVal = dwInterval;

	//vCIeBRs[ w肪ꍇ150
	uint8_t byPriority = 150;
	rtn = EgCollectorGetProperty(clctor.CollectorName, "Priority", &byPriority, sizeof(byPriority));
	if (rtn != 0 || byPriority < 1 || byPriority > 254)
		byPriority = 150;

	clctor.byPriority = byPriority;

	//X^bNTCYRs[
	//Ver.3.1 4096Œ
	clctor.dwStackSize = 4096;

	//R[hTCYRs[
	//0̏ꍇ̫Ēl2048ݒ
	uint32_t dwColSize = 2048;
	rtn = EgCollectorGetProperty(clctor.CollectorName, "ColSize", &dwColSize, sizeof(dwColSize));
	if (rtn != 0 || dwColSize == 0)
		dwColSize = 2048;

	clctor.dwColSize = dwColSize;

	//R[hRs[
	//0̏ꍇ̫Ēl1024ݒ
	uint32_t dwRowSize = 1024;
	rtn = EgCollectorGetProperty(clctor.CollectorName, "RowSize", &dwRowSize, sizeof(dwRowSize));
	if (rtn != 0 || dwRowSize == 0)
		dwRowSize = 1024;

	clctor.dwRowSize = dwRowSize;

	char DatasetName[EG_MAX_DSETNAME+1];
	memset(DatasetName, 0, sizeof(DatasetName));
	rtn = EgCollectorGetProperty(clctor.CollectorName, "DatasetName", DatasetName, sizeof(DatasetName));
	//DatasetNamẽRs[
	if (rtn == 0)
		os_edge_strncpy_s(clctor.DatasetName, sizeof(clctor.DatasetName), DatasetName, _TRUNCATE);
	
	//
	// zɊi[
	//
	egCollectors[egCollectors_Count] = clctor;
	egCollectors_Count++;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		AddClctRef
* DESCRIPTION:
*   RN^Ref̒ǉ(VXep)
\*****************************************************************************/
int32_t AddClctRef(void* pData)
{
	EGCOLLECTORREF    clctorRef = { 0 };
	int32_t rtn = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//RN^ꍇ͏I
	if (!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_CLCTNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//RN^̃Rs[
	os_edge_strncpy_s(clctorRef.CollectorName, sizeof(clctorRef.CollectorName), (char*)pData, _TRUNCATE);

	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egCollectorRefs_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwClctEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgCollectorRef to Service ERROR. Because the size is over. Name : %s", clctorRef.CollectorName);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}

	//d`FbN(Ȃɑ݂Ȃ낤ƂvŃoJ)
	for (int i = 0; i < egCollectorRefs_Count; i++)
	{
		if (strcmp(egCollectorRefs[i].CollectorName, clctorRef.CollectorName) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgCollectorRef to Service ERROR. Name : %s, State : %d", clctorRef.CollectorName, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}

	//R[hTCYRs[
	uint32_t dwColSize = 0;
	rtn = EgCollectorGetProperty(clctorRef.CollectorName, "ColSize", &dwColSize, sizeof(dwColSize));
	if (rtn != 0 || dwColSize == 0)
		dwColSize = 0;

	clctorRef.dwColSize = dwColSize;

	//R[hRs[
	//0̏ꍇ̫Ēl1024ݒ
	uint32_t dwRowSize = 1024;
	rtn = EgCollectorGetProperty(clctorRef.CollectorName, "RowSize", &dwRowSize, sizeof(dwRowSize));
	if (rtn != 0 || dwRowSize == 0)
		dwRowSize = 1024;

	clctorRef.dwRowSize = dwRowSize;

	char DatasetName[EG_MAX_DSETNAME+1];
	memset(DatasetName, 0, sizeof(DatasetName));
	rtn = EgCollectorGetProperty(clctorRef.CollectorName, "DatasetName", DatasetName, sizeof(DatasetName));
	//DatasetNamẽRs[
	if (rtn == 0)
	{

		os_edge_strncpy_s(clctorRef.DatasetName, sizeof(clctorRef.DatasetName), DatasetName, _TRUNCATE);
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "Add EgCollectorRef to Service ERROR. Because No DatasetName.  EgCollectorRef Name : %s, rtn = %d", clctorRef.CollectorName,rtn);
	}
	//
	// zɊi[
	//
	egCollectorRefs[egCollectorRefs_Count] = clctorRef;
	egCollectorRefs_Count++;
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		AddMailBox
* DESCRIPTION:
*   [{bNX̒ǉ(VXep)
\*****************************************************************************/
int32_t AddMailBox(void* pData)
{
	EGMAILBOXINFO* mBoxInfo = NULL;
	uint32_t dwColSize = 2048; //ftHg
	uint32_t dwRowSize = 1024; //ftHg
	int32_t rtn = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	mBoxInfo = (EGMAILBOXINFO*)pData;
	//OꍇATCY傫ꍇNG
	if (strlen(mBoxInfo->MailBoxName) == 0 || strlen(mBoxInfo->MailBoxName) > EG_MAX_MAILBOXNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//ő吔𒴂Ȃ悤Ƀ`FbN
	if (egMailBoxes_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwMailboxEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgMailbox to Service ERROR. Because the size is over. Name : %s", mBoxInfo->MailBoxName);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}

	//d`FbN(Ȃɑ݂Ȃ낤ƂvŃoJ)
	for (int i = 0; i < egMailBoxes_Count; i++)
	{
		if (strcmp(egMailBoxes[i].MailBoxName, mBoxInfo->MailBoxName) == 0)
		{
			PrintSysLog(EG_LOG_ERR, "Add EgMailBox to Service ERROR. Name : %s, State : %d", mBoxInfo->MailBoxName, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}
	//ő吔𒴂Ȃ悤Ƀ`FbN
	if ((uint32_t)egMailBoxes_Count < ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwMailboxEntry)
	{
		//TCYw肪ꍇ͎wTCYɕύX
		if (mBoxInfo->dwColSize > 0)
			dwColSize = mBoxInfo->dwColSize;

		//TCYw肪ꍇ͎wTCYɕύX
		if (mBoxInfo->dwRowSize > 0)
			dwRowSize = mBoxInfo->dwRowSize;

		PrintSysLog(EG_LOG_DBG, "EgMailboxCreate Name[%s] ColSize[%d] RowSize[%d]", mBoxInfo->MailBoxName, dwColSize, dwRowSize);
		// MaibBox̍쐬
		rtn = EgMailboxCreateEx(mBoxInfo->MailBoxName, dwColSize , dwRowSize, &(egMailBoxes[egMailBoxes_Count].MemInfo));
		if (rtn == 0) //肪Βǉ
		{
			//[JMailBox̍쐬
			os_edge_strncpy_s(egMailBoxes[egMailBoxes_Count].MailBoxName, sizeof(egMailBoxes[egMailBoxes_Count].MailBoxName),
					  mBoxInfo->MailBoxName, _TRUNCATE);
			egMailBoxes[egMailBoxes_Count].dwColSize = dwColSize;
			egMailBoxes[egMailBoxes_Count].dwRowSize = dwRowSize;

			egMailBoxes_Count++;
		}
		else
		{
			//Ȃꍇ̓Oo(ERR)
			PrintSysLog(EG_LOG_ERR, "AddMailBox ERR. Name = [%s], rtn = [%d]", mBoxInfo->MailBoxName, rtn);
		}
	}
	return rtn;
}
/*****************************************************************************
* FUNCTION:		EgFW_AddTagTrigger
* DESCRIPTION:
*   TagTriggero^p֐(OJp)
\*****************************************************************************/
int32_t EgFW_AddTagTrigger(const char* pTagName)
{
	return AddTagTrigger((void*)pTagName);
}
/*****************************************************************************
* FUNCTION:		AddTagTrigger
* DESCRIPTION:
*   TagTriggerp(VXep)
\*****************************************************************************/
int32_t AddTagTrigger(void* pData)
{
	int32_t rtn;		//߂l̕ϐ
	EGTAGTRIGGER tagTrigger = {0};	//TagTrigger
	int i;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	//EgTagꍇ͏I
	if (!pData || strlen((char*)pData) == 0 || strlen((char*)pData) > EG_MAX_TAGNAME)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//ő吔𒴂Ȃ悤Ƀ`FbN(T[rXRei)
	if (egTagTriggers_Count == ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagTrigEntry)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagTrigger to Service ERROR. Because TagTrigger Entry Max(Service). Name : %s. MaxTrigNum : %d", (const char*)pData, egTagTriggers_Count);
		return EDGE_FW_OBJECT_SIZE_OVER;
	}

	//
	// TagTrigger̍쐬
	//
	rtn = CreateTagTrigger(pData, &tagTrigger);
	if (rtn != 0)
	{
		PrintSysLog(EG_LOG_ERR, "Add EgTagTrigger to Service ERROR. Name : %s, State : %d", tagTrigger.Name, rtn);
		return rtn;
	}

	//d`FbN
	for (i = 0; i < egTagTriggers_Count; i++)
	{
		if (strcmp(tagTrigger.Name, egTagTriggers[i].Name) == 0) // ɓo^ς݂̃^O
		{
			PrintSysLog(EG_LOG_ERR, "Add EgTagTrigger Service ERROR. It's a registered Tag. Name : %s, State : %d", tagTrigger.Name, EDGE_FW_DUPLICATE_OBJECT);
			return EDGE_FW_DUPLICATE_OBJECT;
		}
	}
	//T[rXƂɕێĂlXV
	egTagTriggers[egTagTriggers_Count] = tagTrigger;		// TagTriggerzɊi[
	egTagTriggers_Count++;									// T[rXo^Ă^OgK[XV

	StartTagTrigThread(); //^OgK[Xbh̊Jn XMLǂݏIłȂƃX^[gȂ
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		StartTagTrigThread
* DESCRIPTION:
*   gK[Xbh Np(VXep)
\*****************************************************************************/
int32_t StartTagTrigThread()
{
	int32_t rtn = 0;				//߂l̕ϐ
	if (gm_ReadENDXmlFileF == FALSE)//XMLǂݏIĂłȂƃX^[gȂ
		return EDGE_SUCCESS;

	if (egTagTriggers_Count == 0)	//^OgK[̐ꍇ̓X^[gȂ
		return EDGE_SUCCESS;

	//^ȌԂŎŃX^[gȂ悤ɒ`\Ƃ
	bool bTmpIsAutoRun = true;
	rtn = EgTagRead(ServiceTrigAutoRunName, &bTmpIsAutoRun, sizeof(bTmpIsAutoRun));
	if (rtn != 0)
	{
		//^O݂ȂꍇȊO̓G[Oɏo
		if(rtn != EDGE_TTABLE_NOEXISTT_TAGNAME)
			PrintSysLog(EG_LOG_ERR, "EgTagRead [%s] ERROR. rtn = [%d]", ServiceTrigAutoRunName, rtn);

	}
	if (bTmpIsAutoRun == true)
		return ExecTagTriggerTh(); //^OgK[Xbh̊Jn 
	
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		CollectorThread
* DESCRIPTION:
*   RN^[Xbh
*   2020/03/25 _ σTCYɔΉ
\*****************************************************************************/
void CollectorThread(EGLOCALCOLLECTOR* pCollector)
{
	int32_t rtn = 0;				//߂l̕ϐ
	int32_t i = 0;					//for̔ėpϐ
	int8_t* pData;					//oCil擾ۂɊi[锠
	RTCDMEMINFO	memInfo = { 0 };	//RTCDMEMINFO
	RTCDHANDLE hHandle = { 0 };		//RTCHANDLE
	char clctMailBoxName[EG_MAX_MAILBOXNAME + 1] = { 0 }; //[{bNXi[p
	size_t dsetsize = 0;					//f[^Zbg̃TCY
	//`FbN
	if (pCollector == NULL)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. pCollector == NULL [FUNC = %s]", __func__);
		return;
	}
	else if (strlen(pCollector->DatasetName) < 1)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. DatasetName Size == 0 [FUNC = %s]", __func__);
		return;

	}
	//f[^Zbg/[{bNX̃TCY`FbN
	dsetsize = EgDatasetGetSize(pCollector->DatasetName);
	if (dsetsize == 0)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. Dataset[%s] Size == 0 [FUNC = %s]", pCollector->DatasetName, __func__);
		return;
	}
	else if (pCollector->dwColSize == 0)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. ColSize == 0 [FUNC = %s]", __func__);
		return;
	}
	else if( pCollector->dwRowSize == 0)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. RowSize == 0 [FUNC = %s]", __func__);
		return;
	}
	else if(dsetsize > pCollector->dwColSize)
	{
		PrintSysLog(EG_LOG_ERR, "Invalid argument. ColSize [%d] < Dataset Size [%d] [FUNC = %s]", pCollector->dwColSize, dsetsize, __func__);
		return;
	}
	//[{bNX݂邩`FbN
	rtn = EgMailboxGetProperty(pCollector->CollectorName, "Name", clctMailBoxName, sizeof(clctMailBoxName));
	if (rtn != 0)//G[̏ꍇ͍ɍs ̏ꍇ݂͑邽߃I[v̂
	{
		//[{bNX쐬 (RN^)
		rtn = EgMailboxCreateEx(pCollector->CollectorName, pCollector->dwColSize, pCollector->dwRowSize, &memInfo);
		if (rtn != 0)
		{
			PrintSysLog(EG_LOG_ERR, "Cannot Create EgMailBox[%s] : STATE[%d]", pCollector->CollectorName, rtn);
			return;
		}
	}
	
	// 2Write
	rtn = EgMailboxOpen(pCollector->CollectorName, RTCD_WRITE, &hHandle);
	if (rtn != 0)
	{
		//[{bNX̍폜
		PrintSysLog(EG_LOG_ERR, "Cannot Open EgMailBox[%s] : STATE[%d]", pCollector->CollectorName, rtn);
		return;
	}
	pCollector->bWorkingF = EG_TRUE;	//삵ĂItO𗧂Ă

	//allocate
	pData = (int8_t*)os_edge_mallocMemory(pCollector->dwColSize);
	if (pData == NULL)
	{
		//[{bNX̃N[Y
		EgMailboxClose(&hHandle);
		PrintSysLog(EG_LOG_ERR, "Cannot malloc memory [%s]", pCollector->CollectorName);
		return;
	}
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Start Collector [%s].", pCollector->CollectorName);
	bool blDsetErrF = false;	//Dataset̃G[ԂăG[̏ꍇ1񃍃Oo͂ď𑱍s܂B
	bool blErrF = false;		//[{bNX݂̃G[ԂăG[̏ꍇ1񃍃Oo͂ď𑱍s܂B
	while (1)
	{
		// I
		if (pCollector->bCancelF == EG_TRUE)
			break;

		// 
		memset(pData, 0, sizeof(pCollector->dwColSize));

		//DataSetp1R[h擾
		rtn = EgDatasetGetBinary(pCollector->DatasetName, pData, pCollector->dwColSize);
		if (rtn == EDGE_SUCCESS)
		{
			blDsetErrF = false;
			// Mailboxɏ
			rtn = EgMailboxSend(&hHandle, pCollector->OwnerServiceName, EM_COLLECTOR_WRITED_DATA, pData, pCollector->dwColSize);
			if (rtn != 0)
			{
					if (blErrF == false)	//G[tOfalsȅꍇɓ(1xG[ɂ)
					{
						blErrF = true;
						if (rtn == EDGE_RTCD_BUFFER_FULL_ERROR)	//obt@t̏ꍇ͈ႤG[Ƃďo
							PrintSysLog(EG_LOG_ERR, "Writing is interrupted because the Mailbox buffer has overflowed.[%s]", pCollector->CollectorName);
						else
							PrintSysLog(EG_LOG_ERR, "Failed to Send a Message[%s]. state = %d", pCollector->CollectorName, rtn);
					}
			}
			else
				blErrF = false;
		}
		else
		{
			if (blDsetErrF == false)	//G[tOfalsȅꍇɓ(1xG[ɂ)
			{
				blDsetErrF = true;
				PrintSysLog(EG_LOG_ERR, "ERROR EgDataGetBinary = [%s] ret = [%d]", pCollector->CollectorName, rtn);
			}
		}

		os_edge_sleep(pCollector->dwInterVal);
	}
	//free
	os_edge_freemallocMemory(pData);
	//[{bNX̃N[Y
	EgMailboxClose(&hHandle);
	//[{bNX
	PrintSysLog(EG_LOG_DBG, "End Collector [%s]. State = [%d]", pCollector->CollectorName, rtn);
	pCollector->bWorkingF = EG_FALSE;	//삵ĂItO0ɂ
}
/*****************************************************************************
* FUNCTION:		TagTriggerThread
* DESCRIPTION:
*   ^OgK[MXbh(VXep)
\*****************************************************************************/
void TagTriggerThread(SRVBOOTARG* pCmdArg)
{
/// ȉvpŎgp
	unsigned long long Start_Counter;	//vJn
	unsigned long long End_Counter;		//vI
	double tm;				//v
	int debugcnter1 = 1;
	int debugcnter2 = 0;
	char fname[128] = { 0 };			//t@C
	FILE *fp;
	BYTE byPTestFlag = 0;	//ptH[}X𑪂邩ۂ R}hŕύX
/// 
	int i;											// for[vŎgp
	int targetCount = 0;							// M^O	
	int TrigCycle = 500;							// gK[`FbNTCNftHg
	int32_t rtn = 0;								// ߂l
	int sendCnt = 0;								// 1̃`FbNőM
	char chValue[EG_MAX_TAGNAME + 1] = { 0 };		// Tag̖Opobt@
	bool bErrFlag = false;							// G[Nꍇ^OɏރtO
	uint32_t oneSendSize = 0;						// xɑM\ȍ\̃TCY
	uint32_t oneSendTagCount = 0;					// xɑM\ȃ^O
	bool sendF = true;								// M邩ۂ̃tO forŎgp
	uint32_t dwColSize = EGFW_DEF_C2C_MAILBOXCOL;	// M[{bNX1R[hTCY ꍇ̓ftHgl
	RTCDHANDLE		hMyMBoxHandle = { 0 };			// g̃[{bNX̃nh
	EGTAGTRIGINFOS* pTrigInfos = NULL;				// 1Mf[^p\
	if (pCmdArg != NULL) {							// ꍇ̓[{bNX̃TCY`Ă̂ł̒l擾
		dwColSize = pCmdArg->dwColSize;
		byPTestFlag = pCmdArg->byPTestFlag;
		if (byPTestFlag != 0)//ptH[}XeXgpt@C쐬
			sprintf_s(fname, sizeof(fname), "TagTrig_%s_%d.csv", ServiceRealName, egTagTriggers_Count);//t@C
	}
	//̃[ő^O
	oneSendTagCount = (dwColSize - sizeof(uint16_t)) / sizeof(EGTAGTRIGINFO);	//1R[hTCYe[uJEgϐAtag̃TCYŊ
	oneSendSize = sizeof(uint16_t) + (oneSendTagCount * sizeof(EGTAGTRIGINFO));	//̃[őTCY
	PrintSysLog(EG_LOG_DBG, "Send Struct Memory = %d", oneSendSize);			//TCY
	pTrigInfos = os_edge_mallocMemory(oneSendSize);								//\̍쐬 蓖
	if (pTrigInfos == NULL)														//Ȃꍇ̓G[ŏI
	{
		PrintSysLog(EG_LOG_ERR, "Cannot be created memory. Please check the environment. [FUNC = %s]", __func__);
		return;
	}
	
	memset(pTrigInfos, 0, oneSendSize);											//
	// ^OgK[XbhُԃXe[^X̓o^ SERVICE.XXXXXX.TrigError
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	EgTagGetProperty(ServiceTrigStateErrName, "Name", chValue, (int32_t)sizeof(chValue));
	if (strlen(chValue) == 0)
	{
		//Ȃꍇ̓^O쐬
		rtn = EgTagCreate(ServiceTrigStateErrName, EgVtBoolean, 1, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceTrigStateErrName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceTrigStateErrName, rtn);
	}
	EgTagWrite(ServiceTrigStateErrName, &bErrFlag, sizeof(bool));			//G[tOFALSEɂ

	rtn = EgMailboxOpen(ServiceMailboxName, RTCD_WRITE, &(hMyMBoxHandle));	// I[v
	if (rtn != EDGE_SUCCESS)												// I[vɂsꍇ̓G[Oo
	{
		bErrFlag = true;	//G[̈trueɂ
		// Oo
		PrintSysLog(EG_LOG_ERR, "Mailbox Open failed. [FUNC = %s] [MyServName = %s] [TargetServName = %s]"
			, __func__, ServiceRealName, ServiceMailboxName);
		EgTagWrite(ServiceTrigStateErrName, &bErrFlag, sizeof(bool));	//G[tO
		return;
	}

	//<LOG>
	//ꍇ͂̒l
	if (pCmdArg != NULL)
	{
		if (pCmdArg->_TrigCycle > 0)//0傫ꍇL
			TrigCycle = pCmdArg->_TrigCycle;
	}
	PrintSysLog(EG_LOG_DBG, "Start TagTrigger Thread Cycle=[%d]", TrigCycle);//<LOG>
	
	while (1)
	{
		// I
		if (gm_TagTriggerCanncelF == EG_TRUE)
			break;

		if (egTagTriggers_Count > 0)
		{
			sendF = false;//ȂtO𗧂Ă 
			
///	ptH[}XeXgp
			if (byPTestFlag != 0)
			{
				fopen_s(&fp, fname, "a");			// t@CǋL[hŃI[v
				os_edge_GetPCounter(&Start_Counter);//JE^[擾
			}
///	ptH[}XeXgp
						
			// Entry͂ɗOɃ`FbNĂ邽ߕK Entryő삷 ()		
			for (i = 0; i < egTagTriggers_Count; i++)
			{
	
				//JE^[Ⴄꍇ̓f[^̃Rs[
				if (((TagsDesc*)egTagTriggers[i].Entry)->cnt != egTagTriggers[i].Count)
				{

					////f[^Read
					rtn = EgTagReadByEntry((void*)((TagsDesc*)egTagTriggers[i].Entry), &pTrigInfos->pTblTagTriggers[pTrigInfos->TblCount].val, egTagTriggers[i].Size);	// lēxKiŎo
					if (rtn == 0)
					{
						sendF = true; //tO𗧂Ă
						egTagTriggers[i].Count = ((TagsDesc*)egTagTriggers[i].Entry)->cnt;	//̃JE^[ێ
						pTrigInfos->pTblTagTriggers[pTrigInfos->TblCount].arrNo = i;		//[J̃^OgK[z̔zԍݒ
						pTrigInfos->TblCount++;												//e[uvX
					}
					else//G[^O
					{
						//񂾂
						if (bErrFlag != true)
						{
							bErrFlag = true;
							EgTagWrite(ServiceTrigStateErrName, &bErrFlag, sizeof(bool));	//G[tO
						}
					}
				}
				if ((pTrigInfos->TblCount == oneSendTagCount) || //z񂪂܂瑗M
					(i == (egTagTriggers_Count - 1) && sendF == true)) // Ō̏ꍇłM̂ꍇ͑M
				{
					// bZ[WM
					rtn = EgMailboxSend(&hMyMBoxHandle, ServiceRealName, EM_TAGTRIGGER_NOTIFICATION, (void*)pTrigInfos, oneSendSize);
					if (rtn != EDGE_SUCCESS)
					{
						_EgFW_PrintSysLog(NULL, EG_LOG_WRN, "Cannot Send Message[%s] Status[%d]", EM_TAGTRIGGER_NOTIFICATION, rtn);
						//񂾂
						if (bErrFlag != true)
						{
							bErrFlag = true;
							EgTagWrite(ServiceTrigStateErrName, &bErrFlag, sizeof(bool));	//G[tO
						}
					}
					sendCnt++;
					sendF = false;						//MtO
					memset(pTrigInfos, 0, oneSendSize); //
				}
			}
///	ptH[}XeXgp
			if (byPTestFlag != 0 && fp)
			{
				os_edge_GetPCounter(&End_Counter);
				os_edge_CalcTime(Start_Counter, End_Counter, &tm);
				tm = tm / 1000;
				
				if (((debugcnter1 < 10001) && debugcnter2 == 0) || 
					(debugcnter1 < 10001 && debugcnter2 > 0 && debugcnter2 < 10001))//10000{
				{
					if (sendCnt == 0)
					{
						fprintf(fp, "tagcount,%d,sendcount,%d,time,%lf\n", egTagTriggers_Count, sendCnt, tm);
						if(debugcnter1 % 100 == 0) //10񂸂\
							printf("%d `FbN Tag[%d] M[%d] : %lf us\n", debugcnter1, egTagTriggers_Count, sendCnt, tm);
					}
					else
					{
						fprintf(fp, "tagcount,%d,sendcount,%d,time,%lf,%lf\n", egTagTriggers_Count, sendCnt, tm, tm);
						if (debugcnter2 % 100 == 0) //10񂸂\
							printf("%d `FbN Tag[%d] M[%d] : %lf us : %d/10000\n", debugcnter2, egTagTriggers_Count, sendCnt, tm, debugcnter1 );
					}

				}
				if (sendCnt > 0)//M͕ʓr
				{
					debugcnter1 = 1;
					debugcnter2++;
				}
				else
					debugcnter1++;
				
				fclose(fp);
			}
///	ptH[}XeXgp
			sendCnt = 0;
		}
		os_edge_sleep(TrigCycle);//wŏ
	}
	//[{bNXN[Y
	EgMailboxClose(&hMyMBoxHandle);
	//free
	os_edge_freemallocMemory(pTrigInfos);
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "End TagTrigger Thread");
}
/*****************************************************************************
* FUNCTION:		StartCollector
* DESCRIPTION:
*   RN^X^[g
\*****************************************************************************/
int32_t StartCollector(EGLOCALCOLLECTOR* pCollector)
{
	void* hHandle = NULL;
	//`FbN
	if (pCollector == NULL)
		return EDGE_PARAM_INVALID;

	//ɓ삵Ăꍇ͎sȂ
	if (pCollector->bWorkingF == EG_TRUE)
		return EDGE_FW_COLLECTOR_ALREADY_WORKING;

	//RN^QƃACeꍇ͏o͂Ȃ
	if (strlen(pCollector->DatasetName) == 0)
	{
		//<LOG>
		PrintSysLog(EG_LOG_ERR, "There is no Item in Collector[%s]. Collector does not start.", pCollector->CollectorName);
		return EDGE_FW_XML_FORMAT_ERROR;
	}

	//XbhJn
	int32_t errorNo = 0;	//debugp
	hHandle = os_edge_createThread(pCollector->byPriority, pCollector->dwStackSize, CollectorThread, pCollector, &errorNo);
	if (hHandle == NULL)
		return EDGE_THREAD_ERROR;

	//Xbh̃J^O
	os_edge_catalog(hHandle, "EgFw");

	//nhi[
	pCollector->hHandle = hHandle;

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		StartCollectorByName
* DESCRIPTION:
*   RN^X^[g Ow
\*****************************************************************************/
int32_t StartCollectorByName(const char* pName)
{
	int32_t i = 0;
	//Ŏw肳ꂽÕRN^X^[g
	for (i = 0; i < egCollectors_Count; i++)
	{
		if (strcmp(egCollectors[i].CollectorName, pName) == 0)
		{
			return StartCollector(&egCollectors[i]);
		}
	}
	//<LOG>
	PrintSysLog(EG_LOG_ERR, "Cannot Start Collector [%s].", pName);
	return EDGE_FW_OBJECT_NOTEXIST;
}
/*****************************************************************************
* FUNCTION:		StartCollectorByBin
* DESCRIPTION:
*   RN^X^[g oCiw(bZ[WnhĂяoz)
\*****************************************************************************/
int32_t StartCollectorByBin(void* pData)
{
	if (strlen((char*)pData) == 0)
		return EDGE_PARAM_INVALID;

	return StartCollectorByName((char*)pData);
}
/*****************************************************************************
* FUNCTION:		StartCollectorAll
* DESCRIPTION:
*   RN^X^[g
\*****************************************************************************/
int32_t StartCollectorAll()
{
	int32_t rtn = 0;
	int32_t tempRtn = -1;
	int32_t i = 0;
	//RN^̐邮X^[g
	for (i = 0; i < egCollectors_Count; i++)
	{
		tempRtn = StartCollector(&egCollectors[i]);
		if (tempRtn != 0)
			rtn = tempRtn;
	}
	return rtn;
}
/*****************************************************************************
* FUNCTION:		StopCollector
* DESCRIPTION:
*   RN^Xgbv
\*****************************************************************************/
int32_t StopCollector(EGLOCALCOLLECTOR* pCollector)
{
	int32_t rtn = 0;
	//XgbvtOTRUEɂďI҂
	pCollector->bCancelF = EG_TRUE;
	//XbhI(Iԍ)܂ő҂
	while (1)
	{
		if (pCollector->bWorkingF == EG_FALSE)
			break;
		os_edge_sleep(50);
	}
	//XbhI
	if (pCollector->hHandle != NULL)
	{
		if (os_edge_deleteThread(pCollector->hHandle) == EG_FALSE)
			rtn = -1;
		pCollector->hHandle = NULL;
	}
	//ēxsł悤FALSEɐݒ肷
	pCollector->bCancelF = EG_FALSE;
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Success Stop Collector [%s]. RTN=[%d]", pCollector->CollectorName, rtn);
	return rtn;
}
/*****************************************************************************
* FUNCTION:		StopCollectorByName
* DESCRIPTION:
*   RN^Xgbv(Ow)
\*****************************************************************************/
int32_t StopCollectorByName(const char* pName)
{
	int32_t i = 0;
	//Ŏw肳ꂽÕRN^Xgbv
	for (i = 0; i < egCollectors_Count; i++)
	{
		if (strcmp(egCollectors[i].CollectorName, pName) == 0)
		{
			return StopCollector(&egCollectors[i]);
		}
	}
	//<LOG>
	PrintSysLog(EG_LOG_ERR, "Cannot Stop Collector [%s].", pName);
	return EDGE_FW_OBJECT_NOTEXIST;
}
/*****************************************************************************
* FUNCTION:		StopCollectorByBin
* DESCRIPTION:
*   RN^Xgbv(oCiw(bZ[WnhĂяoz))
\*****************************************************************************/
int32_t StopCollectorByBin(void* pData)
{
	if (strlen((char*)pData) == 0)
		return EDGE_PARAM_INVALID;

	return StopCollectorByName((char*)pData);
}
/*****************************************************************************
* FUNCTION:		StopCollectorAll
* DESCRIPTION:
*   SẴRN^Xgbv
\*****************************************************************************/
int32_t StopCollectorAll()
{
	int32_t rtn = 0;
	int32_t tempRtn = -1;
	int32_t i = 0;
	//RN^̐邮񂵂ăXgbv
	for (i = 0; i < egCollectors_Count; i++)
	{
		tempRtn = StopCollector(&egCollectors[i]);
		if (tempRtn != 0)
			rtn = tempRtn;
	}
	return rtn;
}
/*****************************************************************************
* FUNCTION:		ExecTagTriggerTh
* DESCRIPTION:
*   ^OgK[XbhX^[g
\*****************************************************************************/
int32_t ExecTagTriggerTh()
{
	//^OgK[[MpXbh쐬
	int32_t rtn = 0;
	int32_t errorNo = 0;	//debugp
	void* hHandle = NULL;
	//ɓ삵Ăꍇ͎sȂ
	if (gm_TriggerThCreateF == EG_TRUE)
		return EDGE_SUCCESS;
	
	PrintSysLog(EG_LOG_DBG, "Create TagTriggerThread. Priority[%d]", gm_CmdArg.byTrigPriority);
	gm_ThTrig = os_edge_createThread(gm_CmdArg.byTrigPriority, 4096, TagTriggerThread, &gm_CmdArg, &errorNo);	//X^bNTCY͌Œ
	if (gm_ThTrig == NULL)
	{
		PrintSysLog(EG_LOG_ERR, "Error createEdgeThread. [FUNC = %s, errorNo = %d]", __func__, errorNo);
		return EDGE_THREAD_ERROR;
	}
	gm_TriggerThCreateF = EG_TRUE;
	//Xbh̃J^O

	rtn = os_edge_catalog(gm_ThTrig, "EgFwTrig");
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		DeleteMailBoxAll
* DESCRIPTION:
*   [{bNX̍폜
\*****************************************************************************/
void DeleteMailBoxAll()
{
	int32_t i = 0;
	//[{bNX̐[v
	for (i = 0; i < egMailBoxes_Count; i++)
	{
		//[{bNX̍폜
		EgMailboxDelete(&(egMailBoxes[i].MemInfo));
	}
}
/*****************************************************************************
* FUNCTION:		ServiceStop
* DESCRIPTION:
*   T[rXXgbv
\*****************************************************************************/
void ServiceStop(void* pData)
{
	_EgFW_Finalize();		//IɏI
	os_edge_sleep(100);//҂
	exit(0);
}
/*****************************************************************************
* FUNCTION:		fnInitPostProccess
* DESCRIPTION:
*   Initilize֐̍ŌɌĂ΂鏈([J֐)
*   قInitIĂiKł肽ƂL
\*****************************************************************************/
void InitPostProccess()
{
	//InitilizesĂꍇ͌Ă΂Ȃ悤
	if (ServiceRealName == NULL || strlen(ServiceRealName) == 0)
		return;
	
	//
	// autoRun ̐ݒ
	//
	char *tagName = NULL;
	//allocate
	size_t bufsize = EG_MAX_TAGNAME + 1;
	tagName = (char*)os_edge_mallocMemory(bufsize);
	if (tagName != NULL)
	{
		memset(tagName, 0, bufsize);
		sprintf_s(tagName, bufsize, "SERVICE.%s.AutoRun", ServiceRealName);//O̍쐬

		//
		// T[rXs
		//
		bool bIsAutoRun = false;
		bool bTmpIsAutoRun = false;
		int32_t rtn = EgTagRead(tagName, &bTmpIsAutoRun, sizeof(bTmpIsAutoRun));
		if (rtn != 0)
		{
			//G[ɂ͂Ȃ Ȃꍇ̂
			EgFW_PrintLog(ServiceRealName, EG_LOG_DBG, "An error occurred in EgTagRead[%s]. Status = %d", tagName, rtn);
		}
		else
			bIsAutoRun = bTmpIsAutoRun;

		if (bIsAutoRun)
		{
			
			//rtn = fnSendMessage(ServiceMailboxName, EM_SERVICE_RUN, NULL, 0);//gɑM
			rtn = fnSendMessageToMe( EM_SERVICE_RUN, NULL, 0);//gɑM
			if (rtn == EDGE_SUCCESS)
				EgFW_PrintLog(ServiceRealName, EG_LOG_DBG, "Auto Run True");
			else
				EgFW_PrintLog(ServiceRealName, EG_LOG_DBG, "Auto Run False");
		}
		else
			EgFW_PrintLog(ServiceRealName, EG_LOG_DBG, "Auto Run False");


		// DependpXe[^X^O̓o^ SERVICE.%s.State2Depend
		// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
		memset(tagName, 0, bufsize);
		EgTagGetProperty(ServiceState2DependName, "Name", tagName, (int32_t)bufsize);
		if (strlen(tagName) == 0)
		{
			rtn = EgTagCreate(ServiceState2DependName, EgVtByte, 1, "", "");
			if (rtn == EDGE_SUCCESS)
			{
				PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceState2DependName);
				//DependpXe[^X^O̒lWrite
				EgTagWrite(ServiceState2DependName, &EG_STATE2DEPEND_INITIALEND, sizeof(uint8_t));
			}
			else
				PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceState2DependName, rtn);

		}
		//else ݂ꍇ͍ȂElȂ ̂̓[U xmlŒ`(0)ꏉI0x10
		
		os_edge_freemallocMemory(tagName); //ŊJ
	}
}
/*****************************************************************************
* FUNCTION:		InitEndFunction
* DESCRIPTION:
*   EgBootT[rXxmlǂݏIۂɎs֐
\*****************************************************************************/
void InitEndFunction()
{
	int32_t count = 0;
	InitPostProccess();								//Framework initłĂł邪ēxĂяo
	if (pInitEndFunc != NULL)						//InitialIɌĂԊ֐
	{
		pInitEndFunc();
		EgFW_PrintLog(ServiceRealName, EG_LOG_DBG, "End pInitEndFunc");
	}
}
/*****************************************************************************
* FUNCTION:		_DebugWriteServiceObject
* DESCRIPTION:
*   Debugo͗p(o^ĂT[rX̏o
\*****************************************************************************/
void _DebugWriteServiceObject()
{
	int32_t i = 0;
	int32_t k = 0;
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "#############################################################");
	PrintSysLog(EG_LOG_DBG, "#          DEBUG WRITE SERVICE OBJECT                       #");
	PrintSysLog(EG_LOG_DBG, "#############################################################");
	PrintSysLog(EG_LOG_DBG, "# ServiceName           : %s", ServiceName);
	PrintSysLog(EG_LOG_DBG, "# ServiceRealName       : %s", ServiceRealName);
	PrintSysLog(EG_LOG_DBG, "# egTagRef       Count  : %d", egTagRefs_Count);
	PrintSysLog(EG_LOG_DBG, "# egTagRef OUT   Count  : %d", egTagRefs_OUT_Count);
	PrintSysLog(EG_LOG_DBG, "# egTagRef IN    Count  : %d", egTagRefs_IN_Count);
	PrintSysLog(EG_LOG_DBG, "# egCollector    Count  : %d", egCollectors_Count);
	PrintSysLog(EG_LOG_DBG, "# egCollectorRef Count  : %d", egCollectorRefs_Count);
	PrintSysLog(EG_LOG_DBG, "# egMailBox      Count  : %d", egMailBoxes_Count);
	PrintSysLog(EG_LOG_DBG, "# egTagTrigger   Count  : %d", egTagTriggers_Count);

	// egTagRef
	if (egTagRefs_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef Data");
		for (i = 0; i < egTagRefs_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], Size[%d], Type[%d], Entry[0x%p]", egTagRefs[i].Name, egTagRefs[i].Size, egTagRefs[i].Type, egTagRefs[i].Entry);
			if (i%100 == 0)
				os_edge_sleep(100);					// TagRef̏ꍇAO\邽Sleep}
		}
	}
	// egTagRef OUT
	if (egTagRefs_OUT_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef OUT No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef OUT Data");
		for (i = 0; i < egTagRefs_OUT_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], Size[%d], Type[%d], Entry[0x%p]", egTagRefs_OUT[i].Name, egTagRefs_OUT[i].Size, egTagRefs_OUT[i].Type, egTagRefs_OUT[i].Entry);
			if (i % 100 == 0)
				os_edge_sleep(100);					// TagRef̏ꍇAO\邽Sleep}
		}
	}
	// egTagRef IN
	if (egTagRefs_IN_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef IN No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egTagRef IN Data");
		for (i = 0; i < egTagRefs_IN_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], Size[%d], Type[%d], Entry[0x%p]", egTagRefs_IN[i].Name, egTagRefs_IN[i].Size, egTagRefs_IN[i].Type, egTagRefs_IN[i].Entry);
			if (i % 100 == 0)
				os_edge_sleep(100);					// TagRef̏ꍇAO\邽Sleep}
		}
	}
	// egCollectors_Count
	if (egCollectors_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egCollector No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egCollector Data");
		for (i = 0; i < egCollectors_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], ColSize[%d], RowSize[%d], InterVal[%d], Priority[%d]", egCollectors[i].CollectorName, egCollectors[i].dwColSize, egCollectors[i].dwRowSize, egCollectors[i].dwInterVal, egCollectors[i].byPriority);
			if (strlen(egCollectors[i].DatasetName) == 0)
				PrintSysLog(EG_LOG_DBG, "#    -- egCollector No Item -- ");
			else
			{
				PrintSysLog(EG_LOG_DBG, "#    -- egCollector Item Name [%s] -- ", egCollectors[i].DatasetName);
				
			}
		}
	}

	// egCollectorRefs
	if (egCollectorRefs_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egCollectorRefs No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egCollectorRefs Data");
		for (i = 0; i < egCollectorRefs_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], ColSize[%d], RowSize[%d]", egCollectorRefs[i].CollectorName, egCollectorRefs[i].dwColSize, egCollectorRefs[i].dwRowSize);
			if (strlen(egCollectorRefs[i].DatasetName) == 0)
				PrintSysLog(EG_LOG_DBG, "#    -- egCollectorRef No Item -- ");
			else
			{
				PrintSysLog(EG_LOG_DBG, "#    -- egCollectorRef Item Name [%s] -- ", egCollectorRefs[i].DatasetName);

			}
		}
	}

	// egMailBox
	if (egMailBoxes_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egMailBox No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egMailBox Data");
		for (i = 0; i < egMailBoxes_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], ColSize[%d], RowSize[%d]", egMailBoxes[i].MailBoxName, egMailBoxes[i].dwColSize, egMailBoxes[i].dwRowSize);
		}
	}

	// egTagTrigger
	if (egTagTriggers_Count == 0)
	{
		PrintSysLog(EG_LOG_DBG, "# egTagTrigger No Data");
	}
	else
	{
		PrintSysLog(EG_LOG_DBG, "# egTagTrigger Data");
		for (i = 0; i < egTagTriggers_Count; i++)
		{
			PrintSysLog(EG_LOG_DBG, "#    Name[%s], Size[%d], Type[%d], Entry[0x%p]", egTagTriggers[i].Name, egTagTriggers[i].Size, egTagTriggers[i].Type, egTagTriggers[i].Entry);
			if (i % 100 == 0)
				os_edge_sleep(100);					// TagTriggeȑꍇAO\邽Sleep}
		}
	}
	//
	// ÕfobOp
	//
	if (pDebugFunc != NULL)
		pDebugFunc();
	//
	// ̑ǉꍇ͈ȉɋL
	// 

	// 
	//
	//

	PrintSysLog(EG_LOG_DBG, "#############################################################");
	PrintSysLog(EG_LOG_DBG, "#          DEBUG WRITE END                                  #");
	PrintSysLog(EG_LOG_DBG, "#############################################################");
}
/*****************************************************************************
* FUNCTION:		MessageHandler
* DESCRIPTION:
*   bZ[Wnh[(VXep)
\*****************************************************************************/
int32_t MessageHandler(const char *senderName, int32_t inMessageNo, void* pData, uint32_t dwSize)
{
	int32_t rtn_user = EDGE_SUCCESS;
	//<LOG>
	// TODO:ModeŐ؂ւ
	//PrintSysLog(EG_LOG_MSG, "[MessageNo : %d] [Sender : %s]", inMessageNo, senderName);
	
	//User Message Handler D
	if (pUserFuncEx != NULL)
	{
		rtn_user = pUserFuncEx(senderName, inMessageNo, pData, dwSize);
	}
	else if (pUserFunc != NULL)
	{
		rtn_user = pUserFunc(senderName, inMessageNo, pData);
	}

	//Default Message Handler
	int32_t rtn = EDGE_FW_MESSAGE_NOTEXIST;//User Message Hanlder ꍇ
	switch (inMessageNo)
	{
	//----------------------------------------------------------------
	case EM_SERVICE_STOP:
		ServiceStop(pData);
		rtn = EDGE_SUCCESS;
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_TAG:			//T[rXŎQƂ^O̒ǉ
		rtn = AddTagRef(pData);
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_REMOVE_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_CLEAR_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_OUT_TAG:		//T[rXŎQƂ^O̒ǉ
		rtn = AddOUTTagRef(pData);
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_REMOVE_OUT_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_CLEAR_OUT_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_IN_TAG:			//T[rXŎQƂ^O̒ǉ
		rtn = AddINTagRef(pData);
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_REMOVE_IN_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_CLEAR_IN_TAG:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_CLCTREF:
		rtn = AddClctRef(pData);
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_REMOVE_CLCTREF:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_CLEAR_CLCTREF:
		//
		//  (v]莟\)
		//
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_MBOX:			//T[rXŎQƂMailBox̒ǉ
		rtn = AddMailBox(pData);
		break;
	//----------------------------------------------------------------
	case EM_SERVICE_ADD_TAGTRIGGER:		//T[rXŎQƂTagTrigger̒ǉ
		rtn = AddTagTrigger(pData);
		break;
	//----------------------------------------------------------------
	case EM_COLLECTOR_CREATE:			//RN^̒ǉ
		rtn = AddCollector(pData);
		break;
	//----------------------------------------------------------------
	case EM_COLLECTOR_START_ALL:		//o^ĂSẴRN^̊Jn
		rtn = StartCollectorAll();
		break;
	//----------------------------------------------------------------		
	case EM_COLLECTOR_STOP_ALL:			//o^ĂSẴRN^̏I
		rtn = StopCollectorAll();
		break;
	//----------------------------------------------------------------		
	case EM_COLLECTOR_START_ONE:
		rtn = StartCollectorByBin(pData);
		break;
	//----------------------------------------------------------------
	case EM_COLLECTOR_STOP_ONE:
		rtn = StopCollectorByBin(pData);
		break;
	//----------------------------------------------------------------
	case EM_TAGTRIGGER_START:
		rtn = ExecTagTriggerTh();
		break;
	//----------------------------------------------------------------
	case EM_READ_REQUEST_SERVICE_XML_END:
		gm_ReadENDXmlFileF = EG_TRUE;
		StartTagTrigThread();			//^OgK[Xbh̊Jn
		rtn = 0;
		break;
	//----------------------------------------------------------------
	case EM_READ_XML_SERVICE_END:
		InitEndFunction();
		rtn = 0;
		break;
	//----------------------------------------------------------------
	case EM_CORE_CREATE_SERVICE_END:
		gm_CoreCreateEndF = EG_TRUE;
		rtn = 0;
		break;
	//----------------------------------------------------------------
	case EM_DEBUG_WRITE_SERVICEOBJ:
		_DebugWriteServiceObject();
		rtn = 0;
		break;
	//----------------------------------------------------------------
	case EM_TAG_DEFAULT_VALUE_SET_END:	// ^OփftHglZbgIʒm
		gm_Ack_TAG_DEFAULT_VALUE_SET_END    = EG_TRUE;				// ʒmM̈
		gm_Result_TAG_DEFAULT_VALUE_SET_END = *(int32_t*)pData;

		break;
	//----------------------------------------------------------------
	default:
		if (pUserFuncEx != NULL || pUserFunc != NULL)
		{
			//<LOG>
			if (rtn_user != EDGE_SUCCESS) {
				PrintSysLog(EG_LOG_MSG, "[USER MessageNo : %d] [Sender : %s] [ErrCode : %d]", inMessageNo, senderName, rtn);
			}
			return rtn_user;
		}
		else
		{
			//<LOG>
			PrintSysLog(EG_LOG_ERR, "The MessageNo %d is Invalid.", inMessageNo);
			return rtn;
		}
		break;
	}
	
	if (rtn != EDGE_SUCCESS) {
		PrintSysLog(EG_LOG_MSG, "[SYS MessageNo : %d] [Sender : %s] [ErrCode : %d]", inMessageNo, senderName, rtn);
	}

	return rtn;
}


/*****************************************************************************
* FUNCTION:		MBoxThread
* DESCRIPTION:
*   [{bNXXbh(VXep)
\*****************************************************************************/
void MBoxThread(SRVBOOTARG* pCmdArg)
{
	char chSenderMboxName[EG_MAX_SERVICENAME + 1];
	int32_t inMessageNo = 0;
	uint32_t cycle = 500;							// ftHg500ms
	uint32_t dwColSize = EGFW_DEF_C2C_MAILBOXCOL;	// T[rXReiԒʐMp[{bNX 1R[hf[^TCY
	uint32_t dwRowSize = EGFW_DEF_C2C_MAILBOXROW;	// T[rXReiԒʐMp[{bNX R[h
	BYTE* pData = NULL;
	int32_t rtn = 0;
	size_t msize = 0;
	msize = sizeof(chSenderMboxName);
	PrintSysLog(EG_LOG_DBG, "Start Service Msize = %d", msize);
	// ꍇ͂̒lAꍇ̓ftHgl@(ȂƂ͂肦Ȃ̂ňꉞG[ô܂܃ftHglŏ)
	if (pCmdArg != NULL)
	{
		dwColSize = pCmdArg->dwColSize;
		dwRowSize = pCmdArg->dwRowSize;
		pData = malloc(dwColSize);
		if (pCmdArg->_MyMboxCycle > 0)//0傫ꍇL
			cycle = pCmdArg->_MyMboxCycle;
	}
	else//G[͏I
	{
		PrintSysLog(EG_LOG_ERR, "Fatal Error MBoxThread CmdArg is NULL");
		free(pData);
		return;
	}
	//EgMailBoxCreate Name
	rtn = EgMailboxCreateEx(ServiceMailboxName, dwColSize, dwRowSize, &gm_MyMBoxMemInfo);
	if (rtn != EDGE_SUCCESS)
	{
		PrintSysLog(EG_LOG_ERR, "Cannot Create Own EgMailBox[%s] - ServiceName[%s] Status[%d]", ServiceMailboxName, ServiceRealName, rtn);
		free(pData);
		return;
	}
	//Xe[^XTag̒lWrite
	EgTagWrite(ServiceMboxColSizeName, &dwColSize, sizeof(uint32_t));
	EgTagWrite(ServiceMboxRowSizeName, &dwRowSize, sizeof(uint32_t));

	// 1Read
	rtn = EgMailboxOpen(ServiceMailboxName, RTCD_READWRITE, &gm_MyMBoxHandle);
	if (rtn != EDGE_SUCCESS)
	{
		PrintSysLog(EG_LOG_ERR, "Cannot Open Own EgMailBox[%s] - ServiceName[%s], Status[%d]", ServiceMailboxName, ServiceRealName, rtn);
		free(pData);
		return;
	}
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Start Service EgMailBox[%s]. Cycle=[%d]", ServiceMailboxName, cycle);
	while (1)
	{
		// I
		if (gm_MyMailBoxCancelF == EG_TRUE)
			break;

		while (1)
		{
			// I
			if (gm_MyMailBoxCancelF == EG_TRUE)
				break;

			memset(chSenderMboxName, 0, sizeof(chSenderMboxName));
			memset(pData, 0, dwColSize);
			//M
			rtn = EgMailboxReceive(&gm_MyMBoxHandle, chSenderMboxName, sizeof(chSenderMboxName), &inMessageNo, pData, dwColSize, EG_WAIT_FOREVER);
			if (rtn == 0)
				MessageHandler(chSenderMboxName, inMessageNo, pData, dwColSize);
			else
				break;
		}
		os_edge_sleep(cycle);
	}
	//[{bNX̃N[Y
	EgMailboxClose(&gm_MyMBoxHandle);
	//[{bNX̍폜
	EgMailboxDelete(&gm_MyMBoxMemInfo);
	//t[
	free(pData);
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "End Service EgMailBox");

}
//
// t[[NJIuWFNg
//
void CreateObject()
{
	if (g_H_egSysCfg == NULL) return; //OŃ`FbNς ꉞ`FbN

	egCollectors = os_edge_mallocMemory((((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry) * sizeof(EGLOCALCOLLECTOR));	//Collector
	egCollectorRefs = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwClctEntry * sizeof(EGCOLLECTORREF));	//CollectorRef
	egMailBoxes = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwMailboxEntry * sizeof(EGMAILBOX));	//MailBox
	egTagRefs_OUT = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGTAGREF));	//TagRef OUT
	egTagRefs_IN = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGTAGREF));	//TagRef IN
	egTagRefs = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry * sizeof(EGTAGREF));		//TagRef
	egTagTriggers = os_edge_mallocMemory(((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagTrigEntry * sizeof(EGTAGTRIGGER));	//TagTrigger
}
/*****************************************************************************
* FUNCTION:		LocalInitialize
* DESCRIPTION:
*   Local(VXep)
\*****************************************************************************/
int32_t LocalInitialize(const char* pPath)
{
	int32_t ret = EDGE_SUCCESS;
	char *chServiceName = NULL;					//T[rX [JŎ擾锠 t@CpXpӂA`FbN{
	char *szPath = NULL;						//pX̔
	char *szFileName = NULL;					//t@C

	//allocate
	size_t bufsize = EG_MAX_SERVICEPATH + 1;
	chServiceName	= (char*)os_edge_mallocMemory(bufsize);
	szPath			= (char*)os_edge_mallocMemory(bufsize);
	szFileName		= (char*)os_edge_mallocMemory(bufsize);
	if ((chServiceName == NULL) || (szPath == NULL) || (szFileName == NULL))
		return EDGE_RTCD_ALLOCATE_ERROR;		// mێs

	gm_TagTriggerCanncelF = EG_FALSE;			//^OgK[MXbhLZtO
	gm_MyMailBoxCancelF = EG_FALSE;
	size_t i = 0;

	//
	CreateObject();	//t[[NJIuWFNg
	//l
	memset(ServiceRealName, 0, EG_MAX_SERVICENAME);
	memset(ServiceStateName, 0, EG_MAX_TAGNAME);
	memset(ServiceStateErrName, 0, EG_MAX_TAGNAME);
	memset(ServiceStateRunName, 0, EG_MAX_TAGNAME);
	memset(ServiceStateLiveName, 0, EG_MAX_TAGNAME);
    memset(ServiceState2DependName, 0, EG_MAX_TAGNAME);
	memset(ServiceMboxTagName, 0, EG_MAX_TAGNAME);
	memset(ServiceMboxColSizeName, 0, EG_MAX_TAGNAME);
	memset(ServiceMboxRowSizeName, 0, EG_MAX_TAGNAME);
	memset(ServiceTrigAutoRunName, 0, EG_MAX_TAGNAME);
	memset(ServiceTrigStateErrName, 0, EG_MAX_TAGNAME);
	memset(chServiceName, 0, bufsize);
	memset(szPath, 0x00, bufsize);
	memset(szFileName, 0, bufsize);
	if(pPath && strlen(pPath) > 0 && strlen(pPath) < EG_MAX_SERVICEPATH)
		os_edge_strncpy_s(szPath, bufsize, pPath, _TRUNCATE);	// pX߰
	else
		os_edge_getProcPath(szPath, (int32_t)bufsize);		//s̃vZX̃tpX擾
	if (strlen(szPath) > 0) {
		//߽Agq폜āÂ̧ٖ݂̎擾
		for (i = strlen(szPath); i > 0; i--) {
			if (szPath[i] == '.')	szPath[i] = 0;		// gqONullݒ
			if (szPath[i] == '\\') {					// ̧ٖ̑Ő؂蕶
				os_edge_strncpy_s(chServiceName, bufsize, &szPath[i + 1], _TRUNCATE);	// ̧ٖ߰
				break;
			}
		}
		if (strlen(chServiceName) > EG_MAX_SERVICENAME)
		{
			fname_get(szPath, szFileName);
			//<LOG>
			//G[̏ꍇ̓T[rX24ȏ
			PrintSysLog(EG_LOG_ERR, "The service name[%s] is not longer than 8 characters. Reset the settings because they do not work properly.", szFileName);
			ret = EDGE_FW_NAME_INVALID;
		}
		else if (strlen(chServiceName) > 0)
		{
			os_edge_strncpy_s(ServiceRealName, sizeof(ServiceRealName), chServiceName, _TRUNCATE);					//T[rX̍쐬
		}
		else
		{
			// vOIG[ SERVICE擾łȂ
			PrintSysLog(EG_LOG_FER, "The service name could not be set.[%s]", szPath);
			ret = EDGE_FW_INIT_ERROR;
		}
	}

	//free
	os_edge_freemallocMemory(chServiceName);
	os_edge_freemallocMemory(szPath);
	os_edge_freemallocMemory(szFileName);

	return ret;
}

/*****************************************************************************
* FUNCTION:		SendAppXml2Framework
* DESCRIPTION:
*   Framework(EgBoot)xmlǂݍł炤bZ[WM(VXep)
\*****************************************************************************/
void SendAppXml2Framework(SRVBOOTARG* pCmdArg)
{
	struct stat st;
	char *szXmlPath = NULL;					//MAX_PATH
	int32_t rtn = 0;
	int32_t count = 0;

	//allocate
	size_t bufsize = EG_MAX_SERVICEPATH + 1;
	szXmlPath	= (char*)os_edge_mallocMemory(bufsize);
	if (szXmlPath == NULL)
		goto failed;

	memset(szXmlPath, 0, bufsize);
	//ECIt@CpXw肪ꍇ̒lgp
	if (pCmdArg && strlen(pCmdArg->chECIPath) > 0)
	{
		memcpy(szXmlPath, pCmdArg->chECIPath, bufsize);
		PrintSysLog(EG_LOG_DBG, "szXmlPath pCmdArg->chECIPath[%s]", pCmdArg->chECIPath);
	}
	else//w肪Ȃꍇ̓T[rXRei.xmlgp
	{
		PrintSysLog(EG_LOG_DBG, "szXmlPath pCmdArg->chName[%s]", pCmdArg->chName);
		sprintf_s(szXmlPath, bufsize, "%s.xml", pCmdArg->chName);
		
	}
	//݂ȂꍇEgBootɑȂ
	//݂ 0ȊOA݂Ȃ 0
	if (stat(szXmlPath, &st) == 0)//݂Ăꍇ݂̂ɓ
	{
		//<LOG>
		PrintSysLog(EG_LOG_DBG, "Send Xml Path -> %s", szXmlPath);
		//EgBootT[rXxmlǂݍނ悤bZ[W𑗂
		gm_ReadENDXmlFileF = EG_FALSE;

		RTCDHANDLE pHandle = { 0 };
		// 1 : Read , 2 : Write , 3 : ReadWrite
		rtn = EgMailboxOpenSC("EgBoot", RTCD_WRITE, &pHandle);
		if (rtn != EDGE_SUCCESS)
		{
			PrintSysLog(EG_LOG_ERR, "EgMailboxOpenSC Error = [%d] [FUNC = %s]", rtn, __func__);
			goto failed;
		}
		PrintSysLog(EG_LOG_DBG, "EgMailboxOpenSC [%d] [FUNC = %s]", rtn, __func__);

		//EgBootxmlǍ߂𑗐M
		rtn = EgMailboxSend(&pHandle, ServiceRealName, EM_READ_REQUEST_SERVICE_XML, (void*)szXmlPath, (uint32_t)bufsize);
		PrintSysLog(EG_LOG_DBG, "EgMailboxSend XML[%s]",szXmlPath);
		if (rtn != EDGE_SUCCESS)
			PrintSysLog(EG_LOG_ERR, "EgMailboxSend Error = [%d] [FUNC = %s]", rtn, __func__);
		else
		{
			while (1)
			{
				//30b҂Ă݂B_EgBootȂ
				if (count > 30)
				{
					PrintSysLog(EG_LOG_ERR, "Cannot Read Xml. EgBoot is Time Out");
					break;
				}
				if (gm_ReadENDXmlFileF == EG_TRUE)
					break;
				count++;
				os_edge_sleep(1000);
			}
		}
		rtn = EgMailboxClose(&pHandle);
	}
	else
	{
		//<LOG>
		PrintSysLog(EG_LOG_DBG, "Did not send the xml path to EgBoot because the xml file doesn't exist. [%s]", szXmlPath);
	}
	gm_ReadENDXmlFileF = EG_TRUE;

	//free
	os_edge_freemallocMemory(szXmlPath);
	return;

failed:
	//free
	if (szXmlPath)
		os_edge_freemallocMemory(szXmlPath);
	return;
}

//-----------------------------------------------
// l`FbN
// 펞true ,@lł͂Ȃꍇfalse
//-----------------------------------------------
bool fnIsDigit(char* pToken, size_t len)
{
	if (len < 1)
		return false; //񂪋 lł͂Ȃ

	//l`FbN@lł͂ȂꍇϊȂ
	for (size_t i = 0; i < len; i++) {
		if (!isdigit(pToken[i])) {
			return false; //G[false
		}
	}

	//l
	return true;
}
/*****************************************************************************
* FUNCTION:		fnGetCommandLine
* DESCRIPTION:
*   R}hCɎw肳Ăl擾 Ԃ
\*****************************************************************************/
void fnGetCommandLine(SRVBOOTARG* pArg)
{
	char chArg[1024] = { 0 }; //
	char* token;
	uint8_t ArgType = EG_ARG_NON;
	os_edge_getCommmandLine(chArg, sizeof(chArg));//R}hC擾
	PrintSysLog(EG_LOG_DBG, "Proccess Argument = %s", chArg);
	if (strlen(chArg) > 0)
	{
		char	*context;
		token = strtok_s(chArg, " " ,&context);
		while (token != NULL) {
			if (ArgType == EG_ARG_PRIORITY) //-priority ̎w肪ꍇA̕l
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
					continue;
				
				pArg->byPriority = atoi(token);	//lɕϊ
			}
			else if (ArgType == EG_ARG_COLSIZE)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
				{
					PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_COLSIZE Bad Data", chArg);
					continue;
				}

				pArg->dwColSize = atoi(token);	//lɕϊ
			}
			else if (ArgType == EG_ARG_ROWSIZE)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
				{
					PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_ROWSIZE Bad Data", chArg);
					continue;
				}

				pArg->dwRowSize = atoi(token);	//lɕϊ
			}
			else if (ArgType == EG_ARG_NAME)
			{
				ArgType = EG_ARG_NON; //
				os_edge_strncpy_s(pArg->chName, sizeof(pArg->chName), token, _TRUNCATE);	// T[rXۊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_NAME Name=[%s]", pArg->chName);
			}
			else if (ArgType == EG_ARG_ECI)
			{
				ArgType = EG_ARG_NON; //
				os_edge_strncpy_s(pArg->chECIPath, sizeof(pArg->chECIPath), token, _TRUNCATE);	// ECIۊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_ECI Path=[%s]", pArg->chECIPath);
			}
			else if (ArgType == EG_ARG_TRIGPRIORITY)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
					continue;

				pArg->byTrigPriority = atoi(token);	//lɕϊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_TRIGPRIORITY Value=[%d]", pArg->byTrigPriority);
			}
			else if (ArgType == EG_ARG_TRIGCYCLE)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
					continue;

				pArg->_TrigCycle = atoi(token);	//lɕϊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_TRIGCYCLE Value=[%d]", pArg->_TrigCycle);
			}
			else if (ArgType == EG_ARG_PTEST)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
					continue;

				pArg->byPTestFlag = atoi(token);	//lɕϊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_PTEST Value=[%d]", pArg->byPTestFlag);
			}
			else if (ArgType == EG_ARG_MYMBOXCYCLE)
			{
				ArgType = EG_ARG_NON; //
				//l`FbN@lł͂ȂꍇϊȂ
				if (fnIsDigit(token, strlen(token)) == false)
					continue;

				pArg->_MyMboxCycle = atoi(token);	//lɕϊ
				PrintSysLog(EG_LOG_DBG, "Proccess Argument = EG_ARG_MYMBOXCYCLE Value=[%d]", pArg->_MyMboxCycle);
			}
			else
			{
				if (_stricmp(token, "-priority") == 0)//-priority ̎w肪ꍇA̕l
					ArgType = EG_ARG_PRIORITY;
				else if (_stricmp(token, "-colsize") == 0)//-colsize ̎w肪ꍇA̕l
					ArgType = EG_ARG_COLSIZE;
				else if (_stricmp(token, "-rowsize") == 0)//-rowsize ̎w肪ꍇA̕l
					ArgType = EG_ARG_ROWSIZE;
				else if (_stricmp(token, "-name") == 0)//-name ̎w肪ꍇA̕l
					ArgType = EG_ARG_NAME;
				else if (_stricmp(token, "-eci") == 0) //-eci ̎w肪ꍇA̕pX
					ArgType = EG_ARG_ECI;
				else if (_stricmp(token, "-trigpriority") == 0)//-trigpriority ̎w肪ꍇA̕l
					ArgType = EG_ARG_TRIGPRIORITY;
				else if (_stricmp(token, "-trigcycle") == 0)//-trigcycle ̎w肪ꍇA̕l
					ArgType = EG_ARG_TRIGCYCLE;
				else if (_stricmp(token, "-ptest") == 0)//-ptest ̎w肪ꍇA̕l
					ArgType = EG_ARG_PTEST;
				else if (_stricmp(token, "-mymboxcycle") == 0)//-mymboxcycle ̎w肪ꍇA̕l
					ArgType = EG_ARG_MYMBOXCYCLE;
				else
					ArgType = EG_ARG_NON;//

			}
			token = strtok_s(NULL, " ", &context);
		}
	}
}
//
// TAG쐬(t[[N)
//
int32_t fnCreateLocalTag()
{
	int32_t rtn = 0;
	char *tagName = NULL;		// Tag̖Opobt@
	char *chValue = NULL;		// Tag̒lpobt@ Ƃ肠őTCYTAGADDRESS
	bool bState = false;		// ^Oɏޕϐ
	
	//allocate
	size_t bufsize1 = EG_MAX_TAGNAME + 1;
	size_t bufsize2 = EG_MAX_SERVICEMAILBOXNAME + 1;
	tagName = (char*)os_edge_mallocMemory(bufsize1);
	chValue = (char*)os_edge_mallocMemory(bufsize2);
	if ((tagName == NULL) || (chValue == NULL))
		goto failed;

	memset(tagName, 0, bufsize1);
	memset(chValue, 0, bufsize2);

	sprintf_s(ServiceStateName, EG_MAX_TAGNAME, "SERVICE.%s.Status", ServiceRealName);			//T[rXXe[^X^O̍쐬
	sprintf_s(ServiceStateErrName, EG_MAX_TAGNAME, "SERVICE.%s.Error", ServiceRealName);		//T[rXG[^O̍쐬
	sprintf_s(ServiceStateRunName, EG_MAX_TAGNAME, "SERVICE.%s.Run", ServiceRealName);			//T[rXRun^O̍쐬
	sprintf_s(ServiceStateLiveName, EG_MAX_TAGNAME, "SERVICE.%s.Live", ServiceRealName);		//T[rXLive^O̍쐬
	sprintf_s(ServiceState2DependName, EG_MAX_TAGNAME, "SERVICE.%s.State2Depend", ServiceRealName);	//T[rXˑ֌WNׂ̈̃Xe[^X^O̍쐬
	sprintf_s(ServiceMboxTagName, EG_MAX_TAGNAME, "SERVICE.%s.MboxNameValue", ServiceRealName);	//T[rX[{bNXTag̍쐬
	sprintf_s(ServiceMboxColSizeName, EG_MAX_TAGNAME, "SERVICE.%s.MboxColSize", ServiceRealName);		//ReiԃbZ[WʐMp[{bNX 1R[hTCY쐬
	sprintf_s(ServiceMboxRowSizeName, EG_MAX_TAGNAME, "SERVICE.%s.MboxRowSize", ServiceRealName);		//ReiԃbZ[WʐMp[{bNX R[h쐬
	sprintf_s(ServiceTrigAutoRunName, EG_MAX_TAGNAME, "SERVICE.%s.TrigAutoRun", ServiceRealName);		//gK[MJn^O̍쐬
	sprintf_s(ServiceTrigStateErrName, EG_MAX_TAGNAME, "SERVICE.%s.TrigError", ServiceRealName);	//gK[XbhG[^O̍쐬
	
	// ^O̓o^("SERVICE." + ServiceName)
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	sprintf_s(tagName, bufsize1, "SERVICE.%s", ServiceRealName);
	rtn = EgTagGetProperty(tagName, "Name", chValue, (int32_t)bufsize2);
	if (rtn == EDGE_TTABLE_MEMORRY_ERROR) //̃G[̏ꍇedgeVXeȂG[̂ߏI ł̏oȂꍇ͑łoȂ͂
	{
		// syslogɑΉꍇl
		PrintSysLog(EG_LOG_ERR, "Shared memory cannot be created. Please check the environment.");
		goto failed;
	}

	if (strlen(chValue) == 0) // T[rX̓o^邩HȂꍇ͈ȉɓ
	{
		rtn = EgTagCreate(tagName, EgVtInt32, 4, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", tagName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", tagName, rtn);
	}

	// Xe[^X^O̓o^ SERVICE.XXXXXX.STATE
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceStateName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceStateName, EgVtByte, 1, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceStateName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceStateName, rtn);

	}
	//Xe[^XTag̒lWrite
	EgTagWrite(ServiceStateName, &EG_STATE_INITIALIZING, sizeof(uint8_t));

	// T[rXُԃXe[^X̓o^ SERVICE.XXXXXX.Error
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceStateErrName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceStateErrName, EgVtBoolean, 1, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceStateErrName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceStateErrName, rtn);

	}
	//Xe[^XTag̒lWrite
	bState = false;
	EgTagWrite(ServiceStateErrName, &bState, sizeof(bool));

	// T[rXsԃXe[^X̓o^ SERVICE.XXXXXX.Run
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceStateRunName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceStateRunName, EgVtBoolean, 1, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceStateRunName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceStateRunName, rtn);

	}
	//Xe[^XTag̒lWrite
	bState = false;
	EgTagWrite(ServiceStateRunName, &bState, sizeof(bool));

	// T[rXsJE^̓o^ SERVICE.XXXXXX.Live
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceStateLiveName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceStateLiveName, EgVtUInt32, 4, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceStateLiveName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceStateLiveName, rtn);

	}
	//Xe[^XTag̒lWrite
	uint32_t liveVal = 0;
	EgTagWrite(ServiceStateLiveName, &liveVal, sizeof(uint32_t));

	
	// T[rXCfbNXo^li[@TAG SERVICE.XXXXXX.Value
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceMboxTagName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceMboxTagName, EgVtUInt32, 2, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceMboxTagName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceMboxTagName, rtn);

	}
	//T[rXReiIndexl^Oɏ
	uint32_t MboxNameValue = 0;
	EgServiceGetProperty(ServiceRealName, "IndexValue", &MboxNameValue, sizeof(MboxNameValue));
	EgTagWrite(ServiceMboxTagName, &MboxNameValue, sizeof(uint32_t));

	// ReiԃbZ[WʐMp[{bNX 1R[hTCY̓o^ SERVICE.XXXXXX.MBOXCOLSIZE
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceMboxColSizeName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceMboxColSizeName, EgVtUInt32, 4, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceMboxColSizeName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceMboxColSizeName, rtn);

	}
	// ReiԃbZ[WʐMp[{bNX  R[h̓o^ SERVICE.XXXXXX.MBOXCOLSIZE
	// ɓo^Ă邩`FbNBo^ĂȂꍇ̂ݓo^
	memset(chValue, 0, bufsize2);
	EgTagGetProperty(ServiceMboxRowSizeName, "Name", chValue, (int32_t)bufsize2);
	if (strlen(chValue) == 0)
	{
		rtn = EgTagCreate(ServiceMboxRowSizeName, EgVtUInt32, 4, "", "");
		if (rtn == EDGE_SUCCESS)
			PrintSysLog(EG_LOG_OPE, "Framework EgTagCreate SUCCESS. Name : [%s]", ServiceMboxRowSizeName);
		else
			PrintSysLog(EG_LOG_ERR, "Framework EgTagCreate ERROR. Name : [%s], Status : [%d]", ServiceMboxRowSizeName, rtn);

	}
	// free
	os_edge_freemallocMemory(tagName);
	os_edge_freemallocMemory(chValue);

	return EDGE_SUCCESS;

failed:
	// free
	if (tagName)
		os_edge_freemallocMemory(tagName);
	if (chValue)
		os_edge_freemallocMemory(chValue);
	return rtn;
}

//###############################################################
//
// t[[NJ֐
//
//###############################################################
#define RTCD_HANDLE_CODE 0x52544344								// RTCDnhʃR[h(nhÓ`FbNp)
/*****************************************************************************
* FUNCTION:		_EgFW_Initialize
* DESCRIPTION:
*   t[[N(J)(VXep)
\*****************************************************************************/
int32_t _EgFW_Initialize(EDGECONFIG *Config)
{
	int32_t rtn = 0;
	char *procPath = NULL;		// T[rXvZX/DLLt@CpX(ŃT[rXExml̃pXɕϊ邽߂Ɏgp)
	char *MboxName = NULL;		// T[rX[{bNX
	int32_t checkcount = 0;		//[{bNX쐬`FbNp
	uint8_t bReadXml = EG_TRUE;	// xmlǂނǂ̃tO
	gm_CmdArg.byPriority = 150;	// [{bNXvCIeB
	gm_CmdArg.dwColSize = 2048;	// [{bNX1R[hf[^
	gm_CmdArg.dwRowSize = 1024;	// [{bNXR[hTCY
	gm_CmdArg.byTrigPriority = 150;	// ^OgK[MXbhvCIeB
	int size = 0;
	bool bState = false;		// ^Oɏޕϐ
	EGSERVICEHANDLE	p;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	size = sizeof(EDGECONFIG);
	//allocate
	size_t bufsize3 = EG_MAX_SERVICEPATH + 1;
	size_t bufsize4 = EG_MAX_SERVICEMAILBOXNAME + 1;
	procPath = (char*)os_edge_mallocMemory(bufsize3);
	MboxName = (char*)os_edge_mallocMemory(bufsize4);
	if ((procPath == NULL) || (MboxName == NULL))
		goto failed;

	//
	memset(procPath, 0, bufsize3);

	if (Config != NULL)	//ConfigNULLł͂Ȃꍇ͐ݒlRs[
		memcpy(procPath, Config->Path, sizeof(Config->Path));

	rtn = LocalInitialize(procPath);		// ServiceName 擾
	if (rtn != EDGE_SUCCESS)
		goto failed;
	
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Start Initialize");

	//
	// R}h擾ĂŐݒ
	// AConfigŎw肳ĂꍇConfigL
	//
	fnGetCommandLine(&gm_CmdArg);
	//Log̊֌Wケłx
	if (Config != NULL)	//ConfigNULLł͂Ȃꍇ͐ݒlRs[
	{
		bReadXml = Config->bReadXmlF;
		if(Config->shPriority < 256)
			gm_CmdArg.byPriority = (uint8_t)Config->shPriority;
	}
	if(strlen(gm_CmdArg.chName) == 0)
		os_edge_strncpy_s(gm_CmdArg.chName, sizeof(gm_CmdArg.chName), ServiceRealName, _TRUNCATE);	// T[rXۊ
	//
	// ُlftHgɕύX
	//
	// vCIeB
	if (gm_CmdArg.byPriority == 0)
		gm_CmdArg.byPriority = EGFW_DEF_C2C_MAILBOXPRI; //ftHgl

	// ^OgK[MpXbhvCIeB
	if (gm_CmdArg.byTrigPriority == 0)
		gm_CmdArg.byTrigPriority = EGFW_DEF_TRIGGER_PRI; //ftHgl
	
	// 1R[hf[^TCY
	if (gm_CmdArg.dwColSize == 0 || gm_CmdArg.dwColSize > ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxC2CMailboxCol)
	{
		PrintSysLog(EG_LOG_WRN, "Warning Argument size exceeds the limit. Convert to default value. [ColSize]", __func__);
		gm_CmdArg.dwColSize = EGFW_DEF_C2C_MAILBOXCOL; //ftHgl
	}
	// R[h
	if (gm_CmdArg.dwRowSize == 0 || gm_CmdArg.dwRowSize > ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxC2CMailboxRow)
	{
		PrintSysLog(EG_LOG_WRN, "Warning Argument size exceeds the limit. Convert to default value. [RowSize]", __func__);
		gm_CmdArg.dwRowSize = EGFW_DEF_C2C_MAILBOXROW; //ftHgl
	}
	// T[rX
	if( strlen(gm_CmdArg.chName) > 0)
		os_edge_strncpy_s(ServiceRealName, sizeof(ServiceRealName), gm_CmdArg.chName, _TRUNCATE);					//T[rX̍쐬


	//
	memset(MboxName, 0, bufsize4);

	//CfbNXƂ܂ŏ҂
	while (EG_TRUE)
	{
		if (checkcount > 10)
		{
			PrintSysLog(EG_LOG_ERR, "Error Get MailboxName. [FUNC = %s]", __func__);
			break;
		}

		EgServiceGetProperty(ServiceRealName, "MailboxName", MboxName, (int32_t)bufsize4);
		if (strlen(MboxName) > 0)
		{
			os_edge_strncpy_s(ServiceMailboxName, sizeof(ServiceMailboxName), MboxName, _TRUNCATE);		//T[rXnbV̍쐬
			os_edge_strncpy_s(ServiceName, sizeof(ServiceName), MboxName, _TRUNCATE);				//T[rXnbV̍쐬
			
			break;
		}
		else
		{
			// xmlǂݍ܂Ȃꍇ͎gŋN̈Ӗ gCreate
			EgServiceCreate(ServiceRealName, "", "", &p);
			PrintSysLog(EG_LOG_DBG, "Called EgServiceCreate[%s] myself.", ServiceRealName);
		}
		checkcount++;
		os_edge_sleep(100);								//ɈӖ͂Ȃ 1b҂Ă݂邽߂̒l
	}
	//nbVƂĂȂ玩Mo^
	if (strlen(MboxName) < 1)
	{
		EgServiceCreate(ServiceRealName, "", "", &p);
		EgServiceGetProperty(ServiceRealName, "MailboxName", MboxName, (int32_t)bufsize4);
		if (strlen(MboxName) > 0)
		{
			os_edge_strncpy_s(ServiceMailboxName, sizeof(ServiceMailboxName), MboxName, _TRUNCATE);		//T[rXnbV̍쐬
			os_edge_strncpy_s(ServiceName, sizeof(ServiceName), MboxName, _TRUNCATE);				//T[rXnbV̍쐬
		}
		PrintSysLog(EG_LOG_WRN, "Called EgServiceCreate[%s] myself.", ServiceRealName);
	}
	//Xe[^X^O̍쐬
	rtn = fnCreateLocalTag();
	if (rtn != EDGE_SUCCESS) //sI
			goto failed;
	
	//[U[bZ[Wnhǉ
	if (Config && Config->fpUserMessHdlFunc)
	{
		pUserFunc = Config->fpUserMessHdlFunc;
		//<LOG>
		PrintSysLog(EG_LOG_DBG, "Add User Messege Handler Function");
	}
	//[U[bZ[Wnhǉ
	if (Config && Config->fpUserMessHdlFuncEx)
	{
		pUserFuncEx = Config->fpUserMessHdlFuncEx;
		//<LOG>
		PrintSysLog(EG_LOG_DBG, "Add User Messege Handler FunctionEx");
	}
	//
	memset(&gm_MyMBoxMemInfo, 0, sizeof(gm_MyMBoxMemInfo));
	memset(&gm_MyMBoxHandle, 0, sizeof(gm_MyMBoxHandle));
	int32_t errorNo = 0;	//debugp
	//T[rXƂ̃[{bNX쐬 + Xbh쐬
	gm_ThMBox = os_edge_createThread(gm_CmdArg.byPriority, 4096, MBoxThread, &gm_CmdArg, &errorNo);	//X^bNTCY͌Œ
	if (gm_ThMBox == NULL)
	{
		PrintSysLog(EG_LOG_ERR, "Error createEdgeThread. [FUNC = %s, errorNo = %d]", __func__, errorNo);
		EgTagWrite(ServiceStateName, &EG_STATE_INITIAL_ERR, sizeof(uint8_t));	//EG_STATE_INITIAL_ERR
		//Xe[^XTag̒lWrite
		bState = true;
		EgTagWrite(ServiceStateErrName, &bState, sizeof(bool));
		rtn = EDGE_THREAD_ERROR;
		goto failed;
	}
	checkcount = 0;
	//[{bNXł܂ŏ҂
	while (EG_TRUE)
	{
		if (checkcount > 10)
		{
			PrintSysLog(EG_LOG_ERR, "Error MBoxHandle. [FUNC = %s]", __func__);
			break;
		}

		if (gm_MyMBoxHandle.code == RTCD_HANDLE_CODE)	//Mailbox̃nhl擾ł甲
			break;

		checkcount++;
		os_edge_sleep(100);								//ɈӖ͂Ȃ 1b҂Ă݂邽߂̒l
	}
	
	//[{bNX쐬LOGɃbZ[Wo
	if (gm_MyMBoxHandle.code == RTCD_HANDLE_CODE)
	{
		EgTagWrite(ServiceStateName, &EG_STATE_CREATED_MBOX, sizeof(uint8_t));
		PrintSysLog(EG_LOG_DBG, "Success Create Service Communicate Mailbox. Priority = %d, ColSize = %d, RowSize = %d", gm_CmdArg.byPriority, gm_CmdArg.dwColSize, gm_CmdArg.dwRowSize);
	}
	else
		PrintSysLog(EG_LOG_ERR, "Error Create Service Communicate Mailbox");

	//xml̓ǂݍ(EgBootɓǂł炤)
	if (bReadXml == EG_TRUE)
		SendAppXml2Framework(&gm_CmdArg);

	//Xe[^XTag̒lWrite
	EgTagWrite(ServiceStateName, &EG_STATE_NORMAL_WORK, sizeof(uint8_t));
	//
	//EgBootxmlǂݏI҂
	//TagRef̓o^ׂďI^C~OŎɐi݂
	//ׂẴT[rXN玟ɐiނɂ
	//蓮ŋNT[rXxmlɊɋNĂT[rX
	//TagRef̋Lڂꍇ͂ł͑҂ĂȂ̂ł͐Ƃ
	//̂ݑΉƂ
	//
	checkcount = 0;
	while (EG_TRUE)
	{
		if (checkcount > 20 || bReadXml == EG_FALSE)
		{
			PrintSysLog(EG_LOG_DBG, "!!! CreateF Not True. Did you start it yourself?");
			break;
		}

		if (gm_CoreCreateEndF == EG_TRUE)	//gm_CoreCreateEndFTRUEɂȂ甲
			break;

		checkcount++;
		os_edge_sleep(100);					//ɈӖ͂Ȃ 1b҂Ă݂邽߂̒l
	}
	// Op[{bNXI[voĂȂꍇ̓G[ԋp
	if (gm_OpendLogMBoxF == EG_FALSE)
	{
		rtn = EDGE_RTCD_CREATE_LOGMBOX_ERROR;
		goto failed;
	}

	//
	// InitilizȅIɎ{Ƃȉ֐Ŏ 
	// EAutoRun̑M
	//
	InitPostProccess();
	
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "End Initialize");
	// free
	os_edge_freemallocMemory(procPath);
	os_edge_freemallocMemory(MboxName);
	
	return EDGE_SUCCESS;

failed:
	// free
	if (procPath)
		os_edge_freemallocMemory(procPath);
	if (MboxName)
		os_edge_freemallocMemory(MboxName);
	return rtn;
}
/*****************************************************************************
* FUNCTION:		_EgFW_Finalize
* DESCRIPTION:
*   ㏈
\*****************************************************************************/
int32_t _EgFW_Finalize(void)
{
	if (strlen(ServiceRealName) == 0 || strlen(ServiceStateName) == 0)
		return EDGE_FW_INIT_ERROR;

	//Xe[^XTag̒lWrite
	EgTagWrite(ServiceStateName, &EG_STATE_FINALIZE_ERR, sizeof(uint8_t));

	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Start Finalize");

	//^OgK[MXbhI
	gm_TagTriggerCanncelF = EG_TRUE;
	//T[rXƂ̃[{bNXXbhI
	gm_MyMailBoxCancelF = EG_TRUE;
	os_edge_sleep(100);

	//Collector̃Xgbv
	StopCollectorAll();

	//CloséAFrameworkŃI[vĂȂׂłȂ
	//č폜̂ݎ{
	//쐬MailBoxSč폜
	DeleteMailBoxAll();

	//Xe[^XTag̒lWrite
	EgTagWrite(ServiceStateName, &EG_STATE_NOT_WORK, sizeof(uint8_t));

	//ŌɃ[{bNX̃Xbh폜
	if (gm_ThMBox != NULL)
	{
		os_edge_deleteThread(gm_ThMBox);
		gm_ThMBox = NULL;
	}
	//ŌɃ^OgK[MXbh폜
	if (gm_ThTrig != NULL)
	{
		os_edge_deleteThread(gm_ThTrig);
		gm_ThTrig = NULL;
	}
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "End Finalize");

	//Log[{bNX
	if (gm_OpendLogMBoxF == EG_TRUE)
	{
		EgMailboxClose(&gm_LogMBoxHandle);
		gm_OpendLogMBoxF = EG_FALSE;
	}
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgFW_AddUserHandler
* DESCRIPTION:
*   [U[pbZ[Wnhǉ֐
\*****************************************************************************/
int32_t EgFW_AddUserHandler(FUNC_POINTER p)
{
	//ĂȂƂ(InitĂłȂAG[ŏIĂ)Ȃ̂ŃG[
	if (strlen(ServiceRealName) == 0 || strlen(ServiceStateName) == 0)
		return EDGE_FW_INIT_ERROR;

	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Add User Messege Handler Function");
	pUserFunc = p;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgFW_AddUserHandlerEx
* DESCRIPTION:
*   [U[pbZ[Wnhǉ֐
\*****************************************************************************/
int32_t EgFW_AddUserHandlerEx(FUNC_POINTEREX p)
{
	//ĂȂƂ(InitĂłȂAG[ŏIĂ)Ȃ̂ŃG[
	if (strlen(ServiceRealName) == 0 || strlen(ServiceStateName) == 0)
		return EDGE_FW_INIT_ERROR;

	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Add User Messege Handler FunctionEx");
	pUserFuncEx = p;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgFW_AddInitEndFunc
* DESCRIPTION:
*   EgBootT[rXInitializeIɎs֐ǉ(C#̃t[[Nz)
\*****************************************************************************/
int32_t EgFW_AddInitEndFunc(INITENDFUNC_POINTER p)
{
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Add Initilize End Function");
	pInitEndFunc = p;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgFW_AddDebugFunc
* DESCRIPTION:
*   fobOp֐ǉ(C#̃t[[Nz)
\*****************************************************************************/
int32_t EgFW_AddDebugFunc(DEBUGFUNC_POINTER p)
{
	//<LOG>
	PrintSysLog(EG_LOG_DBG, "Add Debug Function");
	pDebugFunc = p;
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgFW_PrintLog
* DESCRIPTION:
*   t[[NOOo͊֐
\*****************************************************************************/
void EgFW_PrintLog(const char* pServiceName, const char* pMode, const char* format, ...)
{
	va_list arg;
	char *messBuff = NULL;
	//allocate
	messBuff = (char*)os_edge_mallocMemory(1024);
	if (messBuff == NULL)
		return;
	size_t bufsize = 1024;
	memset(messBuff, 0, bufsize);

	va_start(arg, format);
	vsprintf_s(messBuff, bufsize, format, arg);
	va_end(arg);
	
	// w肳ꂽpServiceNameAŕێĂT[rXRei(24) , T[rXCfbNX(4)݂Ă
	// w肳ꂽpServiceNameindexŎw肳ꂽꍇ́A24̃T[rXReiɕϊ
	if( (pServiceName == NULL && strlen(ServiceRealName) > 0) || ( strlen(ServiceRealName) > 0 && strlen(ServiceMailboxName) > 0  && strcmp(pServiceName, ServiceMailboxName) == 0))
		_PrintLog(ServiceRealName, "EGUSR", pMode, messBuff);
	else
		_PrintLog(pServiceName, "EGUSR", pMode, messBuff);

	//free
	os_edge_freemallocMemory(messBuff);
}
/*****************************************************************************
* FUNCTION:		_EgFW_PrintSysLog
* DESCRIPTION:
*   t[[NOo͊֐(J)(VXe)
\*****************************************************************************/
void _EgFW_PrintSysLog(const char* pServiceName, const char* pMode, const char* format, ...)
{
	va_list arg;
	char *messBuff = NULL;

	//allocate
	messBuff = (char*)os_edge_mallocMemory(1024);
	if (messBuff == NULL)
		return;

	size_t bufsize = 1024;
	memset(messBuff, 0, bufsize);

	va_start(arg, format);
	vsprintf_s(messBuff, bufsize, format, arg);
	va_end(arg);
	_PrintLog(pServiceName, "EGSYS", pMode, messBuff);

	//free
	os_edge_freemallocMemory(messBuff);
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetServiceName
* DESCRIPTION:
*   ϐ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetServiceName(char* pName)
{
	if (strlen(ServiceName) == 0 || pName == NULL)
		return -1;
	
	os_edge_strncpy_s(pName, EG_MAX_SERVICEMAILBOXNAME +1, ServiceName, _TRUNCATE);
	return 0;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetServiceRealName
* DESCRIPTION:
*   ϐ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetServiceRealName(char* pName)
{
	if (strlen(ServiceRealName) == 0 || pName == NULL)
		return -1;

	os_edge_strncpy_s(pName, EG_MAX_SERVICENAME + 1, ServiceRealName, _TRUNCATE);
	return 0;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetServiceMboxName
* DESCRIPTION:
*   ϐ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetServiceMboxName(char* pName)
{
	if (strlen(ServiceMailboxName) == 0 || pName == NULL)
		return -1;

	os_edge_strncpy_s(pName, EG_MAX_SERVICEMAILBOXNAME + 1, ServiceMailboxName, _TRUNCATE);
	return 0;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetServiceStateName
* DESCRIPTION:
*   T[rXXe[^XTag擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetServiceStateName(char* pName)
{
	if (strlen(ServiceStateName) == 0 || pName == NULL)
		return -1;

	os_edge_strncpy_s(pName, EG_MAX_TAGNAME+1, ServiceStateName, _TRUNCATE);
	return 0;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_OUT_Count
* DESCRIPTION:
*   TagRef OUT ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_OUT_Count()
{
	return egTagRefs_OUT_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_IN_Count
* DESCRIPTION:
*   TagRef IN ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_IN_Count()
{
	return egTagRefs_IN_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_Count
* DESCRIPTION:
*   TagRef ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_Count()
{
	return egTagRefs_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetCollectorRef_Count
* DESCRIPTION:
*   CollectorRef ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetCollectorRef_Count()
{
	return egCollectorRefs_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetMailbox_Count
* DESCRIPTION:
*   Mailbox ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetMailbox_Count()
{
	return egMailBoxes_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef_OUT
* DESCRIPTION:
*   TagRef OUT ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef_OUT(EGTAGREF* tagref, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (tagref == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*tagref = egTagRefs_OUT[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef_IN
* DESCRIPTION:
*   TagRef IN ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef_IN(EGTAGREF* tagref, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (tagref == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*tagref = egTagRefs_IN[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef
* DESCRIPTION:
*   TagRef ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef(EGTAGREF* tagref, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (tagref == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*tagref = egTagRefs[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetCollector
* DESCRIPTION:
*   Collector ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetCollector(EGLOCALCOLLECTOR* collector, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (collector == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxClctEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*collector = egCollectors[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetCollectorRef
* DESCRIPTION:
*   CollectorRef ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetCollectorRef(EGCOLLECTORREF* collectorRef, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (collectorRef== NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwClctEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*collectorRef = egCollectorRefs[index];
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgFW_GetMailBox
* DESCRIPTION:
*   MailBox ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetMailBox(EGMAILBOX* mailBoxe, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (mailBoxe == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwMailboxEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*mailBoxe = egMailBoxes[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_OUT_PortInfo_Count
* DESCRIPTION:
*   TagRef OUT ge[u(EdgeIO|[g)̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_OUT_PortInfo_Count()
{
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_OUT_PortInfo != NULL))
	{
		return egTagRefs_OUT_Count;
	}
	else
	{
		return 0;
	}
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_IN_PortInfo_Count
* DESCRIPTION:
*   TagRef IN ge[u(EdgeIO|[g)̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_IN_PortInfo_Count()
{
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_IN_PortInfo != NULL))
	{
		return egTagRefs_IN_Count;
	}
	else
	{
		return 0;
	}
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetEgTagRef_PortInfo_Count
* DESCRIPTION:
*   TagRef ge[u(EdgeIO|[g)̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetEgTagRef_PortInfo_Count()
{
	if ((gm_EdgeIOPortEnabled != 0) && (egTagRefs_PortInfo != NULL))
	{
		return egTagRefs_Count;
	}
	else
	{
		return 0;
	}
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef_OUT_PortInfo
* DESCRIPTION:
*   TagRef OUT ɑΉEdgeIO|[g̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef_OUT_PortInfo(EGIOPORT* egio, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (egTagRefs_OUT_PortInfo == NULL)
		return EDGE_TTABLE_NOT_EXIST_EGIO;

	if (egio == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*egio = egTagRefs_OUT_PortInfo[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef_IN_PortInfo
* DESCRIPTION:
*   TagRef IN ɑΉEdgeIO|[g̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef_IN_PortInfo(EGIOPORT* egio, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (egTagRefs_IN_PortInfo == NULL)
		return EDGE_TTABLE_NOT_EXIST_EGIO;

	if (egio == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*egio = egTagRefs_IN_PortInfo[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagRef_PortInfo
* DESCRIPTION:
*   TagRef ɑΉEdgeIO|[g̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagRef_PortInfo(EGIOPORT* egio, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (egTagRefs_PortInfo == NULL)
		return EDGE_TTABLE_NOT_EXIST_EGIO;

	if (egio == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagRefEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*egio = egTagRefs_PortInfo[index];
	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagTrigger_Count
* DESCRIPTION:
*   TagTrigger ̐擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagTrigger_Count()
{
	return egTagTriggers_Count;
}
/*****************************************************************************
* FUNCTION:		_EgFW_GetTagTrigger
* DESCRIPTION:
*   TagTrigger ̎擾(J)(VXe)
\*****************************************************************************/
int32_t _EgFW_GetTagTrigger(EGTAGTRIGGER* tagtrigger, int32_t index)
{
	int32_t refCount = 0;

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;

	if (egTagTriggers == NULL)
		return EDGE_PARAM_INVALID;

	if (((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxFwTagTrigEntry < (uint32_t)index)	//TCY傫G[
		return EDGE_PARAM_INVALID;

	*tagtrigger = egTagTriggers[index];
	return EDGE_SUCCESS;
}
