////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egInternal.h
*
*   RT-edge system Internal header file
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "egAPI.h"

#ifdef __INTIME__
#define RTAPI __cdecl
#include <rterr.h>
#include <rtdef.h>
#include <rtbase.h>
#else

#endif
/// <summary>
/// ǉ̃G[R[h
/// </summary>
#define	EDGE_NAMESPACE_CREATE_ERROR			-100
#define	EDGE_NAMESPACE_EXIST_ERROR			-1
#define	EDGE_NAMESPACE_MAP_ERROR			-3

#define	EDGE_SYSCFG_CREATE_ERROR			-200
#define	EDGE_SYSCFG_MAP_ERROR				-202
#define	EDGE_SYSCFG_EXIST_ERROR				-201

#define	EDGE_NAMESPACE_COEF					2		// l[Xy[X̃f[^IɊgۂ̌W
#define LINKTAG_PRIFIX_LEN			2			// N^OpɃ^O擪ɕt^镶

typedef uint32_t					OFFSET;
#define	ROUNDUP_4KB(x)				(((x)+0xfff)&0xfffff000)		// 4KBPʂɐ؂グ

#pragma pack(push,1)

//------------------------------------------------------------------------------
// NameSpaceIuWFNg`
//------------------------------------------------------------------------------

/// <summary>
/// nbVR[hl^
/// </summary>
typedef union tHashCode
{
	struct {
		uint32_t	code1;					// 1nbVR[h(32bit) CfbNXp
		uint32_t	code2;					// 2nbVR[h(32bit) CfbNXp
		uint32_t	code3;					// 3nbVR[h(32bit) CfbNXp
		uint32_t	code4;					// 4nbVR[h(32bit) Փ˃`FbNp
	};
	BYTE		code[16];					// nbVR[h(16byte)
}HASHCODE;

/// <summary>
/// NameSpacewb_\
/// </summary>
static const char* EGTAGTABLE_NAME = "EGTAGTABLE";					// EgTAGNameSpace
static const char* EGMBOXTABLE_NAME = "EGMBOXTABLE";				// EgMailboxNameSpace
static const char* EGCLCTTABLE_NAME = "EGCLCTTBL";					// EgCollectorNameSpace
static const char* EGDSETTABLE_NAME = "EGDSETTABLE";				// EgDatasetNameSpace
static const char* EGSERVTABLE_NAME = "EGSERVTABLE";				// EgServiceNameSpace

static const char* EGSCHASHTB_NAME = "EGSCHASHTB";				// EgServicẽnbVe[u

static const char* EGSYSCFGTB_NAME = "EGSYSCFGTB";					// VXee[u

static const char* EGTAGPTR_NAME = "EGTAGPTR";						// ^O|C^pq[v̈於

///
/// VXe^O ^O
///
static const char* EGSYSTAGNAME_SERVICEENTRY_MAX = "EDGESYSTEM.SERVICEENTRY.MAX";	// Maximum size of Service entry.
static const char* EGSYSTAGNAME_DSETENTRY_MAX = "EDGESYSTEM.DSETENTRY.MAX";	// Maximum size of Dataset entry.
static const char* EGSYSTAGNAME_DSETLINK_MAX = "EDGESYSTEM.DSETLINK.MAX";	// Maximum size of Dataset link tag entry.
static const char* EGSYSTAGNAME_CLCTENTRY_MAX = "EDGESYSTEM.CLCTENTRY.MAX";	// Maximum size of Collector entry.
static const char* EGSYSTAGNAME_MAILBOXENTRY_MAX = "EDGESYSTEM.MAILBOXENTRY.MAX";	// Maximum size of Mailbox entry.
static const char* EGSYSTAGNAME_FW_C2C_MAILBOXCOL_MAX = "EDGESYSTEM.FW_C2C_MAILBOXCOL.MAX";	// Maximum col size of Mailbox for Container.
static const char* EGSYSTAGNAME_FW_C2C_MAILBOXROW_MAX = "EDGESYSTEM.FW_C2C_MAILBOXROW.MAX";	// Maximum row size of Mailbox for Container.
static const char* EGSYSTAGNAME_FW_CLCTENTRY_MAX = "EDGESYSTEM.FW_CLCTENTRY.MAX";	// Maximum size of Framework Collector entry.
static const char* EGSYSTAGNAME_FW_MAILBOXENTRY_MAX = "EDGESYSTEM.FW_MAILBOXENTRY.MAX";	// Maximum size of Framework Mailbox entry.
static const char* EGSYSTAGNAME_FW_TAGREFENTRY_MAX = "EDGESYSTEM.FW_TAGREFENTRY.MAX";	// Maximum size of Framework Tagref entry.
static const char* EGSYSTAGNAME_DSETENTRYY_COUNT = "EDGESYSTEM.DSETENTRY.COUNT";	// Dataset entry count
static const char* EGSYSTAGNAME_CLCTENTRY_COUNT = "EDGESYSTEM.CLCTENTRY.COUNT";	// Collector entry count
static const char* EGSYSTAGNAME_SERVICEENTRY_COUNT = "EDGESYSTEM.SERVICEENTRY.COUNT";	// Service entry count
static const char* EGSYSTAGNAME_MAILBOXENTRY_COUNT = "EDGESYSTEM.MAILBOXENTRY.COUNT";	// Mailbox entry count
static const char* EGSYSTAGNAME_TAGENTRY_COUNT = "EDGESYSTEM.TAGENTRY.COUNT";	// Tag entry count
static const char* EGSYSTAGNAME_TAGENTRY_MAX = "EDGESYSTEM.TAGENTRY.MAX";	// Maximum size of Tag entry.
static const char* EGSYSTAGNAME_TAGPTRNUM_MAX = "EDGESYSTEM.TAGPTRNUM.MAX";					// ^O|C^ő吔
static const char* EGSYSTAGNAME_TAGPTRNUM_COUNT = "EDGESYSTEM.TAGPTRNUM.COUNT";				// ^O|C^o^
static const char* EGSYSTAGNAME_TAGPTRSIZE_MAX = "EDGESYSTEM.TAGPTRSIZE.MAX";				// ^O|C^Ńf[^TCY
static const char* EGSYSTAGNAME_TAGPTRSIZE_USE = "EDGESYSTEM.TAGPTRSIZE.USE";				// ^O|C^f[^gp
static const char* EGSYSTAGNAME_TAGPTRRETRY_COUNT = "EDGESYSTEM.TAGPTRRETRY.COUNT";			// ^O|C^bN݂
static const char* EGSYSTAGNAME_FW_TAGTRIGGERENTRY_MAX = "EDGESYSTEM.FW_TAGTRIGGERENTRY_MAX";	// Maximum size of Framework TagTrigger entry.
static const char* EGSYSTAGNAME_SHM_ENTRY_MAX = "EDGESYSTEM.SHM_ENTRY.MAX";				// Maximum size of SHM entry.
static const char* EGSYSTAGNAME_SHM_ENTRY_COUNT = "EDGESYSTEM.SHM_ENTRY.COUNT";			// SHM entry count
static const char* EGSYSTAGNAME_SHM_RETRY_COUNT = "EDGESYSTEM.SHM_RETRY.COUNT";			// ^bN݂
static const char* EGSYSTAGNAME_TAGFIFO_NUM_COUNT = "EDGESYSTEM.TAGFIFO_NUM.COUNT";		// FIFO^Oo^
static const char* EGSYSTAGNAME_TAGFIFO_RETRY_COUNT = "EDGESYSTEM.TAGFIFO_RETRY.COUNT";	// FIFO^ObN݂

typedef struct tNameSpaceHead
{
	char		name[EG_MAX_SPACENAME+1];	// NAMESPACE̖
	uint32_t	nummax;						// őGg[
	uint32_t	numitem;					// o^σGg[
	uint32_t	numindex;					// őCfbNX
	OFFSET		baseindex;					// CfbNX̊Jnʒu(byte)
	OFFSET		baseheap;					// q[v̊Jnʒu
	uint32_t	heapsize;					// q[ṽTCY
	uint32_t	heapused;					// q[v̎gp
}NAMESPACE_HEAD ,*LPNAMESPACE_HEAD;

/// <summary>
/// NameSpaceCfbNX\
/// </summary>
typedef struct tNameSpaceIndex
{
	uint32_t	hint;						// 4nbVl(Փ˃`FbNp)
	OFFSET		offset;						// q[vԓACeւ̃oCgItZbg|C^
}NAMESPACE_INDEX, *LPNAMESPACE_INDEX;

/// <summary>
/// NameSpace\
/// </summary>
typedef struct tNameSpace
{
	NAMESPACE_HEAD		head;				// wb_
	NAMESPACE_INDEX		index[1];			// CfbNX x [numitem]
}NAMESPACE ,*LPNAMESPACE;

//------------------------------------------------------------------------------
// EgDatasetIuWFNg`
//------------------------------------------------------------------------------

/// <summary>
/// EgDatasetIuWFNgGg[\
/// </summary>
typedef struct tDSetDesc
{
	char		chName[EG_MAX_DSETNAME + 1];// 
	uint16_t	woCount;					// ^Oւ̃N
	uint16_t	woMaxCount;					// ^Oւ̃Nő吔
	OFFSET		tag[1];						// CfbNX x [numitem]		// ^Oւ̃N
} DsetDesc;
//------------------------------------------------------------------------------
// EgMailboxIuWFNg`
//------------------------------------------------------------------------------

/// <summary>
/// EgMailboxbZ[Wwb_\
/// </summary>
#pragma pack(push,1)
typedef struct tMboxMsgHead
{
	char		sendername[EG_MAX_SERVICENAME+1];	// ̖
	int32_t		messageno;							// bZ[Wԍ
	char		senderMailboxName[EG_MAX_MAILBOXNAME + 1];	// ̃[{bNX
//	uint8_t		byData[1];							// ȌチbZ[W{iϒ)
} MboxMsgHead;
#pragma pack(pop)

//------------------------------------------------------------------------------
// EgCollectorIuWFNg`
//------------------------------------------------------------------------------

/// <summary>
/// EgCollectorIuWFNgGg[\
/// </summary>
typedef struct tClctDesc
{
	char		chClctName[EG_MAX_CLCTNAME+1];		//RN^
	char		chOwnerName[EG_MAX_SERVICENAME+1];	//WT[rX
	uint32_t	dwInterVal;							//W
	uint8_t		byPriority;							//XbhvCIeB(INtimêݎgp)
	uint32_t	dwColSize;							//i[1R[h̃TCY(ftHg2048)
	uint32_t	dwRowSize;							//i[
	char		chDSetName[EG_MAX_DSETNAME+1];		//f[^Zbg
} ClctDesc;

//------------------------------------------------------------------------------
// EgServiceIuWFNg`
//------------------------------------------------------------------------------
/// <summary>
/// EgServiceIuWFNgGg[\
/// </summary>
typedef struct tServDesc
{
	char		chServName[EG_MAX_SERVICENAME + 1];				//T[rX
	char		chFullPath[EG_MAX_SERVICEPATH + 1];				//pX
	char		chArg[EG_MAX_SERVICEPATH + 1];					//N
	char		chNodeName[EG_MAX_NODENAME + 1];				//T[rX̋Nm[h
	char		chServMailboxName[EG_MAX_SERVICEMAILBOXNAME + 1];	//T[rX̃[{bNX(indexo^̃nbVl4byte)
	uint32_t	uiServIndex;									//T[rXindexl(indexo^̃nbVl4byte)
	uint16_t	usServClass;									//T[rX̃NX(IIO/C2C/ʒʐM,,,etc)
} ServDesc;

/// <summary>
/// EgServiceIuWFNgXgGg[\
/// </summary>
typedef struct tServIndexDesc
{
	uint16_t	woCount;						// NT[rXRei
	uint32_t	ServIndex[1];					// T[rXRe[{bNX(indexl4byte) ǉ̂ݑΉ |C^
} ServIndexDesc, *LSERVINDEXDESC;

/// <summary>
/// EgTagSetDefaultValue f[^\
/// </summary>
typedef struct tSetDefaultValueDesc
{
	uint8_t		byTarget;						// lɍXVΏ 0:ALL 0ȊO:GroupԍΏ
	uint16_t	woGroup;						// O[vԍ
} SetDefaultValueDesc, *LSETDEFAULTVALUEDESC;
#pragma pack(pop)

typedef void*	HNAMESPACE;					// NAMESPACẼnh
typedef void*	NAMESPACE_HEAP;				// NAMESPACẼGg|C^

typedef void*	HSYSCFG;					// SYSCFG̃nh

typedef void*	HTAGPTR;					// ^O|C^pq[v̈nh
typedef void*	HSHM_PTR;					// Lp̈nh

//------------------------------------------------------------------------------
// [JǗp LǗ\
//------------------------------------------------------------------------------
#pragma pack(push,1)
typedef struct tSHM_LOENTRY {
	char					chNodeName[EG_SHM_MAX_NODENAME + 1];
	char					chProcName[EG_SHM_MAX_PROCNAME + 1];
	char					chObjeName[EG_SHM_MAX_OBJENAME + 1];	// L̃J^O
	uint32_t				MappedSize;								// MapTCY
	HSHM_PTR				BaseAddress;							// Map̃x[XAhX
	struct tSHM_LOENTRY		*Next;
} SHM_LO_ENTRY;
#pragma pack(pop)
#define EG_SHM_LO_ENTRY_SIZE	sizeof(SHM_LO_ENTRY)	// 103 byte

//------------------------------------------------------------------------------
// RT-edge API`
//------------------------------------------------------------------------------

	//
	// NameSpace objects
	//

	edge_API HASHCODE _Hash(const char *name);
	edge_API HASHCODE _HashCreate(HNAMESPACE hNameSpace, const char *name);
	edge_API bool _HashCompare(HASHCODE code, const char *name);
	edge_API NAMESPACE_INDEX* EgNamespaceGetIndex(HNAMESPACE hNameSpace, const char *Name);
	edge_API HNAMESPACE EgNamespaceCreate(const char *Name, uint32_t NumMax, uint32_t HeapSize );
	edge_API HNAMESPACE EgNamespaceLookup(const char *Name);
	edge_API NAMESPACE_HEAP EgNamespaceAddEntry(HNAMESPACE hNameSpace, const char *Name, uint32_t heapsize);
	edge_API NAMESPACE_HEAP EgNamespaceGetEntry(HNAMESPACE hNameSpace, const char *Name);
	edge_API NAMESPACE_HEAP EgNamespaceGetEntryByIndex(HNAMESPACE hNameSpace, LPNAMESPACE_INDEX index);
	edge_API uint32_t EgNamespaceGetCount(HNAMESPACE hNameSpace);
	edge_API int32_t EgNamespaceEnumIndex(HNAMESPACE hNameSpace, void *pBuffer, uint32_t dwSize, uint32_t *itemNum);
	edge_API OFFSET _AllocHeap(HNAMESPACE hNameSpace, uint32_t size);
	edge_API bool EgNamespaceGetIndexName(HNAMESPACE hNameSpace, const char *Name, uint32_t* pValue);
	//
	// Dll Load
	//
	edge_API int32_t egosdepLoadLibrary();
	edge_API void edge_FreeLibrary(void* hMod);
	extern edge_API void* g_H_egosdep;

	// System Config
	edge_API EDGESYSTEMCONFIG* EgSysCfgLookup();
	edge_API EDGESYSTEMCONFIG* EgSysCfgCreate(EDGESYSTEMCONFIG* SysCfg);

	extern edge_API void* g_H_egSysCfg;
	extern edge_API bool EgSysCfgCheck();
#ifndef _TRUNCATE
#define _TRUNCATE ((size_t)-1)
#endif