////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egMailbox.h
*
*   RT-edge system Mailbox object
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

static HNAMESPACE		hObjKeep;					// Mailbox NameSpacẽnh
#define MAILBOX_ENTRY_SIZE	sizeof(EGMAILBOXINFO)	// Gg̃oCgTCY
#define MAILBOX_NAME_SPACE	EGMBOXTABLE_NAME		// NameSpace̖


/// <summary>
/// EgMailbox𐶐
/// </summary>
/// <param name="Name">[{bNX</param>
/// <param name="dwColSize">bZ[Wf[^ő咷</param>
/// <param name="dwRowSize">bZ[WR[h</param>
/// <param name="pRtcdInfo">ꂽRTCD</param>
/// <returns></returns>
int32_t EgMailboxCreateEx(const char *Name, uint32_t dwColSize, uint32_t dwRowSize, RTCDMEMINFO *pRtcdInfo)
{
	int32_t rtn;
	// create 
	// NOTE:R[h(dwColSize)ɃbZ[Wwb_TCY
	rtn = os_edge_creMbox(Name, dwColSize + sizeof(MboxMsgHead), dwRowSize + 1, pRtcdInfo);
	if (rtn != EDGE_SUCCESS)
		return rtn;

	// create̓Ggo^
	HNAMESPACE		hMbox;
	hMbox = EgMailboxGetHandle();											// Mailbox̖Oԃnh𓾂
	if (hMbox == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (((LPNAMESPACE)hMbox)->head.numitem >= ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxMailboxEntry)	//ő吔𒴂ꍇ̓G[
		return EDGE_TTABLE_NOEMPTY;

	EGMAILBOXINFO*		nsh;
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hMbox, Name);				// MailboxT
	if (index != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (EGMAILBOXINFO*)EgNamespaceAddEntry(hMbox, Name, MAILBOX_ENTRY_SIZE);	// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs

	os_edge_strncpy_s(nsh->MailBoxName, sizeof(nsh->MailBoxName), Name, _TRUNCATE);	// ̕ۊ
	nsh->dwColSize = dwColSize;												// R[hۊ
	nsh->dwRowSize = dwRowSize;												// R[hۊ
	((LPNAMESPACE)hMbox)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_MAILBOXENTRY_COUNT, &(((LPNAMESPACE)hMbox)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ
	
	return EDGE_SUCCESS;

}
/// <summary>
/// T[rXRei ʐMp EgMailboxI[v ŃnbVl擾
/// </summary>
/// <param name="Name">[{bNX</param>
/// <param name="dwAccess">ANZX(RTCD_WRITE/RTCD_READ/RTCD_READWRITE)</param>
/// <param name="pHandle">ꂽ[{bNX̃nh</param>
/// <returns></returns>
int32_t EgMailboxOpenSC(const char *Name, uint32_t dwAccess, RTCDHANDLE *pHandle)
{
	int32_t rtn = 0;
	char *mboxName = NULL;		// T[rXCfbNX
	size_t bufsize = EG_MAX_SERVICEMAILBOXNAME + 1;
	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (Name == NULL) {												// RTCD([{bNX)`FbN
		return EDGE_RTCD_NAME_INVALID;								// RTCD([{bNX)sł
	}

	mboxName = (char*)os_edge_mallocMemory(bufsize);
	if ((mboxName == NULL))
	{
		rtn = EDGE_RTCD_ALLOCATE_ERROR;
		goto failed;
	}
	memset(mboxName, 0, bufsize);
	//CfbNX擾
	EgServiceGetProperty(Name, "MailboxName", mboxName, (int32_t)bufsize);
	if (strlen(mboxName) > 0)	//[{bNXŃI[v
	{
		rtn = os_edge_openMbox(mboxName, dwAccess, pHandle);
	}
	else
	{
		//Index擾łȂꍇ̓G[
		return EDGE_TTABLE_SERVICE_INDEX_NULL;
		//Ȃꍇ͂̂܂܃I[v
		//rtn = os_edge_openMbox(Name, dwAccess, pHandle);
	}
	// free
	if (mboxName)
		os_edge_freemallocMemory(mboxName);

	return rtn;

failed :
	// free
	if (mboxName)
		os_edge_freemallocMemory(mboxName);

	return rtn;
}
/// <summary>
/// EgMailboxI[v
/// </summary>
/// <param name="Name">[{bNX</param>
/// <param name="dwAccess">ANZX(RTCD_WRITE/RTCD_READ/RTCD_READWRITE)</param>
/// <param name="pHandle">ꂽ[{bNX̃nh</param>
/// <returns></returns>
int32_t EgMailboxOpen(const char *Name, uint32_t dwAccess, RTCDHANDLE *pHandle)
{
	return os_edge_openMbox(Name, dwAccess, pHandle);
}
/// <summary>
/// [{bNXN[Y
/// </summary>
/// <param name="pHandle">폜Ώۂ̃[{bNX̃nh</param>
/// <returns></returns>
int32_t EgMailboxClose(RTCDHANDLE *pHandle)
{
	return os_edge_closeMbox(pHandle);
}
/// <summary>
/// [{bNXɃbZ[W𑗐M
/// </summary>
/// <param name="pHandle">[{bNX̃nh</param>
/// <param name="SenderName">M҂̖OiNULL͖܂</param>
/// <param name="MessageNo">M郁bZ[Wԍ</param>
/// <param name="pData">M郁bZ[W({)</param>
/// <param name="dwSize">M郁bZ[W({)̃oCgTCY</param>
/// <returns></returns>
int32_t EgMailboxSend(RTCDHANDLE *pHandle, const char *SenderName, int32_t MessageNo, void* pData, uint32_t dwSize)
{
	int32_t			ret;
	uint32_t		colsize = sizeof(MboxMsgHead) + dwSize;
	MboxMsgHead		stMsgHead = { 0 };

	if (pHandle == NULL || pHandle->pRtcdHeader == NULL)
		return EDGE_RTCD_HANDLE_INVALID;								// nhsł

	uint32_t dwRecordSize = pHandle->pRtcdHeader->record_size;			// R[hTCY擾

	if (colsize > dwRecordSize)
	{
		return EDGE_RTCD_WRITE_SIZE_INVALID;
	}

	if (SenderName) {													// Senderwb_Ɋi[
		os_edge_strncpy_s(stMsgHead.sendername, sizeof(stMsgHead.sendername), SenderName, _TRUNCATE);
		os_edge_strncpy_s(stMsgHead.senderMailboxName, sizeof(stMsgHead.senderMailboxName), SenderName, _TRUNCATE);
	}

	stMsgHead.messageno = MessageNo;										// MbZ[Wԍi[
	ret = os_edge_sendMboxEx(pHandle, &stMsgHead, sizeof(MboxMsgHead), pData, dwSize);					// M

	return ret;
}
/// <summary>
/// [{bNXM
/// </summary>
/// <param name="pHandle">[{bNX̃nh</param>
/// <param name="SenderName">擾M҂̖Oi[iNULL͖܂</param>
/// <param name="dwNameSize">擾M҂̖Oi[̃obt@TCYiNULL͖܂</param>
/// <param name="MessageNo">擾bZ[Wԍ̊i[iNULL͖܂</param>
/// <param name="pData">擾bZ[W{̂̊i[iNULL͖܂</param>
/// <param name="dwDataSize">擾bZ[W{̂̊i[iNULL͖܂</param>
/// <param name="dwTimeOut">^CAEg(ms)</param>
/// <returns></returns>
int32_t EgMailboxReceive(RTCDHANDLE *pHandle, char *SenderName, uint32_t dwNameSize, int32_t* MessageNo, void* pData, uint32_t dwDataSize, uint32_t dwTimeOut)
{
	int32_t			ret;
	
	if (pHandle == NULL || pHandle->pRtcdHeader == NULL)
		return EDGE_RTCD_HANDLE_INVALID;									// nhsł
	
	uint32_t		dwRecordSize = pHandle->pRtcdHeader->record_size;		// R[h
	uint32_t		msgSize = dwRecordSize - sizeof(MboxMsgHead);
	uint32_t		cpySize = (dwDataSize < msgSize) ? dwDataSize : msgSize;	// ǂ炩ق̃TCYRs[TCY
	MboxMsgHead		stMsgHead = { 0 };
	
	// ۂ̎M
	ret = os_edge_recvMboxEx(pHandle, &stMsgHead, sizeof(stMsgHead), pData, cpySize, dwTimeOut);

	if (SenderName && dwNameSize > 0)										// Senderwb_Ɋi[
		os_edge_strncpy_s(SenderName, dwNameSize, stMsgHead.sendername, _TRUNCATE);
	if (MessageNo)														// bZ[Wԍi[
		*MessageNo = stMsgHead.messageno;

	return ret;
}
/// <summary>
/// [{bNX폜
/// </summary>
/// <param name="pRtcdInfo">ΏۂRTCD</param>
/// <returns></returns>
int32_t EgMailboxDelete(RTCDMEMINFO *pRtcdInfo)
{
	return os_edge_delMbox(pRtcdInfo);
}
/// <summary>
/// [{bNX̏擾
/// </summary>
/// <param name="pHandle">[{bNX̃nh</param>
/// <param name="pInfo">擾RTCD̊i[</param>
/// <returns></returns>
int32_t EgMailboxGetInfo(RTCDHANDLE *pHandle, EDGE_RTCD_HEADER *pInfo)
{
	return os_edge_infoMbox(pHandle, pInfo);
}

/*****************************************************************************
* FUNCTION:		EgMailboxGetHandle
* DESCRIPTION:
*   ()TAGNameSpacenh𓾂
\*****************************************************************************/
HNAMESPACE EgMailboxGetHandle(void)
{
	if (hObjKeep != NULL)
		return hObjKeep;								// Ɏ擾ςȂI

	// ݒt@C̃擾	
	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
		return NULL;

	hObjKeep = EgNamespaceLookup(MAILBOX_NAME_SPACE);
	if (hObjKeep != NULL)
		return hObjKeep;								// ČI

	hObjKeep = EgNamespaceCreate(MAILBOX_NAME_SPACE, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxMailboxEntry, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxMailboxEntry*MAILBOX_ENTRY_SIZE);
	if (hObjKeep != NULL)
		return hObjKeep;								// NameSpaceVɍďI

	return NULL;										// NameSpace𐶐łɎs
}
/*****************************************************************************
* FUNCTION:		EgMailboxGetProperty
* DESCRIPTION:
*   MailboxPropertyl擾
\*****************************************************************************/
int32_t EgMailboxGetProperty(const char *Name, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hMbox;
	hMbox = EgMailboxGetHandle();											// Mailbox̖Oԃnh𓾂
	if (hMbox == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0 || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	EGMAILBOXINFO*	nsh = (EGMAILBOXINFO*)EgNamespaceGetEntry(hMbox, Name);			// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Name"))								// v邩
	{
		if (dwSize < sizeof(nsh->MailBoxName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->MailBoxName), nsh->MailBoxName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "ColSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwColSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwColSize;
	}
	else if (_HashCompare(hashed_propname, "RowSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwRowSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwRowSize;
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(EGMAILBOXINFO**)Value = (EGMAILBOXINFO*)nsh;
	}
	else if (_HashCompare(hashed_propname, "Index"))						// v邩
	{
		if (dwSize < sizeof(NAMESPACE_INDEX*))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(NAMESPACE_INDEX**)Value = EgNamespaceGetIndex(hMbox, Name);
	}
	else if (_HashCompare(hashed_propname, "Hash"))							// v邩
	{
		if (dwSize < sizeof(HASHCODE))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(HASHCODE*)Value = _HashCreate(hMbox, Name);
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgMailboxGetPropertyByIndex
* DESCRIPTION:
*   MailboxPropertyl擾(CfbNXw)
\*****************************************************************************/
int32_t EgMailboxGetPropertyByIndex(EDGE_INDEX *index, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hMbox;
	hMbox = EgMailboxGetHandle();											// Mailbox̖Oԃnh𓾂
	if (hMbox == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	EGMAILBOXINFO*	nsh = (EGMAILBOXINFO*)EgNamespaceGetEntryByIndex(hMbox, (LPNAMESPACE_INDEX)index);	// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Name"))								// v邩
	{
		if (dwSize < sizeof(nsh->MailBoxName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->MailBoxName), nsh->MailBoxName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "ColSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwColSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwColSize;
	}
	else if (_HashCompare(hashed_propname, "RowSize"))						// v邩
	{
		if (dwSize < sizeof(nsh->dwRowSize))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->dwRowSize;
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(EGMAILBOXINFO**)Value = (EGMAILBOXINFO*)nsh;
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgMailboxGetCount
* DESCRIPTION:
*   ݂Mailboxo^擾
\*****************************************************************************/
int32_t EgMailboxGetCount(uint32_t *pItemNum)
{
	HNAMESPACE		hMbox;
	hMbox = EgMailboxGetHandle();											// Mailbox̖Oԃnh𓾂
	if (hMbox == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pItemNum == NULL)
		return EDGE_PARAM_INVALID;											// p[^s

	*pItemNum = EgNamespaceGetCount(hMbox);									// Gg擾

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgMailboxGetEnum
* DESCRIPTION:
*   Mailbox̃CfbNXꗗ擾
\*****************************************************************************/
int32_t EgMailboxGetEnum(EDGE_INDEX *pBuffer, uint32_t dwSize, uint32_t *pItemNum)
{
	HNAMESPACE		hMbox;
	hMbox = EgMailboxGetHandle();											// Mailbox̖Oԃnh𓾂
	if (hMbox == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dwSize < EgNamespaceGetCount(hMbox) * sizeof(NAMESPACE_INDEX))		// i[obt@TCY`FbN
	{
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	return EgNamespaceEnumIndex(hMbox, (void*)pBuffer, dwSize, pItemNum);	// NamespaceCfbNXꗗ擾
}





