////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egNameSpace.c
*
*   RT-edge system NameSpace object
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"
#include "../eghgapiCommon/md5.h"

#define IDSEARCH_RETRY_MAX	11		// CfbNXẼgC

// -----------------------------------------------------------------------
// TODO: ^Ǒؗp Ƃō폜
// -----------------------------------------------------------------------
//#define _TEST_HASH_RETRY_
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
typedef struct tTestHashRetry
{
	uint8_t	retryNum;				// gC
	uint32_t index;					// o^CfbNXNo
}TEST_HASHRETRY, *LPTEST_HASHRETRY;

LPTEST_HASHRETRY gRetry;		// _AllocEntry()ŃgCێq[v
uint32_t gRetryWpos = 0;		// q[v݈̏ʒuItZbg
#endif
// -----------------------------------------------------------------------

//*****************************************************************************
/// <summary>
/// ()Gg[̎gp𒲂ׂ
/// </summary>
/// <param name="target">ΏۃGg[</param>
/// <returns>true=gpAfalse=gp</returns>
//*****************************************************************************
bool _IsEntryUsed(LPNAMESPACE_INDEX target)
{
	return (target->offset != 0);			// gp}[N𒲂ׂ(gp=0)
}
//*****************************************************************************
/// <summary>
/// ()nbVƃGg[v邩ׂ
/// </summary>
/// <param name="target">ΏۃGg[</param>
/// <param name="code"></param>
/// <returns>true=vAfalse=sv</returns>
//*****************************************************************************
bool _IsEntryMatch(LPNAMESPACE_INDEX target, HASHCODE code)
{
	if (false == _IsEntryUsed(target))		// gpȂfalse
		return false;
	return (target->hint == code.code4);	// 4nbVlvȂ獇vtrueƔf
}
//*****************************************************************************
/// <summary>
/// ()q[v̊m
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="size">mۂoCgTCY</param>
/// <returns>q[vAhX(ItZbgoCg)</returns>
//*****************************************************************************
OFFSET _AllocHeap(HNAMESPACE hNameSpace, uint32_t size)
{
	LPNAMESPACE		ns = (LPNAMESPACE)hNameSpace;
	uint32_t heapused = ns->head.heapused;
	uint32_t heapfree = ns->head.heapsize - heapused;	// 󂫂H
	if (heapfree < size)
		return (OFFSET)0;								// 󂫂Ȃ̂Ŏs

	ns->head.heapused = heapused + size;				// m

	return (OFFSET)ns->head.baseheap + (OFFSET)heapused;	// q[vԂ
}
//*****************************************************************************
/// <summary>
/// ()nbVl16byte
/// </summary>
/// <param name="name"></param>
/// <returns>nbVl16byte</returns>
//*****************************************************************************
HASHCODE _Hash(const char *name)
{
	MD5_CONTEXT		hMd5;
	HASHCODE		hash;
	MD5Init(&hMd5);
	MD5Update(&hMd5, (unsigned char*)name, (unsigned int)strlen(name));
	MD5Final(hash.code, &hMd5);
	return hash;
}
//*****************************************************************************
/// <summary>
/// ()NameSpacepɃnbVlH
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="name"></param>
/// <returns>nbVl16byte</returns>
//*****************************************************************************
HASHCODE _HashCreate(HNAMESPACE hNameSpace ,const char *name)
{
	LPNAMESPACE		ns = (LPNAMESPACE)hNameSpace;
	HASHCODE		hash = _Hash(name);
	return hash;
}
//*****************************************************************************
/// <summary>
/// ()nbVlv邩
/// </summary>
/// <param name="code">rnbVl</param>
/// <param name="name">r镶</param>
/// <returns>true:vAfalse:sv</returns>
//*****************************************************************************
bool _HashCompare(HASHCODE code, const char *name)
{
	HASHCODE		hash = _Hash(name);

	for (int i = 0; i < sizeof(hash.code); i++)
	{
		if (hash.code[i] != code.code[i])
			return false;
	}
	return true;
}

//*****************************************************************************
/// <summary>
/// ()l[Xy[XGgVɊmۂ
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="code">nbVl</param>
/// <returns>NAMESPACECfbNX</returns>
//*****************************************************************************
LPNAMESPACE_INDEX _AllocEntry(HNAMESPACE hNameSpace, HASHCODE code)
{
	LPNAMESPACE			ns = (LPNAMESPACE)hNameSpace;
	LPNAMESPACE_INDEX	index;
	int32_t retry;
	int32_t retrymax = IDSEARCH_RETRY_MAX;
	uint32_t dwHash = 0;
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
	int32_t debugRetry = 0;							// ؗpɃgC񐔕ێ
#endif

	for (retry = 0; retry <= retrymax; retry++)		// CfbNXd͐񐔓ŃgC
	{
		// NOTE: gC̓nbVR[h1byte炵Ď擾܂
		dwHash = *((uint32_t*)&code.code[retry]);	// CfbNXɗpnbVR[h擾
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
		debugRetry = retry * 3;						// ؗpɃgC񐔕ێ
#endif
		if (!_IsEntryUsed(index))					// Gg[̎gpL`FbN
			break;									// gpłΌI

		dwHash++;									// (Ȃ)CfbNX1`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
		debugRetry = retry * 3 + 1;					// ؗpɃgC񐔕ێ
#endif
		if (!_IsEntryUsed(index))					// Gg[̎gpL`FbN
			break;									// gpłΌI

		dwHash -= 2;								// (Ȃ)CfbNX1O`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
		debugRetry = retry * 3 + 2;					// ؗpɃgC񐔕ێ
#endif
		if (!_IsEntryUsed(index))					// Gg[̎gpL`FbN
			break;									// gpłΌI
	}
	if (retry > retrymax)							// gCI[o[sie[ũGgő吔݂̂Ɓj
	{
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
		(gRetry + gRetryWpos)->retryNum = retry * 3;
		(gRetry + gRetryWpos)->index = 0;
		gRetryWpos++;
#endif
		return NULL;
	}
	else											// 
	{
		index->offset = (OFFSET)-1;					// Gg[mۍς}[N(-1)
		index->hint = code.code4;					// 4nbVlۊ
#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
		(gRetry + gRetryWpos)->retryNum = debugRetry;
		(gRetry + gRetryWpos)->index = dwHash;
		gRetryWpos++;
#endif
		return index;
	}
}
//*****************************************************************************
/// <summary>
/// NameSpacě
/// </summary>
/// <param name="Name">NameSpace̖O</param>
/// <returns>NAMESPACEnh</returns>
//*****************************************************************************
HNAMESPACE EgNamespaceLookup(const char *Name)
{
	void *memory = os_edge_lookup(Name);
	return (HNAMESPACE)os_edge_map(memory);
}
//*****************************************************************************
/// <summary>
/// NameSpace𐶐
/// </summary>
/// <param name="Name">NAMESPACE̖</param>
/// <param name="NumMAX">őGg[</param>
/// <param name="HeapSize">q[vԃoCgTCY</param>
/// <returns>NAMESPACEnh</returns>
//*****************************************************************************
HNAMESPACE EgNamespaceCreate(const char *Name, uint32_t NumMax, uint32_t HeapSize )
{
	uint32_t		dwSize;
	uint32_t		result = 0;
	void*			hMem = NULL;
	LPNAMESPACE		pMem = NULL;
	uint32_t		dwIndexNum;

	// NOTE: HashlCfbNX̏d邽߁AIɑ₵Ċmۂ܂
	dwIndexNum = NumMax * EDGE_NAMESPACE_COEF;		// ۂɊmۂl[Xy[XCfbNX̌

#ifdef _TEST_HASH_RETRY_	// ^Ǒؗp
	gRetry = os_edge_createMemory(Name+1, sizeof(TEST_HASHRETRY)*dwIndexNum);
	memset(gRetry, 0, sizeof(TEST_HASHRETRY)*dwIndexNum);
#endif

	dwSize = sizeof(NAMESPACE_HEAD) + (dwIndexNum * sizeof(NAMESPACE_INDEX)) + HeapSize;
	dwSize = ROUNDUP_4KB(dwSize);
	//--------------------------------------------------------------------
	//e[u쐬E}bv
	//--------------------------------------------------------------------
	pMem = os_edge_createMemory(Name, dwSize, &hMem);
	if (pMem == NULL) {
		result = EDGE_NAMESPACE_CREATE_ERROR;									// t@C}bsOG[
		goto failed;
	}
	//--------------------------------------------------------------------
	// e[u
	//--------------------------------------------------------------------
	memset(pMem, 0, dwSize);													// 
	pMem->head.nummax = NumMax;
	pMem->head.numindex = dwIndexNum;
	pMem->head.heapsize = HeapSize;
	pMem->head.baseindex = (OFFSET)sizeof(NAMESPACE_HEAD);
	pMem->head.baseheap = (OFFSET)(sizeof(NAMESPACE_HEAD) + (dwIndexNum * sizeof(NAMESPACE_INDEX)));
	os_edge_strncpy_s(pMem->head.name, sizeof(pMem->head.name), Name, _TRUNCATE);	// Oi[
	return (HNAMESPACE)pMem;													// nhԂ

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
failed:
	os_edge_freeMemory(Name, pMem, hMem);
	return (HNAMESPACE)NULL;													// s
}
//*****************************************************************************
/// <summary>
/// NameSpaceɊYACeǉo^Bɑ݂Ǝs(NULL)
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh></param>
/// <param name="Name">ACe</param>
/// <param name="item"></param>
/// <param name="itemsize"></param>
/// <returns>Ggւ̃|C^</returns>
//*****************************************************************************
NAMESPACE_HEAP EgNamespaceAddEntry(HNAMESPACE hNameSpace ,const char *Name ,uint32_t heapsize)
{
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hNameSpace, Name);	// Ggɑ݂H
	if (index != NULL)
		return NULL;										// Ggɑ݂̂Ŏs

	HASHCODE code = _HashCreate(hNameSpace ,Name);
	index = _AllocEntry(hNameSpace, code);					// GgVɊm
	if( !index )
		return NULL;										// GgmۂɎs

	OFFSET heap = _AllocHeap(hNameSpace, heapsize);			// q[vmۂ
	if (heap == (OFFSET)0)
		return NULL;										// q[vmۂɎs

	LPNAMESPACE ns = (LPNAMESPACE)hNameSpace;
	index->offset = heap;									// GgɃq[vo^

	return (uint8_t*)ns + (intptr_t)index->offset;			// l|C^ƂĈuintptr_tBq[v|C^ŕԂ
}
//*****************************************************************************
/// <summary>
/// HASHCODENAMESPACECfbNX擾
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="code">nbVl</param>
/// <returns>NAMESPACECfbNX</returns>
//*****************************************************************************
NAMESPACE_INDEX* EgNamespaceGetIndex(HNAMESPACE hNameSpace, const char *Name)
{
	LPNAMESPACE			ns = (LPNAMESPACE)hNameSpace;
	HASHCODE			code = _HashCreate(hNameSpace, Name);
	LPNAMESPACE_INDEX	index;
	int32_t retry;
	int32_t retrymax = IDSEARCH_RETRY_MAX;		// nbVl̋Rv͐񐔓ŃgC
	uint32_t dwHash = 0;

	for (retry = 0; retry <= retrymax; retry++)
	{
		// NOTE: gC̓nbVR[h1byte炵Ď擾܂
		dwHash = *((uint32_t*)&code.code[retry]);	// CfbNXɗpnbVR[h擾

		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I

		dwHash++;									// (Ȃ)CfbNX1`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I

		dwHash -= 2;								// (Ȃ)CfbNX1O`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I
	}

	if (retry > retrymax)							// gCI[o[s
		return NULL;
	if (!_IsEntryUsed(index))						// gpȂ玸s
		return NULL;

	return index;									// 擾łGgԂ
}
//*****************************************************************************
/// <summary>
/// Oo^ĂCfbNXɑΉCfbNXl擾
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="code">O</param>
/// <returns>CfbNXl4byte</returns>
//*****************************************************************************
bool EgNamespaceGetIndexName(HNAMESPACE hNameSpace, const char *Name, uint32_t* pValue)
{
	LPNAMESPACE			ns = (LPNAMESPACE)hNameSpace;
	HASHCODE			code = _HashCreate(hNameSpace, Name);
	LPNAMESPACE_INDEX	index;
	int32_t retry;
	int32_t retrymax = IDSEARCH_RETRY_MAX;		// nbVl̋Rv͐񐔓ŃgC
	uint32_t dwHash = 0;

	for (retry = 0; retry <= retrymax; retry++)
	{
		// NOTE: gC̓nbVR[h1byte炵Ď擾܂
		dwHash = *((uint32_t*)&code.code[retry]);	// CfbNXɗpnbVR[h擾

		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I

		dwHash++;									// (Ȃ)CfbNX1`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I

		dwHash -= 2;								// (Ȃ)CfbNX1O`FbN
		dwHash %= ns->head.numindex;				// CfbNXɉH
		index = &ns->index[dwHash];					// Yʒũl[Xy[XCfbNX擾
		if (!_IsEntryUsed(index) || _IsEntryMatch(index, code))	// gpA܂̓Gg[v̏ꍇ
			break;									// I
	}

	if (retry > retrymax)							// gCI[o[s
		return false;
	if (!_IsEntryUsed(index))						// gpȂ玸s
		return false;

	*pValue = dwHash;								// 擾łCfbNXlԂ
	return true;									
}
//*****************************************************************************
/// <summary>
/// NameSpaceYACeēBȂƎs(NULL)
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="Name">ACe</param>
/// <returns>Ggւ̃|C^</returns>
//*****************************************************************************
NAMESPACE_HEAP EgNamespaceGetEntry(HNAMESPACE hNameSpace, const char *Name)
{
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hNameSpace, Name);	// Ggɑ݂H
	if (index == NULL)
		return NULL;										// ݂ȂGgŎs

	NAMESPACE_HEAP heap;
	LPNAMESPACE ns = (LPNAMESPACE)hNameSpace;				
	heap = (uint8_t*)ns + (OFFSET)index->offset;			// l|C^ƂĈuintptr_t
	return (NAMESPACE_HEAP)heap;							// q[v|C^ŕԂ
}
//*****************************************************************************
/// <summary>
/// NameSpaceCfbNXYACe擾BȂƎs(NULL)
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <param name="Name">ACe</param>
/// <returns>Ggւ̃|C^</returns>
//*****************************************************************************
NAMESPACE_HEAP EgNamespaceGetEntryByIndex(HNAMESPACE hNameSpace, LPNAMESPACE_INDEX index)
{
	if (index == NULL)
		return NULL;										// ݂ȂGgŎs

	if (!_IsEntryUsed(index))
		return NULL;										// gpȂ玸s

	NAMESPACE_HEAP heap;
	LPNAMESPACE ns = (LPNAMESPACE)hNameSpace;
	OFFSET heapTop = ns->head.baseheap;						// q[v擪ʒu
	OFFSET heapEnd = heapTop + ns->head.heapused;			// gpq[v̏Iʒu
	uint32_t entrySize = ns->head.heapsize / ns->head.nummax;	// Gg̃TCY

	// CfbNXLȃq[v͈͂ł邩f
	if ((index->offset < heapTop) || (index->offset > heapEnd))
		return NULL;										// CfbNXs

	// CfbNXGg̐擪ʒuɍv邩f
	if ((index->offset - ns->head.baseheap) % entrySize != 0)
		return NULL;										// CfbNXs

	heap = (uint8_t*)ns + (OFFSET)index->offset;			// l|C^ƂĈuintptr_t
	return (NAMESPACE_HEAP)heap;							// q[v|C^ŕԂ
}
//*****************************************************************************
/// <summary>
/// NameSpace̎gpGg擾
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
/// <returns>Gǧ</returns>
//*****************************************************************************
uint32_t EgNamespaceGetCount(HNAMESPACE hNameSpace)
{
	return ((LPNAMESPACE)hNameSpace)->head.numitem;
}
//*****************************************************************************
/// <summary>
/// ()CfbNXe[ũItZbgr()
/// </summary>
//*****************************************************************************
int EgNamespaceCmpOffset(const void *val1, const void* val2)
{
	if (((NAMESPACE_INDEX*)val1)->offset > ((NAMESPACE_INDEX*)val2)->offset)
	{
		return 1;
	}
	else if (((NAMESPACE_INDEX*)val1)->offset < ((NAMESPACE_INDEX*)val2)->offset)
	{
		return -1;
	}
	else
	{
		return 0;
	}
}
//*****************************************************************************
/// <summary>
/// NameSpacẽGg̃CfbNXXgAbv
/// </summary>
/// <param name="hNameSpace">NAMESPACEnh</param>
//*****************************************************************************
int32_t EgNamespaceEnumIndex(HNAMESPACE hNameSpace, void *pBuffer, uint32_t dwSize, uint32_t *itemNum)
{
	LPNAMESPACE			ns = (LPNAMESPACE)hNameSpace;
	LPNAMESPACE_INDEX	pTmpBuf;									// Ɨpobt@
	uint32_t			getCnt = 0;									// 擾
	uint32_t			numItem = ns->head.numitem;					// Ggo^

	if (numItem == 0)												// 0̏ꍇ͖(G[ɂ͂Ȃ)
	{
		*itemNum = 0;
		return EDGE_SUCCESS;
	}

	// Ɨ̈m
	pTmpBuf = (LPNAMESPACE_INDEX)os_edge_mallocMemory(numItem * sizeof(NAMESPACE_INDEX));
	memset(pTmpBuf, 0, numItem * sizeof(NAMESPACE_INDEX));

	// CfbNXe[ugp̃CfbNX
	for (uint32_t i = 0; i < ns->head.numindex; i++)				// CfbNXŏ[v
	{
		if (!_IsEntryUsed(&ns->index[i]))							// gpȂ玟
			continue;

		memcpy(pTmpBuf + getCnt, &ns->index[i], sizeof(NAMESPACE_INDEX));	// ƗpɃRs[
		getCnt++;													// 擾XV
		if (numItem <= getCnt)										// Ɨ̈𒴉߂ꍇ͂ŌI(ɐVɃ^Oo^ꂽP[Xz)
			break;
	}

	if (getCnt * sizeof(NAMESPACE_INDEX) > dwSize)					// i[obt@TCY`FbN
	{
		*itemNum = 0;
		return EDGE_TTABLE_VALUE_OVERFLOW;							// i[obt@TCY׎s
	}

	qsort(pTmpBuf, getCnt, sizeof(NAMESPACE_INDEX), EgNamespaceCmpOffset);// CfbNX̃ItZbgɏ]\[gi^OɃ\[g܂j
	
	memcpy(pBuffer, pTmpBuf, getCnt * sizeof(NAMESPACE_INDEX));		// obt@֊i[
	*itemNum = getCnt;												// 擾i[

	os_edge_freemallocMemory(pTmpBuf);								//free

	return EDGE_SUCCESS;
}