////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egService.c
*
*   RT-edge system Service object
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

static HNAMESPACE		hObjKeep;					// SERVICE NameSpacẽnh
#define SERVICES_ENTRY_SIZE	sizeof(ServDesc)		// Gg̃oCgTCY
#define SERVICES_NAME_SPACE	EGSERVTABLE_NAME		// NameSpace̖

/*****************************************************************************
* FUNCTION:		EgServiceGetHandle
* DESCRIPTION:
*   ()SERVICENameSpacenh𓾂
\*****************************************************************************/
HNAMESPACE EgServiceGetHandle(void)
{
	if (hObjKeep != NULL)
		return hObjKeep;								// Ɏ擾ςȂI

	if (EgSysCfgCheck() == false)	//őlݒ苤L擾ł邩H s͏I
	{
		return NULL;			// s
	}

	hObjKeep = EgNamespaceLookup(SERVICES_NAME_SPACE);
	if (hObjKeep != NULL)
		return hObjKeep;								// ČI

	hObjKeep = EgNamespaceCreate(SERVICES_NAME_SPACE, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxServiceEntry, ((EDGESYSTEMCONFIG*)g_H_egSysCfg)->MaxServiceEntry*SERVICES_ENTRY_SIZE);
	if (hObjKeep != NULL)
		return hObjKeep;								// SERVICE HASHTABLEVɍďI

	return NULL;										// SERVICE HASHTABLE𐶐łɎs
}
/// <summary>
/// EdgeT[rX𐶐
/// </summary>
/// <param name="Name>T[rX</param>
/// <param name="path">T[rXW[̃pX</param>
/// <param name="arg">T[rXN̈</param>
/// <param name="pid">vZXnhl</param>
/// <returns></returns>
int32_t EgServiceCreate(const char *Name, const char *path, const char *arg ,EGSERVICEHANDLE *pid )
{
	int32_t rtn;
	intptr_t id;
	char chMboxName[EG_MAX_SERVICEMAILBOXNAME + 1] = { 0 };

	if (pid == NULL)	// pidw肳ĂȂȂ牼obt@gĖi߂
		pid = &id;

	HNAMESPACE		hServ;
	hServ = EgServiceGetHandle();											// SERVICE̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	// create
	// pX̎w肪ꍇ̂ݎs
	if (path != NULL && strlen(path) > 0)
	{
		rtn = os_edge_createService(Name, path, arg, pid);
		if (rtn != EDGE_SUCCESS) {
			return rtn;
		}
	}
	// create̓Ggo^
	ServDesc*		nsh;
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hServ, Name);				// T[rXT
	if (index != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (ServDesc*)EgNamespaceAddEntry(hServ, Name, SERVICES_ENTRY_SIZE);	// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs

	os_edge_strncpy_s(nsh->chServName, sizeof(nsh->chServName), Name, _TRUNCATE);	// ̕ۊ
	os_edge_strncpy_s(nsh->chArg, sizeof(nsh->chArg), arg, _TRUNCATE);				// Nۊ
	if (path != NULL && strlen(path) > 0)
		os_edge_strncpy_s(nsh->chFullPath, sizeof(nsh->chFullPath), path, _TRUNCATE);	// pXۊ

	nsh->usServClass = 0;													// T[rXNXɖ`lZbg

	uint32_t indexValue = 0;
	bool ret = EgNamespaceGetIndexName(hServ, Name, &indexValue);				// T[rXT
	if (ret == false)
		return EDGE_TTABLE_MEMORRY_ERROR;									// o^sĂ
	nsh->uiServIndex = indexValue;
	snprintf(chMboxName, 5, "%04x", indexValue);  // "0012"i[߁j
	
	os_edge_strncpy_s(nsh->chServMailboxName, sizeof(nsh->chServMailboxName), chMboxName, _TRUNCATE);				// pCfbNXl𕶎ɕϊ
	((LPNAMESPACE)hServ)->head.numitem++;									// Gg++
	
	EgTagWrite(EGSYSTAGNAME_SERVICEENTRY_COUNT, &(((LPNAMESPACE)hServ)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ

	return EDGE_SUCCESS;

}

/// <summary>
/// EdgeT[rX𐶐
/// </summary>
/// <param name="Name>T[rX</param>
/// <param name="path">T[rXW[̃pX</param>
/// <param name="arg">T[rXN̈</param>
/// <param name="pid">vZXnhl</param>
/// <returns></returns>
int32_t EgServiceCreateEx(const char *Name, const char *path, const char *arg, EGSERVICEHANDLE *pid, EDGESERVICECONFIG *config)
{
	int32_t rtn;
	intptr_t id;
	
	char chMailboxName[EG_MAX_SERVICEMAILBOXNAME + 1] = { 0 };

	if (pid == NULL)	// pidw肳ĂȂȂ牼obt@gĖi߂
		pid = &id;

	HNAMESPACE		hServ;
	hServ = EgServiceGetHandle();											// SERVICE̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	// create
	// pX̎w肪ꍇ̂ݎs
	if (path != NULL && strlen(path) > 0)
	{
		rtn = os_edge_createServiceEx(Name, path, arg, pid, config);
		if (rtn != EDGE_SUCCESS) {
			return rtn;
		}
	}
	
	// create̓Ggo^
	ServDesc*		nsh;
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hServ, Name);				// T[rXT
	if (index != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (ServDesc*)EgNamespaceAddEntry(hServ, Name, SERVICES_ENTRY_SIZE);	// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs

	os_edge_strncpy_s(nsh->chServName, sizeof(nsh->chServName), Name, _TRUNCATE);	// ̕ۊ
	os_edge_strncpy_s(nsh->chArg, sizeof(nsh->chArg), arg, _TRUNCATE);				// Nۊ
	if (path != NULL && strlen(path) > 0)
		os_edge_strncpy_s(nsh->chFullPath, sizeof(nsh->chFullPath), path, _TRUNCATE);	// pXۊ

	// NodeName̎w肪ꍇ̓Rs[
	if (strlen(config->NodeName) != 0) {
		os_edge_strncpy_s(nsh->chNodeName, sizeof(nsh->chNodeName), config->NodeName, _TRUNCATE);// T[rX̋Nm[hۊ
	}

	nsh->usServClass = config->Class;										// T[rXNXۊ

	uint32_t indexValue = 0;
	bool ret = EgNamespaceGetIndexName(hServ, Name, &indexValue);				// T[rXT
	if (ret == false)
		return EDGE_TTABLE_MEMORRY_ERROR;									// o^sĂ

	nsh->uiServIndex = indexValue;
	snprintf(chMailboxName, 5, "%04x", indexValue);  // "0012"i[߁j
	os_edge_strncpy_s(nsh->chServMailboxName, sizeof(nsh->chServMailboxName), chMailboxName, _TRUNCATE);				// pnbVl𕶎ɕϊ

	((LPNAMESPACE)hServ)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_SERVICEENTRY_COUNT, &(((LPNAMESPACE)hServ)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgServiceGetProperty
* DESCRIPTION:
*   ServicePropertyl擾
\*****************************************************************************/
int32_t EgServiceGetProperty(const char *Name, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hServ;
	uint32_t dwHash = 0;
	char chHash[EG_MAX_SERVICEMAILBOXNAME + 1] = { 0 };

	hServ = EgServiceGetHandle();											// Service̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0 || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	ServDesc*	nsh = (ServDesc*)EgNamespaceGetEntry(hServ, Name);			// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Name"))								// v邩
	{
		if (dwSize < sizeof(nsh->chServName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chServName), nsh->chServName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Path"))							// v邩
	{
		if (dwSize < sizeof(nsh->chFullPath))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chFullPath), nsh->chFullPath, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Arg"))							// v邩
	{
		if (dwSize < sizeof(nsh->chArg))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chArg), nsh->chArg, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "NodeName"))						// v邩
	{
		if (dwSize < sizeof(nsh->chNodeName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chNodeName), nsh->chNodeName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(ServDesc**)Value = (ServDesc*)nsh;
	}
	else if (_HashCompare(hashed_propname, "Index"))						// v邩
	{
		if (dwSize < sizeof(NAMESPACE_INDEX*))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(NAMESPACE_INDEX**)Value = EgNamespaceGetIndex(hServ, Name);
	}
	else if (_HashCompare(hashed_propname, "Hash"))							// v邩
	{
		if (dwSize < sizeof(HASHCODE))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(HASHCODE*)Value = _HashCreate(hServ, Name);
	}
	else if (_HashCompare(hashed_propname, "MailboxName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chServMailboxName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chServMailboxName), nsh->chServMailboxName, _TRUNCATE);				// pCfbNXl𕶎ɕϊ
	}
	else if (_HashCompare(hashed_propname, "IndexValue"))				// v邩
	{
		if (dwSize < sizeof(nsh->uiServIndex))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->uiServIndex;								// pCfbNXl
	}
	else if (_HashCompare(hashed_propname, "Class"))						// v邩
	{
		if (dwSize < sizeof(nsh->usServClass))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint16_t*)Value = nsh->usServClass;
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgServiceGetPropertyByIndex
* DESCRIPTION:
*   ServicePropertyl擾(CfbNXw)
\*****************************************************************************/
int32_t EgServiceGetPropertyByIndex(EDGE_INDEX *index, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hServ;
	hServ = EgServiceGetHandle();											// Service̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL || strlen(propName) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	ServDesc*	nsh = (ServDesc*)EgNamespaceGetEntryByIndex(hServ, (LPNAMESPACE_INDEX)index);	// GgT
	if (nsh == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE	hashed_propname = _Hash(propName);							// propNamẽnbVlƂ

	if (_HashCompare(hashed_propname, "Name"))								// v邩
	{
		if (dwSize < sizeof(nsh->chServName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chServName), nsh->chServName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Path"))							// v邩
	{
		if (dwSize < sizeof(nsh->chFullPath))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chFullPath), nsh->chFullPath, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Arg"))							// v邩
	{
		if (dwSize < sizeof(nsh->chArg))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chArg), nsh->chArg, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "NodeName"))						// v邩
	{
		if (dwSize < sizeof(nsh->chNodeName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chNodeName), nsh->chNodeName, _TRUNCATE);
	}
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof(nsh))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(ServDesc**)Value = (ServDesc*)nsh;
	}
	else if (_HashCompare(hashed_propname, "MailboxName"))					// v邩
	{
		if (dwSize < sizeof(nsh->chServMailboxName))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		
		os_edge_strncpy_s((char*)Value, sizeof(nsh->chServMailboxName), nsh->chServMailboxName, _TRUNCATE);				// pCfbNXl𕶎ɕϊ
	}
	else if (_HashCompare(hashed_propname, "IndexValue"))				// v邩
	{
		if (dwSize < sizeof(nsh->uiServIndex))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint32_t*)Value = nsh->uiServIndex;								// pCfbNXl
	}
	else if (_HashCompare(hashed_propname, "Class"))						// v邩
	{
		if (dwSize < sizeof(nsh->usServClass))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[

		*(uint16_t*)Value = nsh->usServClass;
	}
	else
		return EDGE_PARAM_INVALID;											// ɂvs

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgServiceGetCount
* DESCRIPTION:
*   ݂̃T[rXo^擾
\*****************************************************************************/
int32_t EgServiceGetCount(uint32_t *pItemNum)
{
	HNAMESPACE		hServ;
	hServ = EgServiceGetHandle();											// SERVICE̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pItemNum == NULL)
		return EDGE_PARAM_INVALID;											// p[^s

	*pItemNum = EgNamespaceGetCount(hServ);									// Gg擾

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgServiceGetEnum
* DESCRIPTION:
*   T[rX̃CfbNXꗗ擾
\*****************************************************************************/
int32_t EgServiceGetEnum(EDGE_INDEX *pBuffer, uint32_t dwSize, uint32_t *pItemNum)
{
	HNAMESPACE		hServ;
	hServ = EgServiceGetHandle();											// SERVICE̖Oԃnh𓾂
	if (hServ == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dwSize < EgNamespaceGetCount(hServ) * sizeof(NAMESPACE_INDEX))		// i[obt@TCY`FbN
	{
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	return EgNamespaceEnumIndex(hServ, (void*)pBuffer, dwSize, pItemNum);	// NamespaceCfbNXꗗ擾
}