////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egSystemConfig.c
*
*   RT-edge system configuration
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"
//#include "../eghgapiCommon/md5.h"


//
// T[rXReiCfbNXpe[u }bv
// 2022/5/25_ Tag̃gK[@\Ŏgp
//
EDGESYSTEMCONFIG* EgSysCfgLookup()
{
	void *memory = os_edge_lookup(EGSYSCFGTB_NAME);
	return (EDGESYSTEMCONFIG*)os_edge_map(memory);
}
//
// T[rXReiCfbNXpe[u쐬
// 2022/5/25_ Tag̃gK[@\Ŏgp
//
EDGESYSTEMCONFIG* EgSysCfgCreate(EDGESYSTEMCONFIG* SysCfg)
{
	uint32_t		dwSize;
	uint32_t		result = 0;
	void*			hMem = NULL;
	EDGESYSTEMCONFIG* 	pMem = NULL;

	dwSize = sizeof(EDGESYSTEMCONFIG);
	dwSize = ROUNDUP_4KB(dwSize);

	//--------------------------------------------------------------------
	//e[u쐬E}bv
	//--------------------------------------------------------------------
	pMem = os_edge_createMemory(EGSYSCFGTB_NAME, dwSize, &hMem);
	if (pMem == NULL) {
		result = EDGE_SYSCFG_CREATE_ERROR;									// t@C}bsOG[
		goto failed;
	}

	//--------------------------------------------------------------------
	// e[u
	//--------------------------------------------------------------------
	memset(pMem, 0, dwSize);													// 
	//ftHglݒ
	pMem->MaxDsetEntry = EG_MAX_DSETENTRY;										// f[^ZbgGgő吔ie[ũCfbNXj
	pMem->MaxDsetLink = EG_MAX_DSETLINK;										// f[^Zbg f[^N^Oő吔(TagRef)
	pMem->MaxClctEntry = EG_MAX_CLCTENTRY;										// RN^ Ggő吔
	pMem->MaxServiceEntry = EG_MAX_SERVICEENTRY;								// T[rXRei Ggő吔
	pMem->MaxMailboxEntry = EG_MAX_MAILBOXENTRY;								// [{bNX Ggő吔
	pMem->MaxC2CMailboxCol = EGFW_MAX_C2C_MAILBOXCOL;							// RT-edget[[N ReiԒʐM[{bNXőf[^TCY(ColSize) 
	pMem->MaxC2CMailboxRow = EGFW_MAX_C2C_MAILBOXROW;							// RT-edget[[N ReiԒʐM[{bNX őێ(RowSize)
	pMem->MaxFwClctEntry = EGFW_MAX_CLCTENTRY;									// RT-edget[[N  RN^IuWFNgQ Ggő吔
	pMem->MaxFwMailboxEntry = EGFW_MAX_MAILBOXENTRY;							// RT-edget[[N [{bNXIuWFNg Ggő吔
	pMem->MaxFwTagRefEntry = EGFW_MAX_TAGREFENTRY;								// RT-edget[[N TagRefIuWFNg Ggő吔
	pMem->MaxTagPtrNum = EG_MAX_TAGPTR_NUM;										// ^O|C^ő吔
	pMem->MaxTagPtrSize = EG_MAX_TAGPTR_SIZE;									// ^O|C^őf[^TCY(oCgP)
	pMem->MaxTagPtrRetry = EG_MAX_TAGPTR_RETRY;									// ^O|C^bN݂
	pMem->MaxFwTagTrigEntry = EGFW_MAX_TAGTRIGENTRY;							// RT-edget[[N ^OgK[ Ggő吔

	//t@Cwlݒ
	if (SysCfg != NULL)
	{
		if (SysCfg->MaxDsetEntry != 0) pMem->MaxDsetEntry = SysCfg->MaxDsetEntry;	//f[^Zbg@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxDsetLink != 0) pMem->MaxDsetLink = SysCfg->MaxDsetLink;		//f[^Zbg f[^N^Oő吔(TagRef)@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxClctEntry != 0) pMem->MaxClctEntry = SysCfg->MaxClctEntry;	//RN^ Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxServiceEntry != 0) pMem->MaxServiceEntry = SysCfg->MaxServiceEntry;	//T[rXRei Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxMailboxEntry != 0) pMem->MaxMailboxEntry = SysCfg->MaxMailboxEntry;	//[{bNX Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxC2CMailboxCol != 0) pMem->MaxC2CMailboxCol = SysCfg->MaxC2CMailboxCol;	//RT-edget[[N ReiԒʐM[{bNXőf[^TCY(ColSize) @0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxC2CMailboxRow != 0) pMem->MaxC2CMailboxRow = SysCfg->MaxC2CMailboxRow;	//RT-edget[[N ReiԒʐM[{bNX őێ(RowSize)@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxFwClctEntry != 0) pMem->MaxFwClctEntry = SysCfg->MaxFwClctEntry;			//RT-edget[[N  RN^IuWFNgQ Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxFwMailboxEntry != 0) pMem->MaxFwMailboxEntry = SysCfg->MaxFwMailboxEntry;//RT-edget[[N [{bNXIuWFNg Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxFwTagRefEntry != 0) pMem->MaxFwTagRefEntry = SysCfg->MaxFwTagRefEntry;	//RT-edget[[N TagRefIuWFNg Ggő吔@0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxTagPtrNum != 0) pMem->MaxTagPtrNum = SysCfg->MaxTagPtrNum;				// ^O|C^ő吔 0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxTagPtrSize != 0) pMem->MaxTagPtrSize = SysCfg->MaxTagPtrSize;			// ^O|C^őf[^TCY(oCgP) 0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxTagPtrRetry != 0) pMem->MaxTagPtrRetry = SysCfg->MaxTagPtrRetry;			// ^O|C^bN݂ 0ł͂Ȃꍇ͐ݒ
		if (SysCfg->MaxFwTagTrigEntry != 0) pMem->MaxFwTagTrigEntry = SysCfg->MaxFwTagTrigEntry;	//  RT-edget[[N ^OgK[ Ggő吔
	}
	return (HSYSCFG)pMem;														// nhԂ

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
failed:
	os_edge_freeMemory(EGSYSCFGTB_NAME, pMem, hMem);
	return (HSYSCFG)NULL;													// s
}