////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egTag.c
*
*   RT-edge system TAG object API
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"
#include "xmmintrin.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
static HNAMESPACE		hObjKeep = { 0 };		// TAG NameSpacẽnh
#define TAGS_ENTRY_SIZE	sizeof(TagsDesc)		// Gg̃oCgTCY
#define TAGS_NAME_SPACE	EGTAGTABLE_NAME			// NameSpace̖

extern int32_t EgTagGetSegmentAddress(TagsDesc *nsh);
extern bool EgTagJudgeSegmentType(uint16_t usType);
extern int32_t _EgTagReadSegmentByEntry(TagsDesc *nsh, uint16_t wOffset, void* byteArray, uint16_t wSize);
extern int32_t _EgTagWriteSegmentByEntry(TagsDesc *nsh, uint16_t wOffset, void *pBuffer, uint16_t wSize);
extern int32_t _EgTagReadStringByEntry(TagsDesc *nsh, char* pString, uint16_t wSize);
extern int32_t _EgTagWriteStringByEntry(TagsDesc *nsh, char *pString);
extern int32_t EgTagInitSharedMemory(void);
extern int32_t EgTagGetSharedMemoryAddress(TagsDesc *nsh, LPVOID *addr);
extern int32_t _SHM_DecodeSource(const char *pSource, SHM_DESC *pSHM);
extern SHM_LO_ENTRY* _SHM_LoE_GetEntry(SHM_DESC *pSHM, int32_t *pResult);
extern int32_t EgTagFetchConfigFIFO(void);
extern int32_t _EgTagReadFIFO(TagsDesc *nsh, void* byteArray, uint16_t wSize);
extern int32_t _EgTagWriteFIFO(TagsDesc *nsh, void* byteArray, uint16_t wSize);
extern void PrintSysLog(const char* pMode, const char* format, ...);

extern RTCDHANDLE		gm_MyMBoxHandle;
extern uint8_t			gm_Ack_TAG_DEFAULT_VALUE_SET_END;					// ^OlǍvɑ΂鉞tO
extern int32_t			gm_Result_TAG_DEFAULT_VALUE_SET_END;				// ^OlǍvɑ΂鉞̃Xe[^X

//------------------------------------------------------------------------------
// Bit쎞Ɏgp\
//------------------------------------------------------------------------------
typedef struct tBitStruct {
	uint16_t	Bit_0 : 1;
	uint16_t	Bit_1 : 1;
	uint16_t	Bit_2 : 1;
	uint16_t	Bit_3 : 1;
	uint16_t	Bit_4 : 1;
	uint16_t	Bit_5 : 1;
	uint16_t	Bit_6 : 1;
	uint16_t	Bit_7 : 1;
	uint16_t	Bit_8 : 1;
	uint16_t	Bit_9 : 1;
	uint16_t	Bit_10 : 1;
	uint16_t	Bit_11 : 1;
	uint16_t	Bit_12 : 1;
	uint16_t	Bit_13 : 1;
	uint16_t	Bit_14 : 1;
	uint16_t	Bit_15 : 1;
} BIT_ST;

/*****************************************************************************
* FUNCTION:		EgTagGetHandle
* DESCRIPTION:
*   ()TAGNameSpacenh𓾂
\*****************************************************************************/
HNAMESPACE EgTagGetHandle(void)
{
	int32_t ret = EDGE_SUCCESS;
	uint32_t MaxTagEntry = EG_MAX_TAGENTRY;

	if (hObjKeep != NULL)
		return hObjKeep;								// Ɏ擾ςȂI

	hObjKeep = EgNamespaceLookup(TAGS_NAME_SPACE);
	if (hObjKeep != NULL)
		return hObjKeep;								// ČI

	hObjKeep = EgNamespaceCreate(TAGS_NAME_SPACE, EG_MAX_TAGENTRY, EG_MAX_TAGENTRY*TAGS_ENTRY_SIZE);
	if (hObjKeep != NULL)
		return hObjKeep;								// NameSpaceVɍďI
	
	return NULL;										// NameSpace𐶐łɎs
}

/*****************************************************************************
* FUNCTION:		EgTagGetDataSize
* DESCRIPTION:
*   ()^Õf[^^CvʂɃTCY擾
\*****************************************************************************/
uint16_t EgGetTagDataSize(uint16_t Type)
{	
	uint16_t ret_size = 0;
	switch (Type)
	{
		case EgVtBoolean:		ret_size = 1;		break;
		case EgVtSByte:			ret_size = 1;		break;
		case EgVtByte:			ret_size = 1;		break;
		case EgVtInt16:			ret_size = 2;		break;
		case EgVtUInt16:		ret_size = 2;		break;
		case EgVtInt32:			ret_size = 4;		break;
		case EgVtUInt32:		ret_size = 4;		break;
		case EgVtFloat:			ret_size = 4;		break;
		case EgVtInt64:			ret_size = 8;		break;
		case EgVtUInt64:		ret_size = 8;		break;
		case EgVtDouble:		ret_size = 8;		break;
		case EgVtString:		ret_size = 0;		break;		// ^O|C^ƂĎgpBTCYAPIŎw肷邽߁Ał̓TCYw肵Ȃ
		case EgVtSegment:		ret_size = 0;		break;		// ^O|C^ƂĎgpBTCYAPIŎw肷邽߁Ał̓TCYw肵Ȃ
		case EgVtFIFO:			ret_size = 0;		break;		// FIFO^OƂĎgpBTCY͐pAPIŐݒ肷邽߁Ał̓TCYw肵Ȃ
		// [ُn] ʏ͗L蓾ȂBÔ߁AőTCYZbgĂB
		case EgVtNull:			ret_size = EG_MAX_TAGDATASIZE;	break;
		case EgVtEmpty:			ret_size = EG_MAX_TAGDATASIZE;	break;
		default:				ret_size = EG_MAX_TAGDATASIZE;	break;
	}
	return ret_size;
}

/*****************************************************************************
* FUNCTION:		EgSetRTCD
* DESCRIPTION:
*   RTCDiRTCD𐶐m[hwj
\*****************************************************************************/
int32_t EgSetRTCD(const char *Name)
{

	if (hObjKeep != NULL)									// TagNameSpacenh
		return EDGE_TTABLE_EXIST_ERROR;						// ς݂̂߃G[ԋp

	if (strlen(Name) == 0)									// m[h̋͋Ȃ
		return EDGE_PARAM_INVALID;

	int32_t iRet = os_edge_setNode(Name);					// RTCDm[hݒ
	if (iRet != EDGE_SUCCESS) {
		return iRet;
	}

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgTagInit
* DESCRIPTION:
*   Tag
*   ő^OGgw肵NameSpace
\*****************************************************************************/
int32_t EgTagInit(uint32_t NumMax)
{
	int32_t ret = EDGE_SUCCESS;
	if (hObjKeep != NULL)									// TagNameSpacenh
		return EDGE_TTABLE_EXIST_ERROR;						// ς݂̂߃G[ԋp

	hObjKeep = EgNamespaceLookup(TAGS_NAME_SPACE);			// TagNameSpace
	if (hObjKeep != NULL)									// ꍇ
		return EDGE_TTABLE_EXIST_ERROR;						// ς݂̂߃G[ԋp

	if (NumMax == 0)										// ^O`FbN ől`FbN͍sȂ eʂɔC
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;				// ͈͊Ô߃G[ԋp

	hObjKeep = EgNamespaceCreate(TAGS_NAME_SPACE, NumMax, NumMax*TAGS_ENTRY_SIZE);	// wGgŃ^Opl[Xy[X
	if (hObjKeep == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;					// NameSpaces

	ret = EgTagCreate(EGSYSTAGNAME_TAGENTRY_MAX, EgVtUInt32, 4, "", "Maximum size of Tag entry.");	//EDGESYSTEM.SERVICEENTRY.MAX
	if(ret != EDGE_SUCCESS)
		return ret;
	
	ret = EgTagWrite(EGSYSTAGNAME_TAGENTRY_MAX, &NumMax, sizeof(uint32_t));// Tag̍őTCYݒ
	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagCreate
* DESCRIPTION:
*   Tago^
*   ɑ݂ꍇ͉Ȃ
\*****************************************************************************/
int32_t EgTagCreate(const char *Name, uint16_t Type, uint16_t Size, const char *Source, const char *Comment)
{
	// TCYwsv̂߁Ap[^Size͕sgpB
	// {API͌݊mۂړIƂĎcB

	return EgTagCreateEx(Name, Type, Source, Comment);
}

/*****************************************************************************
* FUNCTION:		_EgTagCreateSHM
* DESCRIPTION:
*   (ďop)Tago^p Lp̊gt鏈
\*****************************************************************************/
int32_t _EgTagCheckSHM(const char *Source, SHM_DESC **ppWORK)
{
	SHM_LO_ENTRY	*pLoE = NULL;
	SHM_DESC		*pWORK = NULL;				// ƗpGA
	int32_t			inResult = ERROR_SUCCESS;

	pWORK = (SHM_DESC*)os_edge_mallocMemory(sizeof(SHM_DESC));			// Ɨp̊m
	if (NULL == pWORK) {
		return EDGE_SHM_ALLOCATE_ERROR;
	}

	inResult = _SHM_DecodeSource(Source, pWORK);						// Source(Address)̕
	if (EDGE_SUCCESS != inResult) {
		os_edge_freemallocMemory(pWORK);								// ꎞƃ̉
		return inResult;												// \G[
	}

	if (ppWORK != NULL) {
		*ppWORK = pWORK;
	}

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagCreateSHM
* DESCRIPTION:
*   (ďop)Tago^p Lp̊gt鏈
\*****************************************************************************/
int32_t _EgTagCreateSHM(TagsDesc *nsh, SHM_DESC *pWORK)
{
	SHM_LO_ENTRY	*pLoE = NULL;
	int32_t			inResult = ERROR_SUCCESS;

	// L^OɕKvȏ^Oe[uփZbg
	memcpy_s(&nsh->SHM, sizeof(SHM_DESC), pWORK, sizeof(SHM_DESC));
	nsh->SHM.chNull = '\0';												// Source\pNULLI[Zbg
	nsh->SHM.InUse = EG_SHM_IN_USE;										// Lgpɐݒ

	os_edge_freemallocMemory(pWORK);									// ꎞƃ̉
	pWORK = NULL;

	pLoE = _SHM_LoE_GetEntry(&nsh->SHM, &inResult);						// [Je[uQƁA}bvȂ}bvĒǉ
	if (pLoE == NULL) {
		return inResult;												// G[
	}

	if (pLoE->MappedSize < (nsh->SHM.Offset + nsh->var.size)) {			// TCY߃`FbN
		return EDGE_SHM_OFFSET_OVERFLOW;								// ItZbgI[o[G[
	}

	return ERROR_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgTagCreateEx
* DESCRIPTION:
*   Tago^
*   ɑ݂ꍇ͉Ȃ
\*****************************************************************************/
int32_t EgTagCreateEx(const char *Name, uint16_t Type, const char *Source, const char *Comment)
{
	HNAMESPACE		hTag;
	SHM_DESC		*pWORK = NULL;
	int32_t			inResult = EDGE_SUCCESS;
	uint8_t			byModeSHM = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL) {
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	}

	if (strlen(Name) == 0) {													// ^Ő͋Ȃ
		return EDGE_PARAM_INVALID;
	}

	if (strlen(Name) > EG_MAX_TAGNAME) {										// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;
	}

	if (strlen(Source) > EG_MAX_TAGADDRESS) {									// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;
	}

	if (strlen(Comment) > EG_MAX_TAGCOMMENT) {								// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;
	}

	if ((Type == EgVtEmpty) || (Type == EgVtString) || (Type >= EgVtFIFO)) {	// ^`FbN String, ByteArray, FIFO͕APIőΉ̂߁AG[Ƃ
		return EDGE_TTABLE_TYPE_ERROR;
	}

	inResult = _strnicmp(Source, EG_SHM_KEY_DELI, strlen(EG_SHM_KEY_DELI));	// Lw`FbN
	if (inResult == 0) {													// L^Cv ?
		byModeSHM = 1;
		inResult = _EgTagCheckSHM(Source, &pWORK);							// Lw`FbN
		if (inResult != EDGE_SUCCESS) {
			return inResult;												// L\G[
		}
	}

	TagsDesc*		nsh;
	NAMESPACE_INDEX *index = EgNamespaceGetIndex(hTag, Name);				// ^OT
	if (index != NULL)
		return EDGE_TTABLE_ISEXIST_TAGNAME;									// o^ςݏI

	nsh = (TagsDesc*)EgNamespaceAddEntry(hTag, Name, TAGS_ENTRY_SIZE);		// VȃGgǉ
	if (nsh == NULL)
		return EDGE_TTABLE_NOEMPTY;											// o^tŎs
	
	os_edge_strncpy_s(nsh->chName, sizeof(nsh->chName), Name, _TRUNCATE);			// ̕ۊ
	os_edge_strncpy_s(nsh->chSource, sizeof(nsh->chSource), Source, _TRUNCATE);	// \[XEAhXۊ
	os_edge_strncpy_s(nsh->chComment, sizeof(nsh->chComment), Comment, _TRUNCATE);	// Rgۊ
	nsh->var.vt = Type;														// Type ^ۊ
	nsh->var.size = EgGetTagDataSize(Type);									// f[^TCYۊ
	nsh->force = false;														// tO
	nsh->isLink = false;													// N^OtO
	memset(&nsh->chSource[strlen(nsh->chSource)], 0, sizeof(nsh->chSource) - strlen(nsh->chSource));

	((LPNAMESPACE)hTag)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_TAGENTRY_COUNT, &(((LPNAMESPACE)hTag)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ

	if (byModeSHM != 0) {													// L^Cv ?
		inResult = _EgTagCreateSHM(nsh, pWORK);								// }bv
		if (inResult != EDGE_SUCCESS) {
			return inResult;
		}
	}

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagCreateSp
* DESCRIPTION:
*   Tago^
*   ɑ݂ꍇ̓N^OƂĕʖo^
\*****************************************************************************/
int32_t _EgTagCreateSp(const char *Name, uint16_t Type, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	char			*tagName = NULL;										// N^Opobt@
	size_t			bufsize = EG_MAX_TAGNAME + 1;							// N^OTCY
	SHM_DESC		*pWORK = NULL;
	int32_t			inResult = EDGE_SUCCESS;
	uint8_t			byModeSHM = 0;
	HNAMESPACE		hTag;

	inResult = _strnicmp(Source, EG_SHM_KEY_DELI, strlen(EG_SHM_KEY_DELI));	// Lw`FbN
	if (inResult == 0) {													// L^Cv ?
		byModeSHM = 1;
		inResult = _EgTagCheckSHM(Source, &pWORK);							// Lw`FbN
		if (inResult != EDGE_SUCCESS) {
			return inResult;												// L\G[
		}
	}

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂

	TagsDesc*	nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);			// Gg
	if (nsh == NULL)														// ^OȂ
	{
		nsh = (TagsDesc*)EgNamespaceAddEntry(hTag, Name, TAGS_ENTRY_SIZE);	// VȃGgǉ
		if (nsh == NULL)
			return EDGE_TTABLE_NOEMPTY;										// o^tŎs
		*isLink = 0;														// N^OtOOFF(ʏ^O)
		edge_strncpy_s(nsh->chName, sizeof(nsh->chName), Name, _TRUNCATE);	// ̕ۊ
		edge_strncpy_s(regName, regNameSize, Name, _TRUNCATE);				// ۂɓo^^Oԋp
	}
	else																	// ^O
	{
		// -----------------------------------------------------------------
		// ɓ^Oo^ς݂̏ꍇAN^OƂĕʖo^܂
		// -----------------------------------------------------------------
		if (strlen(Name) > EG_MAX_TAGNAME - LINKTAG_PRIFIX_LEN)				// TCY`FbN(N^Op̎ʕt^邽߁Al𐧌)
			return EDGE_TTABLE_DUPLICATE_ERROR;								// do^NG

		if (Type != nsh->var.vt)											// ^`FbN(قȂ^̕ʖo^NG)
			return EDGE_TTABLE_DUPLICATE_ERROR;								// do^NG

		// N^O̖̐
		tagName = (char*)edge_mallocMemory(bufsize);						// N^OpɃm
		bool isNameOK = false;
		for (int cnt = 0; cnt < 10; cnt++)									// 0-9̘AԂŖO쐬
		{
			memset(tagName, 0, bufsize);
			sprintf_s(tagName, bufsize, "#%d%s", cnt, Name);				// N^O

			nsh = EgNamespaceGetEntry(hTag, tagName);						// Gg
			if (nsh == NULL)												// ^OȂ
			{
				isNameOK = true;											// ̎擾
				break;
			}
		}
		if (isNameOK == false)												// ̎擾s
		{
			edge_freemallocMemory(tagName);
			return EDGE_TTABLE_DUPLICATE_ERROR;								// do^NG
		}

		// N^O
		nsh = (TagsDesc*)EgNamespaceAddEntry(hTag, tagName, TAGS_ENTRY_SIZE);// VȃGgǉ
		if (nsh == NULL)
		{
			edge_freemallocMemory(tagName);
			return EDGE_TTABLE_NOEMPTY;										// o^tŎs
		}
		*isLink = 1;														// N^OtOON
		edge_strncpy_s(nsh->chName, sizeof(nsh->chName), tagName, _TRUNCATE);// ̕ۊ
		edge_strncpy_s(regName, regNameSize, tagName, _TRUNCATE);			// ۂɓo^^Oԋp
		edge_freemallocMemory(tagName);
	}

	edge_strncpy_s(nsh->chSource, sizeof(nsh->chSource), Source, _TRUNCATE);	// \[XEAhXۊ
	edge_strncpy_s(nsh->chComment, sizeof(nsh->chComment), Comment, _TRUNCATE);	// Rgۊ
	nsh->var.vt = Type;														// Type ^ۊ
	nsh->var.size = EgGetTagDataSize(Type);									// f[^TCYۊ
	nsh->force = false;														// tO
	nsh->isLink = (*isLink != 0) ? true : false;							// N^OtOZbg
	memset(&nsh->chSource[strlen(nsh->chSource)], 0, sizeof(nsh->chSource) - strlen(nsh->chSource));

	((LPNAMESPACE)hTag)->head.numitem++;									// Gg++
	EgTagWrite(EGSYSTAGNAME_TAGENTRY_COUNT, &(((LPNAMESPACE)hTag)->head.numitem), sizeof(uint32_t)); //݂̃Gg^Oɏ

	if (byModeSHM != 0) {													// L^Cv ?
		inResult = _EgTagCreateSHM(nsh, pWORK);								// }bv
		if (inResult != EDGE_SUCCESS) {
			return inResult;
		}
	}

	return EDGE_SUCCESS;				// 
}
/*****************************************************************************
* FUNCTION:		EgTagCreateSp
* DESCRIPTION:
*   Tago^
*   ɑ݂ꍇ̓N^OƂĕʖo^
\*****************************************************************************/
int32_t EgTagCreateSp(const char *Name, uint16_t Type, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	char *tagName = NULL;													// N^Opobt@
	size_t bufsize = EG_MAX_TAGNAME + 1;									// N^OTCY

	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂

	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)													// ^Ő͋Ȃ
		return EDGE_PARAM_INVALID;

	if (strlen(Name) > EG_MAX_TAGNAME)										// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

	if (strlen(Source) > EG_MAX_TAGADDRESS)									// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

	if (strlen(Comment) > EG_MAX_TAGCOMMENT)								// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

	if (regNameSize < EG_MAX_TAGNAME)										// TCY`FbN
		return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

	if ((Type == EgVtEmpty) || (Type == EgVtString) || (Type >= EgVtFIFO))	// ^`FbN String, ByteArray, FIFO͕APIőΉ̂߁AG[Ƃ
		return EDGE_TTABLE_TYPE_ERROR;

	return _EgTagCreateSp(Name, Type, Source, Comment, regName, regNameSize, isLink);
}
/*****************************************************************************
* FUNCTION:		_EgTagWriteByEntry (^O݂̖{̏)
* DESCRIPTION:
*   ()Tagɒlo^@(Entryw)
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagWriteByEntry(TagsDesc *nsh, void *pBuffer, uint16_t wSize)
{
	volatile LPVOID		pVal  = NULL;
	volatile BIT_ST		*pBit = NULL;
	int32_t				inRet = EDGE_SUCCESS;
	uint16_t			woLast = 0;
	uint16_t			woNow  = 0;

	// L^CvƂ͕ʂ ?
	if (nsh->SHM.InUse == 0) {
		//  ʃ^Cv
		pVal = (LPVOID)&nsh->var.val;
	}
	else {
		//  L^Cv
		inRet = EgTagGetSharedMemoryAddress(nsh, (LPVOID *)&pVal);		// L̃AhX擾(ItZbgς)
		if (inRet != EDGE_SUCCESS) {
			return inRet;
		}

		if (nsh->SHM.BitUse != 0) {						// BitgpA ?
			// ˁ BitgpL
			pBit = (BIT_ST*)pVal;

			switch (nsh->SHM.BitOffset) {
			case  0: woLast = pBit->Bit_0;  pBit->Bit_0  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_0;  break;
			case  1: woLast = pBit->Bit_1;  pBit->Bit_1  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_1;  break;
			case  2: woLast = pBit->Bit_2;  pBit->Bit_2  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_2;  break;
			case  3: woLast = pBit->Bit_3;  pBit->Bit_3  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_3;  break;
			case  4: woLast = pBit->Bit_4;  pBit->Bit_4  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_4;  break;
			case  5: woLast = pBit->Bit_5;  pBit->Bit_5  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_5;  break;
			case  6: woLast = pBit->Bit_6;  pBit->Bit_6  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_6;  break;
			case  7: woLast = pBit->Bit_7;  pBit->Bit_7  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_7;  break;
			case  8: woLast = pBit->Bit_8;  pBit->Bit_8  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_8;  break;
			case  9: woLast = pBit->Bit_9;  pBit->Bit_9  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_9;  break;
			case 10: woLast = pBit->Bit_10; pBit->Bit_10 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_10; break;
			case 11: woLast = pBit->Bit_11; pBit->Bit_11 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_11; break;
			case 12: woLast = pBit->Bit_12; pBit->Bit_12 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_12; break;
			case 13: woLast = pBit->Bit_13; pBit->Bit_13 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_13; break;
			case 14: woLast = pBit->Bit_14; pBit->Bit_14 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_14; break;
			case 15: woLast = pBit->Bit_15; pBit->Bit_15 = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_15; break;
			default: woLast = pBit->Bit_0;  pBit->Bit_0  = (((*(uint8_t*)pBuffer) != 0) ? 1 : 0); woNow = pBit->Bit_0;  break;
			}

			if (pBit->Bit_0 != woLast) {	
				nsh->cnt++;	// ݑOƏ݌̒lႤꍇ́AJEgAbv
			}

			// BitgpÁA֍sAŏI
			return EDGE_SUCCESS;
		}
	}
	

	switch (wSize)
	{
	case 1:	// byte size r܂ ͑OƓ͌ŒlႤꍇ͖߂lς 
		#ifdef __INTIME__
		if (InterlockedExchange16((volatile short*)(pVal), (char)*(uint8_t*)pBuffer) != (char)*(uint8_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
		#else
		if (InterlockedExchange8((volatile char*)(pVal), (char)*(uint8_t*)pBuffer) != (char)*(uint8_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
		#endif
	case 2:	// word size r܂ ͑OƓ͌ŒlႤꍇ͖߂lς 
		if (InterlockedExchange16((volatile short*)(pVal), (short)*(uint16_t*)pBuffer) != (short)*(uint16_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
	case 4:// dword size r܂ ͑OƓ͌ŒlႤꍇ͖߂lς 
		if (InterlockedExchange((volatile int*)(pVal), (int)*(uint32_t*)pBuffer) != (int)*(uint32_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
	case 8:// qword size r܂ ͑OƓ͌ŒlႤꍇ͖߂lς 
#if _WIN64
		if (InterlockedExchange64((volatile long long*)(pVal), (long long)*(uint64_t*)pBuffer) != (long long)*(uint64_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
#else
		if (InterlockedExchange64((volatile long long*)(pVal), (long long)*(uint64_t*)pBuffer) != (long long)*(uint64_t*)pBuffer) {
			nsh->cnt++;
		}
		break;
		//if((unsigned long long)nsh->var.val != *(unsigned long long*)pBuffer)
		//	*boTagValChange = (BOOL)TRUE;
		//_mm_stream_pi((__m64*)(pVal), *(__m64*)pBuffer);			// qword size
		//_mm_empty();
		//break;
#endif
	}

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgTagWrite
* DESCRIPTION:
*   ()Tagɒlo^@Ow
\*****************************************************************************/
int32_t _EgTagWrite(const char *Name, void *pBuffer, uint16_t wSize)
{
	int32_t ret = EDGE_SUCCESS;
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// Type^O|C^ / FIFOȊȌꍇ́ATCY`FbN
	if (!EgTagJudgeSegmentType(nsh->var.vt) && (nsh->var.vt != EgVtFIFO))
	{
		if (wSize > sizeof(union EgVARIANTValues))
			return EDGE_TTABLE_VALUE_OVERFLOW;									// TCY𒴂鎸s
	}

	if (nsh->force)															// tO͏܂ɐI
		return EDGE_SUCCESS;

	// Typeɂď𕪊򂷂
	switch (nsh->var.vt)
	{
	case EgVtString:														// 
		ret = _EgTagWriteStringByEntry(nsh, pBuffer);		// ^O
		break;
	case EgVtSegment:													// oCgz
		ret = _EgTagWriteSegmentByEntry(nsh, 0, pBuffer, wSize);						// ^O
		break;
	case EgVtFIFO:															//FIFO
		ret = _EgTagWriteFIFO(nsh, pBuffer, wSize);			// ^O
		break;
	default:																// ȊO
		ret = _EgTagWriteByEntry(nsh, pBuffer, wSize);		// ^O
		break;
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagWrite
* DESCRIPTION:
*   Tagɒlo^@Ow
\*****************************************************************************/
int32_t EgTagWrite(const char *Name, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;
	
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if(Name == NULL)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	if(*Name == '\0')
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// Type^O|C^ / FIFOȊȌꍇ́ATCY`FbN
	if (!EgTagJudgeSegmentType(nsh->var.vt) && (nsh->var.vt != EgVtFIFO))
	{
		if (wSize > sizeof(union EgVARIANTValues))
			return EDGE_TTABLE_VALUE_OVERFLOW;									// TCY𒴂鎸s
	}

	if (nsh->force)															// tO͏܂ɐI
		return EDGE_SUCCESS;

	// N^O
	if (nsh->isLink)
	{
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^O_EgTagWrite()R[
		ret = _EgTagWrite((char *)(Name + LINKTAG_PRIFIX_LEN), pBuffer, wSize);
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:														// 
			ret = _EgTagWriteStringByEntry(nsh, pBuffer);
			break;
		case EgVtSegment:														// oCgz
			ret = _EgTagWriteSegmentByEntry(nsh, 0, pBuffer, wSize);
			break;
		case EgVtFIFO:															// FIFO
			ret = _EgTagWriteFIFO(nsh, pBuffer, wSize);
			break;
		default:																// ȊO
			ret = _EgTagWriteByEntry(nsh, pBuffer, wSize);
			break;
		}
	}
	
	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteByIndex
* DESCRIPTION:
*   Tagɒlo^ (INDEXw)
\*****************************************************************************/
int32_t EgTagWriteByIndex(EDGE_INDEX *index, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;
	
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc* nsh = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);	// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// Type^O|C^ / FIFOȊȌꍇ́ATCY`FbN
	if (!EgTagJudgeSegmentType(nsh->var.vt) && (nsh->var.vt != EgVtFIFO))
	{
		if (wSize > sizeof(union EgVARIANTValues))
			return EDGE_TTABLE_VALUE_OVERFLOW;									// TCY𒴂鎸s
	}

	if (nsh->force)															// tO͏܂ɐI
		return EDGE_SUCCESS;

	// N^O
	if (nsh->isLink)
	{
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^O_EgTagWrite()R[
		return _EgTagWrite((char *)(nsh->chName + LINKTAG_PRIFIX_LEN), pBuffer, wSize);
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:														// 
			ret = _EgTagWriteStringByEntry(nsh, pBuffer);
			break;
		case EgVtSegment:														// oCgz
			ret = _EgTagWriteSegmentByEntry(nsh, 0, pBuffer, wSize);
			break;
		case EgVtFIFO:															// FIFO
			ret = _EgTagWriteFIFO(nsh, pBuffer, wSize);
			break;
		default:																// ȊO
			ret = _EgTagWriteByEntry(nsh, pBuffer, wSize);
			break;
		}
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteByEntry
* DESCRIPTION:
*   Tagɒlo^ (Entryw)
\*****************************************************************************/
int32_t EgTagWriteByEntry(void *pEntry, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;
	
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc* nsh = (TagsDesc*)pEntry;

	// Type^O|C^ / FIFOȊȌꍇ́ATCY`FbN
	if (!EgTagJudgeSegmentType(nsh->var.vt) && (nsh->var.vt != EgVtFIFO))
	{
		if (wSize > sizeof(union EgVARIANTValues))
			return EDGE_TTABLE_VALUE_OVERFLOW;									// TCY𒴂鎸s
	}

	if (nsh->force)															// tO͏܂ɐI
		return EDGE_SUCCESS;

	if (nsh->isLink)														// N^Ȍꍇ
	{
		// NOTE: EgTagGetProperty()Ŏ擾łEntry|C^̓IWi^Ow߁Aʏ͔ȂP[X
		return EDGE_PARAM_INVALID;											// N^OւEntryw菑݂̓G[Ƃ
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:												// 
			ret = _EgTagWriteStringByEntry(nsh, pBuffer);				// ^O
			break;
		case EgVtSegment:												// 
			ret = _EgTagWriteSegmentByEntry(nsh, 0, pBuffer, wSize);	// ^O
			break;
		case EgVtFIFO:													// FIFO
			ret = _EgTagWriteFIFO(nsh, pBuffer, wSize);
			break;
		default:														// ȊO
			ret = _EgTagWriteByEntry(nsh, pBuffer, wSize);				// ^O
			break;
		}
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgTagReadByEntry (^Oǂݍ݂̖{̏)
* DESCRIPTION:
*   ()Tag̒l擾@Entryw
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagReadByEntry(TagsDesc *nsh, void* byteArray, uint16_t wSize)
{
	int32_t		inRet = EDGE_SUCCESS;
	LPVOID		pVal  = NULL;
	BIT_ST		*pBit = NULL;

	// L^CvƂ͕ʂ ?
	if (nsh->SHM.InUse == 0) {
		//  ʃ^Cv
		pVal = (LPVOID)&nsh->var.val;
	} 
	else {
		//  L^Cv
		inRet = EgTagGetSharedMemoryAddress(nsh, &pVal);		// L̃AhX擾(ItZbgς)
		if (inRet != EDGE_SUCCESS) {
			return inRet;
		}

		if (nsh->SHM.BitUse != 0) {								// BitgpA ?
		// ˁ BitgpL
			pBit = (BIT_ST*)pVal;
			switch(nsh->SHM.BitOffset){
			case  0: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_0; break;
			case  1: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_1; break;
			case  2: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_2; break;
			case  3: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_3; break;
			case  4: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_4; break;
			case  5: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_5; break;
			case  6: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_6; break;
			case  7: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_7; break;
			case  8: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_8; break;
			case  9: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_9; break;
			case 10: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_10; break;
			case 11: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_11; break;
			case 12: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_12; break;
			case 13: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_13; break;
			case 14: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_14; break;
			case 15: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_15; break;
			default: *(uint8_t*)byteArray = (uint8_t)pBit->Bit_0;  break;
			}
			// BitgpL莞́A֍sAŏI
			return EDGE_SUCCESS;
		}
	}

	switch (wSize)
	{
	case 1:
		*(uint8_t*)byteArray = *(uint8_t*)(pVal);					// byte size
		break;
	case 2:
		*(uint16_t*)byteArray = *(uint16_t*)(pVal);					// word size
		break;
	case 4:
		*(uint32_t*)byteArray = *(uint32_t*)(pVal);					// dword size
		break;
	case 8:
#if _WIN64
		*(uint64_t*)byteArray = *(uint64_t*)(pVal);					// qword size
		break;
#else
		_mm_stream_pi((__m64*)byteArray, *(__m64*)(pVal));			// qword size
		_mm_empty();
		break;
#endif
	}

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		_EgTagRead
* DESCRIPTION:
*   ()Tag̒l擾@Ow
\*****************************************************************************/
int32_t _EgTagRead(const char *Name, void* byteArray, uint16_t wSize)
{
	int32_t ret = EDGE_SUCCESS;
	HNAMESPACE		hTag;

	if (byteArray == NULL) {
		return EDGE_PARAM_INVALID;											// NULL̓G[
	}

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL) {
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	}

	if (strlen(Name) == 0) {
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[
	}

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL) {
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s
	}
	
	/* @memo FIFOނ͕Ƃ(ʓrްۯs) */
	if ((nsh->var.vt != EgVtFIFO) && (wSize < nsh->var.size)) {
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	// Typeɂď𕪊򂷂
	switch (nsh->var.vt)
	{
	case EgVtString:													// 
		ret = _EgTagReadStringByEntry(nsh, byteArray, wSize);
		break;
	case EgVtSegment:													// oCgz
		ret = _EgTagReadSegmentByEntry(nsh, 0, byteArray, wSize);
		break;
	case EgVtFIFO:														// FIFO
		ret = _EgTagReadFIFO(nsh, byteArray, wSize);
		break;
	default:															// ȊO
		ret = _EgTagReadByEntry(nsh, byteArray, wSize);					// ^Oǂݍ
		break;
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagRead
* DESCRIPTION:
*   Tag̒l擾@Ow
\*****************************************************************************/
int32_t EgTagRead(const char *Name, void* byteArray, uint16_t wSize)
{
	int32_t ret = EDGE_SUCCESS;
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	/* @memo FIFOނ͕Ƃ(ʓrްۯs) */
	if ((nsh->var.vt != EgVtFIFO) && (wSize < nsh->var.size))
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s

		// N^O
	if (nsh->isLink)
	{
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^O_EgTagRead()R[
		return _EgTagRead((char*)(Name + LINKTAG_PRIFIX_LEN), byteArray, wSize);
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:													// 
			ret = _EgTagReadStringByEntry(nsh, byteArray, wSize);
			break;
		case EgVtSegment:													// oCgz
			ret = _EgTagReadSegmentByEntry(nsh, 0, byteArray, wSize);
			break;
		case EgVtFIFO:														// FIFO
			ret = _EgTagReadFIFO(nsh, byteArray, wSize);
			break;
		default:																// ȊO
			ret = _EgTagReadByEntry(nsh, byteArray, wSize);
			break;
		}
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagReadByIndex
* DESCRIPTION:
*   Tag̒l擾 (INDEXw)
\*****************************************************************************/
int32_t EgTagReadByIndex(EDGE_INDEX *index, void* byteArray, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);	// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	/* @memo FIFOނ͕Ƃ(ʓrްۯs) */
	if ((nsh->var.vt != EgVtFIFO) && (wSize < nsh->var.size))
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s

		// N^O
	if (nsh->isLink)
	{
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^O_EgTagRead()R[
		return _EgTagRead((char*)(nsh->chName + LINKTAG_PRIFIX_LEN), byteArray, wSize);
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:													// 
			ret = _EgTagReadStringByEntry(nsh, byteArray, wSize);
			break;
		case EgVtSegment:													// oCgz
			ret = _EgTagReadSegmentByEntry(nsh, 0, byteArray, wSize);
			break;
		case EgVtFIFO:														// FIFO
			ret = _EgTagReadFIFO(nsh, byteArray, wSize);
			break;
		default:																// ȊO
			ret = _EgTagReadByEntry(nsh, byteArray, wSize);
			break;
		}
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagReadByEntry
* DESCRIPTION:
*   Tag̒l擾 (Entryw)
\*****************************************************************************/
int32_t EgTagReadByEntry(void *pEntry, void* byteArray, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc* nsh = (TagsDesc*)pEntry;

	/* @memo FIFOނ͕Ƃ(ʓrްۯs) */
	if ((nsh->var.vt != EgVtFIFO) && (wSize < nsh->var.size))
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s

	if (nsh->isLink)														// N^Ȍꍇ
	{
		// NOTE: EgTagGetProperty()Ŏ擾łEntry|C^̓IWi^Ow߁Aʏ͔ȂP[X
		return EDGE_PARAM_INVALID;											// N^OEntrywǂݍ݂̓G[Ƃ
	}
	else
	{
		// Typeɂď𕪊򂷂
		switch (nsh->var.vt)
		{
		case EgVtString:														// 
			ret = _EgTagReadStringByEntry(nsh, byteArray, wSize);			// ^Oǂݍ
			break;
		case EgVtSegment:														// 
			ret = _EgTagReadSegmentByEntry(nsh, 0, byteArray, wSize);				// ^Oǂݍ
			break;
		case EgVtFIFO:														// FIFO
			ret = _EgTagReadFIFO(nsh, byteArray, wSize);
			break;
		default:																// ȊO
			ret = _EgTagReadByEntry(nsh, byteArray, wSize);						// ^Oǂݍ
			break;
		}
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagWriteVar
* DESCRIPTION:
*   EGVARIANT^ŏ
\*****************************************************************************/
int32_t EgTagWriteVar(const char *Name, EGVAR val)
{
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	EgTagWrite(Name, &val.val, val.size);	// lo

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgTagReadVar
* DESCRIPTION:
*   EGVARIANT^œǂݍ
\*****************************************************************************/
EGVAR EgTagReadVar(const char *Name)
{
	EGVAR	val = { 0 };
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return val;															// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return val;															// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return val;															// ݂s

	val = nsh->var;							// VARIANTŎo
	EgTagRead(Name, &val.val, val.size);	// lēxKiŎo

	return val;
}
/*****************************************************************************
* FUNCTION:		_EgTagGetProperty
* DESCRIPTION:
*   ()TagPropertyl擾
\*****************************************************************************/
int32_t _EgTagGetProperty(TagsDesc *pTagsDescTb, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hTag;
	int32_t			inResult = ERROR_SUCCESS;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pTagsDescTb == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	//----------------------------------------------------------------
	// Type
	//----------------------------------------------------------------
	if (_HashCompare(hashed_propname, "Type"))								// v邩
	{
		if(dwSize < sizeof(pTagsDescTb->var.vt))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(uint16_t*)Value = pTagsDescTb->var.vt;
	}
	//----------------------------------------------------------------
	// Size
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Size"))							// v邩
	{
		if (dwSize < sizeof(pTagsDescTb->var.size))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		*(uint16_t*)Value = pTagsDescTb->var.size;
	}
	//----------------------------------------------------------------
	// Comment
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Comment"))						// v邩
	{
		if (dwSize < sizeof(pTagsDescTb->chComment))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(pTagsDescTb->chComment), pTagsDescTb->chComment, _TRUNCATE);
	}
	//----------------------------------------------------------------
	// Source
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Source") ||						// v邩
			 _HashCompare(hashed_propname, "Address"))						// v邩
	{
		if (dwSize < sizeof(pTagsDescTb->chSource))
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		os_edge_strncpy_s((char*)Value, sizeof(pTagsDescTb->chSource), pTagsDescTb->chSource, _TRUNCATE);
	}
	//----------------------------------------------------------------
	// Value
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Value"))						// v邩
	{
		// Typeɂď𕪊򂷂
		if ((pTagsDescTb->var.vt == EgVtString) || (pTagsDescTb->var.vt == EgVtSegment)) { //  // oCgz
			return EDGE_RTCD_PROPERTY_NOT_SUPPORT;							// T|[ĝ߃G[
		} 
		else if (dwSize < sizeof(pTagsDescTb->var.size)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		} 
		else if (pTagsDescTb->SHM.InUse == 0) {								// LȊO ?
			memcpy_s(Value, pTagsDescTb->var.size, &pTagsDescTb->var, pTagsDescTb->var.size);
		} 
		else {																// L̏ꍇ
			LPVOID p;
			inResult = EgTagGetSharedMemoryAddress(pTagsDescTb, &p);
			if (inResult != ERROR_SUCCESS) {
				return inResult;
			}
			memcpy_s(Value, pTagsDescTb->var.size, (void*)p, pTagsDescTb->var.size);
		}
	}
	//----------------------------------------------------------------
	// Entry
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Entry"))						// v邩
	{
		if (dwSize < sizeof((TagsDesc*)pTagsDescTb)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		// Typeɂď𕪊򂷂
		if ((pTagsDescTb->var.vt == EgVtString) || (pTagsDescTb->var.vt == EgVtSegment)) { //  // oCgz
			EgTagGetSegmentAddress(pTagsDescTb);							// ZOgAhX̎擾
		}
		else if (pTagsDescTb->SHM.InUse == 0) {								// LȊO ?
			pTagsDescTb->var.pSegment = (uint64_t)NULL;						// ZOggp̂ NULL Zbg
		}
		else {																// L̏ꍇ
			/* @todo Entry擾Oϯ߂ĂcƂ삪svɂȂ̂ŁȀ폜 */
			LPVOID p;
			inResult = EgTagGetSharedMemoryAddress(pTagsDescTb, &p);
			if (inResult != ERROR_SUCCESS) {
				return inResult;
			}
		}

		*(TagsDesc**)Value = (TagsDesc*)pTagsDescTb;
	}
	//----------------------------------------------------------------
	// Index
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Index"))						// v邩
	{
		if (dwSize < sizeof(NAMESPACE_INDEX*)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		*(NAMESPACE_INDEX**)Value = EgNamespaceGetIndex(hTag, pTagsDescTb->chName);
	}
	//----------------------------------------------------------------
	// Hash
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Hash"))							// v邩
	{
		if (dwSize < sizeof(HASHCODE)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		*(HASHCODE*)Value = _HashCreate(hTag, pTagsDescTb->chName);
	}
	//----------------------------------------------------------------
	// Name
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Name"))							// v邩
	{
		if (dwSize < sizeof(pTagsDescTb->chName)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		os_edge_strncpy_s((char*)Value, sizeof(pTagsDescTb->chName), pTagsDescTb->chName, _TRUNCATE);
	}
	//----------------------------------------------------------------
	// Count
	//----------------------------------------------------------------
	else if (_HashCompare(hashed_propname, "Count"))					// v邩
	{
		if (dwSize < sizeof(uint8_t)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		*(uint8_t*)Value = pTagsDescTb->cnt;
	}
	//----------------------------------------------------------------
	// RecordCount(FIFOތŗLè)
	//----------------------------------------------------------------
	else if ((pTagsDescTb->var.vt == EgVtFIFO) && _HashCompare(hashed_propname, "RecordCount"))	// v邩
	{
		if (dwSize < sizeof(uint16_t)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}

		*(uint16_t*)Value = pTagsDescTb->extData.fifo.record_count;
	}
	//----------------------------------------------------------------
	// Remain(FIFOތŗLè)
	//----------------------------------------------------------------
	else if ((pTagsDescTb->var.vt == EgVtFIFO) && _HashCompare(hashed_propname, "Remain"))	// v邩
	{
		if (dwSize < sizeof(uint16_t)) {
			return EDGE_RTCD_BUFFER_SIZE_INVALID;							// obt@TCYI[o[邽߃G[
		}
		if ((inResult = EgTagGetRemainFIFOByEntry(pTagsDescTb, (uint16_t*)Value)) != EDGE_SUCCESS) return inResult;
	}
	//----------------------------------------------------------------
	// other property
	//----------------------------------------------------------------
	else
	{
		return EDGE_PARAM_INVALID;											// ɂvs
	}

	return EDGE_SUCCESS;													// 
}
/*****************************************************************************
* FUNCTION:		EgTagGetProperty
* DESCRIPTION:
*   TagPropertyl擾
\*****************************************************************************/
int32_t EgTagGetProperty(const char *Name, const char *propName, void* Value, int32_t dwSize)
{
	bool isLinkOrg = false;			// N^ȌꍇɁAIWi^OQƂ邩ǂ
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*	pTagsDescTb = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);	// GgT
	if (pTagsDescTb == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (pTagsDescTb->isLink)												// N^Ȍꍇ́A擾vpeBɉĎQƐύX
	{
		if (_HashCompare(hashed_propname, "Value")							// Value擾̏ꍇAIWi^OQ
			|| _HashCompare(hashed_propname, "Entry"))						// Entry擾̏ꍇAIWi^OQ
		{
			isLinkOrg = true;	// IWi^Oւ̎QƂƂ
		}
	}

	if (isLinkOrg)
		return EgTagGetProperty((char *)(Name + LINKTAG_PRIFIX_LEN), propName, Value, dwSize);	// IWi^OQƂ邽߁A擪̌Œ蕶𖳎
	else
		return _EgTagGetProperty(pTagsDescTb, propName, Value, dwSize);		// (ʏ폈)GgŃvpeBQ
}
/*****************************************************************************
* FUNCTION:		EgTagGetPropertyByIndex
* DESCRIPTION:
*   TagPropertyl擾(Indexw)
\*****************************************************************************/
int32_t EgTagGetPropertyByIndex(EDGE_INDEX *index, const char *propName, void* Value, int32_t dwSize)
{
	bool isLinkOrg = false;			// N^ȌꍇɁAIWi^OQƂ邩ǂ
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc*	pTagsDescTb = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);	// GgT
	if (pTagsDescTb == NULL)
		return EDGE_TTABLE_NOT_EXIST_ERROR;									// GgȂs

	HASHCODE		hashed_propname = _Hash(propName);						// propNamẽnbVlƂ

	if (pTagsDescTb->isLink)												// N^Ȍꍇ́A擾vpeBɉĎQƐύX
	{
		if (_HashCompare(hashed_propname, "Value")							// Value擾̏ꍇAIWi^OQ
			|| _HashCompare(hashed_propname, "Entry")						// Entry擾̏ꍇAIWi^OQ
			|| _HashCompare(hashed_propname, "Count"))						// Count擾̏ꍇAIWi^OQ
		{
			isLinkOrg = true;	// IWi^Oւ̎QƂƂ
		}
	}

	if (isLinkOrg)
		return EgTagGetProperty((char *)(pTagsDescTb->chName + LINKTAG_PRIFIX_LEN), propName, Value, dwSize);	// IWi^OQƂ邽߁A擪̌Œ蕶𖳎
	else
		return _EgTagGetProperty(pTagsDescTb, propName, Value, dwSize);		// (ʏ폈)GgŃvpeBQ
}

/*****************************************************************************
* FUNCTION:		EgTagGetPropertyByEntry
* DESCRIPTION:
*   TagPropertyl擾(Entryw)
\*****************************************************************************/
int32_t EgTagGetPropertyByEntry(void* pEntry, const char *propName, void* Value, int32_t dwSize)
{
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc*	pTagsDescTb = (TagsDesc*)pEntry;

	if (pTagsDescTb->isLink)												// N^Ȍꍇ
	{
		// NOTE: EgTagGetProperty()Ŏ擾łEntry|C^̓IWi^Ow߁Aʏ͔ȂP[X
		return EDGE_PARAM_INVALID;											// N^OEntrywǂݍ݂̓G[Ƃ
	}

	return _EgTagGetProperty(pTagsDescTb, propName, Value, dwSize);			// (ʏ폈)GgŃvpeBQ
}

/*****************************************************************************
* FUNCTION:		EgTagGetCount
* DESCRIPTION:
*   ݂Tago^擾
\*****************************************************************************/
int32_t EgTagGetCount(uint32_t *pItemNum)
{
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pItemNum == NULL)
		return EDGE_PARAM_INVALID;											// p[^s

	*pItemNum = EgNamespaceGetCount(hTag);									// Gg擾

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgTagGetEnum
* DESCRIPTION:
*   Tag̃CfbNXꗗ擾
\*****************************************************************************/
int32_t EgTagGetEnum(EDGE_INDEX *pBuffer, uint32_t dwSize, uint32_t *pItemNum)
{
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (dwSize < EgNamespaceGetCount(hTag) * sizeof(NAMESPACE_INDEX))		// i[obt@TCY`FbN
	{
		return EDGE_TTABLE_VALUE_OVERFLOW;									// i[obt@TCY׎s
	}

	return EgNamespaceEnumIndex(hTag, (void*)pBuffer, dwSize, pItemNum);	// NamespaceCfbNXꗗ擾
}
/*****************************************************************************
* FUNCTION:		_EgTagSetDefaultValue [J֐
* DESCRIPTION:
*   ^OlZbg
\*****************************************************************************/
int32_t _EgTagSetDefaultValue(bool bAllFlag , uint16_t wGroup)
{
	int32_t rtn = 0;
	int32_t count = 0;
	SetDefaultValueDesc defDesc = { 0 };
	gm_Ack_TAG_DEFAULT_VALUE_SET_END = EG_FALSE;
	gm_Result_TAG_DEFAULT_VALUE_SET_END = EDGE_SUCCESS;

	PrintSysLog(EG_LOG_DBG, "Reqest set default value Tag -> EgBoot");

	RTCDHANDLE pHandle = { 0 };

	// 1:Read , 2:Write , 3:ReadWrite
	rtn = EgMailboxOpenSC("EgBoot", RTCD_WRITE, &pHandle);
	if (rtn != EDGE_SUCCESS) {
		PrintSysLog(EG_LOG_ERR, "EgMailboxOpenSC Error = [%d] [FUNC = %s]", rtn, __func__);
		return rtn;
	}
	PrintSysLog(EG_LOG_DBG, "EgMailboxOpenSC [%d] [FUNC = %s]", rtn, __func__);

	// EgBootփftHgl[h߂𑗐M
	// AllFlag̏ꍇ̓^[Qbg
	if (bAllFlag == true)
	{
		defDesc.byTarget = 0;
		defDesc.woGroup = 0;
	}
	else//AllFlagfalsȅꍇ̓^[Qbgw
	{
		defDesc.byTarget = 1;
		defDesc.woGroup = wGroup;
	}
	rtn = EgMailboxSend(&pHandle, ServiceRealName, EM_TAG_DEFAULT_VALUE_SET, (void*)&defDesc, (uint32_t)sizeof(SetDefaultValueDesc));
	if (rtn != EDGE_SUCCESS) {
		PrintSysLog(EG_LOG_ERR, "EgMailboxSend Error = [%d] [FUNC = %s]", rtn, __func__);
		EgMailboxClose(&pHandle);
		return rtn;
	}

	while (1) {	// M҂(30b)		
		if (count > 30) {	// ^CAEg
			PrintSysLog(EG_LOG_ERR, "Cannot set default value Tag. EgBoot is Time Out");
			rtn = EDGE_TTABLE_RESET_DEFAULT_VALUE_TIMEOUT;
			break;
		}
		if (gm_Ack_TAG_DEFAULT_VALUE_SET_END == EG_TRUE) {	// M
			rtn = gm_Result_TAG_DEFAULT_VALUE_SET_END;
			break;
		}
		count++;
		os_edge_sleep(1000);
	}
	EgMailboxClose(&pHandle);	// [{bNX̃N[Y

	return rtn;
}
/*****************************************************************************
* FUNCTION:		EgTagSetDefaultValueByGroup
* DESCRIPTION:
*   ^OlZbg
\*****************************************************************************/
int32_t EgTagSetDefaultValueByGroup(uint16_t wGroup)
{
	return _EgTagSetDefaultValue(false, wGroup);
}
/*****************************************************************************
* FUNCTION:		EgTagSetDefaultValue
* DESCRIPTION:
*   ^OlZbg
\*****************************************************************************/
int32_t EgTagSetDefaultValue()
{
	return _EgTagSetDefaultValue(true, 0);
}
