/*****************************************************************************
* egTagFIFO.c
*
*   RT-edge tag (Ring buffer memory)
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

/* ۾ŗL */
static bool fetch_config = false;		/* trueŁAȉ۾ŗLرނ擾ςł邱Ƃ */
static uint32_t fifo_lock_retry_count;	/* ۯsײs񐔏 */

/* Q */
extern int32_t _EgTagCreateSp(const char *Name, uint16_t Type, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink);
extern int32_t EgTagGetSharedMemoryAddress(TagsDesc *nsh, LPVOID *addr);

 /*****************************************************************************
 * FIFO\(FIFOشر̲Ұ)
 \*****************************************************************************/
struct FIFO {

	#if 0
		uint32_t sig;					/* ر(0xed, 0x9e, 0xF1, 0xF0) */
		#define FIFO_SIG				(0xF0F19EED)
		uint32_t ver;					/* FIFOްޮ(0x01) */
		#define FIFO_VER				(0x00000001)
	#endif

	struct {
		int32_t	record_size;		/* FIFOňںޒ */
		int32_t	record_count;		/* FIFOޯ̧̑ںސ */
									/* @memo FIFOޯ̧̑̈滲ނ͈ȉ */
									/*       sizeof(struct FIFO) + (record_size * record_count) */
	} param;

	int32_t is_locked;	/* ۯ!0(@memo FIFOԂɏW񂵂Ă߁Avarlockg킸ł) */
	int32_t remain;		/* (ںސ - ǂںސ)Bںސ𒴉߂ƵݔƂ݂Ȃ */
	int32_t wp;
	int32_t rp;

	/* ްر擪 */
	uint8_t data[0];
};

/*****************************************************************************
* FUNCTION:		EgTagFetchConfigFIFO
* DESCRIPTION:
*   FIFO^O ݒlp^ȌEXV
\*****************************************************************************/
int32_t EgTagFetchConfigFIFO(void)
{
	int32_t ret = 0;

	/* ײ */
	{
		ret = EgTagRead(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, &fifo_lock_retry_count, sizeof(fifo_lock_retry_count));
		if (ret != EDGE_SUCCESS) {
			/* ؂ȂB */
			fifo_lock_retry_count = EG_FIFO_MAX_RETRY_LOCK;
			EgTagCreateEx(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, EgVtUInt32, "", "FIFO tag lock retry count.");
			EgTagWrite(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, &fifo_lock_retry_count, sizeof(fifo_lock_retry_count));
		}
		else if (fifo_lock_retry_count == 0) {
			/* slBlŏ㏑ */
			fifo_lock_retry_count = EG_FIFO_MAX_RETRY_LOCK;
			EgTagWrite(EGSYSTAGNAME_TAGFIFO_RETRY_COUNT, &fifo_lock_retry_count, sizeof(fifo_lock_retry_count));
		}
	}

	fetch_config = true;
	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagLockFIFO
* DESCRIPTION:
*   FIFO^O bN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
static int32_t _EgTagLockFIFO(TagsDesc *nsh, struct FIFO *fifo)
{
	int32_t ret;
	
	/* ײ񐔏ނǂݍ */
	if (!fetch_config) EgTagFetchConfigFIFO();

	// bN
	ret = EDGE_TAGPTR_LOCK_TIMOUT;
	for (uint32_t i = 0; i < fifo_lock_retry_count; i++) {
		/* @memo ۯԂƍXV𓯎Ɏ{(ش߼݁E荞݂܂\Ȃ悤΍) */
		if (InterlockedExchange(&fifo->is_locked, 1) == 0) {
			// bN̂߁A[vI
			ret = EDGE_SUCCESS;
			break;
		}
		#ifdef __INTIME__
		{
			knRtSleep(1);
		}
		#else
		{
			os_edge_sleep(1);
		}
		#endif
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		_EgTagUnlockSegment
* DESCRIPTION:
*   FIFO^O AbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
static int32_t _EgTagUnlockFIFO(TagsDesc *nsh, struct FIFO *fifo)
{
	/* ۯ(PȂłǂAmɑXV`Ƃ̂) */
	InterlockedExchange(&fifo->is_locked, 0);

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagGetFIFOByName / _EgTagGetFIFOByIndex / _EgTagGetFIFOByEntry
* DESCRIPTION:
*   (I/F ʏ) ^O\ / FIFO\̂擾
*   ep[^̃`FbNAyъef[^QƂ̂߂̏s
\*****************************************************************************/
static int32_t _EgTagGetFIFO_main(TagsDesc *nsh, struct FIFO **fifo)
{
	int32_t ret = EDGE_SUCCESS;
	
	/* FIFOނ͋L؂Ƃē삵ĂȂ΂ȂȂ */
	if (nsh->SHM.InUse == 0) return EDGE_FIFO_TAG_ERROR;
	/* FIFOސp */
	if (nsh->var.vt != EgVtFIFO) return EDGE_TTABLE_TYPE_ERROR;

	/* L؂̱ڽnsh->var.pSegmentɾĂĂ炤 */
	/* łɁAϯ߂Kvłϯ߂{ */
	if ((ret = EgTagGetSharedMemoryAddress(nsh, fifo)) != EDGE_SUCCESS) return ret;
	
	return ret;
}
static int32_t _EgTagGetFIFOByEntry(void *pEntry, struct FIFO **fifo)
{
	HNAMESPACE hTag = EgTagGetHandle();						// TAG̖Oԃnh𓾂
	if (hTag == NULL) return EDGE_TTABLE_MEMORRY_ERROR;		// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL) return EDGE_PARAM_INVALID;			// NULL̓G[
	
	/* @memo AEntry擾łݸނԋp铮ƂȂĂ */
	/*       ̂߁Aݸނꍇُ͈Ɣf */
	if (((TagsDesc*)pEntry)->isLink) return EDGE_PARAM_INVALID;
	
	/* ܂ŐBFIFO̎擾 */
	return _EgTagGetFIFO_main((TagsDesc*)pEntry, fifo);
}
static int32_t _EgTagGetFIFOByName(const char *Name, TagsDesc **nsh, struct FIFO **fifo)
{
	HNAMESPACE hTag = EgTagGetHandle();								// TAG̖Oԃnh𓾂
	if (hTag == NULL) return EDGE_TTABLE_MEMORRY_ERROR;				// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0) return EDGE_PARAM_INVALID;				// 󕶎ENULL̓G[

	*nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);				// ^OT
	if (*nsh == NULL) return EDGE_TTABLE_NOEXISTT_TAGNAME;			// ݂s
	
	/* ݸނ̏ꍇ́Aݸނ𑀍ΏۂƂ */
	if ((*nsh)->isLink) {
		/* ݸނ̖ÓAw薼Ɋ܂܂̨ǂݔ΂ */
		return _EgTagGetFIFOByName(&Name[LINKTAG_PRIFIX_LEN], nsh, fifo);
	}
	
	/* ܂ŐBFIFO̎擾 */
	return _EgTagGetFIFO_main(*nsh, fifo);
}
static int32_t _EgTagGetFIFOByIndex(EDGE_INDEX *index, TagsDesc **nsh, struct FIFO **fifo)
{
	HNAMESPACE hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL) return EDGE_TTABLE_MEMORRY_ERROR;								// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL) return EDGE_PARAM_INVALID;									// NULL̓G[

	*nsh = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);	// ^OT
	if (*nsh == NULL) return EDGE_TTABLE_NOEXISTT_TAGNAME;							// ݂s

	/* ݸނ̏ꍇ́Aݸނ𑀍ΏۂƂ */
	if ((*nsh)->isLink){
		/* ݸނ̖ÓAw薼Ɋ܂܂̨ǂݔ΂ */
		return _EgTagGetFIFOByName(&(*nsh)->chName[LINKTAG_PRIFIX_LEN], nsh, fifo);
	}
	
	/* ܂ŐBFIFO̎擾 */
	return _EgTagGetFIFO_main(*nsh, fifo);
}

/*****************************************************************************
* FUNCTION:		EgTagCreateFIFO
* DESCRIPTION:
*   FIFO^O
\*****************************************************************************/
int32_t EgTagCreateFIFO(const char *Name, uint16_t RecordSize, uint16_t RecordCount, bool Reserved1_LetFalse, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	int32_t ret;
	uint32_t fifo_count;
	
	/* 쐬ނݸɂȂ(ݸނɂȂ肻ȏꍇ) */
	TagsDesc *nsh_link_to;

	/* FIFOشر֘A */
	struct FIFO *fifo = NULL;
	void *mem_handle; /* װ̓PɕKvȂ̂ */
	char fifo_cat_name[EG_SHM_MAX_OBJENAME + 1/* NULI[ */];

	/* L؎QƐ */
	/* @memo IɂSHM(L)̂ƂĐU镑킹B */
	/*       ɂASHMƋʂ̎dg݂𗘗pmap/unmap@\B */
	/*       ̑㏞ɂuFIFOނ̋Lށv쐬邱Ƃ͂łȂB */
	char src[sizeof(EG_SHM_KEYWORD) + EG_SHM_MAX_NODENAME + EG_SHM_MAX_PROCNAME + EG_SHM_MAX_OBJENAME + sizeof("0")/* @memo NULI[܂ł */ + (sizeof(EG_SHM_DELIMITER) * 4)];

	HNAMESPACE hTag = EgTagGetHandle();													// TAG̖Oԃnh𓾂
	if (hTag == NULL)							return EDGE_TTABLE_MEMORRY_ERROR;		// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	
	/*  */
	if (strlen(Name) == 0)						return EDGE_PARAM_INVALID;				// ^Ő͋Ȃ
	if (strlen(Name) > EG_MAX_TAGNAME)			return EDGE_RTCD_ARG_DATA_SIZE_ERROR;	// TCY`FbN
	if (strlen(Comment) > EG_MAX_TAGCOMMENT)	return EDGE_RTCD_ARG_DATA_SIZE_ERROR;	// TCY`FbN
	if (regNameSize <= EG_MAX_TAGNAME)			return EDGE_RTCD_ARG_DATA_SIZE_ERROR;	// TCY`FbN
	if (RecordSize == 0)						return EDGE_RTCD_ARG_DATA_SIZE_ERROR;	// TCY`FbN
	if (RecordCount == 0)						return EDGE_RTCD_ARG_DATA_SIZE_ERROR;	// TCY`FbN
	
	/* ݸނɂȂ肻 */
	if ((nsh_link_to = (TagsDesc*)EgNamespaceGetEntry(hTag, Name)) != NULL) {
		/* ZB쐬ݸނɂȂ */
		
		/* (ݸƓłKv) */
		if (nsh_link_to->var.size != RecordSize)					return EDGE_RTCD_ARG_DATA_SIZE_ERROR;
		if (nsh_link_to->extData.fifo.record_count != RecordCount)	return EDGE_RTCD_ARG_DATA_SIZE_ERROR;

		/* @memo 쐬鑤(ݸޑ)SHMɂȂȂėǂ */
		src[0] = '\0';

	} else {
		/* 쐬ނ͒ʏ({)ƂȂ */

		/* ݽݽ(̲ݽݽԍƂȂ)擾 */
		while ((ret = EgTagRead(EGSYSTAGNAME_TAGFIFO_NUM_COUNT, &fifo_count, sizeof(fifo_count))) != EDGE_SUCCESS) {
			/* ؂ȂB */
			if ((ret = EgTagCreateEx(EGSYSTAGNAME_TAGFIFO_NUM_COUNT, EgVtUInt32, "", "FIFO tag count.")) != EDGE_SUCCESS) return ret;
			fifo_count = 0;
			if ((ret = EgTagWrite(EGSYSTAGNAME_TAGFIFO_NUM_COUNT, &fifo_count, sizeof(fifo_count))) != EDGE_SUCCESS) return ret;
		}
	
		/* FIFOތŗLؿ쐬 */
		{
			snprintf(fifo_cat_name, sizeof(fifo_cat_name), "EGTAGFIFO0%02X", fifo_count);
			if ((fifo = (struct FIFO *)os_edge_createMemory(fifo_cat_name, sizeof(*fifo) + (RecordSize * RecordCount), &mem_handle)) == NULL) return EDGE_RTCD_ALLOCATE_ERROR;

			/* FIFOر̏ */
			fifo->param.record_size = RecordSize;
			fifo->param.record_count = RecordCount;
			InterlockedExchange(&fifo->remain, 0);
			fifo->rp = 0;
			fifo->wp = 0;
			fifo->is_locked = 0;

			/* @memo ްر̏͏ȗ(Ӑ}Iɱ݂NȂeȂ) */

			/* ސɂ߰ */
			{
				/* @memo ǂpɂɌĂԏᖳA₱ */
				char node[EG_SHM_MAX_NODENAME + 1];
				if ((ret = edge_getNodeName(node, sizeof(node))) != EDGE_SUCCESS) goto err_finalyze;

				/* A */
				snprintf(src, sizeof(src), EG_SHM_KEY_DELI "%s"/* ɰ */ EG_SHM_DELIMITER ""/* ۾ */ EG_SHM_DELIMITER "%s"/*  */ EG_SHM_DELIMITER "0"/* ̾ */, node, fifo_cat_name);
			}
		}

	}

	/* ޖ{̐ */
	if ((ret = _EgTagCreateSp(Name, EgVtFIFO, src, Comment, regName, regNameSize, isLink)) != EDGE_SUCCESS) goto err_finalyze;

	if (*isLink) {
		/* ݸނɂȂ */
		if (nsh_link_to == NULL) {
			/* 쐬Ɋ荞܂ꂽ({Ă͂ȂȂ) */
			/* ݸƂv蔲Ă邽߁Aۏ؂łȂ */
			ret = EDGE_TTABLE_NAME_EXIST_ERROR;
			goto err_finalyze;
		}

	} else
	/* ޏ */
	/* @warning FIFOތŗLر̏ςޑOɱƁAO̒lgp\ */
	/*          cƂAOԂ_AllocEntry() ` ޏ܂ł̊ԁAްނȂȂ? */

	/* @memo (xMD5̐ErȂႢŁAɰްފԂɐLт)B_EgTagCreateSpTagsDescԂ悤悤 */
	{
		TagsDesc *nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);
		if (nsh == NULL) { ret = EDGE_TTABLE_NOEXISTT_TAGNAME; goto err_finalyze; }
		
		if (!nsh->SHM.InUse) {
			/* L؂ɂȂĂȂ̂͂ */
			ret = EDGE_FIFO_TAG_ERROR; goto err_finalyze;
		}

		nsh->var.size = RecordSize; /* wp/rpXV𔺂ȂRead/Writeł́Arp/wpʒuںޓe̓ǂݏł */
		nsh->extData.fifo.record_count = RecordCount;
		nsh->extData.fifo.block_overrun = Reserved1_LetFalse;	/* @todo ̋@\KvɂȂ(APIǉςނ悤\񂵂Ă) */

		/* ݽݽXV(̲ݽݽԍƂȂ) */
		fifo_count++;
		EgTagWrite(EGSYSTAGNAME_TAGFIFO_NUM_COUNT, &fifo_count, sizeof(fifo_count));
	}

	return EDGE_SUCCESS;

err_finalyze:
	if (fifo) os_edge_freeMemory(fifo_cat_name, fifo, mem_handle);
	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgTagReadFIFO
* DESCRIPTION:
*   FIFO^O1R[h擾
*   AAFIFOǂݍ݈ʒuisȂ(Peekǂݏo)B
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagReadFIFO(TagsDesc *nsh, void* byteArray, uint16_t wSize)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFO_main(nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;
	
	/* ނ̒ǉ */
	if (wSize > fifo->param.record_size) return EDGE_TTABLE_VALUE_OVERFLOW;
	
	/* FIFOۯ */
	if ((ret = _EgTagLockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	/* ް擾 */
	memcpy(byteArray, &fifo->data[fifo->rp * fifo->param.record_size], wSize);

	/* ۯ */
	if ((ret = _EgTagUnlockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagWriteFIFO
* DESCRIPTION:
*   FIFO^O1R[ho͂
*   AAFIFO݈ʒuisȂB
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagWriteFIFO(TagsDesc *nsh, void* byteArray, uint16_t wSize)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFO_main(nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* ނ̒ǉ */
	if (wSize > fifo->param.record_size) return EDGE_TTABLE_VALUE_OVERFLOW;
	
	/* FIFOۯ */
	if ((ret = _EgTagLockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	/* ްXV */
	memcpy(&fifo->data[fifo->wp * fifo->param.record_size], byteArray, wSize);

	/* @memo ضތ̏ݶis͂Ȃ */
	/*       FIFOނł̏ݓeḿA݈ʒu̐isłčs */

	/* ۯ */
	if ((ret = _EgTagUnlockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgTagDequeueFIFO / EgTagDequeueFIFOByIndex / EgTagDequeueFIFOByEntry
* DESCRIPTION:
*   FIFO^O1R[h擾
*   byteArray == NULL || wSize == 0 ̏ꍇAǂݏoʒuXV(غ߰𔺂Ȃǂݎ̂ėp)
*   wRemainɂ́AĂяoFIFOޯ̧cԂBNULLwŎ擾Ȃ
*
*   @warning FIFOޯ̧̱݂j~Ȃ(ݔ́Asް擾EDGE_FIFO_UNDERRUNԂ)
*            ݽj~΁AĂяowRemainĎĶްނ邱ƁB
\*****************************************************************************/
static int32_t _EgTagDequeueFIFO_main(TagsDesc *nsh, struct FIFO *fifo, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	int32_t ret = EDGE_SUCCESS;
	bool is_udr = false;
	int32_t remain;

	/* ُneۯ̑O */
	if (wSize > fifo->param.record_size) return EDGE_TTABLE_VALUE_OVERFLOW;

	/* FIFOۯ */
	if ((ret = _EgTagLockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	{
		if (byteArray != NULL && wSize != 0) {
			/* ް擾 */
			memcpy(byteArray, &fifo->data[fifo->rp * fifo->param.record_size], wSize);
		}

		/* ǂݍ݈ʒuEcXV */
		/* @memo remainۯɎ擾鹰邽߁AЯɍXV */
		if (++fifo->rp >= fifo->param.record_count) fifo->rp -= fifo->param.record_count;
		is_udr = ((remain = InterlockedDecrement(&fifo->remain)) < 0);

		/* ضތ̏ݶis */
		nsh->cnt++;
	}

	/* ۯ */
	if ((ret = _EgTagUnlockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	if (wRemain != NULL) *wRemain = remain;

	return is_udr ? EDGE_FIFO_OVERRUN : EDGE_SUCCESS;
}
int32_t EgTagDequeueFIFOByEntry(void *pEntry, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByEntry(pEntry, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagDequeueFIFO_main((TagsDesc *)pEntry, fifo, byteArray, wSize, wRemain);
}
int32_t EgTagDequeueFIFOByIndex(EDGE_INDEX *index, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByIndex(index, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagDequeueFIFO_main(nsh, fifo, byteArray, wSize, wRemain);
}
int32_t EgTagDequeueFIFO(const char *Name, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByName(Name, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagDequeueFIFO_main(nsh, fifo, byteArray, wSize, wRemain);
}

/*****************************************************************************
* FUNCTION:		EgTagEnqueueFIFO / EgTagEnqueueFIFOByIndex / EgTagEnqueueFIFOByEntry
* DESCRIPTION:
*   FIFO^O1R[ho͂
*   byteArray == NULL || wSize == 0 ̏ꍇA݈ʒuXV(ʒuXVlm肷p)
*   wRemainɂ́AĂяoFIFOޯ̧cԂBNULLwŎ擾Ȃ
*   
*   @warning FIFOޯ̵̧݂j~Ȃ(ݔ́AÂްj󂵂EDGE_FIFO_OVERRUNԂ)
*            jj~΁AĂяowRemainĎĶްނ邱ƁB
\*****************************************************************************/
static int32_t _EgTagEnqueueFIFO_main(TagsDesc *nsh, struct FIFO *fifo, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	int32_t ret = EDGE_SUCCESS;
	bool is_ovr = false;
	int32_t remain;

	/* ُneۯ̑O */
	if (wSize > fifo->param.record_size) return EDGE_TTABLE_VALUE_OVERFLOW;
	if (nsh->force)	return EDGE_SUCCESS; /* ݋֎~ނւ݂̏́AۯŐI */

	/* FIFOۯ */
	if ((ret = _EgTagLockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;
	
	{
		if (byteArray != NULL && wSize != 0) {
			/* ްXV */
			memcpy(&fifo->data[fifo->wp * fifo->param.record_size], byteArray, wSize);
		}

		/* ݈ʒuEcXV */
		/* @memo remainۯɎ擾鹰邽߁AЯɍXV */
		if (++fifo->wp >= fifo->param.record_count) fifo->wp -= fifo->param.record_count;
		is_ovr = ((remain = InterlockedIncrement(&fifo->remain)) > fifo->param.record_count);

	}
	
	/* ۯ */
	if ((ret = _EgTagUnlockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	if (wRemain != NULL) *wRemain = remain;
	
	return is_ovr ? EDGE_FIFO_OVERRUN : EDGE_SUCCESS;
}
int32_t EgTagEnqueueFIFOByEntry(void *pEntry, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByEntry(pEntry, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagEnqueueFIFO_main((TagsDesc *)pEntry, fifo, byteArray, wSize, wRemain);
}
int32_t EgTagEnqueueFIFOByIndex(EDGE_INDEX *index, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByIndex(index, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagEnqueueFIFO_main(nsh, fifo, byteArray, wSize, wRemain);
}
int32_t EgTagEnqueueFIFO(const char *Name, void* byteArray, uint16_t wSize, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByName(Name, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagEnqueueFIFO_main(nsh, fifo, byteArray, wSize, wRemain);
}

/*****************************************************************************
* FUNCTION:		EgTagGetRemainFIFO / EgTagGetRemainFIFOByIndex / EgTagGetRemainFIFOByEntry
* DESCRIPTION:
*   FIFO^ÕR[hc擾
*   wRemainɂ́AĂяoFIFOޯ̧cԂB
\*****************************************************************************/
static int32_t _EgTagGetRemainFIFO_main(TagsDesc *nsh, struct FIFO *fifo, uint16_t *wRemain)
{
	/* @memo GetRemainłNULLwsƂ(ӖȂ̂) */
	if (wRemain == NULL) return EDGE_PARAM_INVALID;
	*wRemain = fifo->remain;

	return EDGE_SUCCESS;
}
int32_t EgTagGetRemainFIFOByEntry(void *pEntry, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByEntry(pEntry, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagGetRemainFIFO_main((TagsDesc *)pEntry, fifo, wRemain);
}
int32_t EgTagGetRemainFIFOByIndex(EDGE_INDEX *index, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByIndex(index, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagGetRemainFIFO_main(nsh, fifo, wRemain);
}
int32_t EgTagGetRemainFIFO(const char *Name, uint16_t *wRemain)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByName(Name, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagGetRemainFIFO_main(nsh, fifo, wRemain);
}

/*****************************************************************************
* FUNCTION:		EgTagClearFIFO / EgTagClearFIFOByIndex / EgTagClearFIFOByEntry
* DESCRIPTION:
*   FIFO^ȎSNA
\*****************************************************************************/
static int32_t _EgTagClearFIFO_main(TagsDesc *nsh, struct FIFO *fifo)
{
	int32_t ret = EDGE_SUCCESS;

	/* FIFOۯ */
	if ((ret = _EgTagLockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	{
		/* ܰر ؾ */
		/* @memo remainۯɎ擾鹰邽߁AЯɍXV */
		InterlockedExchange(&fifo->remain, 0);
		fifo->rp = 0;
		fifo->wp = 0;
	}

	/* ۯ */
	if ((ret = _EgTagUnlockFIFO(nsh, fifo)) != EDGE_SUCCESS) return ret;

	return EDGE_SUCCESS;
}
int32_t EgTagClearFIFOByEntry(void *pEntry)
{
	/* FIFO擾(ʏEʴװ) */
	struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByEntry(pEntry, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagClearFIFO_main((TagsDesc *)pEntry, fifo);
}
int32_t EgTagClearFIFOByIndex(EDGE_INDEX *index)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByIndex(index, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagClearFIFO_main(nsh, fifo);
}
int32_t EgTagClearFIFO(const char *Name)
{
	/* FIFO擾(ʏEʴװ) */
	TagsDesc *nsh; struct FIFO *fifo;
	int32_t ret = _EgTagGetFIFOByName(Name, &nsh, &fifo);
	if (ret != EDGE_SUCCESS) return ret;

	/* {̂ */
	return _EgTagClearFIFO_main(nsh, fifo);
}

#if 0
/* SHM̕unmapۂ̂ŁAU */
/*****************************************************************************
* FUNCTION:		EgTagMapFIFO / EgTagMapFIFOByIndex / EgTagMapFIFOByEntry
* DESCRIPTION:
*   FIFO^O̎蓮}bsO
*   @memo Read/WriteɎ}bsO邽߁Aʏ͎蓮ssv
\*****************************************************************************/
int32_t EgTagMapFIFOByEntry(void *pEntry)
{
	/* @todo  */
}
int32_t EgTagMapFIFOByIndex(EDGE_INDEX *index)
{
	/* @todo  */
}
int32_t EgTagMapFIFO(const char *Name)
{
	/* @todo  */
}

/*****************************************************************************
* FUNCTION:		EgTagUnmapFIFO / EgTagUnmapFIFOByIndex / EgTagUnmapFIFOByEntry
* DESCRIPTION:
*   FIFO^ÕA}bsO
*   \[X̉KvȏʂŎgBʏ͌Ăяosv
\*****************************************************************************/
int32_t EgTagUnmapFIFOByEntry(void *pEntry)
{
	/* @todo  */
}
int32_t EgTagUnmapFIFOByIndex(EDGE_INDEX *index)
{
	/* @todo  */
}
int32_t EgTagUnmapFIFO(const char *Name)
{
	/* @todo  */
}
#endif
