////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egTagPtr.c
*
*   RT-edge tag pointer
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
static HTAGPTR		hHeapKeep;				// ^O|C^pq[v̈nh

extern int32_t _EgTagCreateSp(const char *Name, uint16_t Type, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink);

/*****************************************************************************
* FUNCTION:		EgTagLookupSegmentHeap
* DESCRIPTION:
*   ()^O|C^pq[v̈bNAbv
\*****************************************************************************/
HTAGPTR EgTagLookupSegmentHeap()
{
	void *memory = os_edge_lookup(EGTAGPTR_NAME);
	return (HTAGPTR)os_edge_map(memory);
}
/*****************************************************************************
* FUNCTION:		EgTagGetHandleSegmentHeap
* DESCRIPTION:
*   ()^O|C^pq[v̈nh𓾂
\*****************************************************************************/
HTAGPTR EgTagGetHandleSegmentHeap(void)
{
	int32_t ret = EDGE_SUCCESS;

	if (hHeapKeep != NULL)								// ^O|C^pq[v̈nh
		return hHeapKeep;								// Ɏ擾ςȂI

	hHeapKeep = EgTagLookupSegmentHeap();
	if (hHeapKeep != NULL)
		return hHeapKeep;								// ČI

	return NULL;										// q[v̈𐶐łɎs
}
/*****************************************************************************
* FUNCTION:		EgTagConfigSegmentTag
* DESCRIPTION:
*   ()^O|C^Ǘ^Oo^
\*****************************************************************************/
uint32_t EgTagConfigSegmentTag(EDGESYSTEMCONFIG *egSysCfg)
{
	uint32_t		ret = 0;
	uint32_t		val = 0;

	//--------------------------------------------------------------------
	// ^Oo^F^O|C^ő吔
	//--------------------------------------------------------------------
	// ^O̐
	ret = EgTagCreate(EGSYSTAGNAME_TAGPTRNUM_MAX, EgVtUInt32, 4, "", "Maximum number of Tag pointer.");		//EDGESYSTEM.TAGPTRNUM.MAX
	if (ret == 0) {											// 
		// ^Ȍ
		ret = EgTagWrite(EGSYSTAGNAME_TAGPTRNUM_MAX, &egSysCfg->MaxTagPtrNum, sizeof(uint32_t));
	}
	else if (ret != EDGE_TTABLE_ISEXIST_TAGNAME) {			// ɓo^ς
		ret = 0;
	}
	// o^ʔ ... s͏I
	if (ret != 0) { return ret; }

	//--------------------------------------------------------------------
	// ^Oo^F^O|C^o^
	//--------------------------------------------------------------------
	// ^O̐
	ret = EgTagCreate(EGSYSTAGNAME_TAGPTRNUM_COUNT, EgVtUInt32, 4, "", "Config count of Tag pointer.");		//EDGESYSTEM.TAGPTRNUM.COUNT
	if (ret == 0) {											// 
		// ^Ȍ
		ret = EgTagWrite(EGSYSTAGNAME_TAGPTRNUM_COUNT, &val, sizeof(uint32_t));
	}
	else if (ret != EDGE_TTABLE_ISEXIST_TAGNAME) {			// ɓo^ς݂͐Ƃ
		ret = 0;
	}
	// o^ʔ ... s͏I
	if (ret != 0) { return ret; }

	//--------------------------------------------------------------------
	// ^Oo^F^O|C^Ńf[^TCY
	//--------------------------------------------------------------------
	// ^O̐
	ret = EgTagCreate(EGSYSTAGNAME_TAGPTRSIZE_MAX, EgVtUInt32, 4, "", "Maximum size of Tag pointer.");		//EDGESYSTEM.TAGPTRSIZE.MAX
	if (ret == 0) {											// 
		// ^Ȍ
		ret = EgTagWrite(EGSYSTAGNAME_TAGPTRSIZE_MAX, &egSysCfg->MaxTagPtrSize, sizeof(uint32_t));
	}
	else if (ret != EDGE_TTABLE_ISEXIST_TAGNAME) {			// ɓo^ς݂͐Ƃ
		ret = 0;
	}
	// o^ʔ ... s͏I
	if (ret != 0) { return ret; }

	//--------------------------------------------------------------------
	// ^Oo^F^O|C^f[^gp
	//--------------------------------------------------------------------
	// ^O̐
	ret = EgTagCreate(EGSYSTAGNAME_TAGPTRSIZE_USE, EgVtUInt32, 4, "", "Usage size of Tag pointer.");		//EDGESYSTEM.TAGPTRSIZE.USE
	if (ret == 0) {											// 
		// ^Ȍ
		ret = EgTagWrite(EGSYSTAGNAME_TAGPTRSIZE_USE, &val, sizeof(uint32_t));
	}
	else if (ret != EDGE_TTABLE_ISEXIST_TAGNAME) {			// ɓo^ς݂͐Ƃ
		ret = 0;
	}
	// o^ʔ ... s͏I
	if (ret != 0) { return ret; }

	//--------------------------------------------------------------------
	// ^Oo^F^O|C^bN݂
	//--------------------------------------------------------------------
	// ^O̐
	ret = EgTagCreate(EGSYSTAGNAME_TAGPTRRETRY_COUNT, EgVtUInt32, 4, "", "Tag pointer lock retry count.");		//EDGESYSTEM.TAGPTRRETRY.COUNT
	if (ret == 0) {											// 
		// ^Ȍ
		ret = EgTagWrite(EGSYSTAGNAME_TAGPTRRETRY_COUNT, &egSysCfg->MaxTagPtrRetry, sizeof(uint32_t));
	}
	else if (ret != EDGE_TTABLE_ISEXIST_TAGNAME) {			// ɓo^ς݂͐Ƃ
		ret = 0;
	}
	// o^ʔ ... s͏I
	if (ret != 0) { return ret; }

	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgTagLockSegment
* DESCRIPTION:
*   ^O|C^(L)bN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t EgTagLockSegment(TagsDesc *nsh)
{
	int32_t ret;

	// gC񐔎擾
	uint32_t	uiRetry;
	// ^O̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_TAGPTRRETRY_COUNT, &uiRetry, sizeof(uiRetry));
	if (ret != EDGE_SUCCESS) { return ret; }									// ǂݍ݃G[

	// bN
	ret = EDGE_TAGPTR_LOCK_TIMOUT;
	for (uint32_t i = 0; i < uiRetry; i++) {
		if (nsh->var.lock.current == 0) {
			nsh->var.lock.current = 1;					// bNɍXV
			ret = EDGE_SUCCESS;						
			break;										// bN̂߁A[vI
		}
#ifdef __INTIME__
		knRtSleep(1);
#else
		os_edge_sleep(1);
#endif
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		_EgTagUnlockSegment
* DESCRIPTION:
*   ^O|C^(L)AbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t EgTagUnlockSegment(TagsDesc *nsh)
{
	int32_t ret = EDGE_SUCCESS;

	nsh->var.lock.current = 0;						// AbN

	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagJudgeSegmentType
* DESCRIPTION:
*   ^O|C^p^O菈
\*****************************************************************************/
bool EgTagJudgeSegmentType(uint16_t usType)
{
	bool boRet;

	// ^O^Cvŕ
	switch (usType)
	{
	case EgVtString:
	case EgVtSegment:
		boRet = true;		// ^O|C^p^Oł
		break;
	default:
		boRet = false;		// ^O|C^p^OłȂ
		break;
	}

	return boRet;
}

/*****************************************************************************
* FUNCTION:		EgTagGetSegmentAddress
* DESCRIPTION:
*   ^O|C^pZOgAhX擾
\*****************************************************************************/
int32_t EgTagGetSegmentAddress(TagsDesc *nsh)
{
	//--------------------------------------------------------------------
	// q[v̈̐ݒ
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();							// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;						// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	uint8_t *byHeap = (uint8_t*)hHeap;						// oCgzɃLXg
	nsh->var.pSegment = (uint64_t)&byHeap[nsh->var.ulVal];			// AhX̐ݒ

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgTagCreateSegmentHeap
* DESCRIPTION:
*   ^O|C^pq[v̈搶
\*****************************************************************************/
HTAGPTR EgTagCreateSegmentHeap(const char *Name, EDGESYSTEMCONFIG *egSysCfg, uint32_t *result)
{
	uint32_t		dwSize;
	void*			hMem = NULL;
	HTAGPTR 		pMem = NULL;

	*result = 0;

	dwSize = ROUNDUP_4KB(egSysCfg->MaxTagPtrSize);
	//--------------------------------------------------------------------
	//e[u쐬E}bv
	//--------------------------------------------------------------------
	pMem = os_edge_createMemory(Name, dwSize, &hMem);
	if (pMem == NULL) {
		*result = EDGE_TAGPTR_CREATE_ERROR;									// ^O|C^pq[v̈̐łȂ
		goto failed;
	}

	//--------------------------------------------------------------------
	// e[u
	//--------------------------------------------------------------------
	memset(pMem, 0, dwSize);													// 

	//--------------------------------------------------------------------
	// Ǘ^Oo^
	//--------------------------------------------------------------------
	*result = EgTagConfigSegmentTag(egSysCfg);


	return (HTAGPTR)pMem;														// nhԂ

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
failed:
	os_edge_freeMemory(Name, pMem, hMem);
	return (HTAGPTR)NULL;													// s
}

/*****************************************************************************
* FUNCTION:		EgTagInitSegment
* DESCRIPTION:
*   ^O|C^
\*****************************************************************************/
int32_t EgTagInitSegment()
{
	int32_t ret = EDGE_SUCCESS;
	if (hHeapKeep != NULL)									// ^O|C^pq[v̈nh
		return EDGE_TAGPTR_EXIST_ERROR;						// ς݂̂߃G[ԋp

	hHeapKeep = EgTagLookupSegmentHeap();					// ^O|C^pq[v̈nh
	if (hHeapKeep != NULL)									// ^O|C^pq[v̈nh
		return EDGE_TAGPTR_EXIST_ERROR;						// ς݂̂߃G[ԋp

	if (g_H_egSysCfg == NULL)								// VXeݒ񂪑݂邩H
		return EDGE_TTABLE_SYSTEM_CONFIG_NULL;				// ݂Ȃꍇُ͈ȂߏI

	// ^O|C^pq[v̈̐
	hHeapKeep = EgTagCreateSegmentHeap(EGTAGPTR_NAME, (EDGESYSTEMCONFIG*)g_H_egSysCfg, &ret);
	if (hHeapKeep = NULL) {
		return ret;
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgTagCheckSegmentParam
* DESCRIPTION:
*   p[^`FbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagCheckSegmentParam(TagsDesc *nsh, uint16_t wOffset, void* pBuffer, uint16_t wSize)
{

	// ItZbg̃`FbN
	if (wOffset >= nsh->var.size) {
		return EDGE_TAGPTR_OFFSET_OVERFLOW;					// ItZbg͈͊O
	}

	// obt@̃`FbN
	if (pBuffer == NULL) {
		return EDGE_TAGPTR_BUFFER_NULL;						// obt@NULL
	}

	// TCỸ`FbN
	if (wSize == 0) {
		return EDGE_TAGPTR_SIZE_ZERO;						// TCY0w肳ꂽ
	}
	if (wSize > nsh->var.size) {
		return EDGE_TAGPTR_SIZE_OVERFLOW;					// TCY𒴂鎸s
	}
	if ((wOffset + wSize) > nsh->var.size) {
		return EDGE_TAGPTR_SIZE_OVERFLOW;					// TCY𒴂鎸s
	}

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagReadSegmentByEntry
* DESCRIPTION:
*   ^O|C^(L)̒lǂݍ
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagReadSegmentByEntry(TagsDesc *nsh, uint16_t wOffset, void* byteArray, uint16_t wSize)
{
	int32_t ret;

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (nsh->var.vt != EgVtSegment) {
		return EDGE_TAGPTR_TYPE_UNMATCH;					// TypeoCgzłȂ
	}
	ret = _EgTagCheckSegmentParam(nsh, wOffset, byteArray, wSize);
	if (ret != EDGE_SUCCESS) {
		return ret;											// p[^G[
	}

	//--------------------------------------------------------------------
	// q[v̈̐ݒ
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();							// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;						// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	uint8_t *byHeap = (uint8_t*)hHeap;						// oCgzɃLXg
	uint32_t dwPos = nsh->var.ulVal + wOffset;				// ǂݍ݈ʒu̐ݒ

	// bN
	ret = EgTagLockSegment(nsh);
	if (ret != EDGE_SUCCESS) {
		return ret;											// bNs
	}

	// q[v̈悩lǂݍ
	memcpy_s(byteArray, wSize, &byHeap[dwPos], wSize);

	// AbN
	EgTagUnlockSegment(nsh);

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagReadSegment
* DESCRIPTION:
*   ^O|C^(L)̒lǂݍ
\*****************************************************************************/
int32_t EgTagReadSegment(const char *Name, uint16_t wOffset, void* byteArray, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagReadSegment()R[
		ret = EgTagReadSegment((char*)(Name + LINKTAG_PRIFIX_LEN), wOffset, byteArray, wSize);
	}
	else {
		ret = _EgTagReadSegmentByEntry(nsh, wOffset, byteArray, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagReadSegmentByIndex
* DESCRIPTION:
*   ^O|C^(L)̒lǂݍ (INDEXw)
\*****************************************************************************/
int32_t EgTagReadSegmentByIndex(EDGE_INDEX *index, uint16_t wOffset, void* byteArray, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagReadSegment()R[
		ret = EgTagReadSegment((char*)(nsh->chName + LINKTAG_PRIFIX_LEN), wOffset, byteArray, wSize);
	}
	else {
		ret = _EgTagReadSegmentByEntry(nsh, wOffset, byteArray, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagReadSegmentByEntry
* DESCRIPTION:
*   Tag̒l擾 (Entryw)
\*****************************************************************************/
int32_t EgTagReadSegmentByEntry(void *pEntry, uint16_t wOffset, void* byteArray, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc* nsh = (TagsDesc*)pEntry;

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagReadSegment()R[
		return EDGE_PARAM_INVALID;											// N^OEntrywǂݍ݂̓G[Ƃ
	}
	else {
		ret = _EgTagReadSegmentByEntry(nsh, wOffset, byteArray, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		_EgTagWriteSegmentByEntry
* DESCRIPTION:
*   ^O|C^(L)̒l
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagWriteSegmentByEntry(TagsDesc *nsh, uint16_t wOffset, void *pBuffer, uint16_t wSize)
{
	int32_t ret;
	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (nsh->var.vt != EgVtSegment) {
		return EDGE_TAGPTR_TYPE_UNMATCH;					// TypeoCgzłȂ
	}
	ret = _EgTagCheckSegmentParam(nsh, wOffset, pBuffer, wSize);
	if (ret != EDGE_SUCCESS) {
		return ret;											// p[^G[
	}

	if (nsh->force)											// tO͏܂ɐI
		return EDGE_SUCCESS;

	//--------------------------------------------------------------------
	// q[v̈̐ݒ
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();							// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;						// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	uint8_t *byHeap = (uint8_t*)hHeap;						// oCgzɃLXg
	uint32_t dwPos = nsh->var.ulVal + wOffset;				// ݈ʒu̐ݒ

	// bN
	ret = EgTagLockSegment(nsh);
	if (ret != EDGE_SUCCESS) {
		return ret;											// bNs
	}

	// q[v̈ɒl
	memcpy_s(&byHeap[dwPos], wSize, pBuffer, wSize);

	nsh->cnt++;												// lXVJE^(g͌Ȃ)

	// AbN
	EgTagUnlockSegment(nsh);

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteSegment
* DESCRIPTION:
*   ^O|C^(L)̒l
\*****************************************************************************/
int32_t EgTagWriteSegment(const char *Name, uint16_t wOffset, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagWriteSegment()R[
		ret = EgTagWriteSegment((char*)(Name + LINKTAG_PRIFIX_LEN), wOffset, pBuffer, wSize);
	}
	else {
		ret = _EgTagWriteSegmentByEntry(nsh, wOffset, pBuffer, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteSegmentByIndex
* DESCRIPTION:
*   ^O|C^(L)̒l (INDEXw)
\*****************************************************************************/
int32_t EgTagWriteSegmentByIndex(EDGE_INDEX *index, uint16_t wOffset, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (index == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntryByIndex(hTag, (LPNAMESPACE_INDEX)index);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagWriteSegment()R[
		ret = EgTagWriteSegment((char*)(nsh->chName + LINKTAG_PRIFIX_LEN), wOffset, pBuffer, wSize);
	}
	else {
		ret = _EgTagWriteSegmentByEntry(nsh, wOffset, pBuffer, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteSegmentByEntry
* DESCRIPTION:
*   Tagɒlo^ (Entryw)
\*****************************************************************************/
int32_t EgTagWriteSegmentByEntry(void *pEntry, uint16_t wOffset, void *pBuffer, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (pEntry == NULL)
		return EDGE_PARAM_INVALID;											// NULL̓G[

	TagsDesc* nsh = (TagsDesc*)pEntry;

	// N^O
	if (nsh->isLink) {
		// NOTE: EgTagGetProperty()Ŏ擾łEntry|C^̓IWi^Ow߁Aʏ͔ȂP[X
		return EDGE_PARAM_INVALID;											// N^OւEntryw菑݂̓G[Ƃ
	}
	else {
		ret = _EgTagWriteSegmentByEntry(nsh, wOffset, pBuffer, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagIsAliveSegment
* DESCRIPTION:
*   ^O|C^(L)mF
\*****************************************************************************/
int32_t EgTagIsAliveSegment(const char *Name)
{
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s


	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgTagCreateSegmentOrg
* DESCRIPTION:
*   ^O|C^(L)FIWi^O
\*****************************************************************************/
int32_t EgTagCreateSegmentOrg(const char *Name, uint16_t Type, uint16_t Size, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	int32_t ret = EDGE_SUCCESS;

	//--------------------------------------------------------------------
	// 󂫓o^̔
	//--------------------------------------------------------------------
	uint32_t	uiNumMax;				// ^O|C^ő吔
	uint32_t	uiNumCnt;				// ^O|C^o^
	// ^O|C^ő吔̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_TAGPTRNUM_MAX, &uiNumMax, sizeof(uiNumMax));
	if (ret != EDGE_SUCCESS) { return ret; }									// ǂݍ݃G[
	// ^O|C^o^̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_TAGPTRNUM_COUNT, &uiNumCnt, sizeof(uiNumCnt));
	if (ret != EDGE_SUCCESS) { return ret; }									// ǂݍ݃G[
	// 󂫓o^̔	
	if (uiNumMax <= uiNumCnt) { return EDGE_TAGPTR_COUNT_OVER; }				// 󂫂Ȃߓo^łȂ

	//--------------------------------------------------------------------
	// 󂫗eʂ̔
	//--------------------------------------------------------------------
	uint32_t	uiSizeMax;				// ^O|C^Ńf[^TCY
	uint32_t	uiSizeUse;				// ^O|C^f[^gp
	// ^O|C^Ńf[^TCY̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_TAGPTRSIZE_MAX, &uiSizeMax, sizeof(uiSizeMax));
	if (ret != EDGE_SUCCESS) { return ret; }									// ǂݍ݃G[
	// ^O|C^f[^gpʂ̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_TAGPTRSIZE_USE, &uiSizeUse, sizeof(uiSizeUse));
	if (ret != EDGE_SUCCESS) { return ret; }									// ǂݍ݃G[
	// 󂫗eʂ̔
	if (uiSizeMax < (uiSizeUse + Size)) { return EDGE_TAGPTR_NO_FREE_SPACE; }	// 󂫗eʂȂ

	//--------------------------------------------------------------------
	// ^O̓o^
	//--------------------------------------------------------------------
	ret = _EgTagCreateSp(Name, Type, Source, Comment, regName, regNameSize, isLink);
	if (ret != EDGE_SUCCESS) { return ret; }									// o^G[

	//--------------------------------------------------------------------
	// TagDesc̎擾
	//--------------------------------------------------------------------
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	//--------------------------------------------------------------------
	// TagDesc̍XV
	//--------------------------------------------------------------------
	nsh->var.size = Size;												// TCY̍XV
	nsh->var.ulVal = uiSizeUse;											// ǂݍ/݈ʒuݒ

	//--------------------------------------------------------------------
	// ^O|C^o^̍XV
	//--------------------------------------------------------------------
	uiNumCnt++;
	EgTagWrite(EGSYSTAGNAME_TAGPTRNUM_COUNT, &uiNumCnt, sizeof(uiNumCnt));
	if (ret != EDGE_SUCCESS) { return ret; }									// ݃G[

	//--------------------------------------------------------------------
	// ^O|C^gpʂ̍XV
	//--------------------------------------------------------------------
	uiSizeUse += Size;
	// ^Ȍ
	EgTagWrite(EGSYSTAGNAME_TAGPTRSIZE_USE, &uiSizeUse, sizeof(uiSizeUse));
	if (ret != EDGE_SUCCESS) { return ret; }									// ݃G[

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagCreateSegmentLink
* DESCRIPTION:
*   ^O|C^(L)FN^O
\*****************************************************************************/
int32_t EgTagCreateSegmentLink(const char *Name, uint16_t Type, uint16_t Size, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	int32_t ret = EDGE_SUCCESS;

	//--------------------------------------------------------------------
	// IWi^OTagDesc̎擾
	//--------------------------------------------------------------------
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	TagsDesc*		nsh_org = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh_org == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	//--------------------------------------------------------------------
	// ɓo^ς݃^ÕTCYƍĂ邩𔻒肷
	//--------------------------------------------------------------------
	if (nsh_org->var.size != Size) { return EDGE_TAGPTR_SIZE_UNMATCH; }		// N^ÕTCYsv
	if (nsh_org->var.vt != Type) { return EDGE_TAGPTR_TYPE_UNMATCH; }		// N^Õ^Cvsv

	//--------------------------------------------------------------------
	// ^O̓o^
	//--------------------------------------------------------------------
	ret = _EgTagCreateSp(Name, Type, Source, Comment, regName, regNameSize, isLink);
	if (ret != EDGE_SUCCESS) { return ret; }									// o^G[

	//--------------------------------------------------------------------
	// N^OTagDesc̎擾
	//--------------------------------------------------------------------
	TagsDesc*		nsh_link = (TagsDesc*)EgNamespaceGetEntry(hTag, regName);		// ^OT
	if (nsh_link == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME; 								// ݂s

	//--------------------------------------------------------------------
	// N^OTagDesc̍XV
	//--------------------------------------------------------------------
	nsh_link->var.size = nsh_org->var.size;									// TCY̍XV
	nsh_link->var.ulVal = nsh_org->var.ulVal;								// ǂݍ/݈ʒuݒ

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagCreateSegment
* DESCRIPTION:
*   ^O|C^(L)
\*****************************************************************************/
int32_t EgTagCreateSegment(const char *Name, uint16_t Type, uint16_t Size, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink)
{
	int32_t ret = EDGE_SUCCESS;

	//--------------------------------------------------------------------
	// q[v̈nh̎擾
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();											// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;										// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (Size == 0) { return EDGE_TAGPTR_SIZE_ZERO; }							// TCY0w肳ꂽ
	if (!EgTagJudgeSegmentType(Type)) {
		return EDGE_TAGPTR_TYPE_UNMATCH;										// Type^O|C^łȂ
	}

	//--------------------------------------------------------------------
	// TagDesc̎擾
	//--------------------------------------------------------------------
	HNAMESPACE		hTag;
	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
	{
		// ^Oo^̂߁AIWi^OƂĐ
		ret = EgTagCreateSegmentOrg(Name, Type, Size, Source, Comment, regName, regNameSize, isLink);
	}
	else
	{
		// ^Oo^ς݂̂߁AN^OƂĐ
		ret = EgTagCreateSegmentLink(Name, Type, Size, Source, Comment, regName, regNameSize, isLink);
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		_EgTagReadStringByEntry
* DESCRIPTION:
*   ^O|C^(L)̕ǂݍ
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagReadStringByEntry(TagsDesc *nsh, char* pString, uint16_t wSize)
{
	int32_t ret;
	uint16_t	wLen;			// 

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (nsh->var.vt != EgVtString) {
		return EDGE_TAGPTR_TYPE_UNMATCH;					// TypełȂ
	}
	ret = _EgTagCheckSegmentParam(nsh, 0, pString, wSize);
	if (ret != EDGE_SUCCESS) {
		return ret;											// p[^G[
	}

	//--------------------------------------------------------------------
	// q[v̈̐ݒ
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();							// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;						// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	uint8_t *byHeap = (uint8_t*)hHeap;						// oCgzɃLXg
	uint32_t dwPos = nsh->var.ulVal;						// ǂݍ݈ʒu̐ݒ

	// bN
	ret = EgTagLockSegment(nsh);
	if (ret != EDGE_SUCCESS) {
		return ret;											// bNs
	}

	// q[v̈悩lǂݍ
	memcpy_s(&wLen, 2, &byHeap[dwPos], 2);					// 
	// TCY`FbN ... NULL܂߂Ď[ł邩𔻒肷
	if ((wLen + 1) > wSize) {
		ret = EDGE_TAGPTR_SIZE_OVERFLOW;					// TCY
	}
	else {
		// ̐
		memcpy_s(pString, wLen, &byHeap[dwPos+2], wLen);	// 擾
		pString[wLen] = 0;									// NULLt
	}

	// AbN
	EgTagUnlockSegment(nsh);

	return ret;
}
/*****************************************************************************
* FUNCTION:		EgTagReadString
* DESCRIPTION:
*   ^O|C^(L)̕ǂݍ
\*****************************************************************************/
int32_t EgTagReadString(const char *Name, char* pString, uint16_t wSize)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagReadSegment()R[
		ret = EgTagReadString((char*)(Name + LINKTAG_PRIFIX_LEN), pString, wSize);
	}
	else {
		ret = _EgTagReadStringByEntry(nsh, pString, wSize);
	}

	return ret;
}
/*****************************************************************************
* FUNCTION:		_EgTagWriteStringByEntry
* DESCRIPTION:
*   ^O|C^(L)̕񏑂
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t _EgTagWriteStringByEntry(TagsDesc *nsh, char *pString)
{
	int32_t ret;
	uint16_t	wLen;			// 
	uint16_t	wSize;			// q[v̈Ŏgp[TCY
	// [TCY̎Zo
	wLen = (uint16_t)strlen(pString);	
	wSize = 2 + wLen;			// [TCY = [] + []

	//--------------------------------------------------------------------
	// p[^`FbN
	//--------------------------------------------------------------------
	if (nsh->var.vt != EgVtString) {
		return EDGE_TAGPTR_TYPE_UNMATCH;					// TypełȂ
	}
	ret = _EgTagCheckSegmentParam(nsh, 0, pString, wSize);
	if (ret != EDGE_SUCCESS) {
		return ret;											// p[^G[
	}

	if (nsh->force)											// tO͏܂ɐI
		return EDGE_SUCCESS;

	//--------------------------------------------------------------------
	// q[v̈̐ݒ
	//--------------------------------------------------------------------
	HNAMESPACE		hHeap;
	hHeap = EgTagGetHandleSegmentHeap();							// q[v̈nh𓾂
	if (hHeap == NULL)
		return EDGE_TAGPTR_MAP_ERROR;						// q[v̈̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)
	uint8_t *byHeap = (uint8_t*)hHeap;						// oCgzɃLXg
	uint32_t dwPos = nsh->var.ulVal;						// ݈ʒu̐ݒ

	// bN
	ret = EgTagLockSegment(nsh);
	if (ret != EDGE_SUCCESS) {
		return ret;											// bNs
	}

	
	// q[v̈ɒl
	memcpy_s(&byHeap[dwPos], 2, &wLen, 2);					// 
	memcpy_s(&byHeap[dwPos+2], wLen, pString, wLen);		// 

	nsh->cnt++; //^O̍XVJE^

	// AbN
	EgTagUnlockSegment(nsh);

	return EDGE_SUCCESS;
}
/*****************************************************************************
* FUNCTION:		EgTagWriteString
* DESCRIPTION:
*   ^O|C^(L)̕񏑂
\*****************************************************************************/
int32_t EgTagWriteString(const char *Name, char *pString)
{
	HNAMESPACE		hTag;
	int32_t ret = 0;

	hTag = EgTagGetHandle();												// TAG̖Oԃnh𓾂
	if (hTag == NULL)
		return EDGE_TTABLE_MEMORRY_ERROR;									// L̍쐬łȂ(INtimȅꍇ̓J[lNĂȂ)

	if (strlen(Name) == 0)
		return EDGE_PARAM_INVALID;											// 󕶎ENULL̓G[

	TagsDesc*		nsh = (TagsDesc*)EgNamespaceGetEntry(hTag, Name);		// ^OT
	if (nsh == NULL)
		return EDGE_TTABLE_NOEXISTT_TAGNAME;								// ݂s

	// N^O
	if (nsh->isLink) {
		// N^ȌꍇA^O擪̌Œ蕶𖳎BIWi^OEgTagWriteString()R[
		ret = EgTagWriteString((char*)(Name + LINKTAG_PRIFIX_LEN), pString);
	}
	else {
		ret = _EgTagWriteStringByEntry(nsh, pString);
	}

	return ret;
}
