////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egTagPtr.c
*
*   RT-edge tag (Shared Memory)
*
\*****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"

//------------------------------------------------------------------------------
// `
//------------------------------------------------------------------------------
#define EG_SHM_ENTRY_MAX		256

extern int32_t _EgTagCreateSp(const char *Name, uint16_t Type, const char *Source, const char *Comment, char *regName, uint16_t regNameSize, uint16_t *isLink);

static SHM_LO_ENTRY		*s_pSHMLTB[EG_SHM_ENTRY_MAX];

//------------------------------------------------------------------------------
// FUNCTION   : _SHM_LoE_MakeHash
// DESCRIPTION: 
//   ()w蕶񂩂nbVl쐬
//------------------------------------------------------------------------------
static uint32_t _SHM_LoE_MakeHash(const char *Node, const char *Proc, const char *Obje)
{
	uint32_t	hash = 5381;				// 5381 ̓}WbNR[h(Œ)
	int32_t		c;

	while ((c = *Node++)) {					// NULLɎ܂ŃnbVZ
		hash = ((hash << 5) + hash) + c;	// 5rbgVtg(32{)́AvZƏՓ˗̒ጸɂÓl
	}
	while ((c = *Proc++)) {					// NULLɎ܂ŃnbVZ
		hash = ((hash << 5) + hash) + c;	// 5rbgVtg(32{)́AvZƏՓ˗̒ጸɂÓl
	}
	while ((c = *Obje++)) {					// NULLɎ܂ŃnbVZ
		hash = ((hash << 5) + hash) + c;	// 5rbgVtg(32{)́AvZƏՓ˗̒ጸɂÓl
	}

	return hash % EG_SHM_ENTRY_MAX;			// CfbNX̍őlŊA̗]̓CfbNX̖ƂȂ
}

//------------------------------------------------------------------------------
// FUNCTION   : _SHM_LoE_AddEntry
// DESCRIPTION: 
//   ()[JGg[e[uցASHMGg[ǉ
//------------------------------------------------------------------------------
SHM_LO_ENTRY* _SHM_LoE_AddEntry(SHM_DESC *pSHM)
{
	SHM_LO_ENTRY	*pEntry = NULL;

	if (pSHM == NULL) {										// p[^`FbN
		return NULL;
	}

	pEntry  = os_edge_mallocMemory(sizeof(SHM_LO_ENTRY));	// Gg[pm
	if (pEntry == NULL) {
		return NULL;										// mێs
	}

	memset(pEntry, 0, sizeof(sizeof(SHM_LO_ENTRY)));		// [NA

	pEntry->Next = s_pSHMLTB[pSHM->Hash];					// Gg[VGg[NextփZbg
	s_pSHMLTB[pSHM->Hash] = pEntry;							// e[ũGg[́AVGg[Zbg

	// Node, Proc, ObjeName̕ێ
	strcpy_s(pEntry->chNodeName, sizeof(pEntry->chNodeName), pSHM->NodeName);
	strcpy_s(pEntry->chProcName, sizeof(pEntry->chProcName), pSHM->ProcName);
	strcpy_s(pEntry->chObjeName, sizeof(pEntry->chObjeName), pSHM->ObjeName);

	return pEntry;
}

//------------------------------------------------------------------------------
// FUNCTION   : _SHM_LoE_FindEntry
// DESCRIPTION: 
//   ()Node/Proc/ObjeŃGg[
//------------------------------------------------------------------------------
SHM_LO_ENTRY* _SHM_LoE_FindEntry(SHM_DESC *pSHM)
{
	SHM_LO_ENTRY	*pEntry = NULL;

	if (pSHM == NULL) {					// p[^`FbN
		return NULL;
	}

	pEntry  = s_pSHMLTB[pSHM->Hash];

	if (pEntry == NULL) {				// Gg[݂͑Ȃ ?
		return NULL;					// o^
	}

	if (pEntry->Next == NULL) {			// Next  NULL Ƃ͏Փ˂߁AB̃Gg[
		return pEntry;
	}

	// Փ˂ꍇ͂֗Av̂T
	while (pEntry != NULL) {
		if (strcmp(pEntry->chObjeName, pSHM->ObjeName) == 0) {
		if (strcmp(pEntry->chProcName, pSHM->ProcName) == 0) {
		if (strcmp(pEntry->chNodeName, pSHM->NodeName) == 0) {
			return pEntry;
		}}}

		pEntry = pEntry->Next;			// ̏Փ˃Gg[
	}

	return NULL;	// Gg[͌Ȃ
}


/*****************************************************************************
* FUNCTION:		_SHM_LookupMap
* DESCRIPTION:
*   ()LbNAbvă}bv鏈
\*****************************************************************************/
HSHM_PTR _SHM_LookupMap(const char *NodeName, const char *ProcessName, const char *ObjectName, uint32_t *pSize)
{
	void *memory = os_edge_lookup_memory(NodeName, ProcessName, ObjectName, pSize);
	return (HSHM_PTR)os_edge_map(memory);
}

extern void PrintSysLog(const char* pMode, const char* format, ...);
/*****************************************************************************
* FUNCTION:		_SHM_DecodeSource
* DESCRIPTION:
*   (p)L^CvpAddress(Source)͏
\*****************************************************************************/
int32_t _SHM_DecodeSource(const char *pSource, SHM_DESC *pSHM)
{
	uint32_t	uiOffset = 0;		// L擪̃ItZbg
	int			inBase = 10;		// Address lϊ̊(10i/16i)
	char		*pContext = NULL;		// strtok_s pϐ
	char		*pEnd = NULL;		// strstr, strtok_s pϐ
	char		*pSrc = NULL;		// strstr, strtok_s pϐ
	char		*pToken = NULL;		// strstr, strtok_s pϐ
	char		*pPos = NULL;		// strstr, strtok_s pϐ
	char		*pSrcWork = NULL;		// Address pꎞobt@
	int			inSrcWorkSize = (EG_MAX_TAGADDRESS + 1);
	uint16_t	woBitOffset = 0;
	char		chSynxName[16];
	char		chIoAddrss[32];
	uint8_t		byProcSkip = FALSE;
	char		chDelimiter[] = EG_SHM_DELIMITER;
	char		chDoubleDelimiter[] = EG_SHM_DELIMITER EG_SHM_DELIMITER;

	// ̃`FbN
	if ((pSource == NULL) || (strlen(pSource) == 0) || (pSHM == NULL)) {
		PrintSysLog(EG_LOG_ERR, "Invalid argument. [FUNC = %s]", __func__);
		return EDGE_PARAM_INVALID;
	}

	// ƃGAm
	pSrcWork = (char*)os_edge_mallocMemory(inSrcWorkSize);
	if (pSrcWork == NULL) {
		return EDGE_SHM_ALLOCATE_ERROR;
	}

	// ---------------------------------------------------------------------
	// ϐ̏
	// ---------------------------------------------------------------------
	memset(pSrcWork,      0, inSrcWorkSize);
	memset(chSynxName,    0, sizeof(chSynxName));
	memset(chIoAddrss,    0, sizeof(chIoAddrss));
	memset(&pSHM->chNull, 0, sizeof(SHM_DESC) - offsetof(SHM_DESC, chNull));

	/* SourceSHMǗرOłκ߰ */
	if ((void *)pSource != (void *)pSHM) {
		/* @memo {strncpy_s͗]ر0̨قȂׁAU0̨([c) */
		memset(pSHM->chSourceUpper, 0, sizeof(pSHM->chSourceUpper));
		os_edge_strncpy_s(pSHM->chSourceUpper, sizeof(pSHM->chSourceUpper), pSource, _TRUNCATE);
	}

	// ̉ߒŕ񑀍삷邽߁ARs[
	strcpy_s(pSrcWork, inSrcWorkSize, pSource);
	pSrc = (char*)pSrcWork;

	// ---------------------------------------------------------------------
	// vZXfBNgꍇ邽߁A
	// \: Address="MAP/NodeA//MEM_VIOS_IN/16#000F"
	// ---------------------------------------------------------------------
	pPos = strstr(pSrc, chDelimiter);				// ŏ̃f~^
	if (pPos != NULL) {
		pPos = strstr(&pPos[1], chDoubleDelimiter);	// ̌̌Ńf~^2̂
		if (pPos != NULL) {
			byProcSkip = TRUE;	// ̂ŁAvZXfBNg͖A[gvZX猟邱ƂƔ
		}
	}

	// ---------------------------------------------------------------------
	// ʕ̔
	// \: Address="MAP/NodeA/PRCS_RTECHDR/MEM_VIOS_IN/16#000F"
	// ---------------------------------------------------------------------
	// 1ڂ̃f~^[
	pToken = strtok_s(pSrc, EG_SHM_DELIMITER, &pContext); //f~^[؂Ŏʖ擾
	if (pToken == NULL) {
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX1_ERROR; // \G[AL^Cvł͖
	}

	// L^Cv ? EG_SHM_KEYWORD Ŏn܂΋L^Cv
	strcpy_s(chSynxName, sizeof(chSynxName), pToken);
	if (0 != _stricmp(chSynxName, EG_SHM_KEYWORD)) {
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX1_ERROR; // L^Cvł͖
	}

	// 2ڂ̃f~^[
	pToken = strtok_s(NULL, EG_SHM_DELIMITER, &pContext);
	if (pToken == NULL) {
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX2_ERROR; // \G[AL^Cvł͖
	}
	
	strcpy_s(pSHM->NodeName, sizeof(pSHM->NodeName), pToken);
	

	// 3ڂ̃f~^[
	if (byProcSkip == FALSE) {
		pToken = strtok_s(NULL, EG_SHM_DELIMITER, &pContext);
		if (pToken == NULL) {
			os_edge_freemallocMemory(pSrcWork);
			return EDGE_SHM_SYNTAX3_ERROR; // \G[AL^Cvł͖
		}
		strcpy_s(pSHM->ProcName, sizeof(pSHM->ProcName), pToken);
	}

	// 4ڂ̃f~^[
	pToken = strtok_s(NULL, EG_SHM_DELIMITER, &pContext);
	if (pToken == NULL) {
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX4_ERROR; // \G[AL^Cvł͖
	}
	strcpy_s(pSHM->ObjeName, sizeof(pSHM->ObjeName), pToken);

	// ܂ł̕擾
	pToken = strtok_s(NULL, EG_SHM_DELIMITER, &pContext);
	if (pToken == NULL) {
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX5_ERROR; // \G[AL^Cvł͖
	}
	strcpy_s(chIoAddrss, sizeof(chIoAddrss), pToken);
	pSrc = pToken;

	// ---------------------------------------------------------------------
	// 10iE16i\L (AhX"16#"ꍇ16i\LƂĈ)
	// \: Address="MAP/NodeA/PRCS_RTECHDR/MEM_VIOS_IN/16#000F"
	//         ́A16#000F ̕
	// ---------------------------------------------------------------------
	inBase = 10;				// ftHg:10iɃZbg
	pPos = strstr(pSrc, "16#");
	if (pPos != NULL) {			// ꍇ
		pPos = pPos + 3;		// "16#"̌擾
		pSrc = pPos;			// AhX擪ʒuXV
		inBase = 16;			// 16iɃZbg
	}

	// ---------------------------------------------------------------------
	// rbgANZX̍l(AhX.X 𔻒)
	// ---------------------------------------------------------------------
	pPos = strstr(pSrc, ".");
	if (pPos != NULL)		// .(hbg)ꍇ
	{
		*pPos = '\0';		// AhXɃrbg͕sv̂߁AI[Zbg
		pPos = pPos + 1;	// .(hbg)̌擾
		woBitOffset = (WORD)strtoul(pPos, &pEnd, inBase);	// bitԍ擾
		if ((woBitOffset > 15) || (*pEnd != '\0')) {		// bit0`15ȊOA܂́As܂܂ꍇ
			PrintSysLog(EG_LOG_ERR, "Addrees bit format error. Address[%s]", pSource);
			return EDGE_SHM_SYNTAX6_ERROR;
		}
				
		pSHM->BitOffset = woBitOffset;			// bitʒuݒ
		pSHM->BitUse = 1;						// bitgptOON
	}

	// ---------------------------------------------------------------------
	// 񂩂琔l֕ϊ
	// ---------------------------------------------------------------------
	uiOffset = strtoul(pSrc, &pEnd, inBase);
	if (*pEnd != '\0') {		// s܂܂ꍇ
		PrintSysLog(EG_LOG_ERR, "Address format error. Syntax error in offset value. Address[%s]", pSource);
		os_edge_freemallocMemory(pSrcWork);
		return EDGE_SHM_SYNTAX6_ERROR;
	}

	// i[
	pSHM->Offset = uiOffset;

	/* ʯl̷𐶐 */
	pSHM->Hash = _SHM_LoE_MakeHash(pSHM->NodeName, pSHM->ProcName, pSHM->ObjeName);

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_SHM_LoE_GetEntry
* DESCRIPTION:
*	[Je[uփ}bvĒǉĕԋp鏈
\*****************************************************************************/
SHM_LO_ENTRY*	_SHM_LoE_GetEntry(SHM_DESC *pSHM, int32_t *pResult)
{
	HSHM_PTR		hPtr   = NULL;
	SHM_LO_ENTRY	*pLoE = NULL;
	uint32_t		uiIndex = 0;

	if (pResult != NULL) {	*pResult = EDGE_SUCCESS;	}		// ߂Xe[^Xl̏
	if (pSHM	== NULL) {										// p[^NULL`FbN
		if (pResult != NULL) {	*pResult = EDGE_SHM_PARAM_INVALID;	}
		return NULL;
	}

	// [Je[uAꍇ̓}bvς
	pLoE = _SHM_LoE_FindEntry(pSHM);
	if (pLoE != NULL) {
		return pLoE;					// }bvςݏԋp
	}

	// LLookupƃ}bv
	hPtr = _SHM_LookupMap(pSHM->NodeName, pSHM->ProcName, pSHM->ObjeName, &pSHM->MapSize);
	if (hPtr == NULL) {
		if (pResult != NULL) {
			*pResult = EDGE_SHM_MAP_ERROR;
		}
		return NULL;				// L̈̃}bvłȂ
	}
	
	// [Je[uփGg[ǉ
	pLoE = _SHM_LoE_AddEntry(pSHM);
	if (pLoE == NULL) {
		if (pResult != NULL) {
			*pResult = EDGE_SHM_ALLOCATE_ERROR;
		}
		return NULL;				// [J̊mێs
	}

	pLoE->BaseAddress = hPtr;						// }bvx[XAhX̃Zbg
	pLoE->MappedSize  = pSHM->MapSize;				// }bv}bvTCỸZbg
	

	return pLoE;
}

/*****************************************************************************
* FUNCTION:		EgTagInitSharedMemory
* DESCRIPTION:
*   LO 
\*****************************************************************************/
int32_t EgTagInitSharedMemory(void)
{
	void*		hMEM = NULL;
	int32_t		inResult = 0;
	uint32_t	uiMax = 0;

	inResult = EgTagRead(EGSYSTAGNAME_SHM_ENTRY_MAX, &uiMax, sizeof(uint32_t));	// SHM̍őTCY擾
	if (inResult != EDGE_SUCCESS) {
		uiMax = EG_SHM_ENTRY_MAX;												// o^ȂVKo^
		EgTagCreateEx(EGSYSTAGNAME_SHM_ENTRY_MAX, EgVtUInt32, "SHM_ENTRY_MAX", "SHM local entries maximum");
		EgTagWrite(EGSYSTAGNAME_SHM_ENTRY_MAX, &uiMax, sizeof(uiMax));
	}

	if (uiMax == 0) {
		uiMax = EG_SHM_ENTRY_MAX;												// 0 Ȃ`l
		EgTagWrite(EGSYSTAGNAME_SHM_ENTRY_MAX, &uiMax, sizeof(uiMax));
	}

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		EgTagLockSharedMemory
* DESCRIPTION:
*   LbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t EgTagLockSharedMemory(TagsDesc *nsh)
{
	int32_t		ret;
	uint32_t	uiRetry;	// gC񐔎擾

	// ^O̓ǂݍ
	ret = EgTagRead(EGSYSTAGNAME_SHM_RETRY_COUNT, &uiRetry, sizeof(uiRetry));
	if (ret != EDGE_SUCCESS) {
		uiRetry = EG_SHM_MAX_RETRY_LOCK;
	}

	// bN
	ret = EDGE_TAGPTR_LOCK_TIMOUT;
	for (uint32_t i = 0; i < uiRetry; i++) {
		if (nsh->var.lock.current == 0) {
			nsh->var.lock.current = 1;					// bNɍXV
			ret = EDGE_SUCCESS;
			break;										// bN̂߁A[vI
		}
#ifdef __INTIME__
		knRtSleep(1);
#else
		os_edge_sleep(1);
#endif
	}

	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagUnlockSharedMemory
* DESCRIPTION:
*   LAbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
int32_t EgTagUnlockSharedMemory(TagsDesc *nsh)
{
	int32_t ret = EDGE_SUCCESS;

	nsh->var.lock.current = 0;						// AbN

	return ret;
}

/*****************************************************************************
* FUNCTION:		EgTagGetSharedMemoryAddress
* DESCRIPTION:
*   Lpx[XAhX擾
\*****************************************************************************/
int32_t EgTagGetSharedMemoryAddress(TagsDesc *nsh, LPVOID *addr)
{
	int32_t			inRes	= 0;
	HSHM_PTR		hPtr	= NULL;
	SHM_LO_ENTRY	*pLoE	= NULL;
	SHM_DESC		*pSHM	= NULL;
	uint8_t			*pBASE	= NULL;
	
	if (nsh == NULL || addr == NULL) {
		// NULLG[
	}

	pSHM = &nsh->SHM;

	// SHM[Je[u̎Q
	pLoE = _SHM_LoE_GetEntry(pSHM, &inRes);		// [Je[uQƁA}bvȂ}bvĒǉ
	if (pLoE == NULL) {
		return inRes;								// G[
	}

	if (pLoE->MappedSize < (nsh->SHM.Offset + nsh->var.size)) {			// TCY߃`FbN
		return EDGE_SHM_OFFSET_OVERFLOW;								// ItZbgI[o[G[
	}

	pBASE = (uint8_t *)pLoE->BaseAddress;					// oCgzɃLXg
	*addr = &pBASE[pSHM->Offset];							// AhX̐ݒ

	return EDGE_SUCCESS;
}

/*****************************************************************************
* FUNCTION:		_EgTagCheckSharedMemoryParam
* DESCRIPTION:
*   p[^`FbN
*         ep[^͎OɃ`FbNς݂ŃR[邱ƂOƂ܂
\*****************************************************************************/
/*
int32_t _SHM_CheckParam(TagsDesc *nsh)
{
	SHM_DESC	*pSHM;

	if (nsh == NULL) {
		return EDGE_SHM_PARAM_INVALID;						// p[^G[
	}
	pSHM = &nsh->SHM;

	// ItZbg+TCY ̃`FbN
	if (pSHM->MapSize <= (pSHM->Offset + nsh->var.size)) {
		return EDGE_SHM_OFFSET_OVERFLOW;					// ItZbg͈͊O
	}

	return EDGE_SUCCESS;
}
*/
