////
/// Copyright(C) 2021 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egosdepWrap.c
*
*   RT-edge system / OS depend module Wrapper
*
\*****************************************************************************/
#include <stdio.h>
#include <time.h>
#include "egAPI.h"
#include "../eghgapiCommon/egInternal.h"
#include "../eghgapiCommon/egosdepWrap.h"


//------------------------------------------------------------
// setNode
//------------------------------------------------------------
uint32_t os_edge_setNode(const char *Name)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_setNode(Name);
}
//------------------------------------------------------------
// edge_getNodeName
//------------------------------------------------------------
uint32_t os_edge_getNodeName(char *pNode, uint32_t dwSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return os_edge_getNodeName(pNode, dwSize);
}
//------------------------------------------------------------
// lookup
//------------------------------------------------------------
void* os_edge_lookup(const char *Name)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_lookup(Name);
}
//------------------------------------------------------------
// lookup
//------------------------------------------------------------
void* os_edge_lookup_memory(const char *NodeName, const char *ProcessName, const char *ObjectName, uint32_t *pSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_lookup_memory(NodeName, ProcessName, ObjectName, pSize);
}
//------------------------------------------------------------
// createMemory
//------------------------------------------------------------
void* os_edge_createMemory(const char *Name, uint32_t dwSize, void **MemHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_createMemory(Name, dwSize, MemHandle);
}

//------------------------------------------------------------
// freeMemory
//------------------------------------------------------------
uint32_t os_edge_freeMemory(const char *Name, void *Memory, void *MemHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_freeMemory(Name, Memory, MemHandle);
}
//------------------------------------------------------------
// map
//------------------------------------------------------------
void* os_edge_map(void *Memhandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_map(Memhandle);
}
//------------------------------------------------------------
// unmap
//------------------------------------------------------------
uint32_t os_edge_unmap(void *MemPointer, void *MemHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_unmap(MemPointer, MemHandle);
}
//------------------------------------------------------------
// catalog
//------------------------------------------------------------
uint32_t os_edge_catalog(void *MemHandle, const char *Name)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_catalog(MemHandle, Name);
}
//------------------------------------------------------------
// uncatalog
//------------------------------------------------------------
uint32_t os_edge_uncatalog(void *Handle, const char *Name)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_uncatalog(Handle, Name);
}
//------------------------------------------------------------
// closeHandle
//------------------------------------------------------------
uint32_t os_edge_closeHandle(void *Handle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_closeHandle(Handle);
}
//------------------------------------------------------------
// mallocMemory(ʏ̃쐬)
//------------------------------------------------------------
void* os_edge_mallocMemory(size_t dwSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_mallocMemory(dwSize);
}
//------------------------------------------------------------
// freemallocMemory
//------------------------------------------------------------
uint32_t os_edge_freemallocMemory(void *Memory)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_freemallocMemory(Memory);
}
//------------------------------------------------------------
// createThread
//------------------------------------------------------------
void* os_edge_createThread(uint16_t shPriority, uint32_t dwStackSize, void* func, void* arg, int32_t* errorNo)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return NULL;	// [hNG
	}
	return edge_createThread(shPriority, dwStackSize, func, arg, errorNo);
}
//------------------------------------------------------------
// deleteThread
//------------------------------------------------------------
uint8_t os_edge_deleteThread(void* hHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return 0;		// [hNG
	}
	return edge_deleteThread(hHandle);
}
//------------------------------------------------------------
// sleep
//------------------------------------------------------------
void os_edge_sleep(uint32_t dwMillseconds)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return;			// [hNG
	}
	edge_sleep(dwMillseconds);
}
//------------------------------------------------------------
// getProcPath s̃vZXpX擾
//------------------------------------------------------------
void os_edge_getProcPath(char *pPath, uint32_t dwSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return;			// [hNG
	}
	edge_getProcPath(pPath, dwSize);
}
//------------------------------------------------------------
// Ԃ̎擾
//------------------------------------------------------------
int32_t os_edge_getTime(EDGE_TIME_STAMP *pTime)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_getTime(pTime);
}
//------------------------------------------------------------
// Ԃ̎擾
//------------------------------------------------------------
int32_t os_edge_getTimeVal(EDGE_TIME_VAL *pTime)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_getTimeVal(pTime);
}
//------------------------------------------------------------
// Ԃ̕ϊ
//------------------------------------------------------------
int32_t os_edge_Localtime64(void* pTime, void* pLongTime)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_Localtime64(pTime, pLongTime);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̐
//------------------------------------------------------------
int32_t os_edge_creMbox(const char *pName, uint32_t dwLength, uint32_t dwNum, RTCDMEMINFO *pRtcdInfo)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_creMbox(pName, dwLength, dwNum, pRtcdInfo);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̍폜
//------------------------------------------------------------
int32_t os_edge_delMbox(RTCDMEMINFO *pRtcdInfo)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_delMbox(pRtcdInfo);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̃I[v
//------------------------------------------------------------
int32_t os_edge_openMbox(const char *pName, uint32_t dwAccess, RTCDHANDLE *pHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_openMbox(pName, dwAccess, pHandle);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̃N[Y
//------------------------------------------------------------
int32_t os_edge_closeMbox(RTCDHANDLE *pHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_closeMbox(pHandle);
}
//------------------------------------------------------------
// RTCDx[X[{bNXĂ̑M
//------------------------------------------------------------
int32_t os_edge_sendMbox(RTCDHANDLE *pHandle, void *pBuffer, uint32_t dwSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_sendMbox(pHandle, pBuffer, dwSize);
}
//------------------------------------------------------------
// RTCDx[X[{bNXĂ̑M
//------------------------------------------------------------
int32_t os_edge_sendMboxEx(RTCDHANDLE *pHandle, void *pBuffer1, uint32_t dwSize1, void *pBuffer2, uint32_t dwSize2)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_sendMboxEx(pHandle, pBuffer1, dwSize1, pBuffer2, dwSize2);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̎M
//------------------------------------------------------------
int32_t os_edge_recvMbox(RTCDHANDLE *pHandle, void *pBuffer, uint32_t dwBufferSize, uint32_t dwTimeout)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_recvMbox(pHandle, pBuffer, dwBufferSize, dwTimeout);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̎M
//------------------------------------------------------------
int32_t os_edge_recvMboxEx(RTCDHANDLE *pHandle, void *pBuffer1, uint32_t dwBufferSize1, void *pBuffer2, uint32_t dwBufferSize2, uint32_t dwTimeout)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_recvMboxEx(pHandle, pBuffer1, dwBufferSize1, pBuffer2, dwBufferSize2, dwTimeout);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̍\擾
//------------------------------------------------------------
int32_t os_edge_infoMbox(RTCDHANDLE *pHandle, EDGE_RTCD_HEADER *pInfo)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_infoMbox(pHandle, pInfo);
}
//------------------------------------------------------------
// edgeT[rXN
//------------------------------------------------------------
uint32_t os_edge_createService(const char *Name, const char *path, const char *arg, intptr_t *pid)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_createService(Name, path, arg, pid);
}
//------------------------------------------------------------
// edgeT[rXN([gm[hp)
//------------------------------------------------------------
uint32_t os_edge_createServiceEx(const char *Name, const char *path, const char *arg, intptr_t *pid, EDGESERVICECONFIG *config)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_createServiceEx(Name, path, arg, pid, config);
}
//------------------------------------------------------------
// Thread Priority̐ݒ Windowsp
//------------------------------------------------------------
int32_t os_edge_setPriority(void* hdl, uint8_t byPriority)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_setPriority(hdl, byPriority);
}
//------------------------------------------------------------
// vO̎擾
//------------------------------------------------------------
int32_t os_edge_getCommmandLine(char *pArg, uint32_t dwSize)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;		// [hNG
	}
	return edge_getCommmandLine(pArg, dwSize);
}
/// <summary>
/// tRs[(t^\0nɊ܂܂Ȃ) _TRUNCATE(-1)dstmax-1
/// </summary>
/// <param name="dst"></param>
/// <param name="dstmax">dstobt@̃TCY</param>
/// <param name="src"></param>
/// <param name="n">Rs[TCY</param>
void os_edge_strncpy_s(char *dst, size_t dstmax, const char *src, size_t n)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return;			// [hNG
	}
	edge_strncpy_s(dst, dstmax, src, n);
}
/// <summary>
/// nh̃`FbN
/// </summary>
/// <param RTCDHANDLE="pHandle">`FbNnh</param>
int32_t os_edge_checkHandle(RTCDHANDLE *pHandle)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;			// [hNG
	}
	return edge_checkHandle(pHandle);
}
/// <summary>
/// ptH[}XJE^[̎擾
/// </summary>
/// <param"></param>
int32_t os_edge_GetPCounter(unsigned long long *pCounter)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;			// [hNG
	}
	*pCounter = edge_GetPCounter();
	return EDGE_SUCCESS;
}
/// <summary>
/// ptH[}XvZ nano
/// </summary>
/// <param"></param>
int32_t os_edge_CalcTime(unsigned long long start_Count, unsigned long long finish_Count, double* pTime)
{
	int32_t ret = egosdepLoadLibrary();	// egosdep̃[h`FbN
	if (EDGE_SUCCESS != ret)
	{
		return ret;			// [hNG
	}
	*pTime = edge_CalcTime(start_Count, finish_Count);
	return EDGE_SUCCESS;
}