////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*****************************************************************************
* egosdep.c
*
*   RT-edge system / OS depend module for INtime Real-time application
*
\*****************************************************************************/

#include <string.h>
#include <stdlib.h>
#include "../eghgapiCommon/egosdep.h"
#include "../eghgapiCommon/egapi.h"
#include "../eghgapiCommon/egInternal.h"


static RTHANDLE		hRtcdNode = BAD_RTHANDLE;		// RTCDnodẽ[gvZXnh
static LOCATION		hRtcdLoc = BAD_LOCATION;		// RTCDnodẽP[Vnh
static LOCATION		hMyLoc = BAD_LOCATION;			// g̃P[Vnh

/*****************************************************************************
* FUNCTION:		searchRTCD
* DESCRIPTION:
*   ()RTCD̃J^O
\*****************************************************************************/
RTHANDLE searchRTCD(LOCATION hLoc)
{
	RTHANDLE	hRoot = BAD_RTHANDLE;				// [gvZXnh
	RTHANDLE	hMem = BAD_RTHANDLE;				// Lnh
	WORD		wRet;
	BYTE		byREMOTO = FALSE;

	if (hMyLoc == hLoc) { //m[h
		hRoot = GetRtThreadHandles(ROOT_PROCESS);	// [J[gvZXnh͎sȂ
		byREMOTO = FALSE;
	} else {
		hRoot = GetRemoteRootRtProcess(hLoc);		// w肳ꂽP[Ṽ[gvZX擾
		if (hRoot == BAD_RTHANDLE) {
			DeleteRtReferenceObject(hRoot);
			return BAD_RTHANDLE;
		}
		byREMOTO = TRUE;
	}

	hMem = LookupRtHandle(hRoot, EGRTCDNODE, NO_WAIT);	// RTCDbNAbv
	if (hMem == BAD_RTHANDLE) {
		if (byREMOTO) {
			DeleteRtReferenceObject(hRoot);
		}
		return BAD_RTHANDLE;
	}

	wRet = GetRtHandleType(hMem);
	if (wRet != SEGMENT_TYPE) {
		if (byREMOTO) {
			DeleteRtReferenceObject(hRoot);
			DeleteRtReferenceObject(hMem);
		}
		return BAD_RTHANDLE;
	}

	return hRoot;
}

/*****************************************************************************
* FUNCTION:		edge_getRtcdNodeHandle
* DESCRIPTION:
*   ()RTCD݂m[h̃[gvZXnh擾
\*****************************************************************************/
RTHANDLE edge_getRtcdNodeHandle()
{
	LOCATION hLoc;
	RTHANDLE hRoot;
	uint16_t sts;
	NODE_INFO info;

	if (hRtcdNode != BAD_RTHANDLE)
	{
		return hRtcdNode;							// Ɏ擾ςȂI
	}
	if (!GetRtNodeInfo(THIS_LOCATION, &info)) {		// m[h擾
		return BAD_RTHANDLE;
	}
	hMyLoc = info.Location;							// m[h̃P[VoĂ
	// find all nodes
	hLoc = GetFirstRtLocation();					// ŏ̃P[V擾
	while (hLoc != BAD_LOCATION) {					// ܂őSẴm[h`FbN
		sts = GetRtNodeStatus(hLoc);		// m[hNԃ`FbN
		if (sts == E_OK)							// OK
		{
			hRoot = searchRTCD(hLoc);				// RTCDJ^O
			if (hRoot != BAD_RTHANDLE) {			// ꍇAnhێ
				hRtcdLoc = hLoc;
				hRtcdNode = hRoot;
				break;								// I
			}
		}
		hLoc = GetNextRtLocation(hLoc);				// ̃P[V擾
	}
	
	if (hRtcdNode == BAD_RTHANDLE) {				// Ȃꍇ
		if (!GetRtNodeInfo(THIS_LOCATION, &info)) {	// m[hŐ邽߁Am[h擾
			return BAD_RTHANDLE;
		}
		edge_setNode(info.szNodeName);				// RTCDNODE̓o^
	}

	return hRtcdNode;
}
/*****************************************************************************
* FUNCTION:		GetRootRTCD
* DESCRIPTION:
*   ()RTCDm[h̃[gvZXnh擾
\*****************************************************************************/
RTHANDLE GetRootRTCD()
{
	edge_getRtcdNodeHandle();
	return hRtcdNode;
}
/*****************************************************************************
* FUNCTION:		GetLocationRTCD
* DESCRIPTION:
*   ()RTCDm[h̃P[Vnh擾
\*****************************************************************************/
LOCATION GetLocationRTCD()
{
	edge_getRtcdNodeHandle();
	return hRtcdLoc;
}
LOCATION GetMyLocation()
{
	if (hMyLoc == BAD_RTHANDLE)
		edge_getRtcdNodeHandle();
	return hMyLoc;
}

/*****************************************************************************
* FUNCTION:		edge_setNode
* DESCRIPTION:
*   RTCD쐬m[ho^
\*****************************************************************************/
uint32_t edge_setNode(const char *Name)
{
	LOCATION 	hLoc;
	RTHANDLE 	hRoot;
	RTHANDLE 	hMem = 0;
	RTHANDLE 	hMemCatalog = 0;
	WORD		wRet = EDGE_SUCCESS;
	DWORD		dwRet = EDGE_SUCCESS;	//߂l
	void 		*pMem = NULL;			//̃|C^
	NODE_INFO 	info;					//Nodei[ϐ
	BOOL		bThisRoot = FALSE;		//m[hō쐬邩ۂ
	
	if (hRtcdNode != BAD_RTHANDLE)
	{
		return EDGE_RTCD_EXIST_ERROR;	// Ɏ擾ς̏ꍇ͖
	}
	if (!GetRtNodeInfo(THIS_LOCATION, &info)) {	// m[h擾
		return BAD_RTHANDLE;
	}
	hMyLoc = info.Location;				// P[VoĂ
	
	hLoc = GetRtNodeLocationByName(Name);					// wm[h̃P[Vnh擾
	if (hLoc != BAD_LOCATION) {
		if (hMyLoc == hLoc)		//m[hǂ`FbN
			bThisRoot = TRUE;
			
		if(bThisRoot) //m[h̎
			hRoot = GetRtThreadHandles(ROOT_PROCESS);
		else
			hRoot = GetRemoteRootRtProcess(hLoc);				// [gvZXnh擾
		if (hRoot != BAD_RTHANDLE) {
			if (bThisRoot) //m[h̎
			{
				// m
				pMem = AllocateRtMemory(1);						//쐬
				if (pMem == NULL)
				{
					//s͏I
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;
					goto failed;
				}
				hMem = CreateRtMemoryHandle(pMem, 1);				//nh쐬
				//hMem = CreateGlobalRtMemoryObject(hLoc, 1, 0);
				if (hMem == BAD_RTHANDLE) {
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;			// mێs
					goto failed;
				}
			}
			else//m[h
			{
				// m
				hMem = CreateGlobalRtMemoryObject(hLoc, 1, 0);
				if (hMem == BAD_RTHANDLE) {
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;			// mێs
					goto failed;
				}
			}
			hMemCatalog = LookupRtHandle(hRoot, EGRTCDNODE, NO_WAIT);		// ̃Ă邩`FbN
			if (hMemCatalog != BAD_RTHANDLE) {
				wRet = GetRtHandleType(hMemCatalog);
				if (bThisRoot)
					DeleteRtReferenceObject(hMemCatalog);							// t@Xnhĉō폜
				if (wRet == INVALID_TYPE) {
					UncatalogRtHandle(hRoot, EGRTCDNODE);					// J^OcĂԂ̂߃AJ^Oďp
				}
			}
			// J^O
			if (true != CatalogRtHandle(hRoot, hMem, EGRTCDNODE)) {
				dwRet = EDGE_RTCD_CATALOG_ERROR;			// J^Os
				goto failed; 
			}
			hRtcdLoc = hLoc;								// P[Vnhێ
			hRtcdNode = hRoot;								// [gvZXnhێ
			return EDGE_SUCCESS;
		}
	}
	else
	{
		dwRet = EDGE_LOCATION_ERROR;
		goto failed;
	}

failed:
	if (pMem)
		FreeRtMemory(pMem);								//t[
	if (hMem)
		DeleteRtMemoryHandle(hMem);						//폜
	return dwRet;
}

/*****************************************************************************
* FUNCTION:		edge_getNodeName
* DESCRIPTION:
*   RTCDɰނɰޖԂ
\*****************************************************************************/
uint32_t edge_getNodeName(char *pNode, uint32_t dwSize)
{
	LOCATION loc = GetLocationRTCD();
	NODE_INFO info;

	if (pNode == NULL || dwSize == 0) return EDGE_PARAM_INVALID;
	if (loc == BAD_LOCATION) return EDGE_LOCATION_ERROR;
	if (GetRtNodeInfo(loc, &info) == FALSE) return EDGE_LOCATION_ERROR;

	strncpy(pNode, info.szNodeName, dwSize);
	pNode[dwSize - 1] = '\0';

	return EDGE_SUCCESS;
}

//------------------------------------------------------------
// lookup
// @return	قԂ
//------------------------------------------------------------
void* edge_lookup(const char *Name)
{
	WORD		wRet;
	RTHANDLE	hRoot = BAD_RTHANDLE;		// [gvZXnh
	RTHANDLE	hMem = BAD_RTHANDLE;		// Lnh

	//--------------------------------------------------------------------
	// lookupO`FbN
	//--------------------------------------------------------------------
	hRoot = GetRootRTCD();									// [gvZXnh擾

	hMem = LookupRtHandle(hRoot, (LPSTR)Name, NO_WAIT);	// RTCDbNAbv
	if (hMem != BAD_RTHANDLE) {
		wRet = GetRtHandleType(hMem);
		if (wRet == INVALID_TYPE) {
			UncatalogRtHandle(hRoot, (LPSTR)Name);			// J^OcĂԂ̂߃AJ^Oďp
		}
		else if (wRet == SEGMENT_TYPE) {
			return (void *)hMem;									// 
		}
		else {
			return NULL;									// ɓOgĂ܂
		}
	}
	return NULL;
}

//------------------------------------------------------------
// lookup
// @return	قԂ
//------------------------------------------------------------
void* edge_lookup_memory(const char *NodeName, const char *ProcessName, const char *ObjectName, uint32_t *pSize)
{
	WORD		wRet;
	LOCATION	hLoc   = BAD_LOCATION;
	RTHANDLE	hRoot  = BAD_RTHANDLE;		// [gvZXnh
	RTHANDLE	hProc  = BAD_RTHANDLE;		// vZXnh
	RTHANDLE	hOBJ   = BAD_RTHANDLE;		// IuWFNgnh
	BYTE		byRef  = 0;					// t@XtO

	//------------------------------------------------
	// m[hP[Vnh̎擾
	//------------------------------------------------
	if ((NULL != NodeName) && ('\0' != *NodeName)) {			// NodeNamew肪ꍇ
		NODE_INFO	NodeInfo;

		memset(&NodeInfo, 0, sizeof(NodeInfo));				
		if (FALSE == GetRtNodeInfo(THIS_LOCATION, &NodeInfo)) {	// m[h̎擾
			return NULL;										// 擾s
		}

		if (0 == strcmpi(NodeName, NodeInfo.szNodeName)) {		// wm[h́Am[hł
			hRoot = GetRtThreadHandles(ROOT_PROCESS);			// m[h̃[gvZXnh̎擾
		}
		else {													// wm[h́Am[hł
			byRef = TRUE;
			hLoc = GetRtNodeLocationByName(NodeName);			// Ώۃm[h̃P[Vnh擾
			if (hLoc == BAD_LOCATION) {
				return NULL;									// Ȃ
			}

			wRet = GetRtNodeStatus(hLoc);						// J[lԎ擾
			if (wRet != E_OK) {
				return NULL;									// NĂȂ
			}

			hRoot = GetRemoteRootRtProcess(hLoc);				// [gvZXnh̎擾
			if( BAD_RTHANDLE == hRoot ) {
				return NULL;									// NĂȂA~Ȃ
			}
		}
	}
	else {														// m[hw肪ꍇ
		hRoot = GetRtThreadHandles(ROOT_PROCESS);				// m[h̃[gvZXnh̎擾
	}
	
	//------------------------------------------------
	// vZXfBNgp̃vZXnh擾
	//------------------------------------------------
	if ((NULL != ProcessName) && ('\0' != *ProcessName)) {		// ProcessNamew肪ꍇ
		hProc = LookupRtHandle(hRoot, (LPSTR)ProcessName, NO_WAIT);		// ΏۃvZX̌
		if (hProc == BAD_RTHANDLE) {
			return NULL;										// vZX̃bNAbvs
		}
	}
	else {														// ꍇ
		hProc = hRoot;											// 郋[gvZXZbg
	}
	
	//------------------------------------------------
	// IuWFNgnh擾
	//------------------------------------------------
	hOBJ = LookupRtHandle(hProc, (LPSTR)ObjectName, NO_WAIT);	// ΏۃIuWFNgbNAbv

	if (0 != byRef) {
		DeleteRtReferenceObject(hRoot);							// t@X̃[gnh͖߂Oɍ폜
		DeleteRtReferenceObject(hProc);							// t@X̃vZXnh͖߂Oɍ폜
	}

	if (hOBJ == BAD_RTHANDLE) {
		return NULL;											// Ȃ
	}

	wRet = GetRtHandleType(hOBJ);								// nh^Cṽ`FbN
	if (wRet == INVALID_TYPE) {									// G[^Cv ?
		UncatalogRtHandle(hProc, (LPSTR)ObjectName);			// J^OcĂԂ̂߃AJ^O
		return NULL;											// Ȃ
	}

	if (NULL != pSize) {
		*pSize = GetRtSize(hOBJ);								// TCY̎擾
	}
	return (void *)hOBJ;

}

//------------------------------------------------------------
// createMemory
// @return	ϯߍςرڽԂ
//------------------------------------------------------------
void* edge_createMemory(const char *Name, uint32_t dwSize, void **MemHandle)
{
	void 		*pMem = NULL;
	RTHANDLE 	hMem = 0;
	LOCATION 	hLoc;
	LOCATION 	hLocalMyLoc;								//m[h̃P[V
	BOOL		bThisRoot = FALSE;							//m[hǂ̃tO

	hLoc = GetLocationRTCD();								//P[Vnh擾
	if (hLoc == BAD_LOCATION)								//s͏I
	{
		return NULL;
	}

	hLocalMyLoc = GetMyLocation();							//P[V擾
	if (hLocalMyLoc == BAD_LOCATION)						//擾łȂꍇ̓G[
	{
		return NULL;
	}

	if (hLocalMyLoc == hLoc) 								//m[hۂ`FbN
	{
		bThisRoot = TRUE;
	}

	if (bThisRoot)											//m[h̏ꍇm[}ō쐬
	{
		// m
		pMem = AllocateRtMemory(dwSize);					//쐬
		if (pMem == NULL)
		{
			//s͏I
			goto failed;
		}

		hMem = CreateRtMemoryHandle(pMem, dwSize);			//nh쐬
		if (hMem == BAD_RTHANDLE)							//s͏I
		{
			hMem = 0;
			goto failed;
		}
	}
	else													//m[h̏ꍇO[oō쐬
	{
		// m
		hMem = CreateGlobalRtMemoryObject(hLoc, dwSize, 0);	//쐬
		if (hMem == BAD_RTHANDLE)							//s͏I
		{
			hMem = 0;
			goto failed;
		}

		pMem = MapRtSharedMemory(hMem);						//}bv
		if (pMem == NULL)									//s͏I
		{
			goto failed;
		}
	}

	if ((NULL != Name) && (0 != strlen(Name)))				//Name`ꍇɌJ^O
	{
		if (true != edge_catalog((void*)hMem, Name))		//J^O s͏I
		{
			goto failed;
		}
	}

	if (MemHandle != NULL) *MemHandle = (void *)hMem;		//ُo͐悪ΕԂ(ꂪȂfreełȂ)
	return pMem;											//allocatẽ|C^Ԃ

failed:
	if (pMem)
		FreeRtMemory(pMem);						//t[
	if (hMem)
	{
		if(bThisRoot)
			DeleteRtReferenceObject(hMem);					// RTCDnh폜
		else
			DeleteRtMemoryHandle(hMem);				//폜
	}
	return NULL;
}
//------------------------------------------------------------
// freeMemory
//------------------------------------------------------------
uint32_t edge_freeMemory(const char *Name, void *Memory, void *MemHandle)
{
	WORD wRet;

	if ((NULL != Name) && (0 != strlen(Name))) {			//Name`ꍇɌAJ^O
		if (false == edge_uncatalog(MemHandle, Name)) {
			return EDGE_RTCD_DELETE_MEM_HANDLE_ERROR;
		}
	}

	wRet = GetRtHandleType((RTHANDLE)MemHandle);						// nh`FbN
	if (wRet == SEGMENT_TYPE) {
		if (DeleteRtMemoryHandle((RTHANDLE)MemHandle) == FALSE) {		// nh폜
			return	EDGE_RTCD_DELETE_MEM_HANDLE_ERROR;					// nh폜G[
		}
	}

	if (FreeRtMemory(Memory) == -1) {							// ({)
		return EDGE_RTCD_FREE_ERROR;									// G[
	}

	return EDGE_SUCCESS;
}

//------------------------------------------------------------
// map
// @memo INtimeł́AAllocateĂMemoryHandle𐶐邽߁AMapƏdB
//       X͂̉̂߂MemoryHandleȂ^pɂȂĂ̂A
//       ꂾfreeMemoryłȂ肪߁AcreateMemory̓ύX邱Ƃŉ邱ƂƂB
//------------------------------------------------------------
void* edge_map(void *Memhandle)
{
	return MapRtSharedMemory((RTHANDLE)Memhandle);
}

//------------------------------------------------------------
// unmap
//------------------------------------------------------------
uint32_t  edge_unmap(void *MemPointer, void *MemHandle)
{
	if (FreeRtMemory(MemPointer) == -1) {	// RTCD({)
		return EDGE_RTCD_FREE_ERROR;				// G[
	}
	return EDGE_SUCCESS;
}
//------------------------------------------------------------
// catalog
//------------------------------------------------------------
uint32_t edge_catalog(void *MemHandle, const char *Name)
{
	RTHANDLE	hRoot;
	RTHANDLE	hFind;
	WORD		wType;

	hRoot = GetRootRTCD();										// [gvZXnh擾
	hFind = LookupRtHandle(hRoot, (char*)Name, 0);		// bNAbv݂
	if (hFind != BAD_RTHANDLE)
	{
		wType = GetRtHandleType(hFind);							// IuWFNg^ُȂ
		if (wType != SEGMENT_TYPE)
			UncatalogRtHandle(hRoot, (char*)Name);		// J^Oς폜
	}

	return CatalogRtHandle(hRoot, (RTHANDLE)MemHandle, (LPSTR)Name);
}
//------------------------------------------------------------
// uncatalog
//------------------------------------------------------------
uint32_t edge_uncatalog(void *Handle, const char *Name)
{
	return UncatalogRtHandle(edge_getRtcdNodeHandle(), (LPSTR)Name);	//nhAJ^O
}
//------------------------------------------------------------
// closeHandle (INtimeł͖)
//------------------------------------------------------------
uint32_t edge_closeHandle(void *Handle)
{
	return EDGE_SUCCESS;	//INtimeł͕sv
}
//------------------------------------------------------------
// mallocMemory
//------------------------------------------------------------
void* edge_mallocMemory(size_t dwSize)
{
	return AllocateRtMemory(dwSize);	//̍쐬
}
//------------------------------------------------------------
// freemallocMemory
//------------------------------------------------------------
uint32_t edge_freemallocMemory(void *Memory)
{
	return FreeRtMemory(Memory);		//̍폜
}
//------------------------------------------------------------
// createThread
//------------------------------------------------------------
void* edge_createThread(uint16_t shPriority, uint32_t dwStackSize, void* func, void* arg, int32_t* errorNo)
{
	RTHANDLE hHandle;
	uint8_t newPriority = 150;
	if (shPriority < 256)	//255傫̓ftHg150Ƃ
		newPriority = (uint8_t)shPriority;
	hHandle = CreateRtThread(newPriority, func, dwStackSize, arg);	//Xbh쐬 INtimeł͂̂܂
	if (hHandle == BAD_RTHANDLE)
	{
		*errorNo = GetLastRtError();
		return NULL;
	}
	// J^OKvłedge_catalogĂ
	*errorNo = EDGE_SUCCESS;
	return (void*)hHandle;
}
//------------------------------------------------------------
// deleteThread
//------------------------------------------------------------
uint8_t edge_deleteThread(void* hHandle)
{
	// AJ^OKvłedge_uncatalogĂ

	return DeleteRtThread((RTHANDLE)hHandle);
}
//------------------------------------------------------------
// sleep
//------------------------------------------------------------
void edge_sleep(uint32_t dwMillseconds)
{
	RtSleepEx(dwMillseconds);	//RtSleepExgp
}
//------------------------------------------------------------
// getProcPath s̃vZXpX擾
//------------------------------------------------------------
void edge_getProcPath(char *pPath, uint32_t dwSize)
{
	RTHANDLE	hThis = BAD_RTHANDLE;
	RTHANDLE	hHandle;

	hThis = GetRtThreadHandles(THIS_PROCESS);	//Xbhnh擾
	if (BAD_RTHANDLE == hThis)
		return;
	//s̃vZX̃tpX擾
	hHandle = LookupRtHandle(hThis, "R?H$C$NAME", 0);	// vZX̖̂擾
	if (hHandle != BAD_RTHANDLE)
	{
		CopyRtData(hHandle,								// Rs[
			(LPVOID)1,
			0,
			pPath,										// ̃obt@ɃpXRs[
			min(GetRtSize(hHandle),
				256) - 1);
	}
}
//------------------------------------------------------------
// Ԃ̎擾
//------------------------------------------------------------
int32_t edge_getTime(EDGE_TIME_STAMP *pTime)
{
	return edgeGetTimestamp(pTime);
}
//------------------------------------------------------------
// Ԃ̎擾
//------------------------------------------------------------
int32_t edge_getTimeVal(EDGE_TIME_VAL *pTime)
{
	return edgeGetTimeVal(pTime);
}
//------------------------------------------------------------
// Ԃ̕ϊ
//------------------------------------------------------------
int32_t edge_Localtime64(void* pTime, void* pLongTime)
{
	struct tm *pLocalTime = _localtime64((const __time64_t *)pLongTime);			//_localtime64gUNIXԂ猻ݎɕϊ
	memcpy_s((struct tm *)pTime, sizeof(struct tm), pLocalTime, sizeof(struct tm));	//ԃRs[
	return 0;
}
//------------------------------------------------------------
// RTCDx[X[{bNX̐
//------------------------------------------------------------
int32_t edge_creMbox(const char *pName, uint32_t dwLength, uint32_t dwNum, RTCDMEMINFO *pRtcdInfo)
{
	return edgeCreateMailbox(pName, dwLength, dwNum, pRtcdInfo);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̍폜
//------------------------------------------------------------
int32_t edge_delMbox(RTCDMEMINFO *pRtcdInfo)
{
	return edgeDeleteMailbox(pRtcdInfo);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̃I[v
//------------------------------------------------------------
int32_t edge_openMbox(const char *pName, uint32_t dwAccess, RTCDHANDLE *pHandle)
{
	return edgeOpenMailbox(pName, dwAccess, pHandle);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̃N[Y
//------------------------------------------------------------
int32_t edge_closeMbox(RTCDHANDLE *pHandle)
{
	return edgeCloseMailbox(pHandle);
}
//------------------------------------------------------------
// RTCDx[X[{bNXĂ̑M
//------------------------------------------------------------
int32_t edge_sendMbox(RTCDHANDLE *pHandle, void *pBuffer, uint32_t dwSize)
{
	return edgeSendData(pHandle, pBuffer, dwSize);
}
//------------------------------------------------------------
// RTCDx[X[{bNXĂ̑M
//------------------------------------------------------------
int32_t edge_sendMboxEx(RTCDHANDLE *pHandle, void *pBuffer1, uint32_t dwSize1, void *pBuffer2, uint32_t dwSize2)
{
	return edgeSendData4Mbox(pHandle, pBuffer1, dwSize1, pBuffer2, dwSize2);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̎M
//------------------------------------------------------------
int32_t edge_recvMbox(RTCDHANDLE *pHandle, void *pBuffer, uint32_t dwBufferSize, uint32_t dwTimeout)
{
	return edgeReceiveData(pHandle, pBuffer, dwBufferSize, dwTimeout);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̎M
//------------------------------------------------------------
int32_t edge_recvMboxEx(RTCDHANDLE *pHandle, void *pBuffer1, uint32_t dwBufferSize1, void *pBuffer2, uint32_t dwBufferSize2, uint32_t dwTimeout)
{
	return edgeReceiveData4Mbox(pHandle, pBuffer1, dwBufferSize1, pBuffer2, dwBufferSize2, dwTimeout);
}
//------------------------------------------------------------
// RTCDx[X[{bNX̍\擾
//------------------------------------------------------------
int32_t edge_infoMbox(RTCDHANDLE *pHandle, EDGE_RTCD_HEADER *pInfo)
{
	return edgeGetRTCDInfo(pHandle, pInfo);
}
//------------------------------------------------------------
// edgeT[rXN
//------------------------------------------------------------
uint32_t edge_createService(const char *Name, const char *path, const char *arg, intptr_t *pid)
{
	RTHANDLE ret;
	PROCESSATTRIBUTES attrib = { 0 };
	uint32_t flag;

	flag = 0;	// PROC_WAIT_FOR_INITw肵ƂBT[rXSyncronize̎vɂȂB
	attrib.ObjDirSize = 3840;
	attrib.PoolMin = 0;
	attrib.PoolMax = 0xFFFFFFFF;
	attrib.VsegSize = 64 * 1024 * 1024;
	ret = CreateRtProcess(path, arg, &attrib, flag);		// CreateRtProcessrtaN
	*pid = (intptr_t)ret;
	return (ret != BAD_RTHANDLE) ? EDGE_SUCCESS : GetLastRtError();		// (̂܂ܖ߂l)
}
//------------------------------------------------------------
// edgeT[rXwm[hŋN
//------------------------------------------------------------
uint32_t edge_createServiceEx(const char *Name, const char *path, const char *arg, intptr_t *pid, EDGESERVICECONFIG *config)
{
	RTHANDLE ret;
	PROCESSATTRIBUTES attrib = { 0 };
	uint32_t flag;
	LOCATION loc;

	flag = 0;	// PROC_WAIT_FOR_INITw肵ƂBT[rXSyncronize̎vɂȂB
	attrib.ObjDirSize = 3840;
	attrib.PoolMin = 0;
	attrib.PoolMax = 0xFFFFFFFF;
	attrib.VsegSize = 64 * 1024 * 1024;

	if ((config != NULL) && (strlen(config->NodeName) != 0)) {	// m[hw肠̏ꍇ
		loc = GetRtNodeLocationByName(config->NodeName);		// P[Vnh擾
		if (BAD_LOCATION == loc) {
			return EDGE_PARAM_INVALID;							// p[^s
		}
		// wm[hrtaN
		ret = CreateRemoteRtProcess(loc, path, arg, &attrib, flag, NULL);
	}
	else {														// m[hwȂ̏ꍇ
		// [Jm[hrtaN
		ret = CreateRtProcess(path, arg, &attrib, flag);
	}
	*pid = (intptr_t)ret;
	return (ret != BAD_RTHANDLE) ? EDGE_SUCCESS : GetLastRtError();		// (̂܂ܖ߂l)
}
//------------------------------------------------------------
// Thread Priority̐ݒ INtimep
//------------------------------------------------------------
int32_t edge_setPriority(void* hdl, uint8_t byPriority)
{
	uint32_t dwStatus = 0;
	if (FALSE == SetRtThreadPriority((RTHANDLE)hdl, byPriority))	dwStatus = GetLastRtError();//sLastError߂lԂ
	return dwStatus;
}
//------------------------------------------------------------
// vO̎擾
//------------------------------------------------------------
int32_t edge_getCommmandLine(char *pArg, uint32_t dwSize)
{
	RTHANDLE	hThis = BAD_RTHANDLE;
	RTHANDLE	hArgvSeg;
	uint32_t		iSize;
	char* pTempArg;
	hThis = GetRtThreadHandles(THIS_PROCESS);	//Xbhnh擾
	if (BAD_RTHANDLE == hThis)
		return EDGE_THREAD_ERROR;
	//s̃vZX̃tpX擾
	hArgvSeg = LookupRtHandle(hThis, "R?H$C$NAME", 0);
	if (hArgvSeg != BAD_RTHANDLE)
	{
		iSize = GetRtSize(hArgvSeg);
		if (iSize > dwSize)
			return EDGE_RTCD_BUFFER_SIZE_INVALID;

		iSize--;//1oCg炷(ŏ1oCg͒Ȃ̂Łj
		pTempArg = (char*)AllocateRtMemory(iSize);
		// +1ByteڂargvĂ̂œ]
		CopyRtData(hArgvSeg, (LPVOID)1, 0, pTempArg, min(iSize,dwSize) - 1);
		if (strlen(pTempArg) > 0)
		{
			//nullXy[Xɕϊ
			for (uint32_t i = 0; i < iSize; i++)
			{
				if (pTempArg[i] == '\0') pTempArg[i] = ' ';
			}
			pTempArg[iSize] = '\0';
			strcpy_s((char*)pArg, dwSize, pTempArg);
		}
		FreeRtMemory(pTempArg);
		return EDGE_SUCCESS;
	}
	pArg[0] = '\0';
	return EDGE_SUCCESS;
}
/// <summary>
/// tRs[(t^\0nɊ܂܂Ȃ) _TRUNCATE(-1)dstmax-1
/// </summary>
/// <param name="dst"></param>
/// <param name="dstmax">dstobt@̃TCY</param>
/// <param name="src"></param>
/// <param name="n">Rs[TCY</param>
void edge_strncpy_s(char *dst, size_t dstmax, const char *src, size_t n)
{
	/* @memo INtimestrncpy_s()"_TRUNCATE"wɑΉĂȂ */
	if (n == _TRUNCATE) {
		/* dȂ̂strncpyōB */
		strncpy(dst, src, dstmax);
		/* IɏI[ϰ */
		dst[dstmax - 1] = '\0';
	} else {
		strncpy_s(dst, dstmax, src, n);
	}
}
//------------------------------------------------------------
// RTCDx[X[{bNX̃nhL`FbN
//------------------------------------------------------------
int32_t edge_checkHandle(RTCDHANDLE *pHandle)
{
	return edgeHandleCheck(pHandle);
}
//------------------------------------------------------------
// @\  FCPUNbNJE^̎擾iSpeedStep@\̂CPUł͗pł܂)
//   F
//------------------------------------------------------------
unsigned long long edge_GetPCounter(void)
{
	_asm    rdtsc
}
//------------------------------------------------------------
// CPUx̌v( Hz )
//------------------------------------------------------------
DWORD GetCPUSpeed(void)
{
	SYSINFO         sSysInfo;
	DWORD           PentiumTicksPerUsec;
	DWORD           dwResult;

	CopyRtSystemInfo(&sSysInfo);
	PentiumTicksPerUsec = sSysInfo.PentiumTicksPerUsec;
	dwResult = PentiumTicksPerUsec * 1000000;
	return dwResult;
}
//------------------------------------------------------------
// @\  FԂ̎Zo( nano second )
//   Fstart_Count  Jn̶
//		   finish_Count I̶
// ߂lFx(nano second)
//------------------------------------------------------------
double edge_CalcTime(unsigned long long start_Count, unsigned long long finish_Count)
{
	double  dblCPUspeed;
	dblCPUspeed = (double)1000000000 / (double)GetCPUSpeed();
	return ((double)(finish_Count - start_Count) * dblCPUspeed);
}