﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Data;
using System.Windows.Controls;
using System.Windows;

namespace EgBrow
{
    class CsvUtil
    {
        /// <summary>
        /// CSV書き込み
        /// </summary>
        /// <param name="fileNamePrefix"></param>
        /// <param name="data"></param>
        /// <returns></returns>
        public static string WriteCsv(string fileNamePrefix, List<List<string>> data )
        {
            try
            {
                // ファイル名生成(接頭辞 + 日時分秒.csv)
                string fileName = fileNamePrefix + DateTime.Now.ToString("yyyyMMddHHmmss") + ".csv";

                // CSV書き込み
                using (StreamWriter SW = new StreamWriter(fileName, false, Encoding.UTF8))
                {
                    foreach (var row in data)
                    {
                        foreach (var item in row)
                        {
                            SW.Write("\"" + item + "\",");
                        }
                        SW.Write(SW.NewLine);
                    }
                }
                MessageBox.Show("CSVファイルを出力しました。\n" + fileName, "CSV出力");
                return fileName;
            }
            catch(Exception ex)
            {
                MessageBox.Show("CSVファイル出力に失敗しました。\n\n[エラー情報]\n" + ex.ToString(), "CSV出力", MessageBoxButton.OK, MessageBoxImage.Error);
                return string.Empty;
            }
        }
    }
}
