﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
namespace EgBrow
{
    /// <summary>
    /// タブ識別用インデックス
    /// </summary>
    public enum TabIdx :int
    {
        // Note: TabControlのTabIndexに合わせること
        TAG = 0,
        CONTAINER,
        COLLECTOR,
        DATASET,
        MAILBOX
    }

    /// <summary>
    /// 更新周期設定
    /// </summary>
    public class SettingIntv
    {
        /// <summary>
        /// タグ情報更新周期[ms]
        /// </summary>
        public uint IntvTag { get; set; }

        /// <summary>
        /// コンテナ情報更新周期[ms]
        /// </summary>
        public uint IntvContainer { get; set; }

        /// <summary>
        /// コレクタ情報更新周期[ms]
        /// </summary>
        public uint IntvCollector { get; set; }

        /// <summary>
        /// データセット情報更新周期[ms]
        /// </summary>
        public uint IntvDataset { get; set; }

        /// <summary>
        /// メールボックス情報更新周期[ms]
        /// </summary>
        public uint IntvMailbox { get; set; }

        /// <summary>
        /// コンストラクタ
        /// </summary>
        /// <param name="intv"></param>
        public SettingIntv(uint intv)
        {
            IntvTag = intv;
            IntvContainer = intv;
            IntvCollector = intv;
            IntvDataset = intv;
            IntvMailbox = intv;
        }
    }
}
