﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Windows;

namespace EgBrow
{
    /// <summary>
    /// SettingWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class SettingWindow : Window
    {
        SettingIntv _item;

        public SettingWindow(SettingIntv item)
        {
            InitializeComponent();
            this.Closing += new System.ComponentModel.CancelEventHandler(Window_Closing);
            _item = item;
        }

        /// <summary>
        /// Windowクローズ処理
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            try
            {
                // 設定値チェック
                if ((_item.IntvTag == 0)
                    || (_item.IntvContainer == 0)
                    || (_item.IntvCollector == 0)
                    || (_item.IntvDataset == 0)
                    || (_item.IntvMailbox == 0))
                {
                    MessageBox.Show("更新周期は1以上の値を指定してください。", "更新周期設定", MessageBoxButton.OK, MessageBoxImage.Warning);
                    e.Cancel = true;
                }

                // 設定値チェック
                if ((_item.IntvTag > int.MaxValue)
                    || (_item.IntvContainer > int.MaxValue)
                    || (_item.IntvCollector > int.MaxValue)
                    || (_item.IntvDataset > int.MaxValue)
                    || (_item.IntvMailbox > int.MaxValue))
                {
                    MessageBox.Show("更新周期は1以上の値を指定してください。", "更新周期設定", MessageBoxButton.OK, MessageBoxImage.Warning);
                    e.Cancel = true;
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(System.Reflection.MethodBase.GetCurrentMethod().Name + " : " + ex.Message);
            }
        }

        /// <summary>
        /// 閉じるボタンクリックイベント
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void CloseButton_Click(object sender, RoutedEventArgs e)
        {
            Close();
        }
    }
}
