﻿////////////////////////////////////////////////////////////////////////////////////////
/// 機能       :   RT-edge XML編集ツール プロジェクトファイル構成クラス
/// 作成日     :   2022/02/21
/// 作成者     :   mizuno
/// 
/// RT-edge XML編集ツール 機能仕様書
/// file://192.168.1.240/Jobs/KA1601(RT-edge開発）/trunk/0051_Documnet(社内)/0200_egCoreService/20211021_RT-edge_XML編集ツール_機能仕様書.pptx
/// P11. プロジェクトファイル構成
/// 
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace EgConfig
{
    /// <summary>
    /// プロジェクトファイル(.eciproj)シリアライズ用クラス
    /// </summary>
    public class EciProject
    {
        public Version Version;             // バージョン情報の要素
        public List<EciFile> EciFiles;      // 管理するECIファイルの要素
    }
    [Serializable]
    public class Version
    {
        [XmlAttribute("ToolVer")]
        public string ToolVer;
    }
    [Serializable]
    public class EciFile
    {
        [XmlAttribute("Name")]
        public string Name;
    }
}
