﻿////////////////////////////////////////////////////////////////////////////////////////
/// 機能       :   RT-edge XML編集ツール バージョン画面のコードビハインド
/// 作成日     :   2022/02/21
/// 作成者     :   mizuno
/// 
/// RT-edge XML編集ツール 機能仕様書
/// file://192.168.1.240/Jobs/KA1601(RT-edge開発）/trunk/0051_Documnet(社内)/0200_egCoreService/20211021_RT-edge_XML編集ツール_機能仕様書.pptx
/// P10. 基本機能 バージョン
/// 
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace EgConfig
{
    /// <summary>
    /// VersionInformation.xaml の相互作用ロジック
    /// </summary>
    public partial class VersionInformation : Window
    {
        public string Product { get; set; }
        public string Version { get; set; }
        public string CopyRight { get; set; }

        public VersionInformation()
        {
            InitializeComponent();

            // バージョン情報設定
            System.Reflection.Assembly assembly = System.Reflection.Assembly.GetExecutingAssembly();    // バージョン情報取得
            System.Reflection.AssemblyName asmName = assembly.GetName();                                //
            System.Version version = asmName.Version;                                                   //
            this.Version = version.ToString();
            
            FileVersionInfo fileVersionInfo = FileVersionInfo.GetVersionInfo(Assembly.GetExecutingAssembly().Location);
            this.Product = fileVersionInfo.ProductName;             // 製品名
            this.CopyRight = fileVersionInfo.LegalCopyright;        // 著作権

            DataContext = this;
        }

        private void OkBtn_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }
    }
}
